// A Bison parser, made by GNU Bison 3.0.4.

// Skeleton implementation for Bison LALR(1) parsers in C++

// Copyright (C) 2002-2015 Free Software Foundation, Inc.

// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.

// As a special exception, you may create a larger work that contains
// part or all of the Bison parser skeleton and distribute that work
// under terms of your choice, so long as that work isn't itself a
// parser generator using the skeleton or a modified version thereof
// as a parser skeleton.  Alternatively, if you modify or redistribute
// the parser skeleton itself, you may (at your option) remove this
// special exception, which will cause the skeleton and the resulting
// Bison output files to be licensed under the GNU General Public
// License without this special exception.

// This special exception was added by the Free Software Foundation in
// version 2.2 of Bison.


// First part of user declarations.
#line 11 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:404

namespace hilti { namespace detail { class Parser; } }

#include <hilti/compiler/detail/parser/driver.h>

#line 39 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:404


#include <hilti/compiler/detail/parser/scanner.h>

#undef yylex
#define yylex driver->scanner()->lex

static hilti::Meta toMeta(hilti::detail::parser::location l) {
    return hilti::Meta(hilti::Location(*l.begin.filename, l.begin.line, l.end.line, l.begin.column, l.end.column));
}

static hilti::Type iteratorForType(hilti::Type t, bool const_, hilti::Meta m) {
    if ( hilti::type::isIterable(t) )
        return t.iteratorType(const_);
    else {
        hilti::logger().error(hilti::util::fmt("type '%s' is not iterable", t), m.location());
        return hilti::type::Error(m);
        }
}

static hilti::Type viewForType(hilti::Type t, hilti::Meta m) {
    if ( hilti::type::isViewable(t) )
        return t.viewType();
    else {
        hilti::logger().error(hilti::util::fmt("type '%s' is not viewable", t), m.location());
        return hilti::type::Error(m);
        }
}


/**
 * Checks if an unsigned integer value can be represented as an int64_t.
 *
 * @param x value to check
 * @param positive if false, check if ``-x`` can be represented instead of ``x`` itself.
 * @param m location information to associate with error message.
 * @return *x* on success, or zero on failure as a temporary stand-in; in the
 * latter cases an error is reported, too
 */
static uint64_t check_int64_range(uint64_t x, bool positive, const hilti::Meta& m) {
    uint64_t max = (positive ? std::numeric_limits<int64_t>::max() : std::fabs(std::numeric_limits<int64_t>::min()));

    if ( x <= max )
        return x;

    hilti::logger().error("signed integer value out of range", m.location());
    return 0; // Return dummy value
}

#define __loc__ toMeta(yylhs.location)


#line 95 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:404

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

#include "__parser.h"

// User implementation prologue.

#line 109 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:412


#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> // FIXME: INFRINGES ON USER NAME SPACE.
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K].location)
/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

# ifndef YYLLOC_DEFAULT
#  define YYLLOC_DEFAULT(Current, Rhs, N)                               \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).begin  = YYRHSLOC (Rhs, 1).begin;                   \
          (Current).end    = YYRHSLOC (Rhs, N).end;                     \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).begin = (Current).end = YYRHSLOC (Rhs, 0).end;      \
        }                                                               \
    while (/*CONSTCOND*/ false)
# endif


// Suppress unused-variable warnings by "using" E.
#define YYUSE(E) ((void) (E))

// Enable debugging if requested.
#if YYDEBUG

// A pseudo ostream that takes yydebug_ into account.
# define YYCDEBUG if (yydebug_) (*yycdebug_)

# define YY_SYMBOL_PRINT(Title, Symbol)         \
  do {                                          \
    if (yydebug_)                               \
    {                                           \
      *yycdebug_ << Title << ' ';               \
      yy_print_ (*yycdebug_, Symbol);           \
      *yycdebug_ << std::endl;                  \
    }                                           \
  } while (false)

# define YY_REDUCE_PRINT(Rule)          \
  do {                                  \
    if (yydebug_)                       \
      yy_reduce_print_ (Rule);          \
  } while (false)

# define YY_STACK_PRINT()               \
  do {                                  \
    if (yydebug_)                       \
      yystack_print_ ();                \
  } while (false)

#else // !YYDEBUG

# define YYCDEBUG if (false) std::cerr
# define YY_SYMBOL_PRINT(Title, Symbol)  YYUSE(Symbol)
# define YY_REDUCE_PRINT(Rule)           static_cast<void>(0)
# define YY_STACK_PRINT()                static_cast<void>(0)

#endif // !YYDEBUG

#define yyerrok         (yyerrstatus_ = 0)
#define yyclearin       (yyla.clear ())

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYRECOVERING()  (!!yyerrstatus_)

#line 27 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:479
namespace hilti { namespace detail { namespace parser {
#line 195 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:479

  /* Return YYSTR after stripping away unnecessary quotes and
     backslashes, so that it's suitable for yyerror.  The heuristic is
     that double-quoting is unnecessary unless the string contains an
     apostrophe, a comma, or backslash (other than backslash-backslash).
     YYSTR is taken from yytname.  */
  std::string
  Parser::yytnamerr_ (const char *yystr)
  {
    if (*yystr == '"')
      {
        std::string yyr = "";
        char const *yyp = yystr;

        for (;;)
          switch (*++yyp)
            {
            case '\'':
            case ',':
              goto do_not_strip_quotes;

            case '\\':
              if (*++yyp != '\\')
                goto do_not_strip_quotes;
              // Fall through.
            default:
              yyr += *yyp;
              break;

            case '"':
              return yyr;
            }
      do_not_strip_quotes: ;
      }

    return yystr;
  }


  /// Build a parser object.
  Parser::Parser (class Driver* driver_yyarg)
    :
#if YYDEBUG
      yydebug_ (false),
      yycdebug_ (&std::cerr),
#endif
      driver (driver_yyarg)
  {}

  Parser::~Parser ()
  {}


  /*---------------.
  | Symbol types.  |
  `---------------*/

  inline
  Parser::syntax_error::syntax_error (const location_type& l, const std::string& m)
    : std::runtime_error (m)
    , location (l)
  {}

  // basic_symbol.
  template <typename Base>
  inline
  Parser::basic_symbol<Base>::basic_symbol ()
    : value ()
  {}

  template <typename Base>
  inline
  Parser::basic_symbol<Base>::basic_symbol (const basic_symbol& other)
    : Base (other)
    , value ()
    , location (other.location)
  {
      switch (other.type_get ())
    {
      case 16: // "bool value"
        value.copy< bool > (other.value);
        break;

      case 14: // "real value"
      case 253: // const_real
        value.copy< double > (other.value);
        break;

      case 275: // attribute
        value.copy< hilti::Attribute > (other.value);
        break;

      case 252: // ctor
      case 256: // tuple
      case 261: // list
      case 262: // set
      case 263: // map
      case 264: // struct_
      case 267: // regexp
        value.copy< hilti::Ctor > (other.value);
        break;

      case 171: // global_scope_decl
      case 172: // type_decl
      case 173: // constant_decl
      case 174: // local_decl
      case 175: // local_init_decl
      case 176: // global_decl
      case 178: // function_decl
      case 179: // import_decl
      case 180: // property_decl
      case 223: // struct_field
      case 227: // union_field
        value.copy< hilti::Declaration > (other.value);
        break;

      case 231: // expr
      case 234: // expr_0
      case 235: // expr_1
      case 236: // expr_2
      case 237: // expr_3
      case 238: // expr_4
      case 239: // expr_5
      case 240: // expr_6
      case 241: // expr_7
      case 242: // expr_8
      case 243: // expr_9
      case 244: // expr_a
      case 245: // expr_b
      case 246: // expr_c
      case 247: // expr_d
      case 248: // expr_e
      case 249: // expr_f
      case 250: // expr_g
      case 251: // member_expr
      case 259: // tuple_elem
      case 260: // tuple_expr
        value.copy< hilti::Expression > (other.value);
        break;

      case 184: // function_with_body
      case 185: // method_with_body
      case 186: // hook_with_body
      case 187: // function_without_body
        value.copy< hilti::Function > (other.value);
        break;

      case 165: // local_id
      case 166: // scoped_id
      case 167: // dotted_id
      case 182: // function_id
      case 183: // scoped_function_id
        value.copy< hilti::ID > (other.value);
        break;

      case 197: // block
      case 198: // braced_block
      case 201: // stmt
      case 208: // stmt_decl
      case 209: // stmt_expr
        value.copy< hilti::Statement > (other.value);
        break;

      case 210: // base_type_no_attrs
      case 211: // base_type
      case 212: // type
      case 216: // function_type
      case 217: // tuple_type
      case 220: // struct_type
      case 224: // union_type
      case 228: // enum_type
        value.copy< hilti::Type > (other.value);
        break;

      case 274: // map_elem
        value.copy< hilti::ctor::map::Element > (other.value);
        break;

      case 266: // struct_elem
        value.copy< hilti::ctor::struct_::Field > (other.value);
        break;

      case 181: // opt_linkage
        value.copy< hilti::declaration::Linkage > (other.value);
        break;

      case 195: // opt_func_param_kind
        value.copy< hilti::declaration::parameter::Kind > (other.value);
        break;

      case 190: // opt_func_cc
        value.copy< hilti::function::CallingConvention > (other.value);
        break;

      case 205: // switch_case
        value.copy< hilti::statement::switch_::Case > (other.value);
        break;

      case 207: // try_catch
        value.copy< hilti::statement::try_::Catch > (other.value);
        break;

      case 215: // opt_type_flags
        value.copy< hilti::type::Flags > (other.value);
        break;

      case 230: // enum_label
        value.copy< hilti::type::enum_::Label > (other.value);
        break;

      case 188: // opt_func_flavor
      case 189: // func_flavor
        value.copy< hilti::type::function::Flavor > (other.value);
        break;

      case 193: // func_param
        value.copy< hilti::type::function::Parameter > (other.value);
        break;

      case 194: // func_result
        value.copy< hilti::type::function::Result > (other.value);
        break;

      case 219: // tuple_type_elem
        value.copy< hilti::type::tuple::Element > (other.value);
        break;

      case 254: // const_sint
        value.copy< int64_t > (other.value);
        break;

      case 276: // opt_attributes
        value.copy< std::optional<hilti::AttributeSet> > (other.value);
        break;

      case 196: // opt_func_default_expr
        value.copy< std::optional<hilti::Expression> > (other.value);
        break;

      case 202: // opt_else_block
        value.copy< std::optional<hilti::Statement> > (other.value);
        break;

      case 170: // global_scope_items
        value.copy< std::pair<std::vector<hilti::Declaration>, std::vector<hilti::Statement>> > (other.value);
        break;

      case 3: // "identifier"
      case 4: // "scoped identifier"
      case 5: // "scoped ~finally"
      case 6: // "dotted identifier"
      case 7: // "attribute"
      case 8: // "property"
      case 9: // "string value"
      case 10: // "bytes value"
      case 11: // "regular expression value"
      case 12: // "address value"
      case 13: // "port value"
      case 269: // re_pattern_constant
        value.copy< std::string > (other.value);
        break;

      case 222: // struct_fields
      case 225: // opt_union_fields
      case 226: // union_fields
        value.copy< std::vector<hilti::Declaration> > (other.value);
        break;

      case 177: // opt_type_arguments
      case 232: // opt_exprs
      case 233: // exprs
      case 257: // opt_tuple_elems1
      case 258: // opt_tuple_elems2
        value.copy< std::vector<hilti::Expression> > (other.value);
        break;

      case 199: // opt_stmts
      case 200: // stmts
        value.copy< std::vector<hilti::Statement> > (other.value);
        break;

      case 272: // opt_map_elems
      case 273: // map_elems
        value.copy< std::vector<hilti::ctor::map::Element> > (other.value);
        break;

      case 265: // struct_elems
        value.copy< std::vector<hilti::ctor::struct_::Field> > (other.value);
        break;

      case 203: // opt_switch_cases
      case 204: // switch_cases
        value.copy< std::vector<hilti::statement::switch_::Case> > (other.value);
        break;

      case 206: // try_catches
        value.copy< std::vector<hilti::statement::try_::Catch> > (other.value);
        break;

      case 229: // enum_labels
        value.copy< std::vector<hilti::type::enum_::Label> > (other.value);
        break;

      case 191: // opt_func_params
      case 192: // func_params
      case 221: // opt_struct_params
        value.copy< std::vector<hilti::type::function::Parameter> > (other.value);
        break;

      case 218: // tuple_type_elems
        value.copy< std::vector<hilti::type::tuple::Element> > (other.value);
        break;

      case 268: // re_patterns
        value.copy< std::vector<std::string> > (other.value);
        break;

      case 15: // "unsigned integer value"
      case 255: // const_uint
        value.copy< uint64_t > (other.value);
        break;

      default:
        break;
    }

  }


  template <typename Base>
  inline
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const semantic_type& v, const location_type& l)
    : Base (t)
    , value ()
    , location (l)
  {
    (void) v;
      switch (this->type_get ())
    {
      case 16: // "bool value"
        value.copy< bool > (v);
        break;

      case 14: // "real value"
      case 253: // const_real
        value.copy< double > (v);
        break;

      case 275: // attribute
        value.copy< hilti::Attribute > (v);
        break;

      case 252: // ctor
      case 256: // tuple
      case 261: // list
      case 262: // set
      case 263: // map
      case 264: // struct_
      case 267: // regexp
        value.copy< hilti::Ctor > (v);
        break;

      case 171: // global_scope_decl
      case 172: // type_decl
      case 173: // constant_decl
      case 174: // local_decl
      case 175: // local_init_decl
      case 176: // global_decl
      case 178: // function_decl
      case 179: // import_decl
      case 180: // property_decl
      case 223: // struct_field
      case 227: // union_field
        value.copy< hilti::Declaration > (v);
        break;

      case 231: // expr
      case 234: // expr_0
      case 235: // expr_1
      case 236: // expr_2
      case 237: // expr_3
      case 238: // expr_4
      case 239: // expr_5
      case 240: // expr_6
      case 241: // expr_7
      case 242: // expr_8
      case 243: // expr_9
      case 244: // expr_a
      case 245: // expr_b
      case 246: // expr_c
      case 247: // expr_d
      case 248: // expr_e
      case 249: // expr_f
      case 250: // expr_g
      case 251: // member_expr
      case 259: // tuple_elem
      case 260: // tuple_expr
        value.copy< hilti::Expression > (v);
        break;

      case 184: // function_with_body
      case 185: // method_with_body
      case 186: // hook_with_body
      case 187: // function_without_body
        value.copy< hilti::Function > (v);
        break;

      case 165: // local_id
      case 166: // scoped_id
      case 167: // dotted_id
      case 182: // function_id
      case 183: // scoped_function_id
        value.copy< hilti::ID > (v);
        break;

      case 197: // block
      case 198: // braced_block
      case 201: // stmt
      case 208: // stmt_decl
      case 209: // stmt_expr
        value.copy< hilti::Statement > (v);
        break;

      case 210: // base_type_no_attrs
      case 211: // base_type
      case 212: // type
      case 216: // function_type
      case 217: // tuple_type
      case 220: // struct_type
      case 224: // union_type
      case 228: // enum_type
        value.copy< hilti::Type > (v);
        break;

      case 274: // map_elem
        value.copy< hilti::ctor::map::Element > (v);
        break;

      case 266: // struct_elem
        value.copy< hilti::ctor::struct_::Field > (v);
        break;

      case 181: // opt_linkage
        value.copy< hilti::declaration::Linkage > (v);
        break;

      case 195: // opt_func_param_kind
        value.copy< hilti::declaration::parameter::Kind > (v);
        break;

      case 190: // opt_func_cc
        value.copy< hilti::function::CallingConvention > (v);
        break;

      case 205: // switch_case
        value.copy< hilti::statement::switch_::Case > (v);
        break;

      case 207: // try_catch
        value.copy< hilti::statement::try_::Catch > (v);
        break;

      case 215: // opt_type_flags
        value.copy< hilti::type::Flags > (v);
        break;

      case 230: // enum_label
        value.copy< hilti::type::enum_::Label > (v);
        break;

      case 188: // opt_func_flavor
      case 189: // func_flavor
        value.copy< hilti::type::function::Flavor > (v);
        break;

      case 193: // func_param
        value.copy< hilti::type::function::Parameter > (v);
        break;

      case 194: // func_result
        value.copy< hilti::type::function::Result > (v);
        break;

      case 219: // tuple_type_elem
        value.copy< hilti::type::tuple::Element > (v);
        break;

      case 254: // const_sint
        value.copy< int64_t > (v);
        break;

      case 276: // opt_attributes
        value.copy< std::optional<hilti::AttributeSet> > (v);
        break;

      case 196: // opt_func_default_expr
        value.copy< std::optional<hilti::Expression> > (v);
        break;

      case 202: // opt_else_block
        value.copy< std::optional<hilti::Statement> > (v);
        break;

      case 170: // global_scope_items
        value.copy< std::pair<std::vector<hilti::Declaration>, std::vector<hilti::Statement>> > (v);
        break;

      case 3: // "identifier"
      case 4: // "scoped identifier"
      case 5: // "scoped ~finally"
      case 6: // "dotted identifier"
      case 7: // "attribute"
      case 8: // "property"
      case 9: // "string value"
      case 10: // "bytes value"
      case 11: // "regular expression value"
      case 12: // "address value"
      case 13: // "port value"
      case 269: // re_pattern_constant
        value.copy< std::string > (v);
        break;

      case 222: // struct_fields
      case 225: // opt_union_fields
      case 226: // union_fields
        value.copy< std::vector<hilti::Declaration> > (v);
        break;

      case 177: // opt_type_arguments
      case 232: // opt_exprs
      case 233: // exprs
      case 257: // opt_tuple_elems1
      case 258: // opt_tuple_elems2
        value.copy< std::vector<hilti::Expression> > (v);
        break;

      case 199: // opt_stmts
      case 200: // stmts
        value.copy< std::vector<hilti::Statement> > (v);
        break;

      case 272: // opt_map_elems
      case 273: // map_elems
        value.copy< std::vector<hilti::ctor::map::Element> > (v);
        break;

      case 265: // struct_elems
        value.copy< std::vector<hilti::ctor::struct_::Field> > (v);
        break;

      case 203: // opt_switch_cases
      case 204: // switch_cases
        value.copy< std::vector<hilti::statement::switch_::Case> > (v);
        break;

      case 206: // try_catches
        value.copy< std::vector<hilti::statement::try_::Catch> > (v);
        break;

      case 229: // enum_labels
        value.copy< std::vector<hilti::type::enum_::Label> > (v);
        break;

      case 191: // opt_func_params
      case 192: // func_params
      case 221: // opt_struct_params
        value.copy< std::vector<hilti::type::function::Parameter> > (v);
        break;

      case 218: // tuple_type_elems
        value.copy< std::vector<hilti::type::tuple::Element> > (v);
        break;

      case 268: // re_patterns
        value.copy< std::vector<std::string> > (v);
        break;

      case 15: // "unsigned integer value"
      case 255: // const_uint
        value.copy< uint64_t > (v);
        break;

      default:
        break;
    }
}


  // Implementation of basic_symbol constructor for each type.

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const location_type& l)
    : Base (t)
    , value ()
    , location (l)
  {}

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const bool v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const double v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const hilti::Attribute v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const hilti::Ctor v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const hilti::Declaration v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const hilti::Expression v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const hilti::Function v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const hilti::ID v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const hilti::Statement v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const hilti::Type v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const hilti::ctor::map::Element v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const hilti::ctor::struct_::Field v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const hilti::declaration::Linkage v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const hilti::declaration::parameter::Kind v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const hilti::function::CallingConvention v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const hilti::statement::switch_::Case v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const hilti::statement::try_::Catch v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const hilti::type::Flags v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const hilti::type::enum_::Label v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const hilti::type::function::Flavor v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const hilti::type::function::Parameter v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const hilti::type::function::Result v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const hilti::type::tuple::Element v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const int64_t v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const std::optional<hilti::AttributeSet> v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const std::optional<hilti::Expression> v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const std::optional<hilti::Statement> v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const std::pair<std::vector<hilti::Declaration>, std::vector<hilti::Statement>> v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const std::string v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const std::vector<hilti::Declaration> v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const std::vector<hilti::Expression> v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const std::vector<hilti::Statement> v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const std::vector<hilti::ctor::map::Element> v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const std::vector<hilti::ctor::struct_::Field> v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const std::vector<hilti::statement::switch_::Case> v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const std::vector<hilti::statement::try_::Catch> v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const std::vector<hilti::type::enum_::Label> v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const std::vector<hilti::type::function::Parameter> v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const std::vector<hilti::type::tuple::Element> v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const std::vector<std::string> v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const uint64_t v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}


  template <typename Base>
  inline
  Parser::basic_symbol<Base>::~basic_symbol ()
  {
    clear ();
  }

  template <typename Base>
  inline
  void
  Parser::basic_symbol<Base>::clear ()
  {
    // User destructor.
    symbol_number_type yytype = this->type_get ();
    basic_symbol<Base>& yysym = *this;
    (void) yysym;
    switch (yytype)
    {
   default:
      break;
    }

    // Type destructor.
    switch (yytype)
    {
      case 16: // "bool value"
        value.template destroy< bool > ();
        break;

      case 14: // "real value"
      case 253: // const_real
        value.template destroy< double > ();
        break;

      case 275: // attribute
        value.template destroy< hilti::Attribute > ();
        break;

      case 252: // ctor
      case 256: // tuple
      case 261: // list
      case 262: // set
      case 263: // map
      case 264: // struct_
      case 267: // regexp
        value.template destroy< hilti::Ctor > ();
        break;

      case 171: // global_scope_decl
      case 172: // type_decl
      case 173: // constant_decl
      case 174: // local_decl
      case 175: // local_init_decl
      case 176: // global_decl
      case 178: // function_decl
      case 179: // import_decl
      case 180: // property_decl
      case 223: // struct_field
      case 227: // union_field
        value.template destroy< hilti::Declaration > ();
        break;

      case 231: // expr
      case 234: // expr_0
      case 235: // expr_1
      case 236: // expr_2
      case 237: // expr_3
      case 238: // expr_4
      case 239: // expr_5
      case 240: // expr_6
      case 241: // expr_7
      case 242: // expr_8
      case 243: // expr_9
      case 244: // expr_a
      case 245: // expr_b
      case 246: // expr_c
      case 247: // expr_d
      case 248: // expr_e
      case 249: // expr_f
      case 250: // expr_g
      case 251: // member_expr
      case 259: // tuple_elem
      case 260: // tuple_expr
        value.template destroy< hilti::Expression > ();
        break;

      case 184: // function_with_body
      case 185: // method_with_body
      case 186: // hook_with_body
      case 187: // function_without_body
        value.template destroy< hilti::Function > ();
        break;

      case 165: // local_id
      case 166: // scoped_id
      case 167: // dotted_id
      case 182: // function_id
      case 183: // scoped_function_id
        value.template destroy< hilti::ID > ();
        break;

      case 197: // block
      case 198: // braced_block
      case 201: // stmt
      case 208: // stmt_decl
      case 209: // stmt_expr
        value.template destroy< hilti::Statement > ();
        break;

      case 210: // base_type_no_attrs
      case 211: // base_type
      case 212: // type
      case 216: // function_type
      case 217: // tuple_type
      case 220: // struct_type
      case 224: // union_type
      case 228: // enum_type
        value.template destroy< hilti::Type > ();
        break;

      case 274: // map_elem
        value.template destroy< hilti::ctor::map::Element > ();
        break;

      case 266: // struct_elem
        value.template destroy< hilti::ctor::struct_::Field > ();
        break;

      case 181: // opt_linkage
        value.template destroy< hilti::declaration::Linkage > ();
        break;

      case 195: // opt_func_param_kind
        value.template destroy< hilti::declaration::parameter::Kind > ();
        break;

      case 190: // opt_func_cc
        value.template destroy< hilti::function::CallingConvention > ();
        break;

      case 205: // switch_case
        value.template destroy< hilti::statement::switch_::Case > ();
        break;

      case 207: // try_catch
        value.template destroy< hilti::statement::try_::Catch > ();
        break;

      case 215: // opt_type_flags
        value.template destroy< hilti::type::Flags > ();
        break;

      case 230: // enum_label
        value.template destroy< hilti::type::enum_::Label > ();
        break;

      case 188: // opt_func_flavor
      case 189: // func_flavor
        value.template destroy< hilti::type::function::Flavor > ();
        break;

      case 193: // func_param
        value.template destroy< hilti::type::function::Parameter > ();
        break;

      case 194: // func_result
        value.template destroy< hilti::type::function::Result > ();
        break;

      case 219: // tuple_type_elem
        value.template destroy< hilti::type::tuple::Element > ();
        break;

      case 254: // const_sint
        value.template destroy< int64_t > ();
        break;

      case 276: // opt_attributes
        value.template destroy< std::optional<hilti::AttributeSet> > ();
        break;

      case 196: // opt_func_default_expr
        value.template destroy< std::optional<hilti::Expression> > ();
        break;

      case 202: // opt_else_block
        value.template destroy< std::optional<hilti::Statement> > ();
        break;

      case 170: // global_scope_items
        value.template destroy< std::pair<std::vector<hilti::Declaration>, std::vector<hilti::Statement>> > ();
        break;

      case 3: // "identifier"
      case 4: // "scoped identifier"
      case 5: // "scoped ~finally"
      case 6: // "dotted identifier"
      case 7: // "attribute"
      case 8: // "property"
      case 9: // "string value"
      case 10: // "bytes value"
      case 11: // "regular expression value"
      case 12: // "address value"
      case 13: // "port value"
      case 269: // re_pattern_constant
        value.template destroy< std::string > ();
        break;

      case 222: // struct_fields
      case 225: // opt_union_fields
      case 226: // union_fields
        value.template destroy< std::vector<hilti::Declaration> > ();
        break;

      case 177: // opt_type_arguments
      case 232: // opt_exprs
      case 233: // exprs
      case 257: // opt_tuple_elems1
      case 258: // opt_tuple_elems2
        value.template destroy< std::vector<hilti::Expression> > ();
        break;

      case 199: // opt_stmts
      case 200: // stmts
        value.template destroy< std::vector<hilti::Statement> > ();
        break;

      case 272: // opt_map_elems
      case 273: // map_elems
        value.template destroy< std::vector<hilti::ctor::map::Element> > ();
        break;

      case 265: // struct_elems
        value.template destroy< std::vector<hilti::ctor::struct_::Field> > ();
        break;

      case 203: // opt_switch_cases
      case 204: // switch_cases
        value.template destroy< std::vector<hilti::statement::switch_::Case> > ();
        break;

      case 206: // try_catches
        value.template destroy< std::vector<hilti::statement::try_::Catch> > ();
        break;

      case 229: // enum_labels
        value.template destroy< std::vector<hilti::type::enum_::Label> > ();
        break;

      case 191: // opt_func_params
      case 192: // func_params
      case 221: // opt_struct_params
        value.template destroy< std::vector<hilti::type::function::Parameter> > ();
        break;

      case 218: // tuple_type_elems
        value.template destroy< std::vector<hilti::type::tuple::Element> > ();
        break;

      case 268: // re_patterns
        value.template destroy< std::vector<std::string> > ();
        break;

      case 15: // "unsigned integer value"
      case 255: // const_uint
        value.template destroy< uint64_t > ();
        break;

      default:
        break;
    }

    Base::clear ();
  }

  template <typename Base>
  inline
  bool
  Parser::basic_symbol<Base>::empty () const
  {
    return Base::type_get () == empty_symbol;
  }

  template <typename Base>
  inline
  void
  Parser::basic_symbol<Base>::move (basic_symbol& s)
  {
    super_type::move(s);
      switch (this->type_get ())
    {
      case 16: // "bool value"
        value.move< bool > (s.value);
        break;

      case 14: // "real value"
      case 253: // const_real
        value.move< double > (s.value);
        break;

      case 275: // attribute
        value.move< hilti::Attribute > (s.value);
        break;

      case 252: // ctor
      case 256: // tuple
      case 261: // list
      case 262: // set
      case 263: // map
      case 264: // struct_
      case 267: // regexp
        value.move< hilti::Ctor > (s.value);
        break;

      case 171: // global_scope_decl
      case 172: // type_decl
      case 173: // constant_decl
      case 174: // local_decl
      case 175: // local_init_decl
      case 176: // global_decl
      case 178: // function_decl
      case 179: // import_decl
      case 180: // property_decl
      case 223: // struct_field
      case 227: // union_field
        value.move< hilti::Declaration > (s.value);
        break;

      case 231: // expr
      case 234: // expr_0
      case 235: // expr_1
      case 236: // expr_2
      case 237: // expr_3
      case 238: // expr_4
      case 239: // expr_5
      case 240: // expr_6
      case 241: // expr_7
      case 242: // expr_8
      case 243: // expr_9
      case 244: // expr_a
      case 245: // expr_b
      case 246: // expr_c
      case 247: // expr_d
      case 248: // expr_e
      case 249: // expr_f
      case 250: // expr_g
      case 251: // member_expr
      case 259: // tuple_elem
      case 260: // tuple_expr
        value.move< hilti::Expression > (s.value);
        break;

      case 184: // function_with_body
      case 185: // method_with_body
      case 186: // hook_with_body
      case 187: // function_without_body
        value.move< hilti::Function > (s.value);
        break;

      case 165: // local_id
      case 166: // scoped_id
      case 167: // dotted_id
      case 182: // function_id
      case 183: // scoped_function_id
        value.move< hilti::ID > (s.value);
        break;

      case 197: // block
      case 198: // braced_block
      case 201: // stmt
      case 208: // stmt_decl
      case 209: // stmt_expr
        value.move< hilti::Statement > (s.value);
        break;

      case 210: // base_type_no_attrs
      case 211: // base_type
      case 212: // type
      case 216: // function_type
      case 217: // tuple_type
      case 220: // struct_type
      case 224: // union_type
      case 228: // enum_type
        value.move< hilti::Type > (s.value);
        break;

      case 274: // map_elem
        value.move< hilti::ctor::map::Element > (s.value);
        break;

      case 266: // struct_elem
        value.move< hilti::ctor::struct_::Field > (s.value);
        break;

      case 181: // opt_linkage
        value.move< hilti::declaration::Linkage > (s.value);
        break;

      case 195: // opt_func_param_kind
        value.move< hilti::declaration::parameter::Kind > (s.value);
        break;

      case 190: // opt_func_cc
        value.move< hilti::function::CallingConvention > (s.value);
        break;

      case 205: // switch_case
        value.move< hilti::statement::switch_::Case > (s.value);
        break;

      case 207: // try_catch
        value.move< hilti::statement::try_::Catch > (s.value);
        break;

      case 215: // opt_type_flags
        value.move< hilti::type::Flags > (s.value);
        break;

      case 230: // enum_label
        value.move< hilti::type::enum_::Label > (s.value);
        break;

      case 188: // opt_func_flavor
      case 189: // func_flavor
        value.move< hilti::type::function::Flavor > (s.value);
        break;

      case 193: // func_param
        value.move< hilti::type::function::Parameter > (s.value);
        break;

      case 194: // func_result
        value.move< hilti::type::function::Result > (s.value);
        break;

      case 219: // tuple_type_elem
        value.move< hilti::type::tuple::Element > (s.value);
        break;

      case 254: // const_sint
        value.move< int64_t > (s.value);
        break;

      case 276: // opt_attributes
        value.move< std::optional<hilti::AttributeSet> > (s.value);
        break;

      case 196: // opt_func_default_expr
        value.move< std::optional<hilti::Expression> > (s.value);
        break;

      case 202: // opt_else_block
        value.move< std::optional<hilti::Statement> > (s.value);
        break;

      case 170: // global_scope_items
        value.move< std::pair<std::vector<hilti::Declaration>, std::vector<hilti::Statement>> > (s.value);
        break;

      case 3: // "identifier"
      case 4: // "scoped identifier"
      case 5: // "scoped ~finally"
      case 6: // "dotted identifier"
      case 7: // "attribute"
      case 8: // "property"
      case 9: // "string value"
      case 10: // "bytes value"
      case 11: // "regular expression value"
      case 12: // "address value"
      case 13: // "port value"
      case 269: // re_pattern_constant
        value.move< std::string > (s.value);
        break;

      case 222: // struct_fields
      case 225: // opt_union_fields
      case 226: // union_fields
        value.move< std::vector<hilti::Declaration> > (s.value);
        break;

      case 177: // opt_type_arguments
      case 232: // opt_exprs
      case 233: // exprs
      case 257: // opt_tuple_elems1
      case 258: // opt_tuple_elems2
        value.move< std::vector<hilti::Expression> > (s.value);
        break;

      case 199: // opt_stmts
      case 200: // stmts
        value.move< std::vector<hilti::Statement> > (s.value);
        break;

      case 272: // opt_map_elems
      case 273: // map_elems
        value.move< std::vector<hilti::ctor::map::Element> > (s.value);
        break;

      case 265: // struct_elems
        value.move< std::vector<hilti::ctor::struct_::Field> > (s.value);
        break;

      case 203: // opt_switch_cases
      case 204: // switch_cases
        value.move< std::vector<hilti::statement::switch_::Case> > (s.value);
        break;

      case 206: // try_catches
        value.move< std::vector<hilti::statement::try_::Catch> > (s.value);
        break;

      case 229: // enum_labels
        value.move< std::vector<hilti::type::enum_::Label> > (s.value);
        break;

      case 191: // opt_func_params
      case 192: // func_params
      case 221: // opt_struct_params
        value.move< std::vector<hilti::type::function::Parameter> > (s.value);
        break;

      case 218: // tuple_type_elems
        value.move< std::vector<hilti::type::tuple::Element> > (s.value);
        break;

      case 268: // re_patterns
        value.move< std::vector<std::string> > (s.value);
        break;

      case 15: // "unsigned integer value"
      case 255: // const_uint
        value.move< uint64_t > (s.value);
        break;

      default:
        break;
    }

    location = s.location;
  }

  // by_type.
  inline
  Parser::by_type::by_type ()
    : type (empty_symbol)
  {}

  inline
  Parser::by_type::by_type (const by_type& other)
    : type (other.type)
  {}

  inline
  Parser::by_type::by_type (token_type t)
    : type (yytranslate_ (t))
  {}

  inline
  void
  Parser::by_type::clear ()
  {
    type = empty_symbol;
  }

  inline
  void
  Parser::by_type::move (by_type& that)
  {
    type = that.type;
    that.clear ();
  }

  inline
  int
  Parser::by_type::type_get () const
  {
    return type;
  }
  // Implementation of make_symbol for each symbol type.
  Parser::symbol_type
  Parser::make_EOD (const location_type& l)
  {
    return symbol_type (token::EOD, l);
  }

  Parser::symbol_type
  Parser::make_IDENT (const std::string& v, const location_type& l)
  {
    return symbol_type (token::IDENT, v, l);
  }

  Parser::symbol_type
  Parser::make_SCOPED_IDENT (const std::string& v, const location_type& l)
  {
    return symbol_type (token::SCOPED_IDENT, v, l);
  }

  Parser::symbol_type
  Parser::make_SCOPED_FINALIZE (const std::string& v, const location_type& l)
  {
    return symbol_type (token::SCOPED_FINALIZE, v, l);
  }

  Parser::symbol_type
  Parser::make_DOTTED_IDENT (const std::string& v, const location_type& l)
  {
    return symbol_type (token::DOTTED_IDENT, v, l);
  }

  Parser::symbol_type
  Parser::make_ATTRIBUTE (const std::string& v, const location_type& l)
  {
    return symbol_type (token::ATTRIBUTE, v, l);
  }

  Parser::symbol_type
  Parser::make_PROPERTY (const std::string& v, const location_type& l)
  {
    return symbol_type (token::PROPERTY, v, l);
  }

  Parser::symbol_type
  Parser::make_CSTRING (const std::string& v, const location_type& l)
  {
    return symbol_type (token::CSTRING, v, l);
  }

  Parser::symbol_type
  Parser::make_CBYTES (const std::string& v, const location_type& l)
  {
    return symbol_type (token::CBYTES, v, l);
  }

  Parser::symbol_type
  Parser::make_CREGEXP (const std::string& v, const location_type& l)
  {
    return symbol_type (token::CREGEXP, v, l);
  }

  Parser::symbol_type
  Parser::make_CADDRESS (const std::string& v, const location_type& l)
  {
    return symbol_type (token::CADDRESS, v, l);
  }

  Parser::symbol_type
  Parser::make_CPORT (const std::string& v, const location_type& l)
  {
    return symbol_type (token::CPORT, v, l);
  }

  Parser::symbol_type
  Parser::make_CUREAL (const double& v, const location_type& l)
  {
    return symbol_type (token::CUREAL, v, l);
  }

  Parser::symbol_type
  Parser::make_CUINTEGER (const uint64_t& v, const location_type& l)
  {
    return symbol_type (token::CUINTEGER, v, l);
  }

  Parser::symbol_type
  Parser::make_CBOOL (const bool& v, const location_type& l)
  {
    return symbol_type (token::CBOOL, v, l);
  }

  Parser::symbol_type
  Parser::make_ADD (const location_type& l)
  {
    return symbol_type (token::ADD, l);
  }

  Parser::symbol_type
  Parser::make_ASSERT (const location_type& l)
  {
    return symbol_type (token::ASSERT, l);
  }

  Parser::symbol_type
  Parser::make_ASSERT_EXCEPTION (const location_type& l)
  {
    return symbol_type (token::ASSERT_EXCEPTION, l);
  }

  Parser::symbol_type
  Parser::make_ADDRESS (const location_type& l)
  {
    return symbol_type (token::ADDRESS, l);
  }

  Parser::symbol_type
  Parser::make_AFTER (const location_type& l)
  {
    return symbol_type (token::AFTER, l);
  }

  Parser::symbol_type
  Parser::make_AND (const location_type& l)
  {
    return symbol_type (token::AND, l);
  }

  Parser::symbol_type
  Parser::make_ANY (const location_type& l)
  {
    return symbol_type (token::ANY, l);
  }

  Parser::symbol_type
  Parser::make_ARROW (const location_type& l)
  {
    return symbol_type (token::ARROW, l);
  }

  Parser::symbol_type
  Parser::make_AUTO (const location_type& l)
  {
    return symbol_type (token::AUTO, l);
  }

  Parser::symbol_type
  Parser::make_AT (const location_type& l)
  {
    return symbol_type (token::AT, l);
  }

  Parser::symbol_type
  Parser::make_BEGIN_ (const location_type& l)
  {
    return symbol_type (token::BEGIN_, l);
  }

  Parser::symbol_type
  Parser::make_BOOL (const location_type& l)
  {
    return symbol_type (token::BOOL, l);
  }

  Parser::symbol_type
  Parser::make_BREAK (const location_type& l)
  {
    return symbol_type (token::BREAK, l);
  }

  Parser::symbol_type
  Parser::make_BYTES (const location_type& l)
  {
    return symbol_type (token::BYTES, l);
  }

  Parser::symbol_type
  Parser::make_CADDR (const location_type& l)
  {
    return symbol_type (token::CADDR, l);
  }

  Parser::symbol_type
  Parser::make_CALLABLE (const location_type& l)
  {
    return symbol_type (token::CALLABLE, l);
  }

  Parser::symbol_type
  Parser::make_CASE (const location_type& l)
  {
    return symbol_type (token::CASE, l);
  }

  Parser::symbol_type
  Parser::make_CAST (const location_type& l)
  {
    return symbol_type (token::CAST, l);
  }

  Parser::symbol_type
  Parser::make_CATCH (const location_type& l)
  {
    return symbol_type (token::CATCH, l);
  }

  Parser::symbol_type
  Parser::make_CHANNEL (const location_type& l)
  {
    return symbol_type (token::CHANNEL, l);
  }

  Parser::symbol_type
  Parser::make_CLASSIFIER (const location_type& l)
  {
    return symbol_type (token::CLASSIFIER, l);
  }

  Parser::symbol_type
  Parser::make_CNULL (const location_type& l)
  {
    return symbol_type (token::CNULL, l);
  }

  Parser::symbol_type
  Parser::make_CONST (const location_type& l)
  {
    return symbol_type (token::CONST, l);
  }

  Parser::symbol_type
  Parser::make_CONTINUE (const location_type& l)
  {
    return symbol_type (token::CONTINUE, l);
  }

  Parser::symbol_type
  Parser::make_CONTEXT (const location_type& l)
  {
    return symbol_type (token::CONTEXT, l);
  }

  Parser::symbol_type
  Parser::make_COPY (const location_type& l)
  {
    return symbol_type (token::COPY, l);
  }

  Parser::symbol_type
  Parser::make_DECLARE (const location_type& l)
  {
    return symbol_type (token::DECLARE, l);
  }

  Parser::symbol_type
  Parser::make_DEFAULT (const location_type& l)
  {
    return symbol_type (token::DEFAULT, l);
  }

  Parser::symbol_type
  Parser::make_DELETE (const location_type& l)
  {
    return symbol_type (token::DELETE, l);
  }

  Parser::symbol_type
  Parser::make_DIVIDEASSIGN (const location_type& l)
  {
    return symbol_type (token::DIVIDEASSIGN, l);
  }

  Parser::symbol_type
  Parser::make_DOLLARDOLLAR (const location_type& l)
  {
    return symbol_type (token::DOLLARDOLLAR, l);
  }

  Parser::symbol_type
  Parser::make_DOTDOT (const location_type& l)
  {
    return symbol_type (token::DOTDOT, l);
  }

  Parser::symbol_type
  Parser::make_REAL (const location_type& l)
  {
    return symbol_type (token::REAL, l);
  }

  Parser::symbol_type
  Parser::make_ELSE (const location_type& l)
  {
    return symbol_type (token::ELSE, l);
  }

  Parser::symbol_type
  Parser::make_END_ (const location_type& l)
  {
    return symbol_type (token::END_, l);
  }

  Parser::symbol_type
  Parser::make_ENUM (const location_type& l)
  {
    return symbol_type (token::ENUM, l);
  }

  Parser::symbol_type
  Parser::make_EQ (const location_type& l)
  {
    return symbol_type (token::EQ, l);
  }

  Parser::symbol_type
  Parser::make_ERROR (const location_type& l)
  {
    return symbol_type (token::ERROR, l);
  }

  Parser::symbol_type
  Parser::make_EXCEPTION (const location_type& l)
  {
    return symbol_type (token::EXCEPTION, l);
  }

  Parser::symbol_type
  Parser::make_EXPORT (const location_type& l)
  {
    return symbol_type (token::EXPORT, l);
  }

  Parser::symbol_type
  Parser::make_EXTERN (const location_type& l)
  {
    return symbol_type (token::EXTERN, l);
  }

  Parser::symbol_type
  Parser::make_EXTERN_NO_SUSPEND (const location_type& l)
  {
    return symbol_type (token::EXTERN_NO_SUSPEND, l);
  }

  Parser::symbol_type
  Parser::make_FILE (const location_type& l)
  {
    return symbol_type (token::FILE, l);
  }

  Parser::symbol_type
  Parser::make_FINALIZE (const location_type& l)
  {
    return symbol_type (token::FINALIZE, l);
  }

  Parser::symbol_type
  Parser::make_FOR (const location_type& l)
  {
    return symbol_type (token::FOR, l);
  }

  Parser::symbol_type
  Parser::make_FROM (const location_type& l)
  {
    return symbol_type (token::FROM, l);
  }

  Parser::symbol_type
  Parser::make_FUNCTION (const location_type& l)
  {
    return symbol_type (token::FUNCTION, l);
  }

  Parser::symbol_type
  Parser::make_GEQ (const location_type& l)
  {
    return symbol_type (token::GEQ, l);
  }

  Parser::symbol_type
  Parser::make_GLOBAL (const location_type& l)
  {
    return symbol_type (token::GLOBAL, l);
  }

  Parser::symbol_type
  Parser::make_HASATTR (const location_type& l)
  {
    return symbol_type (token::HASATTR, l);
  }

  Parser::symbol_type
  Parser::make_HOOK (const location_type& l)
  {
    return symbol_type (token::HOOK, l);
  }

  Parser::symbol_type
  Parser::make_IF (const location_type& l)
  {
    return symbol_type (token::IF, l);
  }

  Parser::symbol_type
  Parser::make_IMPORT (const location_type& l)
  {
    return symbol_type (token::IMPORT, l);
  }

  Parser::symbol_type
  Parser::make_IN (const location_type& l)
  {
    return symbol_type (token::IN, l);
  }

  Parser::symbol_type
  Parser::make_INIT (const location_type& l)
  {
    return symbol_type (token::INIT, l);
  }

  Parser::symbol_type
  Parser::make_INOUT (const location_type& l)
  {
    return symbol_type (token::INOUT, l);
  }

  Parser::symbol_type
  Parser::make_INT (const location_type& l)
  {
    return symbol_type (token::INT, l);
  }

  Parser::symbol_type
  Parser::make_INTERVAL (const location_type& l)
  {
    return symbol_type (token::INTERVAL, l);
  }

  Parser::symbol_type
  Parser::make_IOSRC (const location_type& l)
  {
    return symbol_type (token::IOSRC, l);
  }

  Parser::symbol_type
  Parser::make_ITERATOR (const location_type& l)
  {
    return symbol_type (token::ITERATOR, l);
  }

  Parser::symbol_type
  Parser::make_CONST_ITERATOR (const location_type& l)
  {
    return symbol_type (token::CONST_ITERATOR, l);
  }

  Parser::symbol_type
  Parser::make_LEQ (const location_type& l)
  {
    return symbol_type (token::LEQ, l);
  }

  Parser::symbol_type
  Parser::make_LIBRARY_TYPE (const location_type& l)
  {
    return symbol_type (token::LIBRARY_TYPE, l);
  }

  Parser::symbol_type
  Parser::make_LIST (const location_type& l)
  {
    return symbol_type (token::LIST, l);
  }

  Parser::symbol_type
  Parser::make_LOCAL (const location_type& l)
  {
    return symbol_type (token::LOCAL, l);
  }

  Parser::symbol_type
  Parser::make_MAP (const location_type& l)
  {
    return symbol_type (token::MAP, l);
  }

  Parser::symbol_type
  Parser::make_MATCH_TOKEN_STATE (const location_type& l)
  {
    return symbol_type (token::MATCH_TOKEN_STATE, l);
  }

  Parser::symbol_type
  Parser::make_METHOD (const location_type& l)
  {
    return symbol_type (token::METHOD, l);
  }

  Parser::symbol_type
  Parser::make_MINUSASSIGN (const location_type& l)
  {
    return symbol_type (token::MINUSASSIGN, l);
  }

  Parser::symbol_type
  Parser::make_MINUSMINUS (const location_type& l)
  {
    return symbol_type (token::MINUSMINUS, l);
  }

  Parser::symbol_type
  Parser::make_MOD (const location_type& l)
  {
    return symbol_type (token::MOD, l);
  }

  Parser::symbol_type
  Parser::make_MODULE (const location_type& l)
  {
    return symbol_type (token::MODULE, l);
  }

  Parser::symbol_type
  Parser::make_MOVE (const location_type& l)
  {
    return symbol_type (token::MOVE, l);
  }

  Parser::symbol_type
  Parser::make_NEW (const location_type& l)
  {
    return symbol_type (token::NEW, l);
  }

  Parser::symbol_type
  Parser::make_NEQ (const location_type& l)
  {
    return symbol_type (token::NEQ, l);
  }

  Parser::symbol_type
  Parser::make_NETWORK (const location_type& l)
  {
    return symbol_type (token::NETWORK, l);
  }

  Parser::symbol_type
  Parser::make_NOT_IN (const location_type& l)
  {
    return symbol_type (token::NOT_IN, l);
  }

  Parser::symbol_type
  Parser::make_OPTIONAL (const location_type& l)
  {
    return symbol_type (token::OPTIONAL, l);
  }

  Parser::symbol_type
  Parser::make_OR (const location_type& l)
  {
    return symbol_type (token::OR, l);
  }

  Parser::symbol_type
  Parser::make_OVERLAY (const location_type& l)
  {
    return symbol_type (token::OVERLAY, l);
  }

  Parser::symbol_type
  Parser::make_PLUSASSIGN (const location_type& l)
  {
    return symbol_type (token::PLUSASSIGN, l);
  }

  Parser::symbol_type
  Parser::make_PLUSPLUS (const location_type& l)
  {
    return symbol_type (token::PLUSPLUS, l);
  }

  Parser::symbol_type
  Parser::make_PORT (const location_type& l)
  {
    return symbol_type (token::PORT, l);
  }

  Parser::symbol_type
  Parser::make_POW (const location_type& l)
  {
    return symbol_type (token::POW, l);
  }

  Parser::symbol_type
  Parser::make_PREINIT (const location_type& l)
  {
    return symbol_type (token::PREINIT, l);
  }

  Parser::symbol_type
  Parser::make_PRIVATE (const location_type& l)
  {
    return symbol_type (token::PRIVATE, l);
  }

  Parser::symbol_type
  Parser::make_PUBLIC (const location_type& l)
  {
    return symbol_type (token::PUBLIC, l);
  }

  Parser::symbol_type
  Parser::make_STRONG_REF (const location_type& l)
  {
    return symbol_type (token::STRONG_REF, l);
  }

  Parser::symbol_type
  Parser::make_REGEXP (const location_type& l)
  {
    return symbol_type (token::REGEXP, l);
  }

  Parser::symbol_type
  Parser::make_RESULT (const location_type& l)
  {
    return symbol_type (token::RESULT, l);
  }

  Parser::symbol_type
  Parser::make_RETURN (const location_type& l)
  {
    return symbol_type (token::RETURN, l);
  }

  Parser::symbol_type
  Parser::make_SCOPE (const location_type& l)
  {
    return symbol_type (token::SCOPE, l);
  }

  Parser::symbol_type
  Parser::make_SET (const location_type& l)
  {
    return symbol_type (token::SET, l);
  }

  Parser::symbol_type
  Parser::make_SHIFTLEFT (const location_type& l)
  {
    return symbol_type (token::SHIFTLEFT, l);
  }

  Parser::symbol_type
  Parser::make_SHIFTRIGHT (const location_type& l)
  {
    return symbol_type (token::SHIFTRIGHT, l);
  }

  Parser::symbol_type
  Parser::make_STREAM (const location_type& l)
  {
    return symbol_type (token::STREAM, l);
  }

  Parser::symbol_type
  Parser::make_STRING (const location_type& l)
  {
    return symbol_type (token::STRING, l);
  }

  Parser::symbol_type
  Parser::make_STRUCT (const location_type& l)
  {
    return symbol_type (token::STRUCT, l);
  }

  Parser::symbol_type
  Parser::make_SWITCH (const location_type& l)
  {
    return symbol_type (token::SWITCH, l);
  }

  Parser::symbol_type
  Parser::make_TIME (const location_type& l)
  {
    return symbol_type (token::TIME, l);
  }

  Parser::symbol_type
  Parser::make_TIMER (const location_type& l)
  {
    return symbol_type (token::TIMER, l);
  }

  Parser::symbol_type
  Parser::make_TIMERMGR (const location_type& l)
  {
    return symbol_type (token::TIMERMGR, l);
  }

  Parser::symbol_type
  Parser::make_TIMESASSIGN (const location_type& l)
  {
    return symbol_type (token::TIMESASSIGN, l);
  }

  Parser::symbol_type
  Parser::make_THROW (const location_type& l)
  {
    return symbol_type (token::THROW, l);
  }

  Parser::symbol_type
  Parser::make_TRY (const location_type& l)
  {
    return symbol_type (token::TRY, l);
  }

  Parser::symbol_type
  Parser::make_TRYATTR (const location_type& l)
  {
    return symbol_type (token::TRYATTR, l);
  }

  Parser::symbol_type
  Parser::make_TUPLE (const location_type& l)
  {
    return symbol_type (token::TUPLE, l);
  }

  Parser::symbol_type
  Parser::make_TYPE (const location_type& l)
  {
    return symbol_type (token::TYPE, l);
  }

  Parser::symbol_type
  Parser::make_TYPEINFO (const location_type& l)
  {
    return symbol_type (token::TYPEINFO, l);
  }

  Parser::symbol_type
  Parser::make_UINT (const location_type& l)
  {
    return symbol_type (token::UINT, l);
  }

  Parser::symbol_type
  Parser::make_UNION (const location_type& l)
  {
    return symbol_type (token::UNION, l);
  }

  Parser::symbol_type
  Parser::make_UNPACK (const location_type& l)
  {
    return symbol_type (token::UNPACK, l);
  }

  Parser::symbol_type
  Parser::make_UNSET (const location_type& l)
  {
    return symbol_type (token::UNSET, l);
  }

  Parser::symbol_type
  Parser::make_VECTOR (const location_type& l)
  {
    return symbol_type (token::VECTOR, l);
  }

  Parser::symbol_type
  Parser::make_VIEW (const location_type& l)
  {
    return symbol_type (token::VIEW, l);
  }

  Parser::symbol_type
  Parser::make_VOID (const location_type& l)
  {
    return symbol_type (token::VOID, l);
  }

  Parser::symbol_type
  Parser::make_WHILE (const location_type& l)
  {
    return symbol_type (token::WHILE, l);
  }

  Parser::symbol_type
  Parser::make_WITH (const location_type& l)
  {
    return symbol_type (token::WITH, l);
  }

  Parser::symbol_type
  Parser::make_VALUE_REF (const location_type& l)
  {
    return symbol_type (token::VALUE_REF, l);
  }

  Parser::symbol_type
  Parser::make_WEAK_REF (const location_type& l)
  {
    return symbol_type (token::WEAK_REF, l);
  }

  Parser::symbol_type
  Parser::make_YIELD (const location_type& l)
  {
    return symbol_type (token::YIELD, l);
  }



  // by_state.
  inline
  Parser::by_state::by_state ()
    : state (empty_state)
  {}

  inline
  Parser::by_state::by_state (const by_state& other)
    : state (other.state)
  {}

  inline
  void
  Parser::by_state::clear ()
  {
    state = empty_state;
  }

  inline
  void
  Parser::by_state::move (by_state& that)
  {
    state = that.state;
    that.clear ();
  }

  inline
  Parser::by_state::by_state (state_type s)
    : state (s)
  {}

  inline
  Parser::symbol_number_type
  Parser::by_state::type_get () const
  {
    if (state == empty_state)
      return empty_symbol;
    else
      return yystos_[state];
  }

  inline
  Parser::stack_symbol_type::stack_symbol_type ()
  {}


  inline
  Parser::stack_symbol_type::stack_symbol_type (state_type s, symbol_type& that)
    : super_type (s, that.location)
  {
      switch (that.type_get ())
    {
      case 16: // "bool value"
        value.move< bool > (that.value);
        break;

      case 14: // "real value"
      case 253: // const_real
        value.move< double > (that.value);
        break;

      case 275: // attribute
        value.move< hilti::Attribute > (that.value);
        break;

      case 252: // ctor
      case 256: // tuple
      case 261: // list
      case 262: // set
      case 263: // map
      case 264: // struct_
      case 267: // regexp
        value.move< hilti::Ctor > (that.value);
        break;

      case 171: // global_scope_decl
      case 172: // type_decl
      case 173: // constant_decl
      case 174: // local_decl
      case 175: // local_init_decl
      case 176: // global_decl
      case 178: // function_decl
      case 179: // import_decl
      case 180: // property_decl
      case 223: // struct_field
      case 227: // union_field
        value.move< hilti::Declaration > (that.value);
        break;

      case 231: // expr
      case 234: // expr_0
      case 235: // expr_1
      case 236: // expr_2
      case 237: // expr_3
      case 238: // expr_4
      case 239: // expr_5
      case 240: // expr_6
      case 241: // expr_7
      case 242: // expr_8
      case 243: // expr_9
      case 244: // expr_a
      case 245: // expr_b
      case 246: // expr_c
      case 247: // expr_d
      case 248: // expr_e
      case 249: // expr_f
      case 250: // expr_g
      case 251: // member_expr
      case 259: // tuple_elem
      case 260: // tuple_expr
        value.move< hilti::Expression > (that.value);
        break;

      case 184: // function_with_body
      case 185: // method_with_body
      case 186: // hook_with_body
      case 187: // function_without_body
        value.move< hilti::Function > (that.value);
        break;

      case 165: // local_id
      case 166: // scoped_id
      case 167: // dotted_id
      case 182: // function_id
      case 183: // scoped_function_id
        value.move< hilti::ID > (that.value);
        break;

      case 197: // block
      case 198: // braced_block
      case 201: // stmt
      case 208: // stmt_decl
      case 209: // stmt_expr
        value.move< hilti::Statement > (that.value);
        break;

      case 210: // base_type_no_attrs
      case 211: // base_type
      case 212: // type
      case 216: // function_type
      case 217: // tuple_type
      case 220: // struct_type
      case 224: // union_type
      case 228: // enum_type
        value.move< hilti::Type > (that.value);
        break;

      case 274: // map_elem
        value.move< hilti::ctor::map::Element > (that.value);
        break;

      case 266: // struct_elem
        value.move< hilti::ctor::struct_::Field > (that.value);
        break;

      case 181: // opt_linkage
        value.move< hilti::declaration::Linkage > (that.value);
        break;

      case 195: // opt_func_param_kind
        value.move< hilti::declaration::parameter::Kind > (that.value);
        break;

      case 190: // opt_func_cc
        value.move< hilti::function::CallingConvention > (that.value);
        break;

      case 205: // switch_case
        value.move< hilti::statement::switch_::Case > (that.value);
        break;

      case 207: // try_catch
        value.move< hilti::statement::try_::Catch > (that.value);
        break;

      case 215: // opt_type_flags
        value.move< hilti::type::Flags > (that.value);
        break;

      case 230: // enum_label
        value.move< hilti::type::enum_::Label > (that.value);
        break;

      case 188: // opt_func_flavor
      case 189: // func_flavor
        value.move< hilti::type::function::Flavor > (that.value);
        break;

      case 193: // func_param
        value.move< hilti::type::function::Parameter > (that.value);
        break;

      case 194: // func_result
        value.move< hilti::type::function::Result > (that.value);
        break;

      case 219: // tuple_type_elem
        value.move< hilti::type::tuple::Element > (that.value);
        break;

      case 254: // const_sint
        value.move< int64_t > (that.value);
        break;

      case 276: // opt_attributes
        value.move< std::optional<hilti::AttributeSet> > (that.value);
        break;

      case 196: // opt_func_default_expr
        value.move< std::optional<hilti::Expression> > (that.value);
        break;

      case 202: // opt_else_block
        value.move< std::optional<hilti::Statement> > (that.value);
        break;

      case 170: // global_scope_items
        value.move< std::pair<std::vector<hilti::Declaration>, std::vector<hilti::Statement>> > (that.value);
        break;

      case 3: // "identifier"
      case 4: // "scoped identifier"
      case 5: // "scoped ~finally"
      case 6: // "dotted identifier"
      case 7: // "attribute"
      case 8: // "property"
      case 9: // "string value"
      case 10: // "bytes value"
      case 11: // "regular expression value"
      case 12: // "address value"
      case 13: // "port value"
      case 269: // re_pattern_constant
        value.move< std::string > (that.value);
        break;

      case 222: // struct_fields
      case 225: // opt_union_fields
      case 226: // union_fields
        value.move< std::vector<hilti::Declaration> > (that.value);
        break;

      case 177: // opt_type_arguments
      case 232: // opt_exprs
      case 233: // exprs
      case 257: // opt_tuple_elems1
      case 258: // opt_tuple_elems2
        value.move< std::vector<hilti::Expression> > (that.value);
        break;

      case 199: // opt_stmts
      case 200: // stmts
        value.move< std::vector<hilti::Statement> > (that.value);
        break;

      case 272: // opt_map_elems
      case 273: // map_elems
        value.move< std::vector<hilti::ctor::map::Element> > (that.value);
        break;

      case 265: // struct_elems
        value.move< std::vector<hilti::ctor::struct_::Field> > (that.value);
        break;

      case 203: // opt_switch_cases
      case 204: // switch_cases
        value.move< std::vector<hilti::statement::switch_::Case> > (that.value);
        break;

      case 206: // try_catches
        value.move< std::vector<hilti::statement::try_::Catch> > (that.value);
        break;

      case 229: // enum_labels
        value.move< std::vector<hilti::type::enum_::Label> > (that.value);
        break;

      case 191: // opt_func_params
      case 192: // func_params
      case 221: // opt_struct_params
        value.move< std::vector<hilti::type::function::Parameter> > (that.value);
        break;

      case 218: // tuple_type_elems
        value.move< std::vector<hilti::type::tuple::Element> > (that.value);
        break;

      case 268: // re_patterns
        value.move< std::vector<std::string> > (that.value);
        break;

      case 15: // "unsigned integer value"
      case 255: // const_uint
        value.move< uint64_t > (that.value);
        break;

      default:
        break;
    }

    // that is emptied.
    that.type = empty_symbol;
  }

  inline
  Parser::stack_symbol_type&
  Parser::stack_symbol_type::operator= (const stack_symbol_type& that)
  {
    state = that.state;
      switch (that.type_get ())
    {
      case 16: // "bool value"
        value.copy< bool > (that.value);
        break;

      case 14: // "real value"
      case 253: // const_real
        value.copy< double > (that.value);
        break;

      case 275: // attribute
        value.copy< hilti::Attribute > (that.value);
        break;

      case 252: // ctor
      case 256: // tuple
      case 261: // list
      case 262: // set
      case 263: // map
      case 264: // struct_
      case 267: // regexp
        value.copy< hilti::Ctor > (that.value);
        break;

      case 171: // global_scope_decl
      case 172: // type_decl
      case 173: // constant_decl
      case 174: // local_decl
      case 175: // local_init_decl
      case 176: // global_decl
      case 178: // function_decl
      case 179: // import_decl
      case 180: // property_decl
      case 223: // struct_field
      case 227: // union_field
        value.copy< hilti::Declaration > (that.value);
        break;

      case 231: // expr
      case 234: // expr_0
      case 235: // expr_1
      case 236: // expr_2
      case 237: // expr_3
      case 238: // expr_4
      case 239: // expr_5
      case 240: // expr_6
      case 241: // expr_7
      case 242: // expr_8
      case 243: // expr_9
      case 244: // expr_a
      case 245: // expr_b
      case 246: // expr_c
      case 247: // expr_d
      case 248: // expr_e
      case 249: // expr_f
      case 250: // expr_g
      case 251: // member_expr
      case 259: // tuple_elem
      case 260: // tuple_expr
        value.copy< hilti::Expression > (that.value);
        break;

      case 184: // function_with_body
      case 185: // method_with_body
      case 186: // hook_with_body
      case 187: // function_without_body
        value.copy< hilti::Function > (that.value);
        break;

      case 165: // local_id
      case 166: // scoped_id
      case 167: // dotted_id
      case 182: // function_id
      case 183: // scoped_function_id
        value.copy< hilti::ID > (that.value);
        break;

      case 197: // block
      case 198: // braced_block
      case 201: // stmt
      case 208: // stmt_decl
      case 209: // stmt_expr
        value.copy< hilti::Statement > (that.value);
        break;

      case 210: // base_type_no_attrs
      case 211: // base_type
      case 212: // type
      case 216: // function_type
      case 217: // tuple_type
      case 220: // struct_type
      case 224: // union_type
      case 228: // enum_type
        value.copy< hilti::Type > (that.value);
        break;

      case 274: // map_elem
        value.copy< hilti::ctor::map::Element > (that.value);
        break;

      case 266: // struct_elem
        value.copy< hilti::ctor::struct_::Field > (that.value);
        break;

      case 181: // opt_linkage
        value.copy< hilti::declaration::Linkage > (that.value);
        break;

      case 195: // opt_func_param_kind
        value.copy< hilti::declaration::parameter::Kind > (that.value);
        break;

      case 190: // opt_func_cc
        value.copy< hilti::function::CallingConvention > (that.value);
        break;

      case 205: // switch_case
        value.copy< hilti::statement::switch_::Case > (that.value);
        break;

      case 207: // try_catch
        value.copy< hilti::statement::try_::Catch > (that.value);
        break;

      case 215: // opt_type_flags
        value.copy< hilti::type::Flags > (that.value);
        break;

      case 230: // enum_label
        value.copy< hilti::type::enum_::Label > (that.value);
        break;

      case 188: // opt_func_flavor
      case 189: // func_flavor
        value.copy< hilti::type::function::Flavor > (that.value);
        break;

      case 193: // func_param
        value.copy< hilti::type::function::Parameter > (that.value);
        break;

      case 194: // func_result
        value.copy< hilti::type::function::Result > (that.value);
        break;

      case 219: // tuple_type_elem
        value.copy< hilti::type::tuple::Element > (that.value);
        break;

      case 254: // const_sint
        value.copy< int64_t > (that.value);
        break;

      case 276: // opt_attributes
        value.copy< std::optional<hilti::AttributeSet> > (that.value);
        break;

      case 196: // opt_func_default_expr
        value.copy< std::optional<hilti::Expression> > (that.value);
        break;

      case 202: // opt_else_block
        value.copy< std::optional<hilti::Statement> > (that.value);
        break;

      case 170: // global_scope_items
        value.copy< std::pair<std::vector<hilti::Declaration>, std::vector<hilti::Statement>> > (that.value);
        break;

      case 3: // "identifier"
      case 4: // "scoped identifier"
      case 5: // "scoped ~finally"
      case 6: // "dotted identifier"
      case 7: // "attribute"
      case 8: // "property"
      case 9: // "string value"
      case 10: // "bytes value"
      case 11: // "regular expression value"
      case 12: // "address value"
      case 13: // "port value"
      case 269: // re_pattern_constant
        value.copy< std::string > (that.value);
        break;

      case 222: // struct_fields
      case 225: // opt_union_fields
      case 226: // union_fields
        value.copy< std::vector<hilti::Declaration> > (that.value);
        break;

      case 177: // opt_type_arguments
      case 232: // opt_exprs
      case 233: // exprs
      case 257: // opt_tuple_elems1
      case 258: // opt_tuple_elems2
        value.copy< std::vector<hilti::Expression> > (that.value);
        break;

      case 199: // opt_stmts
      case 200: // stmts
        value.copy< std::vector<hilti::Statement> > (that.value);
        break;

      case 272: // opt_map_elems
      case 273: // map_elems
        value.copy< std::vector<hilti::ctor::map::Element> > (that.value);
        break;

      case 265: // struct_elems
        value.copy< std::vector<hilti::ctor::struct_::Field> > (that.value);
        break;

      case 203: // opt_switch_cases
      case 204: // switch_cases
        value.copy< std::vector<hilti::statement::switch_::Case> > (that.value);
        break;

      case 206: // try_catches
        value.copy< std::vector<hilti::statement::try_::Catch> > (that.value);
        break;

      case 229: // enum_labels
        value.copy< std::vector<hilti::type::enum_::Label> > (that.value);
        break;

      case 191: // opt_func_params
      case 192: // func_params
      case 221: // opt_struct_params
        value.copy< std::vector<hilti::type::function::Parameter> > (that.value);
        break;

      case 218: // tuple_type_elems
        value.copy< std::vector<hilti::type::tuple::Element> > (that.value);
        break;

      case 268: // re_patterns
        value.copy< std::vector<std::string> > (that.value);
        break;

      case 15: // "unsigned integer value"
      case 255: // const_uint
        value.copy< uint64_t > (that.value);
        break;

      default:
        break;
    }

    location = that.location;
    return *this;
  }


  template <typename Base>
  inline
  void
  Parser::yy_destroy_ (const char* yymsg, basic_symbol<Base>& yysym) const
  {
    if (yymsg)
      YY_SYMBOL_PRINT (yymsg, yysym);
  }

#if YYDEBUG
  template <typename Base>
  void
  Parser::yy_print_ (std::ostream& yyo,
                                     const basic_symbol<Base>& yysym) const
  {
    std::ostream& yyoutput = yyo;
    YYUSE (yyoutput);
    symbol_number_type yytype = yysym.type_get ();
    // Avoid a (spurious) G++ 4.8 warning about "array subscript is
    // below array bounds".
    if (yysym.empty ())
      std::abort ();
    yyo << (yytype < yyntokens_ ? "token" : "nterm")
        << ' ' << yytname_[yytype] << " ("
        << yysym.location << ": ";
    YYUSE (yytype);
    yyo << ')';
  }
#endif

  inline
  void
  Parser::yypush_ (const char* m, state_type s, symbol_type& sym)
  {
    stack_symbol_type t (s, sym);
    yypush_ (m, t);
  }

  inline
  void
  Parser::yypush_ (const char* m, stack_symbol_type& s)
  {
    if (m)
      YY_SYMBOL_PRINT (m, s);
    yystack_.push (s);
  }

  inline
  void
  Parser::yypop_ (unsigned int n)
  {
    yystack_.pop (n);
  }

#if YYDEBUG
  std::ostream&
  Parser::debug_stream () const
  {
    return *yycdebug_;
  }

  void
  Parser::set_debug_stream (std::ostream& o)
  {
    yycdebug_ = &o;
  }


  Parser::debug_level_type
  Parser::debug_level () const
  {
    return yydebug_;
  }

  void
  Parser::set_debug_level (debug_level_type l)
  {
    yydebug_ = l;
  }
#endif // YYDEBUG

  inline Parser::state_type
  Parser::yy_lr_goto_state_ (state_type yystate, int yysym)
  {
    int yyr = yypgoto_[yysym - yyntokens_] + yystate;
    if (0 <= yyr && yyr <= yylast_ && yycheck_[yyr] == yystate)
      return yytable_[yyr];
    else
      return yydefgoto_[yysym - yyntokens_];
  }

  inline bool
  Parser::yy_pact_value_is_default_ (int yyvalue)
  {
    return yyvalue == yypact_ninf_;
  }

  inline bool
  Parser::yy_table_value_is_error_ (int yyvalue)
  {
    return yyvalue == yytable_ninf_;
  }

  int
  Parser::parse ()
  {
    // State.
    int yyn;
    /// Length of the RHS of the rule being reduced.
    int yylen = 0;

    // Error handling.
    int yynerrs_ = 0;
    int yyerrstatus_ = 0;

    /// The lookahead symbol.
    symbol_type yyla;

    /// The locations where the error started and ended.
    stack_symbol_type yyerror_range[3];

    /// The return value of parse ().
    int yyresult;

    // FIXME: This shoud be completely indented.  It is not yet to
    // avoid gratuitous conflicts when merging into the master branch.
    try
      {
    YYCDEBUG << "Starting parse" << std::endl;


    // User initialization code.
    #line 20 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:741
{
    yyla.location.begin.filename = yyla.location.end.filename = driver->currentFile();
}

#line 3177 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:741

    /* Initialize the stack.  The initial state will be set in
       yynewstate, since the latter expects the semantical and the
       location values to have been already stored, initialize these
       stacks with a primary value.  */
    yystack_.clear ();
    yypush_ (YY_NULLPTR, 0, yyla);

    // A new symbol was pushed on the stack.
  yynewstate:
    YYCDEBUG << "Entering state " << yystack_[0].state << std::endl;

    // Accept?
    if (yystack_[0].state == yyfinal_)
      goto yyacceptlab;

    goto yybackup;

    // Backup.
  yybackup:

    // Try to take a decision without lookahead.
    yyn = yypact_[yystack_[0].state];
    if (yy_pact_value_is_default_ (yyn))
      goto yydefault;

    // Read a lookahead token.
    if (yyla.empty ())
      {
        YYCDEBUG << "Reading a token: ";
        try
          {
            yyla.type = yytranslate_ (yylex (&yyla.value, &yyla.location, driver));
          }
        catch (const syntax_error& yyexc)
          {
            error (yyexc);
            goto yyerrlab1;
          }
      }
    YY_SYMBOL_PRINT ("Next token is", yyla);

    /* If the proper action on seeing token YYLA.TYPE is to reduce or
       to detect an error, take that action.  */
    yyn += yyla.type_get ();
    if (yyn < 0 || yylast_ < yyn || yycheck_[yyn] != yyla.type_get ())
      goto yydefault;

    // Reduce or error.
    yyn = yytable_[yyn];
    if (yyn <= 0)
      {
        if (yy_table_value_is_error_ (yyn))
          goto yyerrlab;
        yyn = -yyn;
        goto yyreduce;
      }

    // Count tokens shifted since error; after three, turn off error status.
    if (yyerrstatus_)
      --yyerrstatus_;

    // Shift the lookahead token.
    yypush_ ("Shifting", yyn, yyla);
    goto yynewstate;

  /*-----------------------------------------------------------.
  | yydefault -- do the default action for the current state.  |
  `-----------------------------------------------------------*/
  yydefault:
    yyn = yydefact_[yystack_[0].state];
    if (yyn == 0)
      goto yyerrlab;
    goto yyreduce;

  /*-----------------------------.
  | yyreduce -- Do a reduction.  |
  `-----------------------------*/
  yyreduce:
    yylen = yyr2_[yyn];
    {
      stack_symbol_type yylhs;
      yylhs.state = yy_lr_goto_state_(yystack_[yylen].state, yyr1_[yyn]);
      /* Variants are always initialized to an empty instance of the
         correct type. The default '$$ = $1' action is NOT applied
         when using variants.  */
        switch (yyr1_[yyn])
    {
      case 16: // "bool value"
        yylhs.value.build< bool > ();
        break;

      case 14: // "real value"
      case 253: // const_real
        yylhs.value.build< double > ();
        break;

      case 275: // attribute
        yylhs.value.build< hilti::Attribute > ();
        break;

      case 252: // ctor
      case 256: // tuple
      case 261: // list
      case 262: // set
      case 263: // map
      case 264: // struct_
      case 267: // regexp
        yylhs.value.build< hilti::Ctor > ();
        break;

      case 171: // global_scope_decl
      case 172: // type_decl
      case 173: // constant_decl
      case 174: // local_decl
      case 175: // local_init_decl
      case 176: // global_decl
      case 178: // function_decl
      case 179: // import_decl
      case 180: // property_decl
      case 223: // struct_field
      case 227: // union_field
        yylhs.value.build< hilti::Declaration > ();
        break;

      case 231: // expr
      case 234: // expr_0
      case 235: // expr_1
      case 236: // expr_2
      case 237: // expr_3
      case 238: // expr_4
      case 239: // expr_5
      case 240: // expr_6
      case 241: // expr_7
      case 242: // expr_8
      case 243: // expr_9
      case 244: // expr_a
      case 245: // expr_b
      case 246: // expr_c
      case 247: // expr_d
      case 248: // expr_e
      case 249: // expr_f
      case 250: // expr_g
      case 251: // member_expr
      case 259: // tuple_elem
      case 260: // tuple_expr
        yylhs.value.build< hilti::Expression > ();
        break;

      case 184: // function_with_body
      case 185: // method_with_body
      case 186: // hook_with_body
      case 187: // function_without_body
        yylhs.value.build< hilti::Function > ();
        break;

      case 165: // local_id
      case 166: // scoped_id
      case 167: // dotted_id
      case 182: // function_id
      case 183: // scoped_function_id
        yylhs.value.build< hilti::ID > ();
        break;

      case 197: // block
      case 198: // braced_block
      case 201: // stmt
      case 208: // stmt_decl
      case 209: // stmt_expr
        yylhs.value.build< hilti::Statement > ();
        break;

      case 210: // base_type_no_attrs
      case 211: // base_type
      case 212: // type
      case 216: // function_type
      case 217: // tuple_type
      case 220: // struct_type
      case 224: // union_type
      case 228: // enum_type
        yylhs.value.build< hilti::Type > ();
        break;

      case 274: // map_elem
        yylhs.value.build< hilti::ctor::map::Element > ();
        break;

      case 266: // struct_elem
        yylhs.value.build< hilti::ctor::struct_::Field > ();
        break;

      case 181: // opt_linkage
        yylhs.value.build< hilti::declaration::Linkage > ();
        break;

      case 195: // opt_func_param_kind
        yylhs.value.build< hilti::declaration::parameter::Kind > ();
        break;

      case 190: // opt_func_cc
        yylhs.value.build< hilti::function::CallingConvention > ();
        break;

      case 205: // switch_case
        yylhs.value.build< hilti::statement::switch_::Case > ();
        break;

      case 207: // try_catch
        yylhs.value.build< hilti::statement::try_::Catch > ();
        break;

      case 215: // opt_type_flags
        yylhs.value.build< hilti::type::Flags > ();
        break;

      case 230: // enum_label
        yylhs.value.build< hilti::type::enum_::Label > ();
        break;

      case 188: // opt_func_flavor
      case 189: // func_flavor
        yylhs.value.build< hilti::type::function::Flavor > ();
        break;

      case 193: // func_param
        yylhs.value.build< hilti::type::function::Parameter > ();
        break;

      case 194: // func_result
        yylhs.value.build< hilti::type::function::Result > ();
        break;

      case 219: // tuple_type_elem
        yylhs.value.build< hilti::type::tuple::Element > ();
        break;

      case 254: // const_sint
        yylhs.value.build< int64_t > ();
        break;

      case 276: // opt_attributes
        yylhs.value.build< std::optional<hilti::AttributeSet> > ();
        break;

      case 196: // opt_func_default_expr
        yylhs.value.build< std::optional<hilti::Expression> > ();
        break;

      case 202: // opt_else_block
        yylhs.value.build< std::optional<hilti::Statement> > ();
        break;

      case 170: // global_scope_items
        yylhs.value.build< std::pair<std::vector<hilti::Declaration>, std::vector<hilti::Statement>> > ();
        break;

      case 3: // "identifier"
      case 4: // "scoped identifier"
      case 5: // "scoped ~finally"
      case 6: // "dotted identifier"
      case 7: // "attribute"
      case 8: // "property"
      case 9: // "string value"
      case 10: // "bytes value"
      case 11: // "regular expression value"
      case 12: // "address value"
      case 13: // "port value"
      case 269: // re_pattern_constant
        yylhs.value.build< std::string > ();
        break;

      case 222: // struct_fields
      case 225: // opt_union_fields
      case 226: // union_fields
        yylhs.value.build< std::vector<hilti::Declaration> > ();
        break;

      case 177: // opt_type_arguments
      case 232: // opt_exprs
      case 233: // exprs
      case 257: // opt_tuple_elems1
      case 258: // opt_tuple_elems2
        yylhs.value.build< std::vector<hilti::Expression> > ();
        break;

      case 199: // opt_stmts
      case 200: // stmts
        yylhs.value.build< std::vector<hilti::Statement> > ();
        break;

      case 272: // opt_map_elems
      case 273: // map_elems
        yylhs.value.build< std::vector<hilti::ctor::map::Element> > ();
        break;

      case 265: // struct_elems
        yylhs.value.build< std::vector<hilti::ctor::struct_::Field> > ();
        break;

      case 203: // opt_switch_cases
      case 204: // switch_cases
        yylhs.value.build< std::vector<hilti::statement::switch_::Case> > ();
        break;

      case 206: // try_catches
        yylhs.value.build< std::vector<hilti::statement::try_::Catch> > ();
        break;

      case 229: // enum_labels
        yylhs.value.build< std::vector<hilti::type::enum_::Label> > ();
        break;

      case 191: // opt_func_params
      case 192: // func_params
      case 221: // opt_struct_params
        yylhs.value.build< std::vector<hilti::type::function::Parameter> > ();
        break;

      case 218: // tuple_type_elems
        yylhs.value.build< std::vector<hilti::type::tuple::Element> > ();
        break;

      case 268: // re_patterns
        yylhs.value.build< std::vector<std::string> > ();
        break;

      case 15: // "unsigned integer value"
      case 255: // const_uint
        yylhs.value.build< uint64_t > ();
        break;

      default:
        break;
    }


      // Compute the default @$.
      {
        slice<stack_symbol_type, stack_type> slice (yystack_, yylen);
        YYLLOC_DEFAULT (yylhs.location, slice, yylen);
      }

      // Perform the reduction.
      YY_REDUCE_PRINT (yyn);
      try
        {
          switch (yyn)
            {
  case 2:
#line 280 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { auto m = hilti::Module(yystack_[3].value.as< hilti::ID > (), std::move(yystack_[1].value.as< std::pair<std::vector<hilti::Declaration>, std::vector<hilti::Statement>> > ().first), std::move(yystack_[1].value.as< std::pair<std::vector<hilti::Declaration>, std::vector<hilti::Statement>> > ().second), __loc__);
                                                   driver->setDestinationModule(std::move(m));
                                                 }
#line 3531 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 3:
#line 287 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { std::string name(yystack_[0].value.as< std::string > ());

                                                   if ( name.find('-') != std::string::npos )
                                                       hilti::logger().error(util::fmt("Invalid ID '%s': cannot contain '-'", name), __loc__.location());
                                                   if ( name.substr(0, 2) == "__" && name != "__str__" )
                                                       hilti::logger().error(util::fmt("Invalid ID '%s': cannot start with '__'", name), __loc__.location());

                                                   yylhs.value.as< hilti::ID > () = hilti::ID(std::move(name), __loc__);
                                                 }
#line 3545 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 4:
#line 297 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::ID > () = std::move(yystack_[0].value.as< hilti::ID > ()); }
#line 3551 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 5:
#line 298 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::ID > () = hilti::ID(yystack_[0].value.as< std::string > (), __loc__); }
#line 3557 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 6:
#line 300 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { driver->enableDottedIDMode(); }
#line 3563 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 7:
#line 302 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { driver->disableDottedIDMode(); }
#line 3569 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 8:
#line 302 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::ID > () = hilti::ID(yystack_[1].value.as< std::string > (), __loc__); }
#line 3575 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 9:
#line 308 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::pair<std::vector<hilti::Declaration>, std::vector<hilti::Statement>> > () = std::move(yystack_[1].value.as< std::pair<std::vector<hilti::Declaration>, std::vector<hilti::Statement>> > ()); yylhs.value.as< std::pair<std::vector<hilti::Declaration>, std::vector<hilti::Statement>> > ().first.push_back(yystack_[0].value.as< hilti::Declaration > ()); }
#line 3581 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 10:
#line 310 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::pair<std::vector<hilti::Declaration>, std::vector<hilti::Statement>> > () = std::move(yystack_[1].value.as< std::pair<std::vector<hilti::Declaration>, std::vector<hilti::Statement>> > ()); yylhs.value.as< std::pair<std::vector<hilti::Declaration>, std::vector<hilti::Statement>> > ().second.push_back(yystack_[0].value.as< hilti::Statement > ()); }
#line 3587 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 11:
#line 311 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::pair<std::vector<hilti::Declaration>, std::vector<hilti::Statement>> > () = {}; }
#line 3593 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 12:
#line 315 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Declaration > () = std::move(yystack_[0].value.as< hilti::Declaration > ()); }
#line 3599 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 13:
#line 316 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Declaration > () = std::move(yystack_[0].value.as< hilti::Declaration > ()); }
#line 3605 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 14:
#line 317 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Declaration > () = std::move(yystack_[0].value.as< hilti::Declaration > ()); }
#line 3611 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 15:
#line 318 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Declaration > () = std::move(yystack_[0].value.as< hilti::Declaration > ()); }
#line 3617 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 16:
#line 319 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Declaration > () = std::move(yystack_[0].value.as< hilti::Declaration > ()); }
#line 3623 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 17:
#line 320 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Declaration > () = std::move(yystack_[0].value.as< hilti::Declaration > ()); }
#line 3629 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 18:
#line 323 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Declaration > () = hilti::declaration::Type(std::move(yystack_[4].value.as< hilti::ID > ()), std::move(yystack_[2].value.as< hilti::Type > ()), std::move(yystack_[1].value.as< std::optional<hilti::AttributeSet> > ()), std::move(yystack_[6].value.as< hilti::declaration::Linkage > ()), __loc__); }
#line 3635 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 19:
#line 326 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Declaration > () = hilti::declaration::Constant(yystack_[3].value.as< hilti::ID > (), yystack_[1].value.as< hilti::Expression > (), yystack_[5].value.as< hilti::declaration::Linkage > (), __loc__); }
#line 3641 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 20:
#line 328 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Declaration > () = hilti::declaration::Constant(yystack_[3].value.as< hilti::ID > (), yystack_[4].value.as< hilti::Type > (), yystack_[1].value.as< hilti::Expression > (), yystack_[6].value.as< hilti::declaration::Linkage > (), __loc__); }
#line 3647 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 21:
#line 331 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Declaration > () = hilti::declaration::LocalVariable(yystack_[3].value.as< hilti::ID > (), yystack_[1].value.as< hilti::Expression > (), false, __loc__); }
#line 3653 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 22:
#line 332 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Declaration > () = hilti::declaration::LocalVariable(yystack_[2].value.as< hilti::ID > (), yystack_[3].value.as< hilti::Type > (), yystack_[1].value.as< std::vector<hilti::Expression> > (), {}, false, __loc__); }
#line 3659 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 23:
#line 334 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Declaration > () = hilti::declaration::LocalVariable(yystack_[3].value.as< hilti::ID > (), yystack_[4].value.as< hilti::Type > (), yystack_[1].value.as< hilti::Expression > (), false, __loc__); }
#line 3665 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 24:
#line 336 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Declaration > () = hilti::declaration::LocalVariable(yystack_[3].value.as< hilti::ID > (), yystack_[1].value.as< hilti::Expression > (), false, __loc__); }
#line 3671 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 25:
#line 341 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Declaration > () = hilti::declaration::LocalVariable(yystack_[2].value.as< hilti::ID > (), yystack_[3].value.as< hilti::Type > (), yystack_[0].value.as< hilti::Expression > (), false, __loc__); }
#line 3677 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 26:
#line 343 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Declaration > () = hilti::declaration::LocalVariable(yystack_[2].value.as< hilti::ID > (), yystack_[0].value.as< hilti::Expression > (), false, __loc__); }
#line 3683 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 27:
#line 347 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Declaration > () = hilti::declaration::GlobalVariable(yystack_[3].value.as< hilti::ID > (), yystack_[1].value.as< hilti::Expression > (), yystack_[5].value.as< hilti::declaration::Linkage > (), __loc__); }
#line 3689 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 28:
#line 349 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Declaration > () = hilti::declaration::GlobalVariable(yystack_[2].value.as< hilti::ID > (), yystack_[3].value.as< hilti::Type > (), yystack_[1].value.as< std::vector<hilti::Expression> > (), {}, yystack_[5].value.as< hilti::declaration::Linkage > (), __loc__); }
#line 3695 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 29:
#line 351 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Declaration > () = hilti::declaration::GlobalVariable(yystack_[3].value.as< hilti::ID > (), yystack_[4].value.as< hilti::Type > (), yystack_[1].value.as< hilti::Expression > (), yystack_[6].value.as< hilti::declaration::Linkage > (), __loc__); }
#line 3701 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 30:
#line 353 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Declaration > () = hilti::declaration::GlobalVariable(yystack_[3].value.as< hilti::ID > (), yystack_[1].value.as< hilti::Expression > (), yystack_[6].value.as< hilti::declaration::Linkage > (), __loc__); }
#line 3707 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 31:
#line 357 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<hilti::Expression> > () = std::move(yystack_[1].value.as< std::vector<hilti::Expression> > ()); }
#line 3713 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 32:
#line 358 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<hilti::Expression> > () = std::vector<Expression>{}; }
#line 3719 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 33:
#line 361 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Declaration > () = hilti::declaration::Function(yystack_[0].value.as< hilti::Function > (), yystack_[2].value.as< hilti::declaration::Linkage > (), __loc__); }
#line 3725 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 34:
#line 362 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Declaration > () = hilti::declaration::Function(yystack_[0].value.as< hilti::Function > (), yystack_[2].value.as< hilti::declaration::Linkage > (), __loc__); }
#line 3731 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 35:
#line 365 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Declaration > () = hilti::declaration::Function(yystack_[0].value.as< hilti::Function > (), hilti::declaration::Linkage::Struct, __loc__); }
#line 3737 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 36:
#line 367 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Declaration > () = hilti::declaration::Function(yystack_[1].value.as< hilti::Function > (), yystack_[2].value.as< hilti::declaration::Linkage > (), __loc__); }
#line 3743 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 37:
#line 370 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Declaration > () = hilti::declaration::ImportedModule(std::move(yystack_[1].value.as< hilti::ID > ()), std::string(".hlt"), __loc__); }
#line 3749 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 38:
#line 371 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Declaration > () = hilti::declaration::ImportedModule(std::move(yystack_[3].value.as< hilti::ID > ()), std::string(".hlt"), std::move(yystack_[1].value.as< hilti::ID > ()), __loc__); }
#line 3755 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 39:
#line 375 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Declaration > () = hilti::declaration::Property(ID(std::move(yystack_[1].value.as< std::string > ())), __loc__); }
#line 3761 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 40:
#line 376 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Declaration > () = hilti::declaration::Property(ID(std::move(yystack_[3].value.as< std::string > ())), std::move(yystack_[1].value.as< hilti::Expression > ()), __loc__); }
#line 3767 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 41:
#line 378 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::declaration::Linkage > () = hilti::declaration::Linkage::Public; }
#line 3773 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 42:
#line 379 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::declaration::Linkage > () = hilti::declaration::Linkage::Private; }
#line 3779 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 43:
#line 380 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::declaration::Linkage > () = hilti::declaration::Linkage::Init; }
#line 3785 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 44:
#line 381 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::declaration::Linkage > () = hilti::declaration::Linkage::PreInit; }
#line 3791 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 45:
#line 382 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::declaration::Linkage > () = hilti::declaration::Linkage::Private; }
#line 3797 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 46:
#line 386 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::ID > () = std::move(yystack_[0].value.as< hilti::ID > ()); }
#line 3803 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 47:
#line 387 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::ID > () = hilti::ID("~finally", __loc__); }
#line 3809 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 48:
#line 390 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::ID > () = std::move(yystack_[0].value.as< hilti::ID > ()); }
#line 3815 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 49:
#line 391 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::ID > () = hilti::ID(yystack_[0].value.as< std::string > (), __loc__); }
#line 3821 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 50:
#line 392 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::ID > () = hilti::ID(yystack_[0].value.as< std::string > (), __loc__); }
#line 3827 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 51:
#line 396 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    {
                                                    auto ftype = hilti::type::Function(yystack_[6].value.as< hilti::type::function::Result > (), yystack_[3].value.as< std::vector<hilti::type::function::Parameter> > (), type::function::Flavor::Standard, __loc__);
                                                    yylhs.value.as< hilti::Function > () = hilti::Function(yystack_[5].value.as< hilti::ID > (), std::move(ftype), yystack_[0].value.as< hilti::Statement > (), yystack_[7].value.as< hilti::function::CallingConvention > (), yystack_[1].value.as< std::optional<hilti::AttributeSet> > (), __loc__);
                                                 }
#line 3836 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 52:
#line 403 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    {
                                                    auto ftype = hilti::type::Function(yystack_[6].value.as< hilti::type::function::Result > (), yystack_[3].value.as< std::vector<hilti::type::function::Parameter> > (), type::function::Flavor::Method, __loc__);
                                                    yylhs.value.as< hilti::Function > () = hilti::Function(yystack_[5].value.as< hilti::ID > (), std::move(ftype), yystack_[0].value.as< hilti::Statement > (), yystack_[7].value.as< hilti::function::CallingConvention > (), yystack_[1].value.as< std::optional<hilti::AttributeSet> > (), __loc__);
                                                 }
#line 3845 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 53:
#line 410 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    {
                                                    auto ftype = hilti::type::Function(yystack_[6].value.as< hilti::type::function::Result > (), yystack_[3].value.as< std::vector<hilti::type::function::Parameter> > (), type::function::Flavor::Hook, __loc__);
                                                    yylhs.value.as< hilti::Function > () = hilti::Function(yystack_[5].value.as< hilti::ID > (), std::move(ftype), yystack_[0].value.as< hilti::Statement > (), yystack_[7].value.as< hilti::function::CallingConvention > (), yystack_[1].value.as< std::optional<hilti::AttributeSet> > (), __loc__);
                                                 }
#line 3854 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 54:
#line 417 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    {
                                                    auto ftype = hilti::type::Function(yystack_[5].value.as< hilti::type::function::Result > (), yystack_[2].value.as< std::vector<hilti::type::function::Parameter> > (), yystack_[7].value.as< hilti::type::function::Flavor > (), __loc__);
                                                    yylhs.value.as< hilti::Function > () = hilti::Function(yystack_[4].value.as< hilti::ID > (), std::move(ftype), {}, yystack_[6].value.as< hilti::function::CallingConvention > (), yystack_[0].value.as< std::optional<hilti::AttributeSet> > (), __loc__);
                                                 }
#line 3863 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 55:
#line 422 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::type::function::Flavor > () = yystack_[0].value.as< hilti::type::function::Flavor > (); }
#line 3869 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 56:
#line 423 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::type::function::Flavor > () = hilti::type::function::Flavor::Standard; }
#line 3875 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 57:
#line 425 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::type::function::Flavor > () = hilti::type::function::Flavor::Method; }
#line 3881 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 58:
#line 426 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::type::function::Flavor > () = hilti::type::function::Flavor::Hook; }
#line 3887 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 59:
#line 428 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::function::CallingConvention > () = hilti::function::CallingConvention::Extern; }
#line 3893 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 60:
#line 429 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::function::CallingConvention > () = hilti::function::CallingConvention::ExternNoSuspend; }
#line 3899 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 61:
#line 430 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::function::CallingConvention > () = hilti::function::CallingConvention::Standard; }
#line 3905 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 62:
#line 432 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<hilti::type::function::Parameter> > () = std::move(yystack_[0].value.as< std::vector<hilti::type::function::Parameter> > ()); }
#line 3911 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 63:
#line 433 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<hilti::type::function::Parameter> > () = std::vector<hilti::type::function::Parameter>{}; }
#line 3917 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 64:
#line 435 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<hilti::type::function::Parameter> > () = std::move(yystack_[2].value.as< std::vector<hilti::type::function::Parameter> > ()); yylhs.value.as< std::vector<hilti::type::function::Parameter> > ().push_back(yystack_[0].value.as< hilti::type::function::Parameter > ()); }
#line 3923 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 65:
#line 436 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<hilti::type::function::Parameter> > () = std::vector<hilti::type::function::Parameter>{yystack_[0].value.as< hilti::type::function::Parameter > ()}; }
#line 3929 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 66:
#line 439 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::type::function::Parameter > () = hilti::type::function::Parameter(yystack_[2].value.as< hilti::ID > (), yystack_[3].value.as< hilti::Type > (), yystack_[4].value.as< hilti::declaration::parameter::Kind > (), yystack_[1].value.as< std::optional<hilti::Expression> > (), yystack_[0].value.as< std::optional<hilti::AttributeSet> > (), __loc__); }
#line 3935 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 67:
#line 442 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::type::function::Result > () = hilti::type::function::Result(std::move(yystack_[0].value.as< hilti::Type > ()), __loc__); }
#line 3941 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 68:
#line 445 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::declaration::parameter::Kind > () = hilti::declaration::parameter::Kind::Copy; }
#line 3947 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 69:
#line 446 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::declaration::parameter::Kind > () = hilti::declaration::parameter::Kind::InOut; }
#line 3953 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 70:
#line 447 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::declaration::parameter::Kind > () = hilti::declaration::parameter::Kind::In; }
#line 3959 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 71:
#line 450 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::optional<hilti::Expression> > () = std::move(yystack_[0].value.as< hilti::Expression > ()); }
#line 3965 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 72:
#line 451 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::optional<hilti::Expression> > () = {}; }
#line 3971 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 73:
#line 456 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Statement > () = std::move(yystack_[0].value.as< hilti::Statement > ()); }
#line 3977 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 74:
#line 457 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Statement > () = hilti::statement::Block({yystack_[0].value.as< hilti::Statement > ()}, __loc__); }
#line 3983 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 75:
#line 460 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Statement > () = hilti::statement::Block(std::move(yystack_[1].value.as< std::vector<hilti::Statement> > ()), __loc__); }
#line 3989 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 76:
#line 462 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<hilti::Statement> > () = std::move(yystack_[0].value.as< std::vector<hilti::Statement> > ()); }
#line 3995 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 77:
#line 463 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<hilti::Statement> > () = std::vector<hilti::Statement>{}; }
#line 4001 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 78:
#line 465 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<hilti::Statement> > () = std::move(yystack_[1].value.as< std::vector<hilti::Statement> > ()); yylhs.value.as< std::vector<hilti::Statement> > ().push_back(yystack_[0].value.as< hilti::Statement > ()); }
#line 4007 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 79:
#line 466 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<hilti::Statement> > () = std::vector<hilti::Statement>{std::move(yystack_[0].value.as< hilti::Statement > ())}; }
#line 4013 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 80:
#line 468 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Statement > () = std::move(yystack_[1].value.as< hilti::Statement > ()); }
#line 4019 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 81:
#line 469 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Statement > () = std::move(yystack_[0].value.as< hilti::Statement > ()); }
#line 4025 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 82:
#line 470 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Statement > () = hilti::statement::Return(__loc__); }
#line 4031 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 83:
#line 471 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Statement > () = hilti::statement::Return(std::move(yystack_[1].value.as< hilti::Expression > ()), __loc__); }
#line 4037 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 84:
#line 472 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Statement > () = hilti::statement::Throw(std::move(yystack_[1].value.as< hilti::Expression > ()), __loc__); }
#line 4043 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 85:
#line 473 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Statement > () = hilti::statement::Throw(__loc__); }
#line 4049 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 86:
#line 474 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Statement > () = hilti::statement::Yield(__loc__); }
#line 4055 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 87:
#line 475 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Statement > () = hilti::statement::Break(__loc__); }
#line 4061 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 88:
#line 476 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Statement > () = hilti::statement::Continue(__loc__); }
#line 4067 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 89:
#line 478 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Statement > () = hilti::statement::If(std::move(yystack_[3].value.as< hilti::Expression > ()), std::move(yystack_[1].value.as< hilti::Statement > ()), std::move(yystack_[0].value.as< std::optional<hilti::Statement> > ()), __loc__); }
#line 4073 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 90:
#line 480 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Statement > () = hilti::statement::If(std::move(yystack_[3].value.as< hilti::Declaration > ()), {}, std::move(yystack_[1].value.as< hilti::Statement > ()), std::move(yystack_[0].value.as< std::optional<hilti::Statement> > ()), __loc__); }
#line 4079 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 91:
#line 482 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Statement > () = hilti::statement::If(std::move(yystack_[5].value.as< hilti::Declaration > ()), std::move(yystack_[3].value.as< hilti::Expression > ()), std::move(yystack_[1].value.as< hilti::Statement > ()), std::move(yystack_[0].value.as< std::optional<hilti::Statement> > ()), __loc__); }
#line 4085 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 92:
#line 484 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Statement > () = hilti::statement::While(std::move(yystack_[5].value.as< hilti::Declaration > ()), std::move(yystack_[3].value.as< hilti::Expression > ()), std::move(yystack_[1].value.as< hilti::Statement > ()), std::move(yystack_[0].value.as< std::optional<hilti::Statement> > ()), __loc__); }
#line 4091 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 93:
#line 486 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Statement > () = hilti::statement::While(std::move(yystack_[3].value.as< hilti::Expression > ()), std::move(yystack_[1].value.as< hilti::Statement > ()), std::move(yystack_[0].value.as< std::optional<hilti::Statement> > ()), __loc__); }
#line 4097 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 94:
#line 488 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Statement > () = hilti::statement::While(std::move(yystack_[3].value.as< hilti::Declaration > ()), {}, std::move(yystack_[1].value.as< hilti::Statement > ()), std::move(yystack_[0].value.as< std::optional<hilti::Statement> > ()), __loc__); }
#line 4103 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 95:
#line 490 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Statement > () = hilti::statement::For(std::move(yystack_[4].value.as< hilti::ID > ()), std::move(yystack_[2].value.as< hilti::Expression > ()), std::move(yystack_[0].value.as< hilti::Statement > ()), __loc__); }
#line 4109 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 96:
#line 492 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Statement > () = hilti::statement::Switch(std::move(yystack_[4].value.as< hilti::Expression > ()), std::move(yystack_[1].value.as< std::vector<hilti::statement::switch_::Case> > ()), __loc__); }
#line 4115 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 97:
#line 494 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Statement > () = hilti::statement::Switch(std::move(yystack_[4].value.as< hilti::Declaration > ()), std::move(yystack_[1].value.as< std::vector<hilti::statement::switch_::Case> > ()), __loc__); }
#line 4121 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 98:
#line 496 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Statement > () = hilti::statement::Try(std::move(yystack_[1].value.as< hilti::Statement > ()), std::move(yystack_[0].value.as< std::vector<hilti::statement::try_::Catch> > ()), __loc__); }
#line 4127 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 99:
#line 497 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Statement > () = hilti::statement::Assert(std::move(yystack_[1].value.as< hilti::Expression > ()), {}, __loc__); }
#line 4133 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 100:
#line 498 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Statement > () = hilti::statement::Assert(std::move(yystack_[3].value.as< hilti::Expression > ()), std::move(yystack_[1].value.as< hilti::Expression > ()), __loc__); }
#line 4139 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 101:
#line 499 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Statement > () = hilti::statement::Assert(hilti::statement::assert::Exception(), std::move(yystack_[1].value.as< hilti::Expression > ()), {}, {}, __loc__); }
#line 4145 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 102:
#line 501 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Statement > () = hilti::statement::Assert(hilti::statement::assert::Exception(), std::move(yystack_[3].value.as< hilti::Expression > ()), {}, std::move(yystack_[1].value.as< hilti::Expression > ()), __loc__); }
#line 4151 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 103:
#line 503 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { auto op = yystack_[1].value.as< hilti::Expression > ().tryAs<hilti::expression::UnresolvedOperator>();
                                                   if ( ! (op && op->kind() == hilti::operator_::Kind::Index) )
                                                        error(yylhs.location, "'add' must be used with index expression only");

                                                   auto expr = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::Add, op->operands(), __loc__);
                                                   yylhs.value.as< hilti::Statement > () = hilti::statement::Expression(std::move(expr), __loc__);
                                                 }
#line 4163 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 104:
#line 511 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { auto op = yystack_[1].value.as< hilti::Expression > ().tryAs<hilti::expression::UnresolvedOperator>();
                                                   if ( ! (op && op->kind() == hilti::operator_::Kind::Index) )
                                                        error(yylhs.location, "'delete' must be used with index expressions only");

                                                   auto expr = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::Delete, op->operands(), __loc__);
                                                   yylhs.value.as< hilti::Statement > () = hilti::statement::Expression(std::move(expr), __loc__);
                                                 }
#line 4175 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 105:
#line 519 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { auto op = yystack_[1].value.as< hilti::Expression > ().tryAs<hilti::expression::UnresolvedOperator>();
                                                   if ( ! (op && op->kind() == hilti::operator_::Kind::Member) )
                                                        error(yylhs.location, "'unset' must be used with member expressions only");

                                                   auto expr = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::Unset, op->operands(), __loc__);
                                                   yylhs.value.as< hilti::Statement > () = hilti::statement::Expression(std::move(expr), __loc__);
                                                 }
#line 4187 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 106:
#line 529 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::optional<hilti::Statement> > () = std::move(yystack_[0].value.as< hilti::Statement > ()); }
#line 4193 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 107:
#line 530 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::optional<hilti::Statement> > () = {}; }
#line 4199 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 108:
#line 533 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<hilti::statement::switch_::Case> > () = std::move(yystack_[0].value.as< std::vector<hilti::statement::switch_::Case> > ()); }
#line 4205 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 109:
#line 534 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<hilti::statement::switch_::Case> > () = {}; }
#line 4211 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 110:
#line 536 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<hilti::statement::switch_::Case> > () = std::move(yystack_[1].value.as< std::vector<hilti::statement::switch_::Case> > ()); yylhs.value.as< std::vector<hilti::statement::switch_::Case> > ().push_back(std::move(yystack_[0].value.as< hilti::statement::switch_::Case > ())); }
#line 4217 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 111:
#line 537 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<hilti::statement::switch_::Case> > () = std::vector<hilti::statement::switch_::Case>({ std::move(yystack_[0].value.as< hilti::statement::switch_::Case > ()) }); }
#line 4223 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 112:
#line 539 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::statement::switch_::Case > () = hilti::statement::switch_::Case(std::move(yystack_[2].value.as< std::vector<hilti::Expression> > ()), std::move(yystack_[0].value.as< hilti::Statement > ()), __loc__); }
#line 4229 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 113:
#line 540 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::statement::switch_::Case > () = hilti::statement::switch_::Case(hilti::statement::switch_::Default(), std::move(yystack_[0].value.as< hilti::Statement > ()), __loc__); }
#line 4235 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 114:
#line 542 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<hilti::statement::try_::Catch> > () = std::move(yystack_[1].value.as< std::vector<hilti::statement::try_::Catch> > ()); yylhs.value.as< std::vector<hilti::statement::try_::Catch> > ().push_back(std::move(yystack_[0].value.as< hilti::statement::try_::Catch > ())); }
#line 4241 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 115:
#line 543 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<hilti::statement::try_::Catch> > () = std::vector<hilti::statement::try_::Catch>({ std::move(yystack_[0].value.as< hilti::statement::try_::Catch > ()) }); }
#line 4247 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 116:
#line 546 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::statement::try_::Catch > () = hilti::statement::try_::Catch(declaration::Parameter(yystack_[2].value.as< hilti::ID > (), yystack_[3].value.as< hilti::Type > (), declaration::parameter::Kind::In, {}, __loc__), std::move(yystack_[0].value.as< hilti::Statement > ()), __loc__); }
#line 4253 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 117:
#line 547 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::statement::try_::Catch > () = hilti::statement::try_::Catch(std::move(yystack_[0].value.as< hilti::Statement > ()), __loc__); }
#line 4259 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 118:
#line 549 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Statement > () = hilti::statement::Declaration(yystack_[0].value.as< hilti::Declaration > (), __loc__); }
#line 4265 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 119:
#line 550 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Statement > () = hilti::statement::Declaration(yystack_[0].value.as< hilti::Declaration > (), __loc__); }
#line 4271 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 120:
#line 551 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Statement > () = hilti::statement::Declaration(yystack_[0].value.as< hilti::Declaration > (), __loc__); }
#line 4277 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 121:
#line 554 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Statement > () = hilti::statement::Expression(yystack_[0].value.as< hilti::Expression > (), __loc__); }
#line 4283 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 122:
#line 559 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = hilti::type::Any(__loc__); }
#line 4289 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 123:
#line 560 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = hilti::type::Address(__loc__); }
#line 4295 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 124:
#line 561 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = hilti::type::auto_; }
#line 4301 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 125:
#line 562 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = hilti::type::Bool(__loc__); }
#line 4307 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 126:
#line 563 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = hilti::type::Bytes(__loc__); }
#line 4313 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 127:
#line 564 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = hilti::type::Error(__loc__); }
#line 4319 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 128:
#line 565 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = hilti::type::Interval(__loc__); }
#line 4325 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 129:
#line 566 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = hilti::type::Network(__loc__); }
#line 4331 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 130:
#line 567 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = hilti::type::Port(__loc__); }
#line 4337 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 131:
#line 568 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = hilti::type::Real(__loc__); }
#line 4343 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 132:
#line 569 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = hilti::type::RegExp(__loc__); }
#line 4349 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 133:
#line 570 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = hilti::type::Stream(__loc__); }
#line 4355 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 134:
#line 571 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = hilti::type::String(__loc__); }
#line 4361 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 135:
#line 572 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = hilti::type::Time(__loc__); }
#line 4367 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 136:
#line 573 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = hilti::type::void_; }
#line 4373 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 137:
#line 575 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = hilti::type::SignedInteger(yystack_[1].value.as< uint64_t > (), __loc__); }
#line 4379 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 138:
#line 576 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = hilti::type::SignedInteger(hilti::type::Wildcard(), __loc__); }
#line 4385 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 139:
#line 577 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = hilti::type::UnsignedInteger(yystack_[1].value.as< uint64_t > (), __loc__); }
#line 4391 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 140:
#line 578 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = hilti::type::UnsignedInteger(hilti::type::Wildcard(), __loc__); }
#line 4397 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 141:
#line 580 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = hilti::type::Optional(yystack_[1].value.as< hilti::Type > (), __loc__); }
#line 4403 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 142:
#line 581 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = hilti::type::Result(yystack_[1].value.as< hilti::Type > (), __loc__); }
#line 4409 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 143:
#line 582 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = viewForType(std::move(yystack_[1].value.as< hilti::Type > ()), __loc__); }
#line 4415 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 144:
#line 583 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = iteratorForType(std::move(yystack_[1].value.as< hilti::Type > ()), false, __loc__); }
#line 4421 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 145:
#line 584 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = iteratorForType(std::move(yystack_[1].value.as< hilti::Type > ()), true, __loc__); }
#line 4427 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 146:
#line 585 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = hilti::type::StrongReference(yystack_[1].value.as< hilti::Type > (), __loc__); }
#line 4433 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 147:
#line 586 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = hilti::type::StrongReference(hilti::type::Wildcard(), __loc__); }
#line 4439 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 148:
#line 587 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = hilti::type::ValueReference(yystack_[1].value.as< hilti::Type > (), __loc__); }
#line 4445 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 149:
#line 588 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = hilti::type::ValueReference(hilti::type::Wildcard(), __loc__); }
#line 4451 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 150:
#line 589 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = hilti::type::WeakReference(yystack_[1].value.as< hilti::Type > (), __loc__); }
#line 4457 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 151:
#line 590 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = hilti::type::WeakReference(hilti::type::Wildcard(), __loc__); }
#line 4463 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 152:
#line 592 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = hilti::type::List(hilti::type::Wildcard(), __loc__); }
#line 4469 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 153:
#line 593 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = hilti::type::List(std::move(yystack_[1].value.as< hilti::Type > ()), __loc__); }
#line 4475 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 154:
#line 594 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = hilti::type::Vector(hilti::type::Wildcard(), __loc__); }
#line 4481 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 155:
#line 595 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = hilti::type::Vector(std::move(yystack_[1].value.as< hilti::Type > ()), __loc__); }
#line 4487 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 156:
#line 596 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = hilti::type::Set(hilti::type::Wildcard(), __loc__); }
#line 4493 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 157:
#line 597 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = hilti::type::Set(std::move(yystack_[1].value.as< hilti::Type > ()), __loc__); }
#line 4499 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 158:
#line 598 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = hilti::type::Map(hilti::type::Wildcard(), __loc__); }
#line 4505 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 159:
#line 599 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = hilti::type::Map(std::move(yystack_[3].value.as< hilti::Type > ()), std::move(yystack_[1].value.as< hilti::Type > ()), __loc__); }
#line 4511 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 160:
#line 601 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = hilti::type::Exception(__loc__); }
#line 4517 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 161:
#line 602 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = hilti::type::Exception(std::move(yystack_[0].value.as< hilti::Type > ()), __loc__); }
#line 4523 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 162:
#line 604 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = hilti::type::Library(std::move(yystack_[1].value.as< std::string > ()), __loc__); }
#line 4529 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 163:
#line 606 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = std::move(yystack_[0].value.as< hilti::Type > ()); }
#line 4535 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 164:
#line 607 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = std::move(yystack_[0].value.as< hilti::Type > ()); }
#line 4541 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 165:
#line 608 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = std::move(yystack_[0].value.as< hilti::Type > ()); }
#line 4547 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 166:
#line 609 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = std::move(yystack_[0].value.as< hilti::Type > ()); }
#line 4553 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 167:
#line 613 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = type::addFlags(yystack_[1].value.as< hilti::Type > (), yystack_[0].value.as< hilti::type::Flags > ()); }
#line 4559 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 168:
#line 616 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = std::move(yystack_[0].value.as< hilti::Type > ()); }
#line 4565 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 169:
#line 617 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = std::move(yystack_[0].value.as< hilti::Type > ()); }
#line 4571 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 170:
#line 618 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = hilti::type::UnresolvedID(std::move(yystack_[0].value.as< hilti::ID > ())); }
#line 4577 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 171:
#line 623 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { driver->disableExpressionMode(); }
#line 4583 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 172:
#line 627 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { driver->enableExpressionMode(); }
#line 4589 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 173:
#line 629 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::type::Flags > () = hilti::type::Flags(); }
#line 4595 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 174:
#line 633 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = hilti::type::Function(yystack_[0].value.as< hilti::type::function::Result > (), yystack_[3].value.as< std::vector<hilti::type::function::Parameter> > (), yystack_[6].value.as< hilti::type::function::Flavor > (), __loc__); }
#line 4601 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 175:
#line 636 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = hilti::type::Tuple(hilti::type::Wildcard(), __loc__); }
#line 4607 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 176:
#line 637 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = hilti::type::Tuple(std::move(yystack_[1].value.as< std::vector<hilti::type::tuple::Element> > ()), __loc__); }
#line 4613 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 177:
#line 642 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<hilti::type::tuple::Element> > () = std::move(yystack_[2].value.as< std::vector<hilti::type::tuple::Element> > ()); yylhs.value.as< std::vector<hilti::type::tuple::Element> > ().push_back(std::move(yystack_[0].value.as< hilti::type::tuple::Element > ())); }
#line 4619 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 178:
#line 643 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<hilti::type::tuple::Element> > () = std::vector<hilti::type::tuple::Element>{ std::move(yystack_[0].value.as< hilti::type::tuple::Element > ()) }; }
#line 4625 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 179:
#line 647 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::type::tuple::Element > () = hilti::type::tuple::Element(hilti::ID(), std::move(yystack_[0].value.as< hilti::Type > ()), __loc__); }
#line 4631 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 180:
#line 648 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::type::tuple::Element > () = hilti::type::tuple::Element(std::move(yystack_[2].value.as< hilti::ID > ()), std::move(yystack_[0].value.as< hilti::Type > ()), __loc__); }
#line 4637 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 181:
#line 651 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = hilti::type::Struct(std::move(yystack_[3].value.as< std::vector<hilti::type::function::Parameter> > ()), std::move(yystack_[1].value.as< std::vector<hilti::Declaration> > ()), __loc__); }
#line 4643 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 182:
#line 654 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<hilti::type::function::Parameter> > () = std::move(yystack_[1].value.as< std::vector<hilti::type::function::Parameter> > ()); }
#line 4649 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 183:
#line 655 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<hilti::type::function::Parameter> > () = std::vector<hilti::type::function::Parameter>{}; }
#line 4655 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 184:
#line 657 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<hilti::Declaration> > () = std::move(yystack_[1].value.as< std::vector<hilti::Declaration> > ()); yylhs.value.as< std::vector<hilti::Declaration> > ().push_back(yystack_[0].value.as< hilti::Declaration > ()); }
#line 4661 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 185:
#line 658 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<hilti::Declaration> > () = std::vector<Declaration>{}; }
#line 4667 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 186:
#line 660 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Declaration > () = hilti::declaration::Field(std::move(yystack_[2].value.as< hilti::ID > ()), std::move(yystack_[3].value.as< hilti::Type > ()), std::move(yystack_[1].value.as< std::optional<hilti::AttributeSet> > ()), __loc__); }
#line 4673 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 187:
#line 661 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    {
                                                   auto ftype = hilti::type::Function(std::move(yystack_[6].value.as< hilti::type::function::Result > ()), std::move(yystack_[3].value.as< std::vector<hilti::type::function::Parameter> > ()), yystack_[8].value.as< hilti::type::function::Flavor > (), __loc__);
                                                   yylhs.value.as< hilti::Declaration > () = hilti::declaration::Field(std::move(yystack_[5].value.as< hilti::ID > ()), yystack_[7].value.as< hilti::function::CallingConvention > (), std::move(ftype), yystack_[1].value.as< std::optional<hilti::AttributeSet> > (), __loc__);
                                                   }
#line 4682 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 188:
#line 665 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    {
                                                   auto ftype = hilti::type::Function(std::move(yystack_[6].value.as< hilti::type::function::Result > ()), std::move(yystack_[3].value.as< std::vector<hilti::type::function::Parameter> > ()), yystack_[8].value.as< hilti::type::function::Flavor > (), __loc__);
                                                   auto func = hilti::Function(yystack_[5].value.as< hilti::ID > (), std::move(ftype), std::move(yystack_[0].value.as< hilti::Statement > ()), yystack_[7].value.as< hilti::function::CallingConvention > (), {});
                                                   yylhs.value.as< hilti::Declaration > () = hilti::declaration::Field(yystack_[5].value.as< hilti::ID > (), std::move(func), yystack_[1].value.as< std::optional<hilti::AttributeSet> > (), __loc__);
                                                   }
#line 4692 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 189:
#line 672 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = hilti::type::Union(std::move(yystack_[1].value.as< std::vector<hilti::Declaration> > ()), __loc__); }
#line 4698 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 190:
#line 674 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<hilti::Declaration> > () = yystack_[0].value.as< std::vector<hilti::Declaration> > (); }
#line 4704 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 191:
#line 675 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<hilti::Declaration> > () = std::vector<Declaration>(); }
#line 4710 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 192:
#line 677 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<hilti::Declaration> > () = std::move(yystack_[2].value.as< std::vector<hilti::Declaration> > ()); yylhs.value.as< std::vector<hilti::Declaration> > ().push_back(std::move(yystack_[0].value.as< hilti::Declaration > ())); }
#line 4716 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 193:
#line 678 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<hilti::Declaration> > () = std::vector<Declaration>(); yylhs.value.as< std::vector<hilti::Declaration> > ().push_back(std::move(yystack_[0].value.as< hilti::Declaration > ())); }
#line 4722 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 194:
#line 680 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Declaration > () = hilti::declaration::Field(std::move(yystack_[1].value.as< hilti::ID > ()), std::move(yystack_[2].value.as< hilti::Type > ()), std::move(yystack_[0].value.as< std::optional<hilti::AttributeSet> > ()), __loc__); }
#line 4728 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 195:
#line 682 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = hilti::type::Enum(std::move(yystack_[1].value.as< std::vector<hilti::type::enum_::Label> > ()), __loc__); }
#line 4734 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 196:
#line 683 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = hilti::type::Enum(type::Wildcard(), __loc__); }
#line 4740 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 197:
#line 685 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<hilti::type::enum_::Label> > () = std::move(yystack_[2].value.as< std::vector<hilti::type::enum_::Label> > ()); yylhs.value.as< std::vector<hilti::type::enum_::Label> > ().push_back(std::move(yystack_[0].value.as< hilti::type::enum_::Label > ())); }
#line 4746 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 198:
#line 686 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<hilti::type::enum_::Label> > () = std::move(yystack_[1].value.as< std::vector<hilti::type::enum_::Label> > ()); }
#line 4752 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 199:
#line 687 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<hilti::type::enum_::Label> > () = std::vector<hilti::type::enum_::Label>(); yylhs.value.as< std::vector<hilti::type::enum_::Label> > ().push_back(std::move(yystack_[0].value.as< hilti::type::enum_::Label > ())); }
#line 4758 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 200:
#line 690 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::type::enum_::Label > () = hilti::type::enum_::Label(std::move(yystack_[0].value.as< hilti::ID > ()), __loc__); }
#line 4764 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 201:
#line 691 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::type::enum_::Label > () = hilti::type::enum_::Label(std::move(yystack_[2].value.as< hilti::ID > ()), yystack_[0].value.as< uint64_t > (), __loc__); }
#line 4770 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 202:
#line 696 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = std::move(yystack_[0].value.as< hilti::Expression > ()); }
#line 4776 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 203:
#line 699 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<hilti::Expression> > () = std::move(yystack_[0].value.as< std::vector<hilti::Expression> > ()); }
#line 4782 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 204:
#line 700 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<hilti::Expression> > () = std::vector<Expression>(); }
#line 4788 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 205:
#line 702 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<hilti::Expression> > () = std::move(yystack_[2].value.as< std::vector<hilti::Expression> > ()); yylhs.value.as< std::vector<hilti::Expression> > ().push_back(std::move(yystack_[0].value.as< hilti::Expression > ())); }
#line 4794 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 206:
#line 703 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<hilti::Expression> > () = std::vector<Expression>{std::move(yystack_[0].value.as< hilti::Expression > ())}; }
#line 4800 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 207:
#line 705 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = std::move(yystack_[0].value.as< hilti::Expression > ()); }
#line 4806 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 208:
#line 708 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::Assign(std::move(yystack_[2].value.as< hilti::Expression > ()), std::move(yystack_[0].value.as< hilti::Expression > ()), __loc__); }
#line 4812 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 209:
#line 709 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::DifferenceAssign, {std::move(yystack_[2].value.as< hilti::Expression > ()), std::move(yystack_[0].value.as< hilti::Expression > ())}, __loc__); }
#line 4818 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 210:
#line 710 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::SumAssign, {std::move(yystack_[2].value.as< hilti::Expression > ()), std::move(yystack_[0].value.as< hilti::Expression > ())}, __loc__); }
#line 4824 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 211:
#line 711 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::MultipleAssign, {std::move(yystack_[2].value.as< hilti::Expression > ()), std::move(yystack_[0].value.as< hilti::Expression > ())}, __loc__); }
#line 4830 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 212:
#line 712 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::DivisionAssign, {std::move(yystack_[2].value.as< hilti::Expression > ()), std::move(yystack_[0].value.as< hilti::Expression > ())}, __loc__); }
#line 4836 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 213:
#line 713 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::Ternary(std::move(yystack_[4].value.as< hilti::Expression > ()), std::move(yystack_[2].value.as< hilti::Expression > ()), std::move(yystack_[0].value.as< hilti::Expression > ()), __loc__); }
#line 4842 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 214:
#line 714 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = std::move(yystack_[0].value.as< hilti::Expression > ()); }
#line 4848 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 215:
#line 716 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::LogicalOr(std::move(yystack_[2].value.as< hilti::Expression > ()), std::move(yystack_[0].value.as< hilti::Expression > ()), __loc__); }
#line 4854 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 216:
#line 717 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = std::move(yystack_[0].value.as< hilti::Expression > ()); }
#line 4860 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 217:
#line 719 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::LogicalAnd(std::move(yystack_[2].value.as< hilti::Expression > ()), std::move(yystack_[0].value.as< hilti::Expression > ()), __loc__); }
#line 4866 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 218:
#line 720 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = std::move(yystack_[0].value.as< hilti::Expression > ()); }
#line 4872 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 219:
#line 722 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::Equal, {std::move(yystack_[2].value.as< hilti::Expression > ()), std::move(yystack_[0].value.as< hilti::Expression > ())}, __loc__); }
#line 4878 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 220:
#line 723 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::Unequal, {std::move(yystack_[2].value.as< hilti::Expression > ()), std::move(yystack_[0].value.as< hilti::Expression > ())}, __loc__); }
#line 4884 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 221:
#line 724 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = std::move(yystack_[0].value.as< hilti::Expression > ()); }
#line 4890 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 222:
#line 726 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::Lower, {std::move(yystack_[2].value.as< hilti::Expression > ()), std::move(yystack_[0].value.as< hilti::Expression > ())}, __loc__); }
#line 4896 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 223:
#line 727 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::Greater, {std::move(yystack_[2].value.as< hilti::Expression > ()), std::move(yystack_[0].value.as< hilti::Expression > ())}, __loc__); }
#line 4902 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 224:
#line 728 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::GreaterEqual, {std::move(yystack_[2].value.as< hilti::Expression > ()), std::move(yystack_[0].value.as< hilti::Expression > ())}, __loc__); }
#line 4908 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 225:
#line 729 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::LowerEqual, {std::move(yystack_[2].value.as< hilti::Expression > ()), std::move(yystack_[0].value.as< hilti::Expression > ())}, __loc__); }
#line 4914 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 226:
#line 730 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = std::move(yystack_[0].value.as< hilti::Expression > ()); }
#line 4920 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 227:
#line 732 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::BitOr, {std::move(yystack_[2].value.as< hilti::Expression > ()), std::move(yystack_[0].value.as< hilti::Expression > ())}, __loc__); }
#line 4926 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 228:
#line 733 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = std::move(yystack_[0].value.as< hilti::Expression > ()); }
#line 4932 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 229:
#line 735 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::BitXor, {std::move(yystack_[2].value.as< hilti::Expression > ()), std::move(yystack_[0].value.as< hilti::Expression > ())}, __loc__); }
#line 4938 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 230:
#line 736 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = std::move(yystack_[0].value.as< hilti::Expression > ()); }
#line 4944 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 231:
#line 738 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::BitAnd, {std::move(yystack_[2].value.as< hilti::Expression > ()), std::move(yystack_[0].value.as< hilti::Expression > ())}, __loc__); }
#line 4950 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 232:
#line 739 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = std::move(yystack_[0].value.as< hilti::Expression > ()); }
#line 4956 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 233:
#line 741 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::ShiftLeft, {std::move(yystack_[2].value.as< hilti::Expression > ()), std::move(yystack_[0].value.as< hilti::Expression > ())}, __loc__); }
#line 4962 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 234:
#line 742 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::ShiftRight, {std::move(yystack_[2].value.as< hilti::Expression > ()), std::move(yystack_[0].value.as< hilti::Expression > ())}, __loc__); }
#line 4968 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 235:
#line 743 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = std::move(yystack_[0].value.as< hilti::Expression > ()); }
#line 4974 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 236:
#line 745 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::Sum, {std::move(yystack_[2].value.as< hilti::Expression > ()), std::move(yystack_[0].value.as< hilti::Expression > ())}, __loc__); }
#line 4980 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 237:
#line 746 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::Difference, {std::move(yystack_[2].value.as< hilti::Expression > ()), std::move(yystack_[0].value.as< hilti::Expression > ())}, __loc__); }
#line 4986 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 238:
#line 747 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = std::move(yystack_[0].value.as< hilti::Expression > ()); }
#line 4992 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 239:
#line 749 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::Modulo, {std::move(yystack_[2].value.as< hilti::Expression > ()), std::move(yystack_[0].value.as< hilti::Expression > ())}, __loc__); }
#line 4998 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 240:
#line 750 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::Multiple, {std::move(yystack_[2].value.as< hilti::Expression > ()), std::move(yystack_[0].value.as< hilti::Expression > ())}, __loc__); }
#line 5004 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 241:
#line 751 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::Division, {std::move(yystack_[2].value.as< hilti::Expression > ()), std::move(yystack_[0].value.as< hilti::Expression > ())}, __loc__); }
#line 5010 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 242:
#line 752 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::Power, {std::move(yystack_[2].value.as< hilti::Expression > ()), std::move(yystack_[0].value.as< hilti::Expression > ())}, __loc__); }
#line 5016 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 243:
#line 753 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = std::move(yystack_[0].value.as< hilti::Expression > ()); }
#line 5022 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 244:
#line 755 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::LogicalNot(std::move(yystack_[0].value.as< hilti::Expression > ()), __loc__); }
#line 5028 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 245:
#line 756 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::Deref, {std::move(yystack_[0].value.as< hilti::Expression > ())}, __loc__); }
#line 5034 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 246:
#line 757 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::Negate, {std::move(yystack_[0].value.as< hilti::Expression > ())}, __loc__); }
#line 5040 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 247:
#line 758 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::Size, {std::move(yystack_[1].value.as< hilti::Expression > ())}, __loc__); }
#line 5046 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 248:
#line 759 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::DecrPrefix, {std::move(yystack_[0].value.as< hilti::Expression > ())}, __loc__); }
#line 5052 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 249:
#line 760 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::IncrPrefix, {std::move(yystack_[0].value.as< hilti::Expression > ())}, __loc__); }
#line 5058 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 250:
#line 761 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = std::move(yystack_[0].value.as< hilti::Expression > ()); }
#line 5064 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 251:
#line 763 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::Call, {std::move(yystack_[3].value.as< hilti::Expression > ()), hilti::expression::Ctor(hilti::ctor::Tuple(std::move(yystack_[1].value.as< std::vector<hilti::Expression> > ()), __loc__))}, __loc__); }
#line 5070 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 252:
#line 764 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::Member, {std::move(yystack_[2].value.as< hilti::Expression > ()), std::move(yystack_[0].value.as< hilti::Expression > ())}, __loc__); }
#line 5076 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 253:
#line 765 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::MemberCall, {std::move(yystack_[5].value.as< hilti::Expression > ()), std::move(yystack_[3].value.as< hilti::Expression > ()), hilti::expression::Ctor(hilti::ctor::Tuple(std::move(yystack_[1].value.as< std::vector<hilti::Expression> > ()), __loc__))}, __loc__); }
#line 5082 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 254:
#line 766 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::Index, {std::move(yystack_[3].value.as< hilti::Expression > ()), std::move(yystack_[1].value.as< hilti::Expression > ())}, __loc__); }
#line 5088 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 255:
#line 767 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::HasMember, {std::move(yystack_[2].value.as< hilti::Expression > ()), std::move(yystack_[0].value.as< hilti::Expression > ())}, __loc__); }
#line 5094 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 256:
#line 768 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::In, {std::move(yystack_[2].value.as< hilti::Expression > ()), std::move(yystack_[0].value.as< hilti::Expression > ())}, __loc__); }
#line 5100 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 257:
#line 769 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::LogicalNot(hilti::expression::UnresolvedOperator(hilti::operator_::Kind::In, {std::move(yystack_[2].value.as< hilti::Expression > ()), std::move(yystack_[0].value.as< hilti::Expression > ())}, __loc__)); }
#line 5106 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 258:
#line 770 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::DecrPostfix, {std::move(yystack_[1].value.as< hilti::Expression > ())}, __loc__); }
#line 5112 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 259:
#line 771 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::IncrPostfix, {std::move(yystack_[1].value.as< hilti::Expression > ())}, __loc__); }
#line 5118 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 260:
#line 772 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::TryMember, {std::move(yystack_[2].value.as< hilti::Expression > ()), std::move(yystack_[0].value.as< hilti::Expression > ())}, __loc__); }
#line 5124 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 261:
#line 773 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = std::move(yystack_[0].value.as< hilti::Expression > ()); }
#line 5130 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 262:
#line 775 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::Begin, {std::move(yystack_[1].value.as< hilti::Expression > ())}, __loc__); }
#line 5136 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 263:
#line 776 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::Cast, {std::move(yystack_[1].value.as< hilti::Expression > ()), hilti::expression::Type_(std::move(yystack_[4].value.as< hilti::Type > ()))}, __loc__); }
#line 5142 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 264:
#line 777 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::End, {std::move(yystack_[1].value.as< hilti::Expression > ())}, __loc__); }
#line 5148 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 265:
#line 778 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::Move(std::move(yystack_[1].value.as< hilti::Expression > ()), __loc__); }
#line 5154 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 266:
#line 779 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::Unpack, {hilti::expression::Type_(std::move(yystack_[2].value.as< hilti::Type > ())), std::move(yystack_[0].value.as< hilti::Expression > ())}, __loc__); }
#line 5160 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 267:
#line 780 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::New, {std::move(yystack_[0].value.as< hilti::Expression > ()), hilti::expression::Ctor(hilti::ctor::Tuple({}, __loc__))}, __loc__); }
#line 5166 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 268:
#line 781 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::New, {hilti::expression::Type_(std::move(yystack_[0].value.as< hilti::Type > ())), hilti::expression::Ctor(hilti::ctor::Tuple({}, __loc__))}, __loc__); }
#line 5172 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 269:
#line 782 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::New, {hilti::expression::Type_(std::move(yystack_[3].value.as< hilti::Type > ())), hilti::expression::Ctor(hilti::ctor::Tuple(std::move(yystack_[1].value.as< std::vector<hilti::Expression> > ()), __loc__))}, __loc__); }
#line 5178 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 270:
#line 783 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::TypeInfo(std::move(yystack_[1].value.as< hilti::Expression > ()), __loc__); }
#line 5184 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 271:
#line 784 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::TypeInfo(expression::Type_(std::move(yystack_[1].value.as< hilti::Type > ())), __loc__); }
#line 5190 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 272:
#line 785 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = std::move(yystack_[0].value.as< hilti::Expression > ()); }
#line 5196 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 273:
#line 787 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::Ctor(std::move(yystack_[0].value.as< hilti::Ctor > ()), __loc__); }
#line 5202 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 274:
#line 788 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::builder::port(std::move(yystack_[3].value.as< hilti::Expression > ()), std::move(yystack_[1].value.as< hilti::Expression > ()), __loc__); }
#line 5208 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 275:
#line 789 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::SignNeg, {std::move(yystack_[0].value.as< hilti::Expression > ())}, __loc__); }
#line 5214 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 276:
#line 791 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::ListComprehension(std::move(yystack_[1].value.as< hilti::Expression > ()), std::move(yystack_[5].value.as< hilti::Expression > ()), std::move(yystack_[3].value.as< hilti::ID > ()), {},  __loc__); }
#line 5220 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 277:
#line 793 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::ListComprehension(std::move(yystack_[3].value.as< hilti::Expression > ()), std::move(yystack_[7].value.as< hilti::Expression > ()), std::move(yystack_[5].value.as< hilti::ID > ()), std::move(yystack_[1].value.as< hilti::Expression > ()),  __loc__); }
#line 5226 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 278:
#line 794 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = std::move(yystack_[0].value.as< hilti::Expression > ()); }
#line 5232 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 279:
#line 796 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::Grouping(std::move(yystack_[1].value.as< hilti::Expression > ())); }
#line 5238 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 280:
#line 797 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::UnresolvedID(std::move(yystack_[0].value.as< hilti::ID > ()), __loc__); }
#line 5244 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 281:
#line 800 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::Member(std::move(yystack_[0].value.as< hilti::ID > ()), __loc__); }
#line 5250 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 282:
#line 801 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::Member(ID("error", __loc__), __loc__); }
#line 5256 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 283:
#line 805 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Ctor > () = hilti::ctor::Bool(yystack_[0].value.as< bool > (), __loc__); }
#line 5262 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 284:
#line 806 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Ctor > () = hilti::ctor::Bytes(std::move(yystack_[0].value.as< std::string > ()), __loc__); }
#line 5268 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 285:
#line 807 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Ctor > () = hilti::ctor::String(yystack_[0].value.as< std::string > (), __loc__); }
#line 5274 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 286:
#line 808 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Ctor > () = hilti::ctor::Real(yystack_[0].value.as< double > (), __loc__); }
#line 5280 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 287:
#line 809 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Ctor > () = hilti::ctor::UnsignedInteger(yystack_[0].value.as< uint64_t > (), 64, __loc__); }
#line 5286 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 288:
#line 810 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Ctor > () = hilti::ctor::SignedInteger(check_int64_range(yystack_[0].value.as< uint64_t > (), true, __loc__), 64, __loc__); }
#line 5292 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 289:
#line 811 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Ctor > () = hilti::ctor::SignedInteger(-check_int64_range(yystack_[0].value.as< uint64_t > (), false, __loc__), 64, __loc__); }
#line 5298 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 290:
#line 812 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Ctor > () = hilti::ctor::Null(__loc__); }
#line 5304 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 291:
#line 814 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Ctor > () = hilti::ctor::Address(hilti::ctor::Address::Value(yystack_[0].value.as< std::string > ()), __loc__); }
#line 5310 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 292:
#line 815 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Ctor > () = hilti::ctor::Network(hilti::ctor::Network::Value(yystack_[2].value.as< std::string > (), yystack_[0].value.as< uint64_t > ()), __loc__); }
#line 5316 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 293:
#line 816 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Ctor > () = hilti::ctor::Port(hilti::ctor::Port::Value(yystack_[0].value.as< std::string > ()), __loc__); }
#line 5322 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 294:
#line 817 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { try { yylhs.value.as< hilti::Ctor > () = hilti::ctor::Interval(hilti::ctor::Interval::Value(yystack_[1].value.as< double > (), hilti::rt::Interval::SecondTag()), __loc__); }
                                                   catch ( hilti::rt::OutOfRange& e ) { yylhs.value.as< hilti::Ctor > () = hilti::ctor::Interval(hilti::ctor::Interval::Value()); error(yylhs.location, e.what()); }
                                                 }
#line 5330 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 295:
#line 820 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { try { yylhs.value.as< hilti::Ctor > () = hilti::ctor::Interval(hilti::ctor::Interval::Value(yystack_[1].value.as< int64_t > (), hilti::rt::Interval::SecondTag()), __loc__); }
                                                   catch ( hilti::rt::OutOfRange& e ) { yylhs.value.as< hilti::Ctor > () = hilti::ctor::Interval(hilti::ctor::Interval::Value()); error(yylhs.location, e.what()); }
                                                 }
#line 5338 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 296:
#line 823 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { try { yylhs.value.as< hilti::Ctor > () = hilti::ctor::Time(hilti::ctor::Time::Value(yystack_[1].value.as< double > (), hilti::rt::Time::SecondTag()), __loc__); }
                                                   catch ( hilti::rt::OutOfRange& e ) { yylhs.value.as< hilti::Ctor > () = hilti::ctor::Time(hilti::ctor::Time::Value()); error(yylhs.location, e.what()); }
                                                 }
#line 5346 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 297:
#line 826 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { try { yylhs.value.as< hilti::Ctor > () = hilti::ctor::Time(hilti::ctor::Time::Value(yystack_[1].value.as< uint64_t > (), hilti::rt::Time::SecondTag()), __loc__); }
                                                   catch ( hilti::rt::OutOfRange& e ) { yylhs.value.as< hilti::Ctor > () = hilti::ctor::Time(hilti::ctor::Time::Value()); error(yylhs.location, e.what()); }
                                                 }
#line 5354 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 298:
#line 829 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Ctor > () = hilti::ctor::Stream(std::move(yystack_[1].value.as< std::string > ()), __loc__); }
#line 5360 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 299:
#line 831 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Ctor > () = hilti::ctor::Error(std::move(yystack_[1].value.as< std::string > ()), __loc__); }
#line 5366 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 300:
#line 832 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Ctor > () = hilti::ctor::Optional(std::move(yystack_[1].value.as< hilti::Expression > ()), __loc__); }
#line 5372 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 301:
#line 834 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Ctor > () = hilti::ctor::Default(std::move(yystack_[4].value.as< hilti::Type > ()), std::move(yystack_[1].value.as< std::vector<hilti::Expression> > ()), __loc__); }
#line 5378 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 302:
#line 837 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Ctor > () = hilti::ctor::UnsignedInteger(yystack_[1].value.as< uint64_t > (), yystack_[4].value.as< uint64_t > (), __loc__); }
#line 5384 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 303:
#line 839 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Ctor > () = hilti::ctor::SignedInteger(check_int64_range(yystack_[1].value.as< uint64_t > (), true, __loc__), yystack_[4].value.as< uint64_t > (), __loc__); }
#line 5390 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 304:
#line 841 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Ctor > () = hilti::ctor::SignedInteger(-check_int64_range(yystack_[1].value.as< uint64_t > (), false, __loc__), yystack_[5].value.as< uint64_t > (), __loc__); }
#line 5396 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 305:
#line 843 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Ctor > () = std::move(yystack_[0].value.as< hilti::Ctor > ()); }
#line 5402 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 306:
#line 844 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Ctor > () = std::move(yystack_[0].value.as< hilti::Ctor > ()); }
#line 5408 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 307:
#line 845 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Ctor > () = std::move(yystack_[0].value.as< hilti::Ctor > ()); }
#line 5414 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 308:
#line 846 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Ctor > () = std::move(yystack_[0].value.as< hilti::Ctor > ()); }
#line 5420 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 309:
#line 847 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Ctor > () = std::move(yystack_[0].value.as< hilti::Ctor > ()); }
#line 5426 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 310:
#line 848 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Ctor > () = std::move(yystack_[0].value.as< hilti::Ctor > ()); }
#line 5432 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 311:
#line 851 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< double > () = yystack_[0].value.as< double > (); }
#line 5438 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 312:
#line 852 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< double > () = yystack_[0].value.as< double > (); }
#line 5444 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 313:
#line 853 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< double > () = -yystack_[0].value.as< double > (); }
#line 5450 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 314:
#line 855 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< int64_t > () = check_int64_range(yystack_[0].value.as< uint64_t > (), true, __loc__); }
#line 5456 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 315:
#line 856 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< int64_t > () = check_int64_range(yystack_[0].value.as< uint64_t > (), true, __loc__); }
#line 5462 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 316:
#line 857 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< int64_t > () = -check_int64_range(yystack_[0].value.as< uint64_t > (), false, __loc__); }
#line 5468 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 317:
#line 859 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< uint64_t > () = yystack_[0].value.as< uint64_t > (); }
#line 5474 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 318:
#line 860 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< uint64_t > () = yystack_[0].value.as< uint64_t > (); }
#line 5480 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 319:
#line 863 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Ctor > () = hilti::ctor::Tuple(std::move(yystack_[1].value.as< std::vector<hilti::Expression> > ()), __loc__); }
#line 5486 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 320:
#line 866 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<hilti::Expression> > () = std::vector<hilti::Expression>{std::move(yystack_[0].value.as< hilti::Expression > ())}; }
#line 5492 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 321:
#line 867 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<hilti::Expression> > () = std::vector<hilti::Expression>{std::move(yystack_[2].value.as< hilti::Expression > ())}; yylhs.value.as< std::vector<hilti::Expression> > ().insert(yylhs.value.as< std::vector<hilti::Expression> > ().end(), yystack_[0].value.as< std::vector<hilti::Expression> > ().begin(), yystack_[0].value.as< std::vector<hilti::Expression> > ().end()); }
#line 5498 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 322:
#line 868 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<hilti::Expression> > () = std::vector<hilti::Expression>(); }
#line 5504 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 323:
#line 871 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<hilti::Expression> > () = std::vector<hilti::Expression>{ std::move(yystack_[0].value.as< hilti::Expression > ())}; }
#line 5510 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 324:
#line 872 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<hilti::Expression> > () = std::vector<hilti::Expression>{std::move(yystack_[2].value.as< hilti::Expression > ())}; yylhs.value.as< std::vector<hilti::Expression> > ().insert(yylhs.value.as< std::vector<hilti::Expression> > ().end(), yystack_[0].value.as< std::vector<hilti::Expression> > ().begin(), yystack_[0].value.as< std::vector<hilti::Expression> > ().end()); }
#line 5516 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 325:
#line 873 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<hilti::Expression> > () = std::vector<hilti::Expression>(); }
#line 5522 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 326:
#line 876 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = std::move(yystack_[0].value.as< hilti::Expression > ()); }
#line 5528 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 327:
#line 879 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::Ctor(std::move(yystack_[0].value.as< hilti::Ctor > ()), __loc__); }
#line 5534 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 328:
#line 881 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Ctor > () = hilti::ctor::List(std::move(yystack_[1].value.as< std::vector<hilti::Expression> > ()), __loc__); }
#line 5540 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 329:
#line 882 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Ctor > () = hilti::ctor::List(std::move(yystack_[1].value.as< std::vector<hilti::Expression> > ()), __loc__); }
#line 5546 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 330:
#line 884 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Ctor > () = hilti::ctor::List(std::move(yystack_[4].value.as< hilti::Type > ()), std::move(yystack_[1].value.as< std::vector<hilti::Expression> > ()), __loc__); }
#line 5552 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 331:
#line 885 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Ctor > () = hilti::ctor::Vector(std::move(yystack_[1].value.as< std::vector<hilti::Expression> > ()), __loc__); }
#line 5558 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 332:
#line 887 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Ctor > () = hilti::ctor::Vector(std::move(yystack_[4].value.as< hilti::Type > ()), std::move(yystack_[1].value.as< std::vector<hilti::Expression> > ()), __loc__); }
#line 5564 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 333:
#line 889 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Ctor > () = hilti::ctor::Set(std::move(yystack_[1].value.as< std::vector<hilti::Expression> > ()), __loc__); }
#line 5570 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 334:
#line 891 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Ctor > () = hilti::ctor::Set(std::move(yystack_[4].value.as< hilti::Type > ()), std::move(yystack_[1].value.as< std::vector<hilti::Expression> > ()), __loc__); }
#line 5576 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 335:
#line 893 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Ctor > () = hilti::ctor::Map(std::move(yystack_[1].value.as< std::vector<hilti::ctor::map::Element> > ()), __loc__); }
#line 5582 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 336:
#line 895 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Ctor > () = hilti::ctor::Map(std::move(yystack_[6].value.as< hilti::Type > ()), std::move(yystack_[4].value.as< hilti::Type > ()), std::move(yystack_[1].value.as< std::vector<hilti::ctor::map::Element> > ()), __loc__); }
#line 5588 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 337:
#line 897 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Ctor > () = hilti::ctor::Struct(std::move(yystack_[1].value.as< std::vector<hilti::ctor::struct_::Field> > ()), __loc__); }
#line 5594 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 338:
#line 899 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<hilti::ctor::struct_::Field> > () = std::move(yystack_[2].value.as< std::vector<hilti::ctor::struct_::Field> > ()); yylhs.value.as< std::vector<hilti::ctor::struct_::Field> > ().push_back(yystack_[0].value.as< hilti::ctor::struct_::Field > ()); }
#line 5600 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 339:
#line 900 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<hilti::ctor::struct_::Field> > () = std::vector<hilti::ctor::struct_::Field>{ std::move(yystack_[0].value.as< hilti::ctor::struct_::Field > ()) }; }
#line 5606 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 340:
#line 902 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::ctor::struct_::Field > () = hilti::ctor::struct_::Field(std::move(yystack_[2].value.as< hilti::ID > ()), std::move(yystack_[0].value.as< hilti::Expression > ())); }
#line 5612 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 341:
#line 904 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Ctor > () = hilti::ctor::RegExp(std::move(yystack_[1].value.as< std::vector<std::string> > ()), std::move(yystack_[0].value.as< std::optional<hilti::AttributeSet> > ()), __loc__); }
#line 5618 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 342:
#line 907 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<std::string> > () = yystack_[2].value.as< std::vector<std::string> > (); yylhs.value.as< std::vector<std::string> > ().push_back(std::move(yystack_[0].value.as< std::string > ())); }
#line 5624 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 343:
#line 908 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<std::string> > () = std::vector<std::string>{std::move(yystack_[0].value.as< std::string > ())}; }
#line 5630 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 344:
#line 911 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { driver->enablePatternMode(); }
#line 5636 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 345:
#line 911 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { driver->disablePatternMode(); }
#line 5642 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 346:
#line 912 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::string > () = std::move(yystack_[2].value.as< std::string > ()); }
#line 5648 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 347:
#line 914 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<hilti::ctor::map::Element> > () = std::move(yystack_[0].value.as< std::vector<hilti::ctor::map::Element> > ()); }
#line 5654 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 348:
#line 915 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<hilti::ctor::map::Element> > () = std::vector<hilti::ctor::map::Element>(); }
#line 5660 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 349:
#line 917 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<hilti::ctor::map::Element> > () = std::move(yystack_[2].value.as< std::vector<hilti::ctor::map::Element> > ()); yylhs.value.as< std::vector<hilti::ctor::map::Element> > ().push_back(std::move(yystack_[0].value.as< hilti::ctor::map::Element > ())); }
#line 5666 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 350:
#line 918 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<hilti::ctor::map::Element> > () = std::vector<hilti::ctor::map::Element>(); yylhs.value.as< std::vector<hilti::ctor::map::Element> > ().push_back(std::move(yystack_[0].value.as< hilti::ctor::map::Element > ())); }
#line 5672 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 351:
#line 920 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::ctor::map::Element > () = hilti::ctor::map::Element(yystack_[2].value.as< hilti::Expression > (), yystack_[0].value.as< hilti::Expression > (), __loc__); }
#line 5678 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 352:
#line 923 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Attribute > () = hilti::Attribute(std::move(yystack_[0].value.as< std::string > ()), __loc__); }
#line 5684 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 353:
#line 924 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Attribute > () = hilti::Attribute(std::move(yystack_[2].value.as< std::string > ()), std::move(yystack_[0].value.as< hilti::Expression > ()), __loc__); }
#line 5690 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 354:
#line 927 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::optional<hilti::AttributeSet> > () = hilti::AttributeSet::add(yystack_[1].value.as< std::optional<hilti::AttributeSet> > (), yystack_[0].value.as< hilti::Attribute > ()); }
#line 5696 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 355:
#line 928 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::optional<hilti::AttributeSet> > () = {}; }
#line 5702 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
    break;


#line 5706 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:859
            default:
              break;
            }
        }
      catch (const syntax_error& yyexc)
        {
          error (yyexc);
          YYERROR;
        }
      YY_SYMBOL_PRINT ("-> $$ =", yylhs);
      yypop_ (yylen);
      yylen = 0;
      YY_STACK_PRINT ();

      // Shift the result of the reduction.
      yypush_ (YY_NULLPTR, yylhs);
    }
    goto yynewstate;

  /*--------------------------------------.
  | yyerrlab -- here on detecting error.  |
  `--------------------------------------*/
  yyerrlab:
    // If not already recovering from an error, report this error.
    if (!yyerrstatus_)
      {
        ++yynerrs_;
        error (yyla.location, yysyntax_error_ (yystack_[0].state, yyla));
      }


    yyerror_range[1].location = yyla.location;
    if (yyerrstatus_ == 3)
      {
        /* If just tried and failed to reuse lookahead token after an
           error, discard it.  */

        // Return failure if at end of input.
        if (yyla.type_get () == yyeof_)
          YYABORT;
        else if (!yyla.empty ())
          {
            yy_destroy_ ("Error: discarding", yyla);
            yyla.clear ();
          }
      }

    // Else will try to reuse lookahead token after shifting the error token.
    goto yyerrlab1;


  /*---------------------------------------------------.
  | yyerrorlab -- error raised explicitly by YYERROR.  |
  `---------------------------------------------------*/
  yyerrorlab:

    /* Pacify compilers like GCC when the user code never invokes
       YYERROR and the label yyerrorlab therefore never appears in user
       code.  */
    if (false)
      goto yyerrorlab;
    yyerror_range[1].location = yystack_[yylen - 1].location;
    /* Do not reclaim the symbols of the rule whose action triggered
       this YYERROR.  */
    yypop_ (yylen);
    yylen = 0;
    goto yyerrlab1;

  /*-------------------------------------------------------------.
  | yyerrlab1 -- common code for both syntax error and YYERROR.  |
  `-------------------------------------------------------------*/
  yyerrlab1:
    yyerrstatus_ = 3;   // Each real token shifted decrements this.
    {
      stack_symbol_type error_token;
      for (;;)
        {
          yyn = yypact_[yystack_[0].state];
          if (!yy_pact_value_is_default_ (yyn))
            {
              yyn += yyterror_;
              if (0 <= yyn && yyn <= yylast_ && yycheck_[yyn] == yyterror_)
                {
                  yyn = yytable_[yyn];
                  if (0 < yyn)
                    break;
                }
            }

          // Pop the current state because it cannot handle the error token.
          if (yystack_.size () == 1)
            YYABORT;

          yyerror_range[1].location = yystack_[0].location;
          yy_destroy_ ("Error: popping", yystack_[0]);
          yypop_ ();
          YY_STACK_PRINT ();
        }

      yyerror_range[2].location = yyla.location;
      YYLLOC_DEFAULT (error_token.location, yyerror_range, 2);

      // Shift the error token.
      error_token.state = yyn;
      yypush_ ("Shifting", error_token);
    }
    goto yynewstate;

    // Accept.
  yyacceptlab:
    yyresult = 0;
    goto yyreturn;

    // Abort.
  yyabortlab:
    yyresult = 1;
    goto yyreturn;

  yyreturn:
    if (!yyla.empty ())
      yy_destroy_ ("Cleanup: discarding lookahead", yyla);

    /* Do not reclaim the symbols of the rule whose action triggered
       this YYABORT or YYACCEPT.  */
    yypop_ (yylen);
    while (1 < yystack_.size ())
      {
        yy_destroy_ ("Cleanup: popping", yystack_[0]);
        yypop_ ();
      }

    return yyresult;
  }
    catch (...)
      {
        YYCDEBUG << "Exception caught: cleaning lookahead and stack"
                 << std::endl;
        // Do not try to display the values of the reclaimed symbols,
        // as their printer might throw an exception.
        if (!yyla.empty ())
          yy_destroy_ (YY_NULLPTR, yyla);

        while (1 < yystack_.size ())
          {
            yy_destroy_ (YY_NULLPTR, yystack_[0]);
            yypop_ ();
          }
        throw;
      }
  }

  void
  Parser::error (const syntax_error& yyexc)
  {
    error (yyexc.location, yyexc.what());
  }

  // Generate an error message.
  std::string
  Parser::yysyntax_error_ (state_type yystate, const symbol_type& yyla) const
  {
    // Number of reported tokens (one for the "unexpected", one per
    // "expected").
    size_t yycount = 0;
    // Its maximum.
    enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
    // Arguments of yyformat.
    char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];

    /* There are many possibilities here to consider:
       - If this state is a consistent state with a default action, then
         the only way this function was invoked is if the default action
         is an error action.  In that case, don't check for expected
         tokens because there are none.
       - The only way there can be no lookahead present (in yyla) is
         if this state is a consistent state with a default action.
         Thus, detecting the absence of a lookahead is sufficient to
         determine that there is no unexpected or expected token to
         report.  In that case, just report a simple "syntax error".
       - Don't assume there isn't a lookahead just because this state is
         a consistent state with a default action.  There might have
         been a previous inconsistent state, consistent state with a
         non-default action, or user semantic action that manipulated
         yyla.  (However, yyla is currently not documented for users.)
       - Of course, the expected token list depends on states to have
         correct lookahead information, and it depends on the parser not
         to perform extra reductions after fetching a lookahead from the
         scanner and before detecting a syntax error.  Thus, state
         merging (from LALR or IELR) and default reductions corrupt the
         expected token list.  However, the list is correct for
         canonical LR with one exception: it will still contain any
         token that will not be accepted due to an error action in a
         later state.
    */
    if (!yyla.empty ())
      {
        int yytoken = yyla.type_get ();
        yyarg[yycount++] = yytname_[yytoken];
        int yyn = yypact_[yystate];
        if (!yy_pact_value_is_default_ (yyn))
          {
            /* Start YYX at -YYN if negative to avoid negative indexes in
               YYCHECK.  In other words, skip the first -YYN actions for
               this state because they are default actions.  */
            int yyxbegin = yyn < 0 ? -yyn : 0;
            // Stay within bounds of both yycheck and yytname.
            int yychecklim = yylast_ - yyn + 1;
            int yyxend = yychecklim < yyntokens_ ? yychecklim : yyntokens_;
            for (int yyx = yyxbegin; yyx < yyxend; ++yyx)
              if (yycheck_[yyx + yyn] == yyx && yyx != yyterror_
                  && !yy_table_value_is_error_ (yytable_[yyx + yyn]))
                {
                  if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                    {
                      yycount = 1;
                      break;
                    }
                  else
                    yyarg[yycount++] = yytname_[yyx];
                }
          }
      }

    char const* yyformat = YY_NULLPTR;
    switch (yycount)
      {
#define YYCASE_(N, S)                         \
        case N:                               \
          yyformat = S;                       \
        break
        YYCASE_(0, YY_("syntax error"));
        YYCASE_(1, YY_("syntax error, unexpected %s"));
        YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
        YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
        YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
        YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
#undef YYCASE_
      }

    std::string yyres;
    // Argument number.
    size_t yyi = 0;
    for (char const* yyp = yyformat; *yyp; ++yyp)
      if (yyp[0] == '%' && yyp[1] == 's' && yyi < yycount)
        {
          yyres += yytnamerr_ (yyarg[yyi++]);
          ++yyp;
        }
      else
        yyres += *yyp;
    return yyres;
  }


  const short int Parser::yypact_ninf_ = -598;

  const short int Parser::yytable_ninf_ = -323;

  const short int
  Parser::yypact_[] =
  {
     -38,    71,   107,  -598,     9,  -598,  -598,  1656,  -598,   -53,
    -598,  -598,   -12,  -598,  -598,  -598,  -598,  3236,  3236,  3236,
      56,    74,    65,  -598,    94,    -4,    65,  3236,    97,   103,
     125,   132,    71,  -598,    82,   140,    10,  4634,    63,   221,
    3236,   145,  1814,   152,  3236,   157,  -598,  -598,  -598,  2762,
      99,   160,   175,   178,  2920,  2130,   180,   182,    65,  3236,
     124,   183,   199,  -598,  3236,  3236,  3236,   283,    31,  -598,
    3236,  3236,  1022,  -598,  -598,  -598,  1182,  1340,  -598,  -598,
    -598,  -598,  -598,     8,  -598,  -598,   205,  -598,  -598,  -598,
     112,   326,     4,    55,   200,   209,   201,   194,   154,    78,
    -598,   230,  -598,  -598,  -598,  -598,  -598,  -598,  -598,  -598,
    -598,  -598,  -598,   212,  -598,  3236,  -598,   351,   229,   -79,
     -60,  3236,  -598,  -598,  4748,  -598,    -8,  4748,   234,  3236,
     362,    71,  3078,   -32,   361,    12,  3236,  4748,  -598,  -598,
     375,  -598,  -598,  -598,   -10,  -598,   235,  -598,    65,  -598,
      65,    65,   237,    65,    65,  -598,  -598,    65,  -598,    65,
    -598,    65,    65,  -598,  -598,   239,  -598,    65,    65,  -598,
      65,    65,  -598,    65,    65,   242,  -598,   320,  -598,  -598,
    -598,    71,  -598,  -598,  -598,  -598,  -598,  3236,  4748,  -598,
    -598,  -598,  4748,  -598,  3236,  -598,   243,   240,   244,    10,
      63,   128,   252,    99,   254,   257,   253,   124,  3334,   259,
    -598,  3236,  -598,  3236,  -598,   261,  3236,  4748,   393,  3078,
      14,  -598,   263,  2288,  -598,  -598,     1,   371,  -598,  -598,
    1972,   395,  4748,   271,  3236,  4748,  3078,  -598,   270,   274,
     277,  -598,   264,  -598,  -598,  -598,  -598,  3236,  -598,   415,
    -598,  -598,    71,   372,   273,   292,   -67,  -598,  4748,   221,
    4862,   221,   323,  -598,  3236,  3236,  3236,  3236,  3236,  3236,
    3236,  3236,  3236,  3236,  3236,  3236,  3236,  3236,  3236,  3236,
    3236,  3236,  3236,  3236,  3236,  3236,  3236,  3236,  3236,    48,
     102,  -598,   102,  -598,    48,  3236,    48,  3236,   281,   435,
     302,  -598,  -598,  -598,  3236,  -598,  3236,   303,   297,   307,
     221,   297,  -598,   306,   308,   380,  4976,   -33,   309,  -598,
    -598,   305,  -598,   317,   319,   311,   327,  -598,   330,   297,
     328,    71,   314,  4748,    17,  4748,  4748,   453,  3488,  3602,
    4748,  3716,  4748,  3830,   -20,   331,  3944,    24,    34,  4058,
    4748,  4172,  4286,  3236,   324,  -598,    20,   318,   332,   335,
    -598,   339,    88,  -598,   333,   459,  3488,  3602,  3830,   463,
    4058,  3236,   343,   344,  -598,   346,   297,   347,   348,   350,
    -598,   321,   473,   352,   353,  -598,   355,  2446,  -598,  2604,
     462,  -598,   356,   357,   354,   297,  -598,   358,   297,   -21,
     364,  -598,  -598,  3236,  -598,   366,  -598,   373,    71,  -598,
    3236,   336,  -598,   374,   323,  -598,  4748,   334,   376,   323,
    -598,  4748,   377,  -598,  -598,   489,  -598,  -598,  -598,   359,
       5,   117,   121,   365,   368,   370,   378,   379,   360,   231,
     190,   202,   104,   163,  -598,  -598,  -598,  -598,  -598,  -598,
    -598,   322,   325,  -598,   382,   381,   383,  -598,   386,  -598,
    -598,   388,   390,  -598,  -598,   385,  -598,  4748,   392,  -598,
    -598,  3236,   518,    71,  3236,  2130,  2130,   391,   516,   394,
    -598,  -598,  -598,  -598,  -598,   397,  3236,   401,    44,  -598,
     387,  -598,   297,   297,   297,   297,   400,   297,   297,   297,
     402,   297,   297,   297,   297,   297,   297,  -598,  -598,   404,
     405,  -598,  4748,  -598,   297,   403,  -598,    46,  -598,   297,
     297,  4400,   297,   297,   297,   297,   297,   297,   297,   409,
     -20,  3236,  3236,   410,  3236,  -598,  3236,  4748,  -598,  -598,
    -598,  -598,  -598,   411,  -598,   297,   408,   297,   297,   412,
    -598,  3236,  -598,   416,  -598,   407,   421,  -598,  -598,  -598,
    -598,  -598,  1498,  -598,  -598,  -598,  -598,   418,   419,  -598,
     420,  3236,  2130,  2130,  -598,  -598,   422,   398,  3236,   494,
    -598,  -598,  3236,   425,    88,   427,  3236,    37,    88,  4748,
    3236,  -598,  3236,  -598,  3236,  -598,  -598,  3236,    88,  3236,
     426,   430,   431,   429,   524,   525,  -598,  -598,    -9,  3236,
     437,   561,  -598,    71,  -598,  -598,  -598,  -598,  -598,  -598,
    -598,  -598,  -598,  4748,  -598,  -598,  -598,  -598,  -598,  -598,
    -598,    11,    71,  4517,  -598,  4748,  4748,  -598,  -598,  -598,
      71,   440,   436,  -598,  -598,  -598,  -598,  -598,  -598,  -598,
    -598,  -598,   438,   441,   442,  -598,  -598,  -598,   297,   -20,
     444,  4748,   447,   448,  -598,   450,  3236,    80,    80,    71,
     579,  3236,  -598,  -598,  3236,   452,   546,   549,  3236,  -598,
    -598,  3236,   461,  3236,   465,  3236,   467,  3236,   475,   472,
    -598,  -598,   474,  -598,   477,   479,   480,  2130,  3236,  3236,
    2130,  2130,  -598,  -598,  -598,   481,   589,   484,  -598,  -598,
    -598,   297,  -598,   485,  -598,   191,    71,  -598,  -598,  -598,
    -598,  -598,  4748,   598,  -598,  -598,   486,   487,   297,  -598,
     490,  3236,   491,   493,    80,  -598,   495,   497,   498,   499,
    2130,  -598,  -598,  -598,   -57,  -598,   488,   -20,   496,  -598,
     502,  -598,   -20,     2,  -598,  -598,   -20,  -598,  -598,  -598,
    -598,   594,  -598,  -598,   503,  -598,  -598,  3236,  -598,  4748,
    -598,   638,  -598,  4748,  3236,  -598,   505,  -598,   213,  2130,
    -598,  -598,  -598,  2130,  -598,  -598,   599,  3236,  -598,  -598,
     507,  -598,  -598,   509,  -598,   513,  -598,  -598,  -598,   638,
      41,    30,  -598,   515,    36,  2130,  -598,  -598,  -598,   500,
    -598,  -598,  -598,   506,  -598,  -598,  -598,  -598,  -598,    36,
      36,   638,   -20,  -598,  -598,   519,  -598,    13,  -598,  -598
  };

  const unsigned short int
  Parser::yydefact_[] =
  {
       0,     0,     0,     3,     0,     1,    11,    45,     5,     0,
     285,   284,   291,   293,   311,   287,   283,     0,     0,     0,
       0,     0,     0,   290,     0,    45,     0,     0,     0,     0,
       0,     0,     0,    43,     0,     0,     0,    56,     0,    61,
       0,     0,    56,     0,     0,     0,    44,    42,    41,     0,
       0,     0,     0,     0,     0,    45,     0,     0,     0,     0,
       0,     0,     0,     2,   322,     0,     0,     0,     0,   344,
       0,     0,   204,     4,   280,     9,    12,    13,   118,    14,
      15,    16,    17,     0,    10,    81,     0,   121,   202,   207,
     214,   216,   218,   221,   226,   228,   230,   232,   235,   238,
     243,   250,   261,   272,   278,   273,   286,   310,   305,   308,
     306,   309,   307,   355,   343,     0,    39,     0,     0,     0,
       0,     0,    87,   171,    56,    88,    56,    56,     0,     0,
       0,     0,     0,     0,     0,     0,   204,    56,   123,   122,
       0,   125,   126,   131,     0,   127,   160,    58,     0,   128,
       0,     0,     0,     0,     0,    57,   129,     0,   130,     0,
     132,     0,     0,   133,   134,   183,   135,     0,     0,   355,
       0,     0,   136,     0,     0,     4,   170,     0,    55,   173,
     168,     0,   169,   163,   164,   165,   166,   348,    56,    59,
      60,    35,    56,   248,     0,   124,   127,     0,   128,     0,
       0,     0,   130,     0,   133,   135,     0,     0,   170,   268,
     267,     0,   249,     0,    82,     0,   204,    56,     0,     0,
       0,    85,     0,    45,   119,   120,     0,     0,    73,    74,
       0,     0,    56,     0,   204,    56,     0,    86,   326,     0,
     320,   245,     0,   312,   288,   313,   289,     0,   275,     0,
     244,   246,     0,   206,     0,   203,     0,   339,    56,    61,
      56,    61,     0,    80,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   258,     0,   259,     0,   204,     0,     0,     0,   341,
       0,   292,   103,    99,     0,   101,     0,     0,     0,     0,
      61,     0,   104,     0,     0,     0,    56,     0,     0,     6,
      37,     0,   314,     0,     0,     0,     0,   206,     0,     0,
       0,     0,     0,    56,     0,    56,    56,     0,    56,    56,
      56,    56,    56,    56,    70,     0,    56,     0,     0,    56,
      56,    56,    56,     0,     0,   167,    32,     0,     0,   347,
     350,     0,     0,    67,     0,   171,    56,    56,    56,   171,
      56,   204,     0,     0,    83,     0,     0,     0,     0,     0,
     317,     0,     0,     0,     0,    84,     0,    45,    79,    45,
      98,   115,     0,     0,     0,     0,   105,     0,     0,     0,
       0,   279,   319,   325,   247,     0,   345,     0,     0,   328,
       0,     0,   337,   170,     0,    33,    56,     0,   170,     0,
      34,    56,     0,   212,   209,   215,   210,   211,   208,     0,
     217,   219,   220,   224,   225,   222,   223,   227,   229,   231,
     233,   234,   236,   237,   242,   240,   239,   241,   282,   281,
     255,   256,   257,   260,     0,   252,     0,   342,   352,   354,
      40,     0,     0,   262,   172,     0,    36,    56,     0,   264,
     299,     0,     0,     0,     0,    45,    45,     0,     0,     0,
     315,   316,   294,   295,   329,     0,     0,   200,     0,   199,
       0,   161,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    68,    69,     0,
      62,    65,    56,   185,     0,     4,   179,     0,   178,     0,
       0,    56,     0,     0,     0,     0,     0,     0,     0,     0,
      70,     0,   204,     0,     0,   335,     0,    56,    49,    50,
      47,    46,    48,     0,   265,     0,     0,     0,     0,     0,
     300,     0,   333,     0,   298,     0,     0,   318,   296,   297,
      75,    78,    56,   117,   114,   271,   270,     0,     0,   331,
       0,     0,    45,    45,   326,   321,   323,     0,     0,     0,
     205,   338,     0,     0,     0,     0,     0,    32,     0,    56,
       0,   251,   204,   254,     0,   100,   102,     0,     0,   204,
       0,     0,     0,     0,   107,   107,    38,     7,     0,   322,
       0,     0,   195,   198,   196,   137,   138,   144,   145,   162,
     152,   153,   158,    56,   141,   147,   146,   142,   156,   157,
     182,    70,     0,    56,   175,    56,    56,   176,   139,   140,
       0,     0,   190,   193,   154,   155,   143,   149,   148,   151,
     150,    21,     0,     0,     0,    22,   351,   349,     0,    70,
     153,    56,   157,   155,   269,     0,   322,   109,   109,     0,
       0,   322,   327,   266,   322,     0,   107,   107,   325,   346,
     340,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     355,   213,     0,   353,     0,     0,     0,    45,     0,     0,
      45,    45,    90,    89,     8,     0,     0,     0,    24,   201,
     197,     0,    64,    72,   181,    61,     0,   184,   180,   177,
     355,   189,    56,     0,    23,    31,     0,     0,     0,   274,
       0,     0,     0,     0,   108,   111,     0,     0,     0,     0,
      45,    94,    93,   324,     0,    19,     0,    70,     0,    27,
       0,    28,    70,     0,   253,   263,    70,   301,    95,    26,
      25,   107,   106,   303,     0,   330,   159,     0,   355,    56,
     355,   194,   192,    56,   348,   355,   159,   334,     0,    45,
      97,   110,    96,    45,   302,   332,   107,     0,   276,    20,
       0,    30,    29,     0,    18,     0,    91,   304,    71,    66,
       0,     0,   174,     0,     0,    45,   113,   116,    92,     0,
     355,   355,   355,     0,   186,   336,    52,   112,   277,     0,
       0,    54,    70,    51,    53,     0,   355,     0,   187,   188
  };

  const short int
  Parser::yypgoto_[] =
  {
    -598,  -598,    -1,    89,  -598,  -598,  -598,  -598,  -598,   652,
     656,  -598,  -133,  -598,    77,  -598,  -598,  -598,    47,  -135,
    -429,  -598,  -598,  -598,  -598,   540,    38,  -254,  -509,  -598,
      42,  -406,  -598,  -598,  -386,  -547,  -598,  -598,    -3,  -597,
       7,  -598,   -58,  -598,   284,  -598,  -598,  -598,   449,   482,
     815,   262,  -598,  -598,  -598,  -598,    45,  -598,  -598,  -598,
    -598,  -598,  -598,  -598,   -55,  -598,  -598,    69,     6,  -134,
     -48,  -598,  -251,  -598,   424,   414,    92,    15,   417,   413,
     406,    87,    90,    -2,   -84,  -598,  -598,   620,   -73,  -598,
     -86,  -598,  -598,   126,  -525,    18,  -402,  -598,  -598,  -598,
    -598,  -598,  -598,   286,  -598,  -598,   423,  -598,  -598,   -76,
    -598,   164,  -598,  -157
  };

  const short int
  Parser::yydefgoto_[] =
  {
      -1,     2,    73,    74,   477,   478,   704,     7,    75,   224,
     225,    78,   317,    79,   533,    80,    81,    82,   226,   542,
     543,   415,   191,   420,   309,   177,   178,   192,   509,   510,
     511,   362,   512,   768,   227,   228,   386,   387,   229,   702,
     733,   734,   735,   390,   391,    85,    86,   179,   180,   363,
     334,   465,   355,   182,   183,   517,   518,   184,   345,   633,
     717,   185,   641,   642,   643,   186,   488,   489,    87,   254,
     255,    88,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   450,   105,
     106,   326,   384,   107,   239,   575,   240,   673,   108,   109,
     110,   111,   256,   257,   112,   113,   114,   249,   577,   358,
     359,   360,   459,   299
  };

  const short int
  Parser::yytable_[] =
  {
       4,   576,   328,   563,    84,   416,   705,   421,   703,   458,
     584,   787,   348,   423,   424,   588,   426,   427,   428,   429,
     458,   652,   507,   118,   119,   120,    14,   322,    14,   380,
     319,   133,   492,   128,     3,     8,   175,   458,   193,   519,
     258,   458,   212,   458,     3,   245,   246,   258,   210,   325,
       1,     3,   508,   507,    83,   215,   467,   272,   272,   147,
     222,   598,   303,   241,   242,   233,   304,    33,   250,   251,
     238,   259,   126,   260,     3,   261,   155,   411,   253,   741,
     742,   305,   375,   508,   707,   306,   378,   115,   116,   604,
     605,     3,   538,   539,   412,   273,   273,    46,    47,    48,
     397,   540,   448,   399,   788,     3,     8,     5,   474,   320,
     475,    10,    11,   731,    12,    13,    14,    15,    16,   274,
     571,   300,   572,   -63,   732,   262,   176,   307,   331,    20,
     315,   208,   262,   275,   383,   313,    22,   332,   318,   330,
      23,   730,   327,   794,   117,   706,    26,     6,   540,   739,
     727,   223,   136,    28,   828,   684,    29,   123,   264,   689,
     531,   454,   532,   493,   796,   323,   324,   381,   382,   695,
     520,   814,   521,   247,   223,    34,    35,   687,   285,   532,
     356,   274,    36,   612,    38,   274,   676,   677,   613,   808,
     636,    41,    42,   357,   464,   275,    43,   265,   121,   275,
     364,    45,   276,   277,   285,   187,   451,   266,   452,   267,
     123,    50,   123,   176,    51,   122,   176,   372,    53,   373,
     388,   453,   327,   455,   286,   379,   176,    56,    57,   134,
      58,   268,    60,   287,   288,   125,   393,   549,   790,   129,
     327,   216,   400,   793,    64,   130,   123,   795,   189,   190,
     286,   407,   269,   405,   -55,    67,    68,   816,    69,   287,
     288,   270,    72,   285,   276,   277,   234,   131,   276,   277,
     211,   123,   823,   824,   132,   123,   576,   176,   189,   190,
     829,   176,   135,   444,   445,   446,   447,   194,   449,   433,
     434,   435,   436,   449,   211,   449,   289,   243,   244,   213,
     290,   327,   218,   456,   281,   282,   176,   283,   284,   286,
     461,   758,   462,   825,   761,   762,   291,   219,   287,   288,
     220,   176,   230,   292,   176,   236,     3,     8,   293,   231,
     487,   243,   480,   245,   481,   243,   557,     3,     8,   691,
     237,   281,   282,   283,   284,   515,   263,   413,   271,   418,
     278,   422,   294,   280,   786,   283,   284,   410,   805,   529,
     279,   541,   298,   800,   431,   432,   301,   802,   440,   441,
     302,   314,   295,   442,   443,   312,   321,   327,     3,   337,
     333,   344,   353,   354,   561,   130,   135,   365,   289,   296,
     297,   289,   290,   806,   213,   290,   218,   807,   654,   220,
     369,   371,   374,   377,   385,   176,   389,   579,   291,   574,
     394,   291,   396,   401,   404,   292,   580,   402,   292,   817,
     293,   403,   176,   293,   176,   176,   406,   176,   176,   176,
     176,   176,   176,   408,   409,   176,   410,    69,   176,   176,
     176,   176,   458,   460,   294,   464,   463,   294,   466,   469,
     471,   470,   476,   479,   482,   176,   176,   176,   692,   176,
     490,   769,   496,   534,   295,   696,   530,   295,   486,   513,
     483,   601,   602,   484,   321,   535,   544,   600,   394,   536,
     603,   296,   297,   537,   296,   297,   550,   245,   551,   552,
     554,   555,   610,   556,   560,   558,   559,   389,   252,   565,
     566,   569,   567,   583,   590,   176,   585,   573,   587,   401,
     176,   271,   280,   578,   582,   278,   586,   589,   278,   181,
     278,     3,   607,   592,   209,   591,   594,   597,   278,   595,
     279,   596,   606,   753,   599,   614,   608,   653,   327,   609,
     656,   611,   357,   619,   593,   667,   623,   630,   635,   631,
     651,   655,   661,   659,   679,   664,   176,   665,   666,   668,
     670,   671,   674,   771,   681,   683,   678,   685,   238,   697,
     698,   699,   700,   468,   701,   701,   709,   675,   708,   721,
     722,   723,   724,   541,   680,   725,   609,   541,   682,   666,
     674,   485,   686,   729,   738,   740,   701,   541,   327,   701,
     693,   176,   745,   694,   764,   327,   308,   747,   749,   311,
     176,   799,   487,   801,   752,   574,   751,   754,   804,   329,
     755,   756,   773,   757,   763,   767,   176,   765,   774,   789,
     775,   713,   780,   777,   782,   515,   779,   791,   553,   720,
     783,   784,   785,   792,   701,   458,   797,   774,   822,   701,
     810,   208,   811,   819,   820,   821,   812,   568,   815,    76,
     570,   818,   826,    77,   688,   813,   310,   772,   737,   827,
     361,   715,   574,   712,   564,   736,   781,   574,   176,   392,
     574,   719,   710,   778,   574,   430,   439,   744,   248,   746,
     425,   748,   438,   750,   672,   437,   743,   581,   803,   376,
     657,     0,     0,     0,   759,   760,     0,     0,     0,     0,
       0,     0,   176,     0,   395,   770,     0,   398,     0,     0,
       0,   457,   176,     0,   176,   176,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   327,     0,     0,
     414,     0,   419,     0,     0,     0,     0,     0,     0,     0,
     176,     0,     0,     0,   615,   616,   617,   618,     0,   620,
     621,   622,     0,   624,   625,   626,   627,   628,   629,     0,
       0,     0,     0,   798,     0,     0,   634,     0,     0,   637,
     357,   638,   639,     0,   644,   645,   646,   647,   648,   649,
     650,     0,     0,   809,     0,     0,     0,     0,   473,   541,
       0,     0,     0,     0,     0,     0,     0,   660,     0,   662,
     663,   176,     0,     0,     0,   491,     0,   494,   495,     0,
     498,   500,   501,   503,   504,   506,     0,     0,   516,     0,
       0,   523,   524,   526,   528,     0,     0,   124,     0,     0,
       0,   127,     0,     0,     0,     0,     0,     0,   545,   546,
     547,   137,   548,   188,     0,     0,     0,     0,   176,     0,
       0,     0,   176,     0,     0,   217,     0,     0,     0,     0,
       0,     0,     0,   232,     0,   235,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     726,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   335,   336,     0,   338,   339,
       0,     0,   340,   766,   341,     0,   342,   343,     0,     0,
       0,     0,   346,   347,     0,   349,   350,     0,   351,   352,
     776,     0,     0,     0,   632,     0,     0,     0,     0,     0,
       0,     0,     0,   640,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   366,   367,   340,     0,   368,   658,
       0,   347,   370,     0,     0,     3,     8,     0,     0,     0,
       0,    10,    11,     0,    12,    13,    14,    15,    16,     0,
       0,     0,     0,     0,   669,     0,     0,     0,     0,    20,
       0,     0,     0,     0,     0,     0,    22,     0,     0,     0,
      23,     0,     0,     0,     0,     0,    26,     0,     0,     0,
       0,   690,     0,    28,     0,     0,    29,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    34,    35,     0,     0,     0,
       0,     0,    36,     0,    38,   711,     0,     0,    40,     0,
       0,    41,    42,     0,     0,   716,    43,   718,   516,     0,
      44,    45,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    50,     0,     0,    51,     0,     0,     0,    53,     0,
       0,     0,     0,   728,     0,     0,     0,    56,    57,     0,
      58,     0,    60,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    64,     0,     0,     0,    65,     0,
       0,     0,    66,     0,     0,    67,    68,     0,    69,    70,
      71,     0,    72,     0,   252,   -12,   -12,     0,     0,     0,
     -12,   -12,   -12,     0,   -12,   -12,   -12,   -12,   -12,   -12,
     -12,   -12,     0,     0,   640,     0,     0,     0,     0,   -12,
       0,   -12,     0,     0,     0,     0,   -12,     0,     0,     0,
     -12,   -12,   -12,     0,     0,   -12,   -12,   -12,     0,     0,
       0,     0,     0,   -12,     0,     0,   -12,     0,     0,     0,
       0,     0,     0,   -12,     0,   -12,     0,   -12,     0,   -12,
     -12,   -12,     0,   -12,     0,   -12,   -12,     0,     0,     0,
       0,     0,   -12,   -12,   -12,     0,   -12,     0,   -12,     0,
       0,   -12,   -12,     0,     0,     0,   -12,     0,     0,     0,
     -12,   -12,     0,   -12,   -12,   -12,     0,     0,     0,   -12,
       0,   -12,     0,     0,   -12,     0,     0,   -12,   -12,     0,
       0,     0,   -12,   -12,     0,     0,   -12,   -12,   -12,     0,
     -12,   -12,   -12,     0,     0,   -12,     0,     0,     0,   -12,
       0,   -12,     0,     0,   -12,     0,     0,     0,   -12,     0,
       0,     0,   -12,     0,     0,   -12,   -12,     0,   -12,   -12,
     -12,     0,   -12,   -13,   -13,     0,     0,     0,   -13,   -13,
     -13,     0,   -13,   -13,   -13,   -13,   -13,   -13,   -13,   -13,
       0,     0,     0,     0,     0,     0,     0,   -13,     0,   -13,
       0,     0,     0,     0,   -13,     0,     0,     0,   -13,   -13,
     -13,     0,     0,   -13,   -13,   -13,     0,     0,     0,     0,
       0,   -13,     0,     0,   -13,     0,     0,     0,     0,     0,
       0,   -13,     0,   -13,     0,   -13,     0,   -13,   -13,   -13,
       0,   -13,     0,   -13,   -13,     0,     0,     0,     0,     0,
     -13,   -13,   -13,     0,   -13,     0,   -13,     0,     0,   -13,
     -13,     0,     0,     0,   -13,     0,     0,     0,   -13,   -13,
       0,   -13,   -13,   -13,     0,     0,     0,   -13,     0,   -13,
       0,     0,   -13,     0,     0,   -13,   -13,     0,     0,     0,
     -13,   -13,     0,     0,   -13,   -13,   -13,     0,   -13,   -13,
     -13,     0,     0,   -13,     0,     0,     0,   -13,     0,   -13,
       0,     0,   -13,     0,     0,     0,   -13,     0,     0,     0,
     -13,     0,     0,   -13,   -13,     0,   -13,   -13,   -13,     0,
     -13,     3,     8,     0,     0,     0,     0,    10,    11,     0,
      12,    13,    14,    15,    16,     0,     0,     0,   138,     0,
       0,   139,     0,   195,     0,    20,   141,     0,   142,     0,
       0,     0,    22,     0,     0,     0,    23,     0,     0,     0,
       0,     0,    26,     0,     0,     0,     0,   143,     0,    28,
     144,     0,   196,   146,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   147,     0,     0,     0,     0,
       0,   197,   198,     0,   150,   151,     0,   152,   199,     0,
     200,     0,   155,     0,    40,     0,     0,    41,    42,     0,
     156,     0,   201,     0,     0,     0,    44,   202,     0,     0,
       0,     0,   159,   160,   161,     0,     0,   203,     0,     0,
     204,   164,   165,     0,   205,     0,     0,     0,     0,     0,
       0,   167,     0,    56,   206,   169,    58,     0,   207,   171,
     172,     0,     0,   173,   174,     0,     0,     0,     0,     0,
      64,  -322,     0,     0,    65,     0,     0,     0,    66,     0,
       0,    67,    68,     0,    69,    70,    71,     0,    72,     3,
       8,     0,     0,     0,     9,    10,    11,     0,    12,    13,
      14,    15,    16,    17,    18,    19,     0,     0,     0,     0,
       0,     0,     0,    20,     0,    21,     0,     0,     0,     0,
      22,     0,     0,     0,    23,     0,    24,     0,     0,    25,
      26,    27,     0,     0,     0,     0,     0,    28,     0,     0,
      29,     0,     0,     0,     0,     0,     0,    30,     0,     0,
       0,     0,     0,     0,    31,    32,     0,    33,     0,    34,
      35,     0,     0,     0,     0,     0,    36,    37,    38,     0,
      39,     0,    40,     0,     0,    41,    42,     0,     0,     0,
      43,     0,     0,     0,    44,    45,     0,    46,    47,    48,
       0,     0,     0,    49,     0,    50,     0,     0,    51,     0,
       0,    52,    53,     0,     0,     0,    54,    55,     0,     0,
       0,    56,    57,     0,    58,    59,    60,     0,     0,    61,
       0,     0,     0,    62,     0,    63,     0,     0,    64,     0,
       0,     0,    65,     0,     0,     0,    66,     0,     0,    67,
      68,     0,    69,    70,    71,     0,    72,     3,     8,     0,
       0,     0,     0,    10,    11,     0,    12,    13,    14,    15,
      16,     0,     0,     0,   138,     0,     0,   139,     0,   195,
       0,    20,   141,     0,   142,     0,     0,     0,    22,     0,
       0,     0,    23,     0,     0,     0,     0,     0,    26,     0,
       0,     0,     0,   143,     0,    28,   144,     0,   196,   146,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   147,     0,     0,     0,     0,     0,   197,   198,     0,
     150,   151,     0,   152,   199,     0,   200,     0,   155,     0,
      40,     0,     0,    41,    42,     0,   156,     0,   201,     0,
       0,     0,    44,   202,     0,     0,     0,     0,   159,   160,
     161,     0,     0,   203,     0,     0,   204,   164,   165,     0,
     205,     0,     0,     0,     0,     0,     0,   167,     0,    56,
     206,   169,    58,     0,   207,   171,   172,     0,     0,   173,
     174,     0,     0,     0,     0,     0,    64,     0,     0,     0,
      65,     0,     0,     0,    66,     0,     0,    67,    68,     0,
      69,    70,    71,     0,    72,     3,     8,     0,     0,     0,
       0,    10,    11,     0,    12,    13,    14,    15,    16,     0,
       0,     0,   138,     0,     0,   139,     0,   195,     0,    20,
     141,     0,   142,     0,     0,     0,    22,     0,     0,     0,
      23,     0,     0,     0,     0,     0,    26,     0,     0,     0,
       0,   143,     0,    28,   144,     0,   196,   146,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   197,   198,     0,   150,   151,
       0,   152,   199,     0,   200,     0,     0,     0,    40,     0,
       0,    41,    42,     0,   156,     0,   201,     0,     0,     0,
      44,   202,     0,     0,     0,     0,   159,   160,   161,     0,
       0,   203,     0,     0,   204,   164,   165,     0,   205,     0,
       0,     0,     0,     0,     0,   167,     0,    56,   206,   169,
      58,     0,   207,   171,   172,     0,     0,   173,   174,     0,
       0,     0,     0,     0,    64,     0,     0,     0,    65,     0,
       0,     0,    66,     0,     0,    67,    68,     0,    69,    70,
      71,     0,    72,     3,     8,     0,     0,     0,     0,    10,
      11,     0,    12,    13,    14,    15,    16,    17,    18,    19,
       0,     0,     0,     0,     0,     0,     0,    20,     0,    21,
       0,     0,     0,     0,    22,     0,     0,     0,    23,     0,
      24,     0,     0,     0,    26,    27,     0,     0,     0,     0,
       0,    28,     0,     0,    29,     0,     0,     0,     0,     0,
       0,    30,     0,     0,     0,     0,     0,     0,    31,     0,
       0,    33,     0,    34,    35,     0,     0,     0,     0,     0,
      36,    37,    38,     0,     0,     0,    40,     0,     0,    41,
      42,     0,     0,     0,    43,     0,     0,     0,    44,    45,
       0,    46,    47,    48,     0,     0,     0,    49,     0,    50,
       0,     0,    51,     0,     0,    52,    53,     0,     0,     0,
      54,    55,     0,     0,     0,    56,    57,     0,    58,    59,
      60,     0,     0,    61,     0,     0,     0,    62,   223,     0,
       0,     0,    64,     0,     0,     0,    65,     0,     0,     0,
      66,     0,     0,    67,    68,     0,    69,    70,    71,     0,
      72,     3,     8,     0,     0,     0,     0,    10,    11,     0,
      12,    13,    14,    15,    16,    17,    18,    19,     0,     0,
       0,     0,     0,     0,     0,    20,     0,    21,     0,     0,
       0,     0,    22,     0,     0,     0,    23,     0,    24,     0,
       0,     0,    26,    27,     0,     0,     0,     0,     0,    28,
       0,     0,    29,     0,     0,     0,     0,     0,     0,    30,
       0,     0,     0,     0,     0,     0,    31,     0,     0,    33,
       0,    34,    35,     0,     0,     0,     0,     0,    36,    37,
      38,     0,     0,     0,    40,     0,     0,    41,    42,     0,
       0,     0,    43,     0,     0,     0,    44,    45,     0,    46,
      47,    48,     0,     0,     0,    49,     0,    50,     0,     0,
      51,     0,     0,    52,    53,     0,     0,     0,    54,    55,
       0,     0,     0,    56,    57,     0,    58,    59,    60,     0,
       0,    61,     0,     0,     0,    62,     0,   -77,     0,     0,
      64,     0,     0,     0,    65,     0,     0,     0,    66,     0,
       0,    67,    68,     0,    69,    70,    71,     0,    72,     3,
       8,     0,     0,     0,     0,    10,    11,     0,    12,    13,
      14,    15,    16,    17,    18,    19,     0,     0,     0,     0,
       0,     0,     0,    20,     0,    21,     0,     0,     0,     0,
      22,     0,     0,     0,    23,     0,    24,     0,     0,     0,
      26,    27,     0,     0,     0,     0,     0,    28,     0,     0,
      29,     0,     0,     0,     0,     0,     0,    30,     0,     0,
       0,     0,     0,     0,    31,     0,     0,    33,     0,    34,
      35,     0,     0,     0,     0,     0,    36,    37,    38,     0,
       0,     0,    40,     0,     0,    41,    42,     0,     0,     0,
      43,     0,     0,     0,    44,    45,     0,    46,    47,    48,
       0,     0,     0,    49,     0,    50,     0,     0,    51,     0,
       0,    52,    53,     0,     0,     0,    54,    55,     0,     0,
       0,    56,    57,     0,    58,    59,    60,     0,     0,    61,
       0,     0,     0,    62,     0,   -76,     0,     0,    64,     0,
       0,     0,    65,     0,     0,     0,    66,     0,     0,    67,
      68,     0,    69,    70,    71,     0,    72,     3,     8,     0,
       0,     0,     0,    10,    11,     0,    12,    13,    14,    15,
      16,    17,    18,    19,     0,     0,     0,     0,     0,     0,
       0,    20,     0,    21,     0,     0,     0,     0,    22,     0,
       0,     0,    23,     0,    24,     0,     0,     0,    26,    27,
       0,     0,     0,     0,     0,    28,     0,     0,    29,     0,
       0,     0,     0,     0,     0,    30,     0,     0,     0,     0,
       0,     0,    31,     0,     0,    33,     0,    34,    35,     0,
       0,     0,     0,     0,    36,    37,    38,     0,     0,     0,
      40,     0,     0,    41,    42,     0,     0,     0,    43,     0,
       0,     0,    44,    45,     0,    46,    47,    48,     0,     0,
       0,    49,     0,    50,     0,     0,    51,     0,     0,    52,
      53,     0,     0,     0,    54,    55,     0,     0,     0,    56,
      57,     0,    58,    59,    60,     0,     0,    61,     0,     0,
       0,    62,   223,     0,     0,     0,   562,     0,     0,     0,
      65,     0,     0,     0,    66,     0,     0,    67,    68,     0,
      69,    70,    71,     0,    72,     3,     8,     0,     0,     0,
       0,    10,    11,     0,    12,    13,    14,    15,    16,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    20,
       0,     0,     0,     0,     0,     0,    22,     0,     0,     0,
      23,     0,     0,     0,     0,     0,    26,     0,     0,     0,
       0,     0,     0,    28,     0,     0,    29,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    34,    35,     0,     0,     0,
       0,     0,    36,     0,    38,     0,     0,     0,    40,     0,
       0,    41,    42,     0,     0,     0,    43,     0,     0,     0,
      44,    45,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    50,     0,     0,    51,     0,     0,     0,    53,     0,
       0,     0,     0,     0,     0,     0,     0,    56,    57,     0,
      58,     0,    60,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   214,    64,     0,     0,     0,    65,     0,
       0,     0,    66,     0,     0,    67,    68,     0,    69,    70,
      71,     0,    72,     3,     8,     0,     0,     0,     0,    10,
      11,     0,    12,    13,    14,    15,    16,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    20,     0,     0,
       0,     0,     0,     0,    22,     0,     0,     0,    23,     0,
       0,     0,     0,     0,    26,     0,     0,     0,     0,     0,
       0,    28,     0,     0,    29,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    34,    35,     0,     0,     0,     0,     0,
      36,     0,    38,     0,     0,     0,    40,     0,     0,    41,
      42,     0,     0,     0,    43,     0,     0,     0,    44,    45,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    50,
       0,     0,    51,     0,     0,     0,    53,     0,     0,     0,
       0,     0,     0,     0,     0,    56,    57,     0,    58,     0,
      60,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   221,    64,     0,     0,     0,    65,     0,     0,     0,
      66,     0,     0,    67,    68,     0,    69,    70,    71,     0,
      72,     3,     8,     0,     0,     0,     0,    10,    11,     0,
      12,    13,    14,    15,    16,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    20,     0,     0,     0,     0,
       0,     0,    22,     0,     0,     0,    23,     0,     0,     0,
       0,     0,    26,     0,     0,     0,     0,     0,     0,    28,
       0,     0,    29,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    34,    35,     0,     0,     0,     0,     0,    36,   316,
      38,     0,     0,     0,    40,     0,     0,    41,    42,     0,
       0,     0,    43,     0,     0,     0,    44,    45,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    50,     0,     0,
      51,     0,     0,     0,    53,     0,     0,     0,     0,     0,
       0,     0,     0,    56,    57,     0,    58,     0,    60,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      64,     0,     0,     0,    65,     0,     0,     0,    66,     0,
       0,    67,    68,     0,    69,    70,    71,     0,    72,     3,
       8,     0,     0,     0,     0,    10,    11,     0,    12,    13,
      14,    15,    16,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    20,     0,     0,     0,     0,     0,     0,
      22,     0,     0,     0,    23,     0,     0,     0,     0,     0,
      26,     0,     0,     0,     0,     0,     0,    28,     0,     0,
      29,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    34,
      35,     0,     0,     0,     0,     0,    36,     0,    38,     0,
       0,     0,    40,     0,     0,    41,    42,     0,     0,     0,
      43,     0,     0,     0,    44,    45,     0,     0,     0,     0,
       0,  -170,     0,     0,     0,    50,     0,     0,    51,     0,
       0,     0,    53,     0,     0,     0,  -170,     0,     0,     0,
       0,    56,    57,     0,    58,     0,    60,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    64,     0,
    -170,     0,    65,     0,     0,     0,    66,  -170,     0,    67,
      68,     0,    69,    70,    71,  -170,    72,     0,  -170,     0,
    -170,     0,  -170,     0,  -170,     0,     0,     0,     0,     0,
       0,     0,  -170,     0,     0,     0,     0,     0,     0,  -170,
    -170,     0,     0,     0,     0,  -170,     0,  -170,     0,  -170,
       0,  -170,  -170,     0,  -170,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  -170,  -170,     0,     0,     0,     0,
       0,     0,     0,  -170,     0,     0,  -170,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  -170,  -170,  -170,  -170,  -170,  -170,  -170,  -170,
    -170,  -170,  -170,  -170,  -170,  -170,  -170,  -170,  -170,  -170,
    -170,     3,     8,  -170,  -170,  -170,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   138,     0,
       0,   139,     0,   195,     0,     0,   141,     0,   142,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   143,     0,     0,
     144,     0,   145,   146,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   147,     0,     0,     0,     0,
       0,   148,   149,     0,   150,   151,     0,   152,   153,     0,
     154,     0,   155,     0,     0,     0,     0,     0,     0,     0,
     156,     0,   157,     0,     0,     0,     0,   158,     0,     0,
       0,     0,   159,   160,   161,     0,     0,   162,     0,     0,
     163,   164,   165,     0,   166,     3,     8,     0,     0,     0,
       0,   167,     0,     0,   168,   169,     0,     0,   170,   171,
     172,     0,   138,   173,   174,   139,     0,   195,     0,     0,
     141,     0,   142,     0,   497,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   143,     0,     0,   144,     0,   145,   146,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   147,
       0,     0,     0,     0,     0,   148,   149,     0,   150,   151,
       0,   152,   153,     0,   154,     0,   155,     0,     0,     0,
       0,     0,     0,     0,   156,     0,   157,     0,     0,     0,
       0,   158,     0,     0,     0,     0,   159,   160,   161,     0,
       0,   162,     0,     0,   163,   164,   165,     0,   166,     3,
       8,     0,     0,     0,     0,   167,     0,     0,   168,   169,
       0,     0,   170,   171,   172,     0,   138,   173,   174,   139,
       0,   195,     0,     0,   141,     0,   142,     0,   499,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   143,     0,     0,   144,     0,
     145,   146,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   147,     0,     0,     0,     0,     0,   148,
     149,     0,   150,   151,     0,   152,   153,     0,   154,     0,
     155,     0,     0,     0,     0,     0,     0,     0,   156,     0,
     157,     0,     0,     0,     0,   158,     0,     0,     0,     0,
     159,   160,   161,     0,     0,   162,     0,     0,   163,   164,
     165,     0,   166,     3,     8,     0,     0,     0,     0,   167,
       0,     0,   168,   169,     0,     0,   170,   171,   172,     0,
     138,   173,   174,   139,     0,   195,     0,     0,   141,     0,
     142,     0,   502,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   143,
       0,     0,   144,     0,   145,   146,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   147,     0,     0,
       0,     0,     0,   148,   149,     0,   150,   151,     0,   152,
     153,     0,   154,     0,   155,     0,     0,     0,     0,     0,
       0,     0,   156,     0,   157,     0,     0,     0,     0,   158,
       0,     0,     0,     0,   159,   160,   161,     0,     0,   162,
       0,     0,   163,   164,   165,     0,   166,     3,     8,     0,
       0,     0,     0,   167,     0,     0,   168,   169,     0,     0,
     170,   171,   172,     0,   138,   173,   174,   139,     0,   195,
       0,     0,   141,     0,   142,     0,   505,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   143,     0,     0,   144,     0,   145,   146,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   147,     0,     0,     0,     0,     0,   148,   149,     0,
     150,   151,     0,   152,   153,     0,   154,     0,   155,     0,
       0,     0,     0,     0,     0,     0,   156,     0,   157,     0,
       0,     0,     0,   158,     0,     0,     0,     0,   159,   160,
     161,     0,     0,   162,     0,     0,   163,   164,   165,     0,
     166,     3,     8,     0,     0,     0,     0,   167,     0,     0,
     168,   169,     0,     0,   170,   171,   172,     0,   138,   173,
     174,   139,     0,   195,     0,     0,   141,     0,   142,     0,
     514,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   143,     0,     0,
     144,     0,   145,   146,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   147,     0,     0,     0,     0,
       0,   148,   149,     0,   150,   151,     0,   152,   153,     0,
     154,     0,   155,     0,     0,     0,     0,     0,     0,     0,
     156,     0,   157,     0,     0,     0,     0,   158,     0,     0,
       0,     0,   159,   160,   161,     0,     0,   162,     0,     0,
     163,   164,   165,     0,   166,     3,     8,     0,     0,     0,
       0,   167,     0,     0,   168,   169,     0,     0,   170,   171,
     172,     0,   138,   173,   174,   139,     0,   195,     0,     0,
     141,     0,   142,     0,   522,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   143,     0,     0,   144,     0,   145,   146,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   147,
       0,     0,     0,     0,     0,   148,   149,     0,   150,   151,
       0,   152,   153,     0,   154,     0,   155,     0,     0,     0,
       0,     0,     0,     0,   156,     0,   157,     0,     0,     0,
       0,   158,     0,     0,     0,     0,   159,   160,   161,     0,
       0,   162,     0,     0,   163,   164,   165,     0,   166,     3,
       8,     0,     0,     0,     0,   167,     0,     0,   168,   169,
       0,     0,   170,   171,   172,     0,   138,   173,   174,   139,
       0,   195,     0,     0,   141,     0,   142,     0,   525,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   143,     0,     0,   144,     0,
     145,   146,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   147,     0,     0,     0,     0,     0,   148,
     149,     0,   150,   151,     0,   152,   153,     0,   154,     0,
     155,     0,     0,     0,     0,     0,     0,     0,   156,     0,
     157,     0,     0,     0,     0,   158,     0,     0,     0,     0,
     159,   160,   161,     0,     0,   162,     0,     0,   163,   164,
     165,     0,   166,     3,     8,     0,     0,     0,     0,   167,
       0,     0,   168,   169,     0,     0,   170,   171,   172,     0,
     138,   173,   174,   139,     0,   195,     0,     0,   141,     0,
     142,     0,   527,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   143,
       0,     0,   144,     0,   145,   146,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   147,     0,     0,
       0,     0,     0,   148,   149,     0,   150,   151,     0,   152,
     153,     0,   154,     0,   155,     0,     0,     0,     0,     0,
       0,     0,   156,     0,   157,     0,     0,     0,     0,   158,
       0,     0,     0,     0,   159,   160,   161,     0,     0,   162,
       0,     0,   163,   164,   165,     0,   166,     0,     0,     0,
       3,     8,     0,   167,     0,     0,   168,   169,     0,     0,
     170,   171,   172,     0,     0,   173,   174,   138,     0,  -191,
     139,     0,   195,     0,     0,   141,     0,   142,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   143,     0,     0,   144,
       0,   145,   146,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   147,     0,     0,     0,     0,     0,
     148,   149,     0,   150,   151,     0,   152,   153,     0,   154,
       0,   155,     0,     0,     0,     0,     0,     0,     0,   156,
       0,   157,     0,     0,     0,     0,   158,     0,     0,     0,
       0,   159,   160,   161,     0,     0,   162,     0,     0,   163,
     164,   165,     0,   166,     0,     0,     0,     3,     8,     0,
     167,     0,     0,   168,   169,     0,     0,   170,   171,   172,
       0,     0,   173,   174,   138,     0,   714,   139,     0,   140,
       0,     0,   141,     0,   142,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   143,     0,     0,   144,     0,   145,   146,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   147,     0,     0,     0,     0,     0,   148,   149,     0,
     150,   151,     0,   152,   153,     0,   154,     0,   155,     0,
       0,     0,     0,     0,     0,     0,   156,     0,   157,     0,
       0,     0,     0,   158,     0,     0,     0,     0,   159,   160,
     161,     0,     0,   162,     0,     0,   163,   164,   165,     0,
     166,     3,     8,     0,     0,     0,     0,   167,     0,     0,
     168,   169,     0,     0,   170,   171,   172,     0,   138,   173,
     174,   139,     0,   195,     0,     0,   141,     0,   142,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   143,     0,     0,
     144,     0,   145,   146,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   147,     0,     0,     0,     0,
       0,   148,   149,     0,   150,   151,     0,   152,   153,     0,
     154,     0,   155,     0,     0,     0,     0,     0,     0,     0,
     156,     0,   157,     0,     0,     0,     0,   158,     0,     0,
       0,     0,   159,   160,   161,     0,     0,   162,     0,     0,
     163,   164,   165,     0,   166,     3,     8,     0,     0,     0,
       0,   167,     0,     0,   168,   169,     0,     0,   170,   171,
     172,     0,   138,   173,   174,   139,     0,   417,     0,     0,
     141,     0,   142,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   143,     0,     0,   144,     0,   145,   146,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   147,
       0,     0,     0,     0,     0,   148,   149,     0,   150,   151,
       0,   152,   153,     0,   154,     0,   155,     0,     0,     0,
       0,     0,     0,     0,   156,     0,   157,     0,     0,     0,
       0,   158,     0,     0,     0,     0,   159,   160,   161,     0,
       0,   162,     0,     0,   163,   164,   165,     0,   166,     3,
       8,     0,     0,     0,     0,   167,     0,     0,   168,   169,
       0,     0,   170,   171,   172,     0,   138,   173,   174,   139,
       0,   472,     0,     0,   141,     0,   142,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   143,     0,     0,   144,     0,
     145,   146,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   147,     0,     0,     0,     0,     0,   148,
     149,     0,   150,   151,     0,   152,   153,     0,   154,     0,
     155,     0,     0,     0,     0,     0,     0,     0,   156,     0,
     157,     0,     0,     0,     0,   158,     0,     0,     0,     0,
     159,   160,   161,     0,     0,   162,     0,     0,   163,   164,
     165,     0,   166,     0,     0,     0,     0,     0,     0,   167,
       0,     0,   168,   169,     0,     0,   170,   171,   172,     0,
       0,   173,   174
  };

  const short int
  Parser::yycheck_[] =
  {
       1,   403,   136,   389,     7,   259,    15,   261,   605,     7,
     416,    68,   169,   264,   265,   421,   267,   268,   269,   270,
       7,   530,    42,    17,    18,    19,    14,    15,    14,    15,
      62,    32,    15,    27,     3,     4,    37,     7,    40,    15,
      39,     7,    44,     7,     3,    14,    15,    39,    42,   135,
      88,     3,    72,    42,     7,    49,   310,    53,    53,    67,
      54,   467,   141,    65,    66,    59,   145,    71,    70,    71,
      64,    63,    25,    65,     3,    67,    84,   144,    72,   676,
     677,   141,   216,    72,   609,   145,   219,   140,   141,   475,
     476,     3,     4,     5,   161,    91,    91,   101,   102,   103,
     234,    60,    54,   236,   161,     3,     4,     0,   141,   141,
     143,     9,    10,    33,    12,    13,    14,    15,    16,    64,
     141,   115,   143,   143,    44,   124,    37,   121,   138,    27,
     131,    42,   124,    78,   220,   129,    34,   147,   132,   140,
      38,   666,   136,   141,   156,   154,    44,   138,    60,   674,
     659,   138,   142,    51,   141,   584,    54,   147,    46,   588,
     140,   295,   142,   146,   761,   153,   154,   153,   154,   598,
     146,   141,   138,   142,   138,    73,    74,   140,   100,   142,
     181,    64,    80,   139,    82,    64,   572,   573,   144,   786,
     144,    89,    90,   187,   148,    78,    94,    85,   142,    78,
     194,    99,   147,   148,   100,   142,   290,    95,   292,    97,
     147,   109,   147,   124,   112,   141,   127,   211,   116,   213,
     223,   294,   216,   296,   146,   219,   137,   125,   126,   147,
     128,   119,   130,   155,   156,   141,   230,   371,   747,   142,
     234,   142,   236,   752,   142,   142,   147,   756,    57,    58,
     146,   252,   140,   247,    63,   153,   154,   804,   156,   155,
     156,   149,   160,   100,   147,   148,   142,   142,   147,   148,
     142,   147,   819,   820,   142,   147,   678,   188,    57,    58,
     827,   192,   142,   285,   286,   287,   288,   142,   289,   274,
     275,   276,   277,   294,   142,   296,    66,    14,    15,   142,
      70,   295,   142,   297,   110,   111,   217,   153,   154,   146,
     304,   697,   306,   822,   700,   701,    86,   142,   155,   156,
     142,   232,   142,    93,   235,   142,     3,     4,    98,   147,
     331,    14,    15,    14,    15,    14,    15,     3,     4,   590,
     141,   110,   111,   153,   154,   346,   141,   258,    22,   260,
     150,   262,   122,   152,   740,   153,   154,   144,   145,   353,
     151,   362,   150,   769,   272,   273,    15,   773,   281,   282,
     141,     9,   142,   283,   284,   141,    15,   371,     3,   142,
     145,   142,   140,    63,   387,   142,   142,   147,    66,   159,
     160,    66,    70,   779,   142,    70,   142,   783,   532,   142,
     147,   142,   141,    10,   141,   316,    35,   408,    86,   403,
      15,    86,   141,   143,   150,    93,   410,   143,    93,   805,
      98,   144,   333,    98,   335,   336,    11,   338,   339,   340,
     341,   342,   343,    61,   161,   346,   144,   156,   349,   350,
     351,   352,     7,   141,   122,   148,   143,   122,   141,   143,
      70,   143,   143,   148,   143,   366,   367,   368,   592,   370,
     146,   715,     9,   145,   142,   599,   142,   142,   140,   138,
     143,   472,   473,   143,    15,   143,   143,   471,    15,   144,
     474,   159,   160,   144,   159,   160,   143,    14,   144,   143,
     143,   143,   486,   143,   139,   143,   143,    35,   162,   143,
     143,   143,   148,   414,   145,   416,   417,   143,   419,   143,
     421,    22,   152,   140,   140,   150,   140,   140,   150,    37,
     150,     3,     6,   142,    42,   143,   140,   142,   150,   141,
     151,   141,   141,   690,   142,   148,   142,   531,   532,   142,
     534,   140,   536,   143,   161,   138,   144,   143,   145,   144,
     141,   141,   144,   142,   156,   143,   467,   551,   142,   138,
     142,   142,   142,   720,    70,   140,   144,   140,   562,   143,
     140,   140,   143,   311,    50,    50,    15,   571,   141,   139,
     144,   143,   141,   584,   578,   143,   142,   588,   582,   142,
     142,   329,   586,   143,    15,   143,    50,   598,   592,    50,
     594,   512,   141,   597,    15,   599,   124,   142,   141,   127,
     521,   768,   613,   770,   142,   609,   141,   143,   775,   137,
     143,   142,    24,   143,   143,   140,   537,   143,   142,   141,
     143,   632,   139,   143,   139,   636,   145,   141,   376,   640,
     143,   143,   143,   141,    50,     7,   143,   142,   142,    50,
     143,   562,   143,   810,   811,   812,   143,   395,   143,     7,
     398,   161,   143,     7,   587,   800,   126,   722,   669,   826,
     188,   633,   666,   631,   390,   668,   734,   671,   589,   230,
     674,   636,   613,   731,   678,   271,   280,   681,    68,   683,
     266,   685,   279,   687,   568,   278,   678,   411,   774,   217,
     536,    -1,    -1,    -1,   698,   699,    -1,    -1,    -1,    -1,
      -1,    -1,   623,    -1,   232,   716,    -1,   235,    -1,    -1,
      -1,   298,   633,    -1,   635,   636,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   731,    -1,    -1,
     258,    -1,   260,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     661,    -1,    -1,    -1,   492,   493,   494,   495,    -1,   497,
     498,   499,    -1,   501,   502,   503,   504,   505,   506,    -1,
      -1,    -1,    -1,   767,    -1,    -1,   514,    -1,    -1,   517,
     774,   519,   520,    -1,   522,   523,   524,   525,   526,   527,
     528,    -1,    -1,   787,    -1,    -1,    -1,    -1,   316,   800,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   545,    -1,   547,
     548,   722,    -1,    -1,    -1,   333,    -1,   335,   336,    -1,
     338,   339,   340,   341,   342,   343,    -1,    -1,   346,    -1,
      -1,   349,   350,   351,   352,    -1,    -1,    22,    -1,    -1,
      -1,    26,    -1,    -1,    -1,    -1,    -1,    -1,   366,   367,
     368,    36,   370,    38,    -1,    -1,    -1,    -1,   769,    -1,
      -1,    -1,   773,    -1,    -1,    50,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    58,    -1,    60,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     658,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   150,   151,    -1,   153,   154,
      -1,    -1,   157,   711,   159,    -1,   161,   162,    -1,    -1,
      -1,    -1,   167,   168,    -1,   170,   171,    -1,   173,   174,
     728,    -1,    -1,    -1,   512,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   521,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   199,   200,   201,    -1,   203,   537,
      -1,   206,   207,    -1,    -1,     3,     4,    -1,    -1,    -1,
      -1,     9,    10,    -1,    12,    13,    14,    15,    16,    -1,
      -1,    -1,    -1,    -1,   562,    -1,    -1,    -1,    -1,    27,
      -1,    -1,    -1,    -1,    -1,    -1,    34,    -1,    -1,    -1,
      38,    -1,    -1,    -1,    -1,    -1,    44,    -1,    -1,    -1,
      -1,   589,    -1,    51,    -1,    -1,    54,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    73,    74,    -1,    -1,    -1,
      -1,    -1,    80,    -1,    82,   623,    -1,    -1,    86,    -1,
      -1,    89,    90,    -1,    -1,   633,    94,   635,   636,    -1,
      98,    99,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   109,    -1,    -1,   112,    -1,    -1,    -1,   116,    -1,
      -1,    -1,    -1,   661,    -1,    -1,    -1,   125,   126,    -1,
     128,    -1,   130,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   142,    -1,    -1,    -1,   146,    -1,
      -1,    -1,   150,    -1,    -1,   153,   154,    -1,   156,   157,
     158,    -1,   160,    -1,   162,     3,     4,    -1,    -1,    -1,
       8,     9,    10,    -1,    12,    13,    14,    15,    16,    17,
      18,    19,    -1,    -1,   722,    -1,    -1,    -1,    -1,    27,
      -1,    29,    -1,    -1,    -1,    -1,    34,    -1,    -1,    -1,
      38,    39,    40,    -1,    -1,    43,    44,    45,    -1,    -1,
      -1,    -1,    -1,    51,    -1,    -1,    54,    -1,    -1,    -1,
      -1,    -1,    -1,    61,    -1,    63,    -1,    65,    -1,    67,
      68,    69,    -1,    71,    -1,    73,    74,    -1,    -1,    -1,
      -1,    -1,    80,    81,    82,    -1,    84,    -1,    86,    -1,
      -1,    89,    90,    -1,    -1,    -1,    94,    -1,    -1,    -1,
      98,    99,    -1,   101,   102,   103,    -1,    -1,    -1,   107,
      -1,   109,    -1,    -1,   112,    -1,    -1,   115,   116,    -1,
      -1,    -1,   120,   121,    -1,    -1,   124,   125,   126,    -1,
     128,   129,   130,    -1,    -1,   133,    -1,    -1,    -1,   137,
      -1,   139,    -1,    -1,   142,    -1,    -1,    -1,   146,    -1,
      -1,    -1,   150,    -1,    -1,   153,   154,    -1,   156,   157,
     158,    -1,   160,     3,     4,    -1,    -1,    -1,     8,     9,
      10,    -1,    12,    13,    14,    15,    16,    17,    18,    19,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    27,    -1,    29,
      -1,    -1,    -1,    -1,    34,    -1,    -1,    -1,    38,    39,
      40,    -1,    -1,    43,    44,    45,    -1,    -1,    -1,    -1,
      -1,    51,    -1,    -1,    54,    -1,    -1,    -1,    -1,    -1,
      -1,    61,    -1,    63,    -1,    65,    -1,    67,    68,    69,
      -1,    71,    -1,    73,    74,    -1,    -1,    -1,    -1,    -1,
      80,    81,    82,    -1,    84,    -1,    86,    -1,    -1,    89,
      90,    -1,    -1,    -1,    94,    -1,    -1,    -1,    98,    99,
      -1,   101,   102,   103,    -1,    -1,    -1,   107,    -1,   109,
      -1,    -1,   112,    -1,    -1,   115,   116,    -1,    -1,    -1,
     120,   121,    -1,    -1,   124,   125,   126,    -1,   128,   129,
     130,    -1,    -1,   133,    -1,    -1,    -1,   137,    -1,   139,
      -1,    -1,   142,    -1,    -1,    -1,   146,    -1,    -1,    -1,
     150,    -1,    -1,   153,   154,    -1,   156,   157,   158,    -1,
     160,     3,     4,    -1,    -1,    -1,    -1,     9,    10,    -1,
      12,    13,    14,    15,    16,    -1,    -1,    -1,    20,    -1,
      -1,    23,    -1,    25,    -1,    27,    28,    -1,    30,    -1,
      -1,    -1,    34,    -1,    -1,    -1,    38,    -1,    -1,    -1,
      -1,    -1,    44,    -1,    -1,    -1,    -1,    49,    -1,    51,
      52,    -1,    54,    55,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    67,    -1,    -1,    -1,    -1,
      -1,    73,    74,    -1,    76,    77,    -1,    79,    80,    -1,
      82,    -1,    84,    -1,    86,    -1,    -1,    89,    90,    -1,
      92,    -1,    94,    -1,    -1,    -1,    98,    99,    -1,    -1,
      -1,    -1,   104,   105,   106,    -1,    -1,   109,    -1,    -1,
     112,   113,   114,    -1,   116,    -1,    -1,    -1,    -1,    -1,
      -1,   123,    -1,   125,   126,   127,   128,    -1,   130,   131,
     132,    -1,    -1,   135,   136,    -1,    -1,    -1,    -1,    -1,
     142,   143,    -1,    -1,   146,    -1,    -1,    -1,   150,    -1,
      -1,   153,   154,    -1,   156,   157,   158,    -1,   160,     3,
       4,    -1,    -1,    -1,     8,     9,    10,    -1,    12,    13,
      14,    15,    16,    17,    18,    19,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    27,    -1,    29,    -1,    -1,    -1,    -1,
      34,    -1,    -1,    -1,    38,    -1,    40,    -1,    -1,    43,
      44,    45,    -1,    -1,    -1,    -1,    -1,    51,    -1,    -1,
      54,    -1,    -1,    -1,    -1,    -1,    -1,    61,    -1,    -1,
      -1,    -1,    -1,    -1,    68,    69,    -1,    71,    -1,    73,
      74,    -1,    -1,    -1,    -1,    -1,    80,    81,    82,    -1,
      84,    -1,    86,    -1,    -1,    89,    90,    -1,    -1,    -1,
      94,    -1,    -1,    -1,    98,    99,    -1,   101,   102,   103,
      -1,    -1,    -1,   107,    -1,   109,    -1,    -1,   112,    -1,
      -1,   115,   116,    -1,    -1,    -1,   120,   121,    -1,    -1,
      -1,   125,   126,    -1,   128,   129,   130,    -1,    -1,   133,
      -1,    -1,    -1,   137,    -1,   139,    -1,    -1,   142,    -1,
      -1,    -1,   146,    -1,    -1,    -1,   150,    -1,    -1,   153,
     154,    -1,   156,   157,   158,    -1,   160,     3,     4,    -1,
      -1,    -1,    -1,     9,    10,    -1,    12,    13,    14,    15,
      16,    -1,    -1,    -1,    20,    -1,    -1,    23,    -1,    25,
      -1,    27,    28,    -1,    30,    -1,    -1,    -1,    34,    -1,
      -1,    -1,    38,    -1,    -1,    -1,    -1,    -1,    44,    -1,
      -1,    -1,    -1,    49,    -1,    51,    52,    -1,    54,    55,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    67,    -1,    -1,    -1,    -1,    -1,    73,    74,    -1,
      76,    77,    -1,    79,    80,    -1,    82,    -1,    84,    -1,
      86,    -1,    -1,    89,    90,    -1,    92,    -1,    94,    -1,
      -1,    -1,    98,    99,    -1,    -1,    -1,    -1,   104,   105,
     106,    -1,    -1,   109,    -1,    -1,   112,   113,   114,    -1,
     116,    -1,    -1,    -1,    -1,    -1,    -1,   123,    -1,   125,
     126,   127,   128,    -1,   130,   131,   132,    -1,    -1,   135,
     136,    -1,    -1,    -1,    -1,    -1,   142,    -1,    -1,    -1,
     146,    -1,    -1,    -1,   150,    -1,    -1,   153,   154,    -1,
     156,   157,   158,    -1,   160,     3,     4,    -1,    -1,    -1,
      -1,     9,    10,    -1,    12,    13,    14,    15,    16,    -1,
      -1,    -1,    20,    -1,    -1,    23,    -1,    25,    -1,    27,
      28,    -1,    30,    -1,    -1,    -1,    34,    -1,    -1,    -1,
      38,    -1,    -1,    -1,    -1,    -1,    44,    -1,    -1,    -1,
      -1,    49,    -1,    51,    52,    -1,    54,    55,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    73,    74,    -1,    76,    77,
      -1,    79,    80,    -1,    82,    -1,    -1,    -1,    86,    -1,
      -1,    89,    90,    -1,    92,    -1,    94,    -1,    -1,    -1,
      98,    99,    -1,    -1,    -1,    -1,   104,   105,   106,    -1,
      -1,   109,    -1,    -1,   112,   113,   114,    -1,   116,    -1,
      -1,    -1,    -1,    -1,    -1,   123,    -1,   125,   126,   127,
     128,    -1,   130,   131,   132,    -1,    -1,   135,   136,    -1,
      -1,    -1,    -1,    -1,   142,    -1,    -1,    -1,   146,    -1,
      -1,    -1,   150,    -1,    -1,   153,   154,    -1,   156,   157,
     158,    -1,   160,     3,     4,    -1,    -1,    -1,    -1,     9,
      10,    -1,    12,    13,    14,    15,    16,    17,    18,    19,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    27,    -1,    29,
      -1,    -1,    -1,    -1,    34,    -1,    -1,    -1,    38,    -1,
      40,    -1,    -1,    -1,    44,    45,    -1,    -1,    -1,    -1,
      -1,    51,    -1,    -1,    54,    -1,    -1,    -1,    -1,    -1,
      -1,    61,    -1,    -1,    -1,    -1,    -1,    -1,    68,    -1,
      -1,    71,    -1,    73,    74,    -1,    -1,    -1,    -1,    -1,
      80,    81,    82,    -1,    -1,    -1,    86,    -1,    -1,    89,
      90,    -1,    -1,    -1,    94,    -1,    -1,    -1,    98,    99,
      -1,   101,   102,   103,    -1,    -1,    -1,   107,    -1,   109,
      -1,    -1,   112,    -1,    -1,   115,   116,    -1,    -1,    -1,
     120,   121,    -1,    -1,    -1,   125,   126,    -1,   128,   129,
     130,    -1,    -1,   133,    -1,    -1,    -1,   137,   138,    -1,
      -1,    -1,   142,    -1,    -1,    -1,   146,    -1,    -1,    -1,
     150,    -1,    -1,   153,   154,    -1,   156,   157,   158,    -1,
     160,     3,     4,    -1,    -1,    -1,    -1,     9,    10,    -1,
      12,    13,    14,    15,    16,    17,    18,    19,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    27,    -1,    29,    -1,    -1,
      -1,    -1,    34,    -1,    -1,    -1,    38,    -1,    40,    -1,
      -1,    -1,    44,    45,    -1,    -1,    -1,    -1,    -1,    51,
      -1,    -1,    54,    -1,    -1,    -1,    -1,    -1,    -1,    61,
      -1,    -1,    -1,    -1,    -1,    -1,    68,    -1,    -1,    71,
      -1,    73,    74,    -1,    -1,    -1,    -1,    -1,    80,    81,
      82,    -1,    -1,    -1,    86,    -1,    -1,    89,    90,    -1,
      -1,    -1,    94,    -1,    -1,    -1,    98,    99,    -1,   101,
     102,   103,    -1,    -1,    -1,   107,    -1,   109,    -1,    -1,
     112,    -1,    -1,   115,   116,    -1,    -1,    -1,   120,   121,
      -1,    -1,    -1,   125,   126,    -1,   128,   129,   130,    -1,
      -1,   133,    -1,    -1,    -1,   137,    -1,   139,    -1,    -1,
     142,    -1,    -1,    -1,   146,    -1,    -1,    -1,   150,    -1,
      -1,   153,   154,    -1,   156,   157,   158,    -1,   160,     3,
       4,    -1,    -1,    -1,    -1,     9,    10,    -1,    12,    13,
      14,    15,    16,    17,    18,    19,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    27,    -1,    29,    -1,    -1,    -1,    -1,
      34,    -1,    -1,    -1,    38,    -1,    40,    -1,    -1,    -1,
      44,    45,    -1,    -1,    -1,    -1,    -1,    51,    -1,    -1,
      54,    -1,    -1,    -1,    -1,    -1,    -1,    61,    -1,    -1,
      -1,    -1,    -1,    -1,    68,    -1,    -1,    71,    -1,    73,
      74,    -1,    -1,    -1,    -1,    -1,    80,    81,    82,    -1,
      -1,    -1,    86,    -1,    -1,    89,    90,    -1,    -1,    -1,
      94,    -1,    -1,    -1,    98,    99,    -1,   101,   102,   103,
      -1,    -1,    -1,   107,    -1,   109,    -1,    -1,   112,    -1,
      -1,   115,   116,    -1,    -1,    -1,   120,   121,    -1,    -1,
      -1,   125,   126,    -1,   128,   129,   130,    -1,    -1,   133,
      -1,    -1,    -1,   137,    -1,   139,    -1,    -1,   142,    -1,
      -1,    -1,   146,    -1,    -1,    -1,   150,    -1,    -1,   153,
     154,    -1,   156,   157,   158,    -1,   160,     3,     4,    -1,
      -1,    -1,    -1,     9,    10,    -1,    12,    13,    14,    15,
      16,    17,    18,    19,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    27,    -1,    29,    -1,    -1,    -1,    -1,    34,    -1,
      -1,    -1,    38,    -1,    40,    -1,    -1,    -1,    44,    45,
      -1,    -1,    -1,    -1,    -1,    51,    -1,    -1,    54,    -1,
      -1,    -1,    -1,    -1,    -1,    61,    -1,    -1,    -1,    -1,
      -1,    -1,    68,    -1,    -1,    71,    -1,    73,    74,    -1,
      -1,    -1,    -1,    -1,    80,    81,    82,    -1,    -1,    -1,
      86,    -1,    -1,    89,    90,    -1,    -1,    -1,    94,    -1,
      -1,    -1,    98,    99,    -1,   101,   102,   103,    -1,    -1,
      -1,   107,    -1,   109,    -1,    -1,   112,    -1,    -1,   115,
     116,    -1,    -1,    -1,   120,   121,    -1,    -1,    -1,   125,
     126,    -1,   128,   129,   130,    -1,    -1,   133,    -1,    -1,
      -1,   137,   138,    -1,    -1,    -1,   142,    -1,    -1,    -1,
     146,    -1,    -1,    -1,   150,    -1,    -1,   153,   154,    -1,
     156,   157,   158,    -1,   160,     3,     4,    -1,    -1,    -1,
      -1,     9,    10,    -1,    12,    13,    14,    15,    16,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    27,
      -1,    -1,    -1,    -1,    -1,    -1,    34,    -1,    -1,    -1,
      38,    -1,    -1,    -1,    -1,    -1,    44,    -1,    -1,    -1,
      -1,    -1,    -1,    51,    -1,    -1,    54,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    73,    74,    -1,    -1,    -1,
      -1,    -1,    80,    -1,    82,    -1,    -1,    -1,    86,    -1,
      -1,    89,    90,    -1,    -1,    -1,    94,    -1,    -1,    -1,
      98,    99,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   109,    -1,    -1,   112,    -1,    -1,    -1,   116,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   125,   126,    -1,
     128,    -1,   130,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   141,   142,    -1,    -1,    -1,   146,    -1,
      -1,    -1,   150,    -1,    -1,   153,   154,    -1,   156,   157,
     158,    -1,   160,     3,     4,    -1,    -1,    -1,    -1,     9,
      10,    -1,    12,    13,    14,    15,    16,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    27,    -1,    -1,
      -1,    -1,    -1,    -1,    34,    -1,    -1,    -1,    38,    -1,
      -1,    -1,    -1,    -1,    44,    -1,    -1,    -1,    -1,    -1,
      -1,    51,    -1,    -1,    54,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    73,    74,    -1,    -1,    -1,    -1,    -1,
      80,    -1,    82,    -1,    -1,    -1,    86,    -1,    -1,    89,
      90,    -1,    -1,    -1,    94,    -1,    -1,    -1,    98,    99,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,
      -1,    -1,   112,    -1,    -1,    -1,   116,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   125,   126,    -1,   128,    -1,
     130,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   141,   142,    -1,    -1,    -1,   146,    -1,    -1,    -1,
     150,    -1,    -1,   153,   154,    -1,   156,   157,   158,    -1,
     160,     3,     4,    -1,    -1,    -1,    -1,     9,    10,    -1,
      12,    13,    14,    15,    16,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    27,    -1,    -1,    -1,    -1,
      -1,    -1,    34,    -1,    -1,    -1,    38,    -1,    -1,    -1,
      -1,    -1,    44,    -1,    -1,    -1,    -1,    -1,    -1,    51,
      -1,    -1,    54,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    73,    74,    -1,    -1,    -1,    -1,    -1,    80,    81,
      82,    -1,    -1,    -1,    86,    -1,    -1,    89,    90,    -1,
      -1,    -1,    94,    -1,    -1,    -1,    98,    99,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,    -1,    -1,
     112,    -1,    -1,    -1,   116,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   125,   126,    -1,   128,    -1,   130,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     142,    -1,    -1,    -1,   146,    -1,    -1,    -1,   150,    -1,
      -1,   153,   154,    -1,   156,   157,   158,    -1,   160,     3,
       4,    -1,    -1,    -1,    -1,     9,    10,    -1,    12,    13,
      14,    15,    16,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    27,    -1,    -1,    -1,    -1,    -1,    -1,
      34,    -1,    -1,    -1,    38,    -1,    -1,    -1,    -1,    -1,
      44,    -1,    -1,    -1,    -1,    -1,    -1,    51,    -1,    -1,
      54,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    73,
      74,    -1,    -1,    -1,    -1,    -1,    80,    -1,    82,    -1,
      -1,    -1,    86,    -1,    -1,    89,    90,    -1,    -1,    -1,
      94,    -1,    -1,    -1,    98,    99,    -1,    -1,    -1,    -1,
      -1,     7,    -1,    -1,    -1,   109,    -1,    -1,   112,    -1,
      -1,    -1,   116,    -1,    -1,    -1,    22,    -1,    -1,    -1,
      -1,   125,   126,    -1,   128,    -1,   130,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   142,    -1,
      46,    -1,   146,    -1,    -1,    -1,   150,    53,    -1,   153,
     154,    -1,   156,   157,   158,    61,   160,    -1,    64,    -1,
      66,    -1,    68,    -1,    70,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    78,    -1,    -1,    -1,    -1,    -1,    -1,    85,
      86,    -1,    -1,    -1,    -1,    91,    -1,    93,    -1,    95,
      -1,    97,    98,    -1,   100,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   110,   111,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   119,    -1,    -1,   122,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
     156,     3,     4,   159,   160,   161,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    -1,
      -1,    23,    -1,    25,    -1,    -1,    28,    -1,    30,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    49,    -1,    -1,
      52,    -1,    54,    55,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    67,    -1,    -1,    -1,    -1,
      -1,    73,    74,    -1,    76,    77,    -1,    79,    80,    -1,
      82,    -1,    84,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      92,    -1,    94,    -1,    -1,    -1,    -1,    99,    -1,    -1,
      -1,    -1,   104,   105,   106,    -1,    -1,   109,    -1,    -1,
     112,   113,   114,    -1,   116,     3,     4,    -1,    -1,    -1,
      -1,   123,    -1,    -1,   126,   127,    -1,    -1,   130,   131,
     132,    -1,    20,   135,   136,    23,    -1,    25,    -1,    -1,
      28,    -1,    30,    -1,   146,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    49,    -1,    -1,    52,    -1,    54,    55,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    67,
      -1,    -1,    -1,    -1,    -1,    73,    74,    -1,    76,    77,
      -1,    79,    80,    -1,    82,    -1,    84,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    92,    -1,    94,    -1,    -1,    -1,
      -1,    99,    -1,    -1,    -1,    -1,   104,   105,   106,    -1,
      -1,   109,    -1,    -1,   112,   113,   114,    -1,   116,     3,
       4,    -1,    -1,    -1,    -1,   123,    -1,    -1,   126,   127,
      -1,    -1,   130,   131,   132,    -1,    20,   135,   136,    23,
      -1,    25,    -1,    -1,    28,    -1,    30,    -1,   146,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    49,    -1,    -1,    52,    -1,
      54,    55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    67,    -1,    -1,    -1,    -1,    -1,    73,
      74,    -1,    76,    77,    -1,    79,    80,    -1,    82,    -1,
      84,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    92,    -1,
      94,    -1,    -1,    -1,    -1,    99,    -1,    -1,    -1,    -1,
     104,   105,   106,    -1,    -1,   109,    -1,    -1,   112,   113,
     114,    -1,   116,     3,     4,    -1,    -1,    -1,    -1,   123,
      -1,    -1,   126,   127,    -1,    -1,   130,   131,   132,    -1,
      20,   135,   136,    23,    -1,    25,    -1,    -1,    28,    -1,
      30,    -1,   146,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    49,
      -1,    -1,    52,    -1,    54,    55,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    67,    -1,    -1,
      -1,    -1,    -1,    73,    74,    -1,    76,    77,    -1,    79,
      80,    -1,    82,    -1,    84,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    92,    -1,    94,    -1,    -1,    -1,    -1,    99,
      -1,    -1,    -1,    -1,   104,   105,   106,    -1,    -1,   109,
      -1,    -1,   112,   113,   114,    -1,   116,     3,     4,    -1,
      -1,    -1,    -1,   123,    -1,    -1,   126,   127,    -1,    -1,
     130,   131,   132,    -1,    20,   135,   136,    23,    -1,    25,
      -1,    -1,    28,    -1,    30,    -1,   146,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    49,    -1,    -1,    52,    -1,    54,    55,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    67,    -1,    -1,    -1,    -1,    -1,    73,    74,    -1,
      76,    77,    -1,    79,    80,    -1,    82,    -1,    84,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    92,    -1,    94,    -1,
      -1,    -1,    -1,    99,    -1,    -1,    -1,    -1,   104,   105,
     106,    -1,    -1,   109,    -1,    -1,   112,   113,   114,    -1,
     116,     3,     4,    -1,    -1,    -1,    -1,   123,    -1,    -1,
     126,   127,    -1,    -1,   130,   131,   132,    -1,    20,   135,
     136,    23,    -1,    25,    -1,    -1,    28,    -1,    30,    -1,
     146,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    49,    -1,    -1,
      52,    -1,    54,    55,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    67,    -1,    -1,    -1,    -1,
      -1,    73,    74,    -1,    76,    77,    -1,    79,    80,    -1,
      82,    -1,    84,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      92,    -1,    94,    -1,    -1,    -1,    -1,    99,    -1,    -1,
      -1,    -1,   104,   105,   106,    -1,    -1,   109,    -1,    -1,
     112,   113,   114,    -1,   116,     3,     4,    -1,    -1,    -1,
      -1,   123,    -1,    -1,   126,   127,    -1,    -1,   130,   131,
     132,    -1,    20,   135,   136,    23,    -1,    25,    -1,    -1,
      28,    -1,    30,    -1,   146,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    49,    -1,    -1,    52,    -1,    54,    55,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    67,
      -1,    -1,    -1,    -1,    -1,    73,    74,    -1,    76,    77,
      -1,    79,    80,    -1,    82,    -1,    84,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    92,    -1,    94,    -1,    -1,    -1,
      -1,    99,    -1,    -1,    -1,    -1,   104,   105,   106,    -1,
      -1,   109,    -1,    -1,   112,   113,   114,    -1,   116,     3,
       4,    -1,    -1,    -1,    -1,   123,    -1,    -1,   126,   127,
      -1,    -1,   130,   131,   132,    -1,    20,   135,   136,    23,
      -1,    25,    -1,    -1,    28,    -1,    30,    -1,   146,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    49,    -1,    -1,    52,    -1,
      54,    55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    67,    -1,    -1,    -1,    -1,    -1,    73,
      74,    -1,    76,    77,    -1,    79,    80,    -1,    82,    -1,
      84,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    92,    -1,
      94,    -1,    -1,    -1,    -1,    99,    -1,    -1,    -1,    -1,
     104,   105,   106,    -1,    -1,   109,    -1,    -1,   112,   113,
     114,    -1,   116,     3,     4,    -1,    -1,    -1,    -1,   123,
      -1,    -1,   126,   127,    -1,    -1,   130,   131,   132,    -1,
      20,   135,   136,    23,    -1,    25,    -1,    -1,    28,    -1,
      30,    -1,   146,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    49,
      -1,    -1,    52,    -1,    54,    55,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    67,    -1,    -1,
      -1,    -1,    -1,    73,    74,    -1,    76,    77,    -1,    79,
      80,    -1,    82,    -1,    84,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    92,    -1,    94,    -1,    -1,    -1,    -1,    99,
      -1,    -1,    -1,    -1,   104,   105,   106,    -1,    -1,   109,
      -1,    -1,   112,   113,   114,    -1,   116,    -1,    -1,    -1,
       3,     4,    -1,   123,    -1,    -1,   126,   127,    -1,    -1,
     130,   131,   132,    -1,    -1,   135,   136,    20,    -1,   139,
      23,    -1,    25,    -1,    -1,    28,    -1,    30,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    49,    -1,    -1,    52,
      -1,    54,    55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    67,    -1,    -1,    -1,    -1,    -1,
      73,    74,    -1,    76,    77,    -1,    79,    80,    -1,    82,
      -1,    84,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    92,
      -1,    94,    -1,    -1,    -1,    -1,    99,    -1,    -1,    -1,
      -1,   104,   105,   106,    -1,    -1,   109,    -1,    -1,   112,
     113,   114,    -1,   116,    -1,    -1,    -1,     3,     4,    -1,
     123,    -1,    -1,   126,   127,    -1,    -1,   130,   131,   132,
      -1,    -1,   135,   136,    20,    -1,   139,    23,    -1,    25,
      -1,    -1,    28,    -1,    30,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    49,    -1,    -1,    52,    -1,    54,    55,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    67,    -1,    -1,    -1,    -1,    -1,    73,    74,    -1,
      76,    77,    -1,    79,    80,    -1,    82,    -1,    84,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    92,    -1,    94,    -1,
      -1,    -1,    -1,    99,    -1,    -1,    -1,    -1,   104,   105,
     106,    -1,    -1,   109,    -1,    -1,   112,   113,   114,    -1,
     116,     3,     4,    -1,    -1,    -1,    -1,   123,    -1,    -1,
     126,   127,    -1,    -1,   130,   131,   132,    -1,    20,   135,
     136,    23,    -1,    25,    -1,    -1,    28,    -1,    30,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    49,    -1,    -1,
      52,    -1,    54,    55,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    67,    -1,    -1,    -1,    -1,
      -1,    73,    74,    -1,    76,    77,    -1,    79,    80,    -1,
      82,    -1,    84,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      92,    -1,    94,    -1,    -1,    -1,    -1,    99,    -1,    -1,
      -1,    -1,   104,   105,   106,    -1,    -1,   109,    -1,    -1,
     112,   113,   114,    -1,   116,     3,     4,    -1,    -1,    -1,
      -1,   123,    -1,    -1,   126,   127,    -1,    -1,   130,   131,
     132,    -1,    20,   135,   136,    23,    -1,    25,    -1,    -1,
      28,    -1,    30,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    49,    -1,    -1,    52,    -1,    54,    55,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    67,
      -1,    -1,    -1,    -1,    -1,    73,    74,    -1,    76,    77,
      -1,    79,    80,    -1,    82,    -1,    84,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    92,    -1,    94,    -1,    -1,    -1,
      -1,    99,    -1,    -1,    -1,    -1,   104,   105,   106,    -1,
      -1,   109,    -1,    -1,   112,   113,   114,    -1,   116,     3,
       4,    -1,    -1,    -1,    -1,   123,    -1,    -1,   126,   127,
      -1,    -1,   130,   131,   132,    -1,    20,   135,   136,    23,
      -1,    25,    -1,    -1,    28,    -1,    30,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    49,    -1,    -1,    52,    -1,
      54,    55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    67,    -1,    -1,    -1,    -1,    -1,    73,
      74,    -1,    76,    77,    -1,    79,    80,    -1,    82,    -1,
      84,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    92,    -1,
      94,    -1,    -1,    -1,    -1,    99,    -1,    -1,    -1,    -1,
     104,   105,   106,    -1,    -1,   109,    -1,    -1,   112,   113,
     114,    -1,   116,    -1,    -1,    -1,    -1,    -1,    -1,   123,
      -1,    -1,   126,   127,    -1,    -1,   130,   131,   132,    -1,
      -1,   135,   136
  };

  const unsigned short int
  Parser::yystos_[] =
  {
       0,    88,   164,     3,   165,     0,   138,   170,     4,     8,
       9,    10,    12,    13,    14,    15,    16,    17,    18,    19,
      27,    29,    34,    38,    40,    43,    44,    45,    51,    54,
      61,    68,    69,    71,    73,    74,    80,    81,    82,    84,
      86,    89,    90,    94,    98,    99,   101,   102,   103,   107,
     109,   112,   115,   116,   120,   121,   125,   126,   128,   129,
     130,   133,   137,   139,   142,   146,   150,   153,   154,   156,
     157,   158,   160,   165,   166,   171,   172,   173,   174,   176,
     178,   179,   180,   181,   201,   208,   209,   231,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   252,   253,   256,   261,   262,
     263,   264,   267,   268,   269,   140,   141,   156,   231,   231,
     231,   142,   141,   147,   213,   141,   181,   213,   231,   142,
     142,   142,   142,   165,   147,   142,   142,   213,    20,    23,
      25,    28,    30,    49,    52,    54,    55,    67,    73,    74,
      76,    77,    79,    80,    82,    84,    92,    94,    99,   104,
     105,   106,   109,   112,   113,   114,   116,   123,   126,   127,
     130,   131,   132,   135,   136,   165,   166,   188,   189,   210,
     211,   212,   216,   217,   220,   224,   228,   142,   213,    57,
      58,   185,   190,   246,   142,    25,    54,    73,    74,    80,
      82,    94,    99,   109,   112,   116,   126,   130,   166,   212,
     231,   142,   246,   142,   141,   231,   142,   213,   142,   142,
     142,   141,   231,   138,   172,   173,   181,   197,   198,   201,
     142,   147,   213,   231,   142,   213,   142,   141,   231,   257,
     259,   246,   246,    14,    15,    14,    15,   142,   250,   270,
     246,   246,   162,   231,   232,   233,   265,   266,    39,    63,
      65,    67,   124,   141,    46,    85,    95,    97,   119,   140,
     149,    22,    53,    91,    64,    78,   147,   148,   150,   151,
     152,   110,   111,   153,   154,   100,   146,   155,   156,    66,
      70,    86,    93,    98,   122,   142,   159,   160,   150,   276,
     231,    15,   141,   141,   145,   141,   145,   231,   212,   187,
     188,   212,   141,   231,     9,   165,    81,   175,   231,    62,
     141,    15,    15,   153,   154,   253,   254,   231,   232,   212,
     165,   138,   147,   145,   213,   213,   213,   142,   213,   213,
     213,   213,   213,   213,   142,   221,   213,   213,   276,   213,
     213,   213,   213,   140,    63,   215,   165,   231,   272,   273,
     274,   212,   194,   212,   231,   147,   213,   213,   213,   147,
     213,   142,   231,   231,   141,   232,   212,    10,   175,   231,
      15,   153,   154,   253,   255,   141,   199,   200,   201,    35,
     206,   207,   211,   231,    15,   212,   141,   232,   212,   175,
     231,   143,   143,   144,   150,   231,    11,   165,    61,   161,
     144,   144,   161,   166,   212,   184,   190,    25,   166,   212,
     186,   190,   166,   235,   235,   237,   235,   235,   235,   235,
     238,   239,   239,   240,   240,   240,   240,   241,   242,   243,
     244,   244,   245,   245,   246,   246,   246,   246,    54,   165,
     251,   247,   247,   251,   232,   251,   231,   269,     7,   275,
     141,   231,   231,   143,   148,   214,   141,   190,   214,   143,
     143,    70,    25,   212,   141,   143,   143,   167,   168,   148,
      15,    15,   143,   143,   143,   214,   140,   165,   229,   230,
     146,   212,    15,   146,   212,   212,     9,   146,   212,   146,
     212,   212,   146,   212,   212,   146,   212,    42,    72,   191,
     192,   193,   195,   138,   146,   165,   212,   218,   219,    15,
     146,   138,   146,   212,   212,   146,   212,   146,   212,   231,
     142,   140,   142,   177,   145,   143,   144,   144,     4,     5,
      60,   165,   182,   183,   143,   212,   212,   212,   212,   232,
     143,   144,   143,   214,   143,   143,   143,    15,   143,   143,
     139,   201,   142,   197,   207,   143,   143,   148,   214,   143,
     214,   141,   143,   143,   231,   258,   259,   271,   140,   165,
     231,   266,   140,   166,   194,   166,   140,   166,   194,   140,
     145,   143,   142,   161,   140,   141,   141,   142,   194,   142,
     231,   165,   165,   231,   197,   197,   141,     6,   142,   142,
     231,   140,   139,   144,   148,   214,   214,   214,   214,   143,
     214,   214,   214,   144,   214,   214,   214,   214,   214,   214,
     143,   144,   212,   222,   214,   145,   144,   214,   214,   214,
     212,   225,   226,   227,   214,   214,   214,   214,   214,   214,
     214,   141,   191,   231,   232,   141,   231,   274,   212,   142,
     214,   144,   214,   214,   143,   231,   142,   138,   138,   212,
     142,   142,   256,   260,   142,   231,   197,   197,   144,   156,
     231,    70,   231,   140,   183,   140,   231,   140,   177,   183,
     212,   235,   232,   231,   231,   183,   232,   143,   140,   140,
     143,    50,   202,   202,   169,    15,   154,   257,   141,    15,
     230,   212,   193,   165,   139,   189,   212,   223,   212,   219,
     165,   139,   144,   143,   141,   143,   214,   191,   212,   143,
     257,    33,    44,   203,   204,   205,   203,   165,    15,   257,
     143,   202,   202,   258,   231,   141,   231,   142,   231,   141,
     231,   141,   142,   276,   143,   143,   142,   143,   197,   231,
     231,   197,   197,   143,    15,   143,   214,   140,   196,   190,
     165,   276,   227,    24,   142,   143,   214,   143,   233,   145,
     139,   205,   139,   143,   143,   143,   197,    68,   161,   141,
     191,   141,   141,   191,   141,   191,   202,   143,   231,   276,
     194,   276,   194,   272,   276,   145,   197,   197,   202,   231,
     143,   143,   143,   182,   141,   143,   198,   197,   161,   276,
     276,   276,   142,   198,   198,   191,   143,   276,   141,   198
  };

  const unsigned short int
  Parser::yyr1_[] =
  {
       0,   163,   164,   165,   166,   166,   168,   169,   167,   170,
     170,   170,   171,   171,   171,   171,   171,   171,   172,   173,
     173,   174,   174,   174,   174,   175,   175,   176,   176,   176,
     176,   177,   177,   178,   178,   178,   178,   179,   179,   180,
     180,   181,   181,   181,   181,   181,   182,   182,   183,   183,
     183,   184,   185,   186,   187,   188,   188,   189,   189,   190,
     190,   190,   191,   191,   192,   192,   193,   194,   195,   195,
     195,   196,   196,   197,   197,   198,   199,   199,   200,   200,
     201,   201,   201,   201,   201,   201,   201,   201,   201,   201,
     201,   201,   201,   201,   201,   201,   201,   201,   201,   201,
     201,   201,   201,   201,   201,   201,   202,   202,   203,   203,
     204,   204,   205,   205,   206,   206,   207,   207,   208,   208,
     208,   209,   210,   210,   210,   210,   210,   210,   210,   210,
     210,   210,   210,   210,   210,   210,   210,   210,   210,   210,
     210,   210,   210,   210,   210,   210,   210,   210,   210,   210,
     210,   210,   210,   210,   210,   210,   210,   210,   210,   210,
     210,   210,   210,   210,   210,   210,   210,   211,   212,   212,
     212,   213,   214,   215,   216,   217,   217,   218,   218,   219,
     219,   220,   221,   221,   222,   222,   223,   223,   223,   224,
     225,   225,   226,   226,   227,   228,   228,   229,   229,   229,
     230,   230,   231,   232,   232,   233,   233,   234,   235,   235,
     235,   235,   235,   235,   235,   236,   236,   237,   237,   238,
     238,   238,   239,   239,   239,   239,   239,   240,   240,   241,
     241,   242,   242,   243,   243,   243,   244,   244,   244,   245,
     245,   245,   245,   245,   246,   246,   246,   246,   246,   246,
     246,   247,   247,   247,   247,   247,   247,   247,   247,   247,
     247,   247,   248,   248,   248,   248,   248,   248,   248,   248,
     248,   248,   248,   249,   249,   249,   249,   249,   249,   250,
     250,   251,   251,   252,   252,   252,   252,   252,   252,   252,
     252,   252,   252,   252,   252,   252,   252,   252,   252,   252,
     252,   252,   252,   252,   252,   252,   252,   252,   252,   252,
     252,   253,   253,   253,   254,   254,   254,   255,   255,   256,
     257,   257,   257,   258,   258,   258,   259,   260,   261,   261,
     261,   261,   261,   262,   262,   263,   263,   264,   265,   265,
     266,   267,   268,   268,   270,   271,   269,   272,   272,   273,
     273,   274,   275,   275,   276,   276
  };

  const unsigned char
  Parser::yyr2_[] =
  {
       0,     2,     5,     1,     1,     1,     0,     0,     3,     2,
       2,     0,     1,     1,     1,     1,     1,     1,     7,     6,
       7,     5,     5,     6,     6,     5,     5,     6,     6,     7,
       7,     3,     0,     3,     3,     2,     4,     3,     5,     2,
       4,     1,     1,     1,     1,     0,     1,     1,     1,     1,
       1,     8,     8,     8,     8,     1,     0,     1,     1,     1,
       1,     0,     1,     0,     3,     1,     5,     1,     1,     1,
       0,     2,     0,     1,     1,     3,     1,     0,     2,     1,
       2,     1,     2,     3,     3,     2,     2,     2,     2,     6,
       6,     8,     8,     6,     6,     7,     7,     7,     3,     3,
       5,     3,     5,     3,     3,     3,     2,     0,     1,     0,
       2,     1,     4,     3,     2,     1,     6,     2,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     4,     4,     4,
       4,     4,     4,     4,     4,     4,     4,     4,     4,     4,
       4,     4,     4,     4,     4,     4,     4,     4,     4,     6,
       1,     3,     4,     1,     1,     1,     1,     2,     1,     1,
       1,     1,     1,     0,     7,     4,     4,     3,     1,     1,
       3,     5,     3,     0,     2,     0,     4,     9,     9,     5,
       1,     0,     3,     1,     3,     4,     4,     3,     2,     1,
       1,     3,     1,     1,     0,     3,     1,     1,     3,     3,
       3,     3,     3,     5,     1,     3,     1,     3,     1,     3,
       3,     1,     3,     3,     3,     3,     1,     3,     1,     3,
       1,     3,     1,     3,     3,     1,     3,     3,     1,     3,
       3,     3,     3,     1,     2,     2,     2,     3,     2,     2,
       1,     4,     3,     6,     4,     3,     3,     3,     2,     2,
       3,     1,     4,     7,     4,     4,     5,     2,     2,     5,
       4,     4,     1,     1,     6,     2,     7,     9,     1,     3,
       1,     1,     1,     1,     1,     1,     1,     1,     2,     2,
       1,     1,     3,     1,     4,     4,     4,     4,     4,     4,
       4,     7,     7,     7,     8,     1,     1,     1,     1,     1,
       1,     1,     2,     2,     1,     2,     2,     1,     2,     3,
       1,     3,     0,     1,     3,     0,     1,     1,     3,     4,
       7,     4,     7,     4,     7,     4,     9,     3,     3,     1,
       4,     2,     3,     1,     0,     0,     5,     1,     0,     3,
       1,     3,     1,     3,     2,     0
  };



  // YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
  // First, the terminals, then, starting at \a yyntokens_, nonterminals.
  const char*
  const Parser::yytname_[] =
  {
  "\"<end of input>\"", "error", "$undefined", "\"identifier\"",
  "\"scoped identifier\"", "\"scoped ~finally\"", "\"dotted identifier\"",
  "\"attribute\"", "\"property\"", "\"string value\"", "\"bytes value\"",
  "\"regular expression value\"", "\"address value\"", "\"port value\"",
  "\"real value\"", "\"unsigned integer value\"", "\"bool value\"",
  "\"add\"", "\"assert\"", "\"assert-exception\"", "\"addr\"", "\"after\"",
  "\"&&\"", "\"any\"", "\"->\"", "\"auto\"", "\"at\"", "\"begin\"",
  "\"bool\"", "\"break\"", "\"bytes\"", "\"caddr\"", "\"callable\"",
  "\"case\"", "\"cast\"", "\"catch\"", "\"channel\"", "\"classifier\"",
  "\"Null\"", "\"const\"", "\"continue\"", "\"context\"", "\"copy\"",
  "\"declare\"", "\"default\"", "\"delete\"", "\"/=\"", "\"$$\"", "\"..\"",
  "\"real\"", "\"else\"", "\"end\"", "\"enum\"", "\"==\"", "\"error\"",
  "\"exception\"", "\"export\"", "\"extern\"", "\"extern-no-suspend\"",
  "\"file\"", "\"~finally\"", "\"for\"", "\"from\"", "\"function\"",
  "\">=\"", "\"global\"", "\"?.\"", "\"hook\"", "\"if\"", "\"import\"",
  "\"in\"", "\"init\"", "\"inout\"", "\"int\"", "\"interval\"",
  "\"iosrc\"", "\"iterator\"", "\"const_iterator\"", "\"<=\"",
  "\"library type\"", "\"list\"", "\"local\"", "\"map\"",
  "\"match_token_state\"", "\"method\"", "\"-=\"", "\"--\"", "\"%\"",
  "\"module\"", "\"move\"", "\"new\"", "\"!=\"", "\"net\"", "\"!in\"",
  "\"optional\"", "\"||\"", "\"overlay\"", "\"+=\"", "\"++\"", "\"port\"",
  "\"**\"", "\"preinit\"", "\"private\"", "\"public\"", "\"strong_ref\"",
  "\"regexp\"", "\"result\"", "\"return\"", "\"scope\"", "\"set\"",
  "\"<<\"", "\">>\"", "\"stream\"", "\"string\"", "\"struct\"",
  "\"switch\"", "\"time\"", "\"timer\"", "\"timer_mgr\"", "\"*=\"",
  "\"throw\"", "\"try\"", "\".?\"", "\"tuple\"", "\"type\"",
  "\"typeinfo\"", "\"uint\"", "\"union\"", "\"unpack\"", "\"unset\"",
  "\"vector\"", "\"view\"", "\"void\"", "\"while\"", "\"with\"",
  "\"value_ref\"", "\"weak_ref\"", "\"yield\"", "'{'", "'}'", "'='", "';'",
  "'('", "')'", "','", "':'", "'*'", "'<'", "'>'", "'?'", "'|'", "'^'",
  "'&'", "'+'", "'-'", "'%'", "'/'", "'!'", "'~'", "'.'", "'['", "']'",
  "'$'", "$accept", "module", "local_id", "scoped_id", "dotted_id", "$@1",
  "$@2", "global_scope_items", "global_scope_decl", "type_decl",
  "constant_decl", "local_decl", "local_init_decl", "global_decl",
  "opt_type_arguments", "function_decl", "import_decl", "property_decl",
  "opt_linkage", "function_id", "scoped_function_id", "function_with_body",
  "method_with_body", "hook_with_body", "function_without_body",
  "opt_func_flavor", "func_flavor", "opt_func_cc", "opt_func_params",
  "func_params", "func_param", "func_result", "opt_func_param_kind",
  "opt_func_default_expr", "block", "braced_block", "opt_stmts", "stmts",
  "stmt", "opt_else_block", "opt_switch_cases", "switch_cases",
  "switch_case", "try_catches", "try_catch", "stmt_decl", "stmt_expr",
  "base_type_no_attrs", "base_type", "type", "type_param_begin",
  "type_param_end", "opt_type_flags", "function_type", "tuple_type",
  "tuple_type_elems", "tuple_type_elem", "struct_type",
  "opt_struct_params", "struct_fields", "struct_field", "union_type",
  "opt_union_fields", "union_fields", "union_field", "enum_type",
  "enum_labels", "enum_label", "expr", "opt_exprs", "exprs", "expr_0",
  "expr_1", "expr_2", "expr_3", "expr_4", "expr_5", "expr_6", "expr_7",
  "expr_8", "expr_9", "expr_a", "expr_b", "expr_c", "expr_d", "expr_e",
  "expr_f", "expr_g", "member_expr", "ctor", "const_real", "const_sint",
  "const_uint", "tuple", "opt_tuple_elems1", "opt_tuple_elems2",
  "tuple_elem", "tuple_expr", "list", "set", "map", "struct_",
  "struct_elems", "struct_elem", "regexp", "re_patterns",
  "re_pattern_constant", "$@3", "$@4", "opt_map_elems", "map_elems",
  "map_elem", "attribute", "opt_attributes", YY_NULLPTR
  };

#if YYDEBUG
  const unsigned short int
  Parser::yyrline_[] =
  {
       0,   279,   279,   287,   297,   298,   300,   302,   300,   307,
     309,   311,   315,   316,   317,   318,   319,   320,   322,   325,
     327,   331,   332,   333,   335,   340,   342,   346,   348,   350,
     352,   357,   358,   360,   362,   365,   366,   370,   371,   375,
     376,   378,   379,   380,   381,   382,   386,   387,   390,   391,
     392,   395,   402,   409,   416,   422,   423,   425,   426,   428,
     429,   430,   432,   433,   435,   436,   438,   442,   445,   446,
     447,   450,   451,   456,   457,   460,   462,   463,   465,   466,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     479,   481,   483,   485,   487,   489,   491,   493,   495,   497,
     498,   499,   500,   503,   511,   519,   529,   530,   533,   534,
     536,   537,   539,   540,   542,   543,   545,   547,   549,   550,
     551,   554,   559,   560,   561,   562,   563,   564,   565,   566,
     567,   568,   569,   570,   571,   572,   573,   575,   576,   577,
     578,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   592,   593,   594,   595,   596,   597,   598,   599,
     601,   602,   604,   606,   607,   608,   609,   612,   616,   617,
     618,   622,   626,   629,   632,   636,   637,   641,   643,   647,
     648,   651,   654,   655,   657,   658,   660,   661,   665,   671,
     674,   675,   677,   678,   680,   682,   683,   685,   686,   687,
     690,   691,   696,   699,   700,   702,   703,   705,   708,   709,
     710,   711,   712,   713,   714,   716,   717,   719,   720,   722,
     723,   724,   726,   727,   728,   729,   730,   732,   733,   735,
     736,   738,   739,   741,   742,   743,   745,   746,   747,   749,
     750,   751,   752,   753,   755,   756,   757,   758,   759,   760,
     761,   763,   764,   765,   766,   767,   768,   769,   770,   771,
     772,   773,   775,   776,   777,   778,   779,   780,   781,   782,
     783,   784,   785,   787,   788,   789,   790,   792,   794,   796,
     797,   800,   801,   805,   806,   807,   808,   809,   810,   811,
     812,   814,   815,   816,   817,   820,   823,   826,   829,   831,
     832,   833,   836,   838,   840,   843,   844,   845,   846,   847,
     848,   851,   852,   853,   855,   856,   857,   859,   860,   863,
     866,   867,   868,   871,   872,   873,   876,   879,   881,   882,
     883,   885,   886,   889,   890,   893,   894,   897,   899,   900,
     902,   904,   906,   908,   911,   911,   911,   914,   915,   917,
     918,   920,   923,   924,   927,   928
  };

  // Print the state stack on the debug stream.
  void
  Parser::yystack_print_ ()
  {
    *yycdebug_ << "Stack now";
    for (stack_type::const_iterator
           i = yystack_.begin (),
           i_end = yystack_.end ();
         i != i_end; ++i)
      *yycdebug_ << ' ' << i->state;
    *yycdebug_ << std::endl;
  }

  // Report on the debug stream that the rule \a yyrule is going to be reduced.
  void
  Parser::yy_reduce_print_ (int yyrule)
  {
    unsigned int yylno = yyrline_[yyrule];
    int yynrhs = yyr2_[yyrule];
    // Print the symbols being reduced, and their result.
    *yycdebug_ << "Reducing stack by rule " << yyrule - 1
               << " (line " << yylno << "):" << std::endl;
    // The symbols being reduced.
    for (int yyi = 0; yyi < yynrhs; yyi++)
      YY_SYMBOL_PRINT ("   $" << yyi + 1 << " =",
                       yystack_[(yynrhs) - (yyi + 1)]);
  }
#endif // YYDEBUG

  // Symbol number corresponding to token number t.
  inline
  Parser::token_number_type
  Parser::yytranslate_ (int t)
  {
    static
    const token_number_type
    translate_table[] =
    {
     0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   157,     2,     2,   162,   155,   152,     2,
     142,   143,   146,   153,   144,   154,   159,   156,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   145,   141,
     147,   140,   148,   149,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   160,     2,   161,   151,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   138,   150,   139,   158,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137
    };
    const unsigned int user_token_number_max_ = 392;
    const token_number_type undef_token_ = 2;

    if (static_cast<int>(t) <= yyeof_)
      return yyeof_;
    else if (static_cast<unsigned int> (t) <= user_token_number_max_)
      return translate_table[t];
    else
      return undef_token_;
  }

#line 27 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:1167
} } } // hilti::detail::parser
#line 7578 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc" // lalr1.cc:1167
#line 930 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/hilti/src/autogen/__parser.cc.pp" // lalr1.cc:1168


void hilti::detail::parser::Parser::error(const Parser::location_type& l, const std::string& m) {
    driver->error(m, toMeta(l));
}
