// A Bison parser, made by GNU Bison 3.0.4.

// Skeleton implementation for Bison LALR(1) parsers in C++

// Copyright (C) 2002-2015 Free Software Foundation, Inc.

// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.

// As a special exception, you may create a larger work that contains
// part or all of the Bison parser skeleton and distribute that work
// under terms of your choice, so long as that work isn't itself a
// parser generator using the skeleton or a modified version thereof
// as a parser skeleton.  Alternatively, if you modify or redistribute
// the parser skeleton itself, you may (at your option) remove this
// special exception, which will cause the skeleton and the resulting
// Bison output files to be licensed under the GNU General Public
// License without this special exception.

// This special exception was added by the Free Software Foundation in
// version 2.2 of Bison.


// First part of user declarations.
#line 11 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:404

namespace spicy { namespace detail { class Parser; } }

#include <spicy/compiler/detail/parser/driver.h>

#line 40 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:404


#include <spicy/compiler/detail/parser/scanner.h>

#undef yylex
#define yylex driver->scanner()->lex

static hilti::Meta toMeta(spicy::detail::parser::location l) {
    return hilti::Meta(hilti::Location(*l.begin.filename, l.begin.line, l.end.line, l.begin.column, l.end.column));
}

static hilti::Type iteratorForType(hilti::Type t, bool const_, hilti::Meta m) {
    if ( hilti::type::isIterable(t) )
        return t.iteratorType(const_);
    else {
        hilti::logger().error(hilti::util::fmt("type '%s' is not iterable", t), m.location());
        return hilti::type::Error(m);
        }
}

static hilti::Type viewForType(hilti::Type t, hilti::Meta m) {
    if ( hilti::type::isViewable(t) )
        return t.viewType();
    else {
        hilti::logger().error(hilti::util::fmt("type '%s' is not viewable", t), m.location());
        return hilti::type::Error(m);
        }
}

/**
 * Checks if an unsigned integer value can be represented as an int64_t.
 *
 * @param x value to check
 * @param positive if false, check if ``-x`` can be represented instead of ``x`` itself.
 * @param m location information to associate with error message.
 * @return *x* on success, or zero on failure as a temporary stand-in; in the
 * latter cases an error is reported, too
 */
static uint64_t check_int64_range(uint64_t x, bool positive, const hilti::Meta& m) {
    uint64_t max = (positive ? std::numeric_limits<int64_t>::max() : std::fabs(std::numeric_limits<int64_t>::min()));

    if ( x <= max )
        return x;

    hilti::logger().error("signed integer value out of range", m.location());
    return 0; // Return dummy value
}

#define __loc__ toMeta(yylhs.location)

static int _field_width = 0;


#line 96 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:404

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

#include "__parser.h"

// User implementation prologue.

#line 110 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:412


#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> // FIXME: INFRINGES ON USER NAME SPACE.
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K].location)
/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

# ifndef YYLLOC_DEFAULT
#  define YYLLOC_DEFAULT(Current, Rhs, N)                               \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).begin  = YYRHSLOC (Rhs, 1).begin;                   \
          (Current).end    = YYRHSLOC (Rhs, N).end;                     \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).begin = (Current).end = YYRHSLOC (Rhs, 0).end;      \
        }                                                               \
    while (/*CONSTCOND*/ false)
# endif


// Suppress unused-variable warnings by "using" E.
#define YYUSE(E) ((void) (E))

// Enable debugging if requested.
#if YYDEBUG

// A pseudo ostream that takes yydebug_ into account.
# define YYCDEBUG if (yydebug_) (*yycdebug_)

# define YY_SYMBOL_PRINT(Title, Symbol)         \
  do {                                          \
    if (yydebug_)                               \
    {                                           \
      *yycdebug_ << Title << ' ';               \
      yy_print_ (*yycdebug_, Symbol);           \
      *yycdebug_ << std::endl;                  \
    }                                           \
  } while (false)

# define YY_REDUCE_PRINT(Rule)          \
  do {                                  \
    if (yydebug_)                       \
      yy_reduce_print_ (Rule);          \
  } while (false)

# define YY_STACK_PRINT()               \
  do {                                  \
    if (yydebug_)                       \
      yystack_print_ ();                \
  } while (false)

#else // !YYDEBUG

# define YYCDEBUG if (false) std::cerr
# define YY_SYMBOL_PRINT(Title, Symbol)  YYUSE(Symbol)
# define YY_REDUCE_PRINT(Rule)           static_cast<void>(0)
# define YY_STACK_PRINT()                static_cast<void>(0)

#endif // !YYDEBUG

#define yyerrok         (yyerrstatus_ = 0)
#define yyclearin       (yyla.clear ())

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYRECOVERING()  (!!yyerrstatus_)

#line 28 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:479
namespace spicy { namespace detail { namespace parser {
#line 196 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:479

  /* Return YYSTR after stripping away unnecessary quotes and
     backslashes, so that it's suitable for yyerror.  The heuristic is
     that double-quoting is unnecessary unless the string contains an
     apostrophe, a comma, or backslash (other than backslash-backslash).
     YYSTR is taken from yytname.  */
  std::string
  Parser::yytnamerr_ (const char *yystr)
  {
    if (*yystr == '"')
      {
        std::string yyr = "";
        char const *yyp = yystr;

        for (;;)
          switch (*++yyp)
            {
            case '\'':
            case ',':
              goto do_not_strip_quotes;

            case '\\':
              if (*++yyp != '\\')
                goto do_not_strip_quotes;
              // Fall through.
            default:
              yyr += *yyp;
              break;

            case '"':
              return yyr;
            }
      do_not_strip_quotes: ;
      }

    return yystr;
  }


  /// Build a parser object.
  Parser::Parser (class Driver* driver_yyarg)
    :
#if YYDEBUG
      yydebug_ (false),
      yycdebug_ (&std::cerr),
#endif
      driver (driver_yyarg)
  {}

  Parser::~Parser ()
  {}


  /*---------------.
  | Symbol types.  |
  `---------------*/

  inline
  Parser::syntax_error::syntax_error (const location_type& l, const std::string& m)
    : std::runtime_error (m)
    , location (l)
  {}

  // basic_symbol.
  template <typename Base>
  inline
  Parser::basic_symbol<Base>::basic_symbol ()
    : value ()
  {}

  template <typename Base>
  inline
  Parser::basic_symbol<Base>::basic_symbol (const basic_symbol& other)
    : Base (other)
    , value ()
    , location (other.location)
  {
      switch (other.type_get ())
    {
      case 19: // "bool value"
        value.copy< bool > (other.value);
        break;

      case 16: // "real value"
      case 285: // const_real
        value.copy< double > (other.value);
        break;

      case 255: // unit_hook_attribute
      case 307: // attribute
        value.copy< hilti::Attribute > (other.value);
        break;

      case 284: // ctor
      case 288: // tuple
      case 292: // list
      case 293: // vector
      case 294: // set
      case 295: // map
      case 296: // struct_
      case 299: // regexp
        value.copy< hilti::Ctor > (other.value);
        break;

      case 177: // global_scope_decl
      case 178: // type_decl
      case 179: // constant_decl
      case 180: // local_decl
      case 181: // local_init_decl
      case 182: // global_decl
      case 183: // function_decl
      case 184: // import_decl
      case 185: // property_decl
      case 186: // hook_decl
      case 220: // struct_field
        value.copy< hilti::Declaration > (other.value);
        break;

      case 261: // expr
      case 266: // expr_0
      case 267: // expr_1
      case 268: // expr_2
      case 269: // expr_3
      case 270: // expr_4
      case 271: // expr_5
      case 272: // expr_6
      case 273: // expr_7
      case 274: // expr_8
      case 275: // expr_9
      case 276: // expr_a
      case 277: // expr_b
      case 278: // expr_c
      case 279: // expr_d
      case 280: // expr_e
      case 281: // expr_f
      case 282: // expr_g
      case 283: // member_expr
      case 291: // tuple_elem
        value.copy< hilti::Expression > (other.value);
        break;

      case 188: // function_with_body
      case 189: // function_without_body
        value.copy< hilti::Function > (other.value);
        break;

      case 171: // local_id
      case 172: // scoped_id
      case 173: // dotted_id
      case 252: // unit_hook_id
        value.copy< hilti::ID > (other.value);
        break;

      case 199: // block
      case 200: // braced_block
      case 203: // stmt
      case 207: // stmt_decl
      case 208: // stmt_expr
        value.copy< hilti::Statement > (other.value);
        break;

      case 209: // base_type_no_ref
      case 210: // reference_type
      case 211: // base_type
      case 212: // type
      case 215: // tuple_type
      case 218: // struct_type
      case 221: // enum_type
      case 224: // bitfield_type
      case 229: // unit_type
        value.copy< hilti::Type > (other.value);
        break;

      case 306: // map_elem
        value.copy< hilti::ctor::map::Element > (other.value);
        break;

      case 298: // struct_elem
        value.copy< hilti::ctor::struct_::Field > (other.value);
        break;

      case 187: // opt_linkage
        value.copy< hilti::declaration::Linkage > (other.value);
        break;

      case 197: // opt_func_param_kind
        value.copy< hilti::declaration::parameter::Kind > (other.value);
        break;

      case 191: // opt_func_cc
        value.copy< hilti::function::CallingConvention > (other.value);
        break;

      case 206: // switch_case
        value.copy< hilti::statement::switch_::Case > (other.value);
        break;

      case 223: // enum_label
        value.copy< hilti::type::enum_::Label > (other.value);
        break;

      case 190: // opt_func_flavor
        value.copy< hilti::type::function::Flavor > (other.value);
        break;

      case 194: // func_param
        value.copy< hilti::type::function::Parameter > (other.value);
        break;

      case 195: // func_result
      case 196: // opt_func_result
        value.copy< hilti::type::function::Result > (other.value);
        break;

      case 217: // tuple_type_elem
        value.copy< hilti::type::tuple::Element > (other.value);
        break;

      case 286: // const_sint
        value.copy< int64_t > (other.value);
        break;

      case 241: // opt_unit_field_engine
      case 256: // opt_hook_engine
        value.copy< spicy::Engine > (other.value);
        break;

      case 249: // unit_hook
        value.copy< spicy::Hook > (other.value);
        break;

      case 228: // bitfield_bits_spec
        value.copy< spicy::type::bitfield::Bits > (other.value);
        break;

      case 233: // unit_item
      case 234: // unit_variable
      case 235: // unit_sink
      case 236: // unit_property
      case 237: // unit_field
      case 238: // unit_field_in_container
      case 239: // unit_wide_hook
      case 257: // unit_switch
        value.copy< spicy::type::unit::Item > (other.value);
        break;

      case 260: // unit_switch_case
        value.copy< spicy::type::unit::item::switch_::Case > (other.value);
        break;

      case 251: // opt_unit_hook_attributes
      case 308: // opt_attributes
        value.copy< std::optional<hilti::AttributeSet> > (other.value);
        break;

      case 198: // opt_init_expression
      case 243: // unit_field_repeat
      case 244: // opt_unit_field_repeat
      case 245: // opt_unit_field_condition
      case 258: // opt_unit_switch_expr
        value.copy< std::optional<hilti::Expression> > (other.value);
        break;

      case 240: // opt_unit_field_id
        value.copy< std::optional<hilti::ID> > (other.value);
        break;

      case 204: // opt_else_block
        value.copy< std::optional<hilti::Statement> > (other.value);
        break;

      case 176: // global_scope_items
        value.copy< std::pair<std::vector<hilti::Declaration>, std::vector<hilti::Statement>> > (other.value);
        break;

      case 3: // "identifier"
      case 4: // "scoped identifier"
      case 5: // "dotted identifier"
      case 6: // "hook identifier"
      case 7: // "$-identifier"
      case 8: // "attribute"
      case 9: // "property"
      case 10: // "preprocessor directive"
      case 11: // "string value"
      case 12: // "bytes value"
      case 13: // "regular expression value"
      case 14: // "address value"
      case 15: // "port value"
      case 301: // re_pattern_constant
        value.copy< std::string > (other.value);
        break;

      case 219: // struct_fields
        value.copy< std::vector<hilti::Declaration> > (other.value);
        break;

      case 242: // opt_unit_field_args
      case 246: // opt_unit_field_sinks
      case 264: // opt_exprs
      case 265: // exprs
      case 289: // opt_tuple_elems1
      case 290: // opt_tuple_elems2
        value.copy< std::vector<hilti::Expression> > (other.value);
        break;

      case 201: // opt_stmts
      case 202: // stmts
        value.copy< std::vector<hilti::Statement> > (other.value);
        break;

      case 304: // opt_map_elems
      case 305: // map_elems
        value.copy< std::vector<hilti::ctor::map::Element> > (other.value);
        break;

      case 297: // struct_elems
        value.copy< std::vector<hilti::ctor::struct_::Field> > (other.value);
        break;

      case 205: // switch_cases
        value.copy< std::vector<hilti::statement::switch_::Case> > (other.value);
        break;

      case 222: // enum_labels
        value.copy< std::vector<hilti::type::enum_::Label> > (other.value);
        break;

      case 192: // opt_func_params
      case 193: // func_params
      case 230: // opt_unit_params
      case 250: // opt_unit_hook_params
        value.copy< std::vector<hilti::type::function::Parameter> > (other.value);
        break;

      case 216: // tuple_type_elems
        value.copy< std::vector<hilti::type::tuple::Element> > (other.value);
        break;

      case 247: // opt_unit_item_hooks
      case 248: // unit_hooks
        value.copy< std::vector<spicy::Hook> > (other.value);
        break;

      case 226: // opt_bitfield_bits
      case 227: // bitfield_bits
        value.copy< std::vector<spicy::type::bitfield::Bits> > (other.value);
        break;

      case 231: // unit_items
      case 232: // opt_unit_items
        value.copy< std::vector<spicy::type::unit::Item> > (other.value);
        break;

      case 259: // unit_switch_cases
        value.copy< std::vector<spicy::type::unit::item::switch_::Case> > (other.value);
        break;

      case 300: // re_patterns
        value.copy< std::vector<std::string> > (other.value);
        break;

      case 17: // "unsigned integer value"
      case 18: // "$<N>"
      case 287: // const_uint
        value.copy< uint64_t > (other.value);
        break;

      default:
        break;
    }

  }


  template <typename Base>
  inline
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const semantic_type& v, const location_type& l)
    : Base (t)
    , value ()
    , location (l)
  {
    (void) v;
      switch (this->type_get ())
    {
      case 19: // "bool value"
        value.copy< bool > (v);
        break;

      case 16: // "real value"
      case 285: // const_real
        value.copy< double > (v);
        break;

      case 255: // unit_hook_attribute
      case 307: // attribute
        value.copy< hilti::Attribute > (v);
        break;

      case 284: // ctor
      case 288: // tuple
      case 292: // list
      case 293: // vector
      case 294: // set
      case 295: // map
      case 296: // struct_
      case 299: // regexp
        value.copy< hilti::Ctor > (v);
        break;

      case 177: // global_scope_decl
      case 178: // type_decl
      case 179: // constant_decl
      case 180: // local_decl
      case 181: // local_init_decl
      case 182: // global_decl
      case 183: // function_decl
      case 184: // import_decl
      case 185: // property_decl
      case 186: // hook_decl
      case 220: // struct_field
        value.copy< hilti::Declaration > (v);
        break;

      case 261: // expr
      case 266: // expr_0
      case 267: // expr_1
      case 268: // expr_2
      case 269: // expr_3
      case 270: // expr_4
      case 271: // expr_5
      case 272: // expr_6
      case 273: // expr_7
      case 274: // expr_8
      case 275: // expr_9
      case 276: // expr_a
      case 277: // expr_b
      case 278: // expr_c
      case 279: // expr_d
      case 280: // expr_e
      case 281: // expr_f
      case 282: // expr_g
      case 283: // member_expr
      case 291: // tuple_elem
        value.copy< hilti::Expression > (v);
        break;

      case 188: // function_with_body
      case 189: // function_without_body
        value.copy< hilti::Function > (v);
        break;

      case 171: // local_id
      case 172: // scoped_id
      case 173: // dotted_id
      case 252: // unit_hook_id
        value.copy< hilti::ID > (v);
        break;

      case 199: // block
      case 200: // braced_block
      case 203: // stmt
      case 207: // stmt_decl
      case 208: // stmt_expr
        value.copy< hilti::Statement > (v);
        break;

      case 209: // base_type_no_ref
      case 210: // reference_type
      case 211: // base_type
      case 212: // type
      case 215: // tuple_type
      case 218: // struct_type
      case 221: // enum_type
      case 224: // bitfield_type
      case 229: // unit_type
        value.copy< hilti::Type > (v);
        break;

      case 306: // map_elem
        value.copy< hilti::ctor::map::Element > (v);
        break;

      case 298: // struct_elem
        value.copy< hilti::ctor::struct_::Field > (v);
        break;

      case 187: // opt_linkage
        value.copy< hilti::declaration::Linkage > (v);
        break;

      case 197: // opt_func_param_kind
        value.copy< hilti::declaration::parameter::Kind > (v);
        break;

      case 191: // opt_func_cc
        value.copy< hilti::function::CallingConvention > (v);
        break;

      case 206: // switch_case
        value.copy< hilti::statement::switch_::Case > (v);
        break;

      case 223: // enum_label
        value.copy< hilti::type::enum_::Label > (v);
        break;

      case 190: // opt_func_flavor
        value.copy< hilti::type::function::Flavor > (v);
        break;

      case 194: // func_param
        value.copy< hilti::type::function::Parameter > (v);
        break;

      case 195: // func_result
      case 196: // opt_func_result
        value.copy< hilti::type::function::Result > (v);
        break;

      case 217: // tuple_type_elem
        value.copy< hilti::type::tuple::Element > (v);
        break;

      case 286: // const_sint
        value.copy< int64_t > (v);
        break;

      case 241: // opt_unit_field_engine
      case 256: // opt_hook_engine
        value.copy< spicy::Engine > (v);
        break;

      case 249: // unit_hook
        value.copy< spicy::Hook > (v);
        break;

      case 228: // bitfield_bits_spec
        value.copy< spicy::type::bitfield::Bits > (v);
        break;

      case 233: // unit_item
      case 234: // unit_variable
      case 235: // unit_sink
      case 236: // unit_property
      case 237: // unit_field
      case 238: // unit_field_in_container
      case 239: // unit_wide_hook
      case 257: // unit_switch
        value.copy< spicy::type::unit::Item > (v);
        break;

      case 260: // unit_switch_case
        value.copy< spicy::type::unit::item::switch_::Case > (v);
        break;

      case 251: // opt_unit_hook_attributes
      case 308: // opt_attributes
        value.copy< std::optional<hilti::AttributeSet> > (v);
        break;

      case 198: // opt_init_expression
      case 243: // unit_field_repeat
      case 244: // opt_unit_field_repeat
      case 245: // opt_unit_field_condition
      case 258: // opt_unit_switch_expr
        value.copy< std::optional<hilti::Expression> > (v);
        break;

      case 240: // opt_unit_field_id
        value.copy< std::optional<hilti::ID> > (v);
        break;

      case 204: // opt_else_block
        value.copy< std::optional<hilti::Statement> > (v);
        break;

      case 176: // global_scope_items
        value.copy< std::pair<std::vector<hilti::Declaration>, std::vector<hilti::Statement>> > (v);
        break;

      case 3: // "identifier"
      case 4: // "scoped identifier"
      case 5: // "dotted identifier"
      case 6: // "hook identifier"
      case 7: // "$-identifier"
      case 8: // "attribute"
      case 9: // "property"
      case 10: // "preprocessor directive"
      case 11: // "string value"
      case 12: // "bytes value"
      case 13: // "regular expression value"
      case 14: // "address value"
      case 15: // "port value"
      case 301: // re_pattern_constant
        value.copy< std::string > (v);
        break;

      case 219: // struct_fields
        value.copy< std::vector<hilti::Declaration> > (v);
        break;

      case 242: // opt_unit_field_args
      case 246: // opt_unit_field_sinks
      case 264: // opt_exprs
      case 265: // exprs
      case 289: // opt_tuple_elems1
      case 290: // opt_tuple_elems2
        value.copy< std::vector<hilti::Expression> > (v);
        break;

      case 201: // opt_stmts
      case 202: // stmts
        value.copy< std::vector<hilti::Statement> > (v);
        break;

      case 304: // opt_map_elems
      case 305: // map_elems
        value.copy< std::vector<hilti::ctor::map::Element> > (v);
        break;

      case 297: // struct_elems
        value.copy< std::vector<hilti::ctor::struct_::Field> > (v);
        break;

      case 205: // switch_cases
        value.copy< std::vector<hilti::statement::switch_::Case> > (v);
        break;

      case 222: // enum_labels
        value.copy< std::vector<hilti::type::enum_::Label> > (v);
        break;

      case 192: // opt_func_params
      case 193: // func_params
      case 230: // opt_unit_params
      case 250: // opt_unit_hook_params
        value.copy< std::vector<hilti::type::function::Parameter> > (v);
        break;

      case 216: // tuple_type_elems
        value.copy< std::vector<hilti::type::tuple::Element> > (v);
        break;

      case 247: // opt_unit_item_hooks
      case 248: // unit_hooks
        value.copy< std::vector<spicy::Hook> > (v);
        break;

      case 226: // opt_bitfield_bits
      case 227: // bitfield_bits
        value.copy< std::vector<spicy::type::bitfield::Bits> > (v);
        break;

      case 231: // unit_items
      case 232: // opt_unit_items
        value.copy< std::vector<spicy::type::unit::Item> > (v);
        break;

      case 259: // unit_switch_cases
        value.copy< std::vector<spicy::type::unit::item::switch_::Case> > (v);
        break;

      case 300: // re_patterns
        value.copy< std::vector<std::string> > (v);
        break;

      case 17: // "unsigned integer value"
      case 18: // "$<N>"
      case 287: // const_uint
        value.copy< uint64_t > (v);
        break;

      default:
        break;
    }
}


  // Implementation of basic_symbol constructor for each type.

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const location_type& l)
    : Base (t)
    , value ()
    , location (l)
  {}

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const bool v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const double v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const hilti::Attribute v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const hilti::Ctor v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const hilti::Declaration v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const hilti::Expression v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const hilti::Function v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const hilti::ID v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const hilti::Statement v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const hilti::Type v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const hilti::ctor::map::Element v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const hilti::ctor::struct_::Field v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const hilti::declaration::Linkage v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const hilti::declaration::parameter::Kind v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const hilti::function::CallingConvention v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const hilti::statement::switch_::Case v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const hilti::type::enum_::Label v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const hilti::type::function::Flavor v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const hilti::type::function::Parameter v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const hilti::type::function::Result v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const hilti::type::tuple::Element v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const int64_t v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const spicy::Engine v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const spicy::Hook v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const spicy::type::bitfield::Bits v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const spicy::type::unit::Item v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const spicy::type::unit::item::switch_::Case v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const std::optional<hilti::AttributeSet> v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const std::optional<hilti::Expression> v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const std::optional<hilti::ID> v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const std::optional<hilti::Statement> v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const std::pair<std::vector<hilti::Declaration>, std::vector<hilti::Statement>> v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const std::string v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const std::vector<hilti::Declaration> v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const std::vector<hilti::Expression> v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const std::vector<hilti::Statement> v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const std::vector<hilti::ctor::map::Element> v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const std::vector<hilti::ctor::struct_::Field> v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const std::vector<hilti::statement::switch_::Case> v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const std::vector<hilti::type::enum_::Label> v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const std::vector<hilti::type::function::Parameter> v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const std::vector<hilti::type::tuple::Element> v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const std::vector<spicy::Hook> v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const std::vector<spicy::type::bitfield::Bits> v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const std::vector<spicy::type::unit::Item> v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const std::vector<spicy::type::unit::item::switch_::Case> v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const std::vector<std::string> v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}

  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const uint64_t v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}


  template <typename Base>
  inline
  Parser::basic_symbol<Base>::~basic_symbol ()
  {
    clear ();
  }

  template <typename Base>
  inline
  void
  Parser::basic_symbol<Base>::clear ()
  {
    // User destructor.
    symbol_number_type yytype = this->type_get ();
    basic_symbol<Base>& yysym = *this;
    (void) yysym;
    switch (yytype)
    {
   default:
      break;
    }

    // Type destructor.
    switch (yytype)
    {
      case 19: // "bool value"
        value.template destroy< bool > ();
        break;

      case 16: // "real value"
      case 285: // const_real
        value.template destroy< double > ();
        break;

      case 255: // unit_hook_attribute
      case 307: // attribute
        value.template destroy< hilti::Attribute > ();
        break;

      case 284: // ctor
      case 288: // tuple
      case 292: // list
      case 293: // vector
      case 294: // set
      case 295: // map
      case 296: // struct_
      case 299: // regexp
        value.template destroy< hilti::Ctor > ();
        break;

      case 177: // global_scope_decl
      case 178: // type_decl
      case 179: // constant_decl
      case 180: // local_decl
      case 181: // local_init_decl
      case 182: // global_decl
      case 183: // function_decl
      case 184: // import_decl
      case 185: // property_decl
      case 186: // hook_decl
      case 220: // struct_field
        value.template destroy< hilti::Declaration > ();
        break;

      case 261: // expr
      case 266: // expr_0
      case 267: // expr_1
      case 268: // expr_2
      case 269: // expr_3
      case 270: // expr_4
      case 271: // expr_5
      case 272: // expr_6
      case 273: // expr_7
      case 274: // expr_8
      case 275: // expr_9
      case 276: // expr_a
      case 277: // expr_b
      case 278: // expr_c
      case 279: // expr_d
      case 280: // expr_e
      case 281: // expr_f
      case 282: // expr_g
      case 283: // member_expr
      case 291: // tuple_elem
        value.template destroy< hilti::Expression > ();
        break;

      case 188: // function_with_body
      case 189: // function_without_body
        value.template destroy< hilti::Function > ();
        break;

      case 171: // local_id
      case 172: // scoped_id
      case 173: // dotted_id
      case 252: // unit_hook_id
        value.template destroy< hilti::ID > ();
        break;

      case 199: // block
      case 200: // braced_block
      case 203: // stmt
      case 207: // stmt_decl
      case 208: // stmt_expr
        value.template destroy< hilti::Statement > ();
        break;

      case 209: // base_type_no_ref
      case 210: // reference_type
      case 211: // base_type
      case 212: // type
      case 215: // tuple_type
      case 218: // struct_type
      case 221: // enum_type
      case 224: // bitfield_type
      case 229: // unit_type
        value.template destroy< hilti::Type > ();
        break;

      case 306: // map_elem
        value.template destroy< hilti::ctor::map::Element > ();
        break;

      case 298: // struct_elem
        value.template destroy< hilti::ctor::struct_::Field > ();
        break;

      case 187: // opt_linkage
        value.template destroy< hilti::declaration::Linkage > ();
        break;

      case 197: // opt_func_param_kind
        value.template destroy< hilti::declaration::parameter::Kind > ();
        break;

      case 191: // opt_func_cc
        value.template destroy< hilti::function::CallingConvention > ();
        break;

      case 206: // switch_case
        value.template destroy< hilti::statement::switch_::Case > ();
        break;

      case 223: // enum_label
        value.template destroy< hilti::type::enum_::Label > ();
        break;

      case 190: // opt_func_flavor
        value.template destroy< hilti::type::function::Flavor > ();
        break;

      case 194: // func_param
        value.template destroy< hilti::type::function::Parameter > ();
        break;

      case 195: // func_result
      case 196: // opt_func_result
        value.template destroy< hilti::type::function::Result > ();
        break;

      case 217: // tuple_type_elem
        value.template destroy< hilti::type::tuple::Element > ();
        break;

      case 286: // const_sint
        value.template destroy< int64_t > ();
        break;

      case 241: // opt_unit_field_engine
      case 256: // opt_hook_engine
        value.template destroy< spicy::Engine > ();
        break;

      case 249: // unit_hook
        value.template destroy< spicy::Hook > ();
        break;

      case 228: // bitfield_bits_spec
        value.template destroy< spicy::type::bitfield::Bits > ();
        break;

      case 233: // unit_item
      case 234: // unit_variable
      case 235: // unit_sink
      case 236: // unit_property
      case 237: // unit_field
      case 238: // unit_field_in_container
      case 239: // unit_wide_hook
      case 257: // unit_switch
        value.template destroy< spicy::type::unit::Item > ();
        break;

      case 260: // unit_switch_case
        value.template destroy< spicy::type::unit::item::switch_::Case > ();
        break;

      case 251: // opt_unit_hook_attributes
      case 308: // opt_attributes
        value.template destroy< std::optional<hilti::AttributeSet> > ();
        break;

      case 198: // opt_init_expression
      case 243: // unit_field_repeat
      case 244: // opt_unit_field_repeat
      case 245: // opt_unit_field_condition
      case 258: // opt_unit_switch_expr
        value.template destroy< std::optional<hilti::Expression> > ();
        break;

      case 240: // opt_unit_field_id
        value.template destroy< std::optional<hilti::ID> > ();
        break;

      case 204: // opt_else_block
        value.template destroy< std::optional<hilti::Statement> > ();
        break;

      case 176: // global_scope_items
        value.template destroy< std::pair<std::vector<hilti::Declaration>, std::vector<hilti::Statement>> > ();
        break;

      case 3: // "identifier"
      case 4: // "scoped identifier"
      case 5: // "dotted identifier"
      case 6: // "hook identifier"
      case 7: // "$-identifier"
      case 8: // "attribute"
      case 9: // "property"
      case 10: // "preprocessor directive"
      case 11: // "string value"
      case 12: // "bytes value"
      case 13: // "regular expression value"
      case 14: // "address value"
      case 15: // "port value"
      case 301: // re_pattern_constant
        value.template destroy< std::string > ();
        break;

      case 219: // struct_fields
        value.template destroy< std::vector<hilti::Declaration> > ();
        break;

      case 242: // opt_unit_field_args
      case 246: // opt_unit_field_sinks
      case 264: // opt_exprs
      case 265: // exprs
      case 289: // opt_tuple_elems1
      case 290: // opt_tuple_elems2
        value.template destroy< std::vector<hilti::Expression> > ();
        break;

      case 201: // opt_stmts
      case 202: // stmts
        value.template destroy< std::vector<hilti::Statement> > ();
        break;

      case 304: // opt_map_elems
      case 305: // map_elems
        value.template destroy< std::vector<hilti::ctor::map::Element> > ();
        break;

      case 297: // struct_elems
        value.template destroy< std::vector<hilti::ctor::struct_::Field> > ();
        break;

      case 205: // switch_cases
        value.template destroy< std::vector<hilti::statement::switch_::Case> > ();
        break;

      case 222: // enum_labels
        value.template destroy< std::vector<hilti::type::enum_::Label> > ();
        break;

      case 192: // opt_func_params
      case 193: // func_params
      case 230: // opt_unit_params
      case 250: // opt_unit_hook_params
        value.template destroy< std::vector<hilti::type::function::Parameter> > ();
        break;

      case 216: // tuple_type_elems
        value.template destroy< std::vector<hilti::type::tuple::Element> > ();
        break;

      case 247: // opt_unit_item_hooks
      case 248: // unit_hooks
        value.template destroy< std::vector<spicy::Hook> > ();
        break;

      case 226: // opt_bitfield_bits
      case 227: // bitfield_bits
        value.template destroy< std::vector<spicy::type::bitfield::Bits> > ();
        break;

      case 231: // unit_items
      case 232: // opt_unit_items
        value.template destroy< std::vector<spicy::type::unit::Item> > ();
        break;

      case 259: // unit_switch_cases
        value.template destroy< std::vector<spicy::type::unit::item::switch_::Case> > ();
        break;

      case 300: // re_patterns
        value.template destroy< std::vector<std::string> > ();
        break;

      case 17: // "unsigned integer value"
      case 18: // "$<N>"
      case 287: // const_uint
        value.template destroy< uint64_t > ();
        break;

      default:
        break;
    }

    Base::clear ();
  }

  template <typename Base>
  inline
  bool
  Parser::basic_symbol<Base>::empty () const
  {
    return Base::type_get () == empty_symbol;
  }

  template <typename Base>
  inline
  void
  Parser::basic_symbol<Base>::move (basic_symbol& s)
  {
    super_type::move(s);
      switch (this->type_get ())
    {
      case 19: // "bool value"
        value.move< bool > (s.value);
        break;

      case 16: // "real value"
      case 285: // const_real
        value.move< double > (s.value);
        break;

      case 255: // unit_hook_attribute
      case 307: // attribute
        value.move< hilti::Attribute > (s.value);
        break;

      case 284: // ctor
      case 288: // tuple
      case 292: // list
      case 293: // vector
      case 294: // set
      case 295: // map
      case 296: // struct_
      case 299: // regexp
        value.move< hilti::Ctor > (s.value);
        break;

      case 177: // global_scope_decl
      case 178: // type_decl
      case 179: // constant_decl
      case 180: // local_decl
      case 181: // local_init_decl
      case 182: // global_decl
      case 183: // function_decl
      case 184: // import_decl
      case 185: // property_decl
      case 186: // hook_decl
      case 220: // struct_field
        value.move< hilti::Declaration > (s.value);
        break;

      case 261: // expr
      case 266: // expr_0
      case 267: // expr_1
      case 268: // expr_2
      case 269: // expr_3
      case 270: // expr_4
      case 271: // expr_5
      case 272: // expr_6
      case 273: // expr_7
      case 274: // expr_8
      case 275: // expr_9
      case 276: // expr_a
      case 277: // expr_b
      case 278: // expr_c
      case 279: // expr_d
      case 280: // expr_e
      case 281: // expr_f
      case 282: // expr_g
      case 283: // member_expr
      case 291: // tuple_elem
        value.move< hilti::Expression > (s.value);
        break;

      case 188: // function_with_body
      case 189: // function_without_body
        value.move< hilti::Function > (s.value);
        break;

      case 171: // local_id
      case 172: // scoped_id
      case 173: // dotted_id
      case 252: // unit_hook_id
        value.move< hilti::ID > (s.value);
        break;

      case 199: // block
      case 200: // braced_block
      case 203: // stmt
      case 207: // stmt_decl
      case 208: // stmt_expr
        value.move< hilti::Statement > (s.value);
        break;

      case 209: // base_type_no_ref
      case 210: // reference_type
      case 211: // base_type
      case 212: // type
      case 215: // tuple_type
      case 218: // struct_type
      case 221: // enum_type
      case 224: // bitfield_type
      case 229: // unit_type
        value.move< hilti::Type > (s.value);
        break;

      case 306: // map_elem
        value.move< hilti::ctor::map::Element > (s.value);
        break;

      case 298: // struct_elem
        value.move< hilti::ctor::struct_::Field > (s.value);
        break;

      case 187: // opt_linkage
        value.move< hilti::declaration::Linkage > (s.value);
        break;

      case 197: // opt_func_param_kind
        value.move< hilti::declaration::parameter::Kind > (s.value);
        break;

      case 191: // opt_func_cc
        value.move< hilti::function::CallingConvention > (s.value);
        break;

      case 206: // switch_case
        value.move< hilti::statement::switch_::Case > (s.value);
        break;

      case 223: // enum_label
        value.move< hilti::type::enum_::Label > (s.value);
        break;

      case 190: // opt_func_flavor
        value.move< hilti::type::function::Flavor > (s.value);
        break;

      case 194: // func_param
        value.move< hilti::type::function::Parameter > (s.value);
        break;

      case 195: // func_result
      case 196: // opt_func_result
        value.move< hilti::type::function::Result > (s.value);
        break;

      case 217: // tuple_type_elem
        value.move< hilti::type::tuple::Element > (s.value);
        break;

      case 286: // const_sint
        value.move< int64_t > (s.value);
        break;

      case 241: // opt_unit_field_engine
      case 256: // opt_hook_engine
        value.move< spicy::Engine > (s.value);
        break;

      case 249: // unit_hook
        value.move< spicy::Hook > (s.value);
        break;

      case 228: // bitfield_bits_spec
        value.move< spicy::type::bitfield::Bits > (s.value);
        break;

      case 233: // unit_item
      case 234: // unit_variable
      case 235: // unit_sink
      case 236: // unit_property
      case 237: // unit_field
      case 238: // unit_field_in_container
      case 239: // unit_wide_hook
      case 257: // unit_switch
        value.move< spicy::type::unit::Item > (s.value);
        break;

      case 260: // unit_switch_case
        value.move< spicy::type::unit::item::switch_::Case > (s.value);
        break;

      case 251: // opt_unit_hook_attributes
      case 308: // opt_attributes
        value.move< std::optional<hilti::AttributeSet> > (s.value);
        break;

      case 198: // opt_init_expression
      case 243: // unit_field_repeat
      case 244: // opt_unit_field_repeat
      case 245: // opt_unit_field_condition
      case 258: // opt_unit_switch_expr
        value.move< std::optional<hilti::Expression> > (s.value);
        break;

      case 240: // opt_unit_field_id
        value.move< std::optional<hilti::ID> > (s.value);
        break;

      case 204: // opt_else_block
        value.move< std::optional<hilti::Statement> > (s.value);
        break;

      case 176: // global_scope_items
        value.move< std::pair<std::vector<hilti::Declaration>, std::vector<hilti::Statement>> > (s.value);
        break;

      case 3: // "identifier"
      case 4: // "scoped identifier"
      case 5: // "dotted identifier"
      case 6: // "hook identifier"
      case 7: // "$-identifier"
      case 8: // "attribute"
      case 9: // "property"
      case 10: // "preprocessor directive"
      case 11: // "string value"
      case 12: // "bytes value"
      case 13: // "regular expression value"
      case 14: // "address value"
      case 15: // "port value"
      case 301: // re_pattern_constant
        value.move< std::string > (s.value);
        break;

      case 219: // struct_fields
        value.move< std::vector<hilti::Declaration> > (s.value);
        break;

      case 242: // opt_unit_field_args
      case 246: // opt_unit_field_sinks
      case 264: // opt_exprs
      case 265: // exprs
      case 289: // opt_tuple_elems1
      case 290: // opt_tuple_elems2
        value.move< std::vector<hilti::Expression> > (s.value);
        break;

      case 201: // opt_stmts
      case 202: // stmts
        value.move< std::vector<hilti::Statement> > (s.value);
        break;

      case 304: // opt_map_elems
      case 305: // map_elems
        value.move< std::vector<hilti::ctor::map::Element> > (s.value);
        break;

      case 297: // struct_elems
        value.move< std::vector<hilti::ctor::struct_::Field> > (s.value);
        break;

      case 205: // switch_cases
        value.move< std::vector<hilti::statement::switch_::Case> > (s.value);
        break;

      case 222: // enum_labels
        value.move< std::vector<hilti::type::enum_::Label> > (s.value);
        break;

      case 192: // opt_func_params
      case 193: // func_params
      case 230: // opt_unit_params
      case 250: // opt_unit_hook_params
        value.move< std::vector<hilti::type::function::Parameter> > (s.value);
        break;

      case 216: // tuple_type_elems
        value.move< std::vector<hilti::type::tuple::Element> > (s.value);
        break;

      case 247: // opt_unit_item_hooks
      case 248: // unit_hooks
        value.move< std::vector<spicy::Hook> > (s.value);
        break;

      case 226: // opt_bitfield_bits
      case 227: // bitfield_bits
        value.move< std::vector<spicy::type::bitfield::Bits> > (s.value);
        break;

      case 231: // unit_items
      case 232: // opt_unit_items
        value.move< std::vector<spicy::type::unit::Item> > (s.value);
        break;

      case 259: // unit_switch_cases
        value.move< std::vector<spicy::type::unit::item::switch_::Case> > (s.value);
        break;

      case 300: // re_patterns
        value.move< std::vector<std::string> > (s.value);
        break;

      case 17: // "unsigned integer value"
      case 18: // "$<N>"
      case 287: // const_uint
        value.move< uint64_t > (s.value);
        break;

      default:
        break;
    }

    location = s.location;
  }

  // by_type.
  inline
  Parser::by_type::by_type ()
    : type (empty_symbol)
  {}

  inline
  Parser::by_type::by_type (const by_type& other)
    : type (other.type)
  {}

  inline
  Parser::by_type::by_type (token_type t)
    : type (yytranslate_ (t))
  {}

  inline
  void
  Parser::by_type::clear ()
  {
    type = empty_symbol;
  }

  inline
  void
  Parser::by_type::move (by_type& that)
  {
    type = that.type;
    that.clear ();
  }

  inline
  int
  Parser::by_type::type_get () const
  {
    return type;
  }
  // Implementation of make_symbol for each symbol type.
  Parser::symbol_type
  Parser::make_EOD (const location_type& l)
  {
    return symbol_type (token::EOD, l);
  }

  Parser::symbol_type
  Parser::make_IDENT (const std::string& v, const location_type& l)
  {
    return symbol_type (token::IDENT, v, l);
  }

  Parser::symbol_type
  Parser::make_SCOPED_IDENT (const std::string& v, const location_type& l)
  {
    return symbol_type (token::SCOPED_IDENT, v, l);
  }

  Parser::symbol_type
  Parser::make_DOTTED_IDENT (const std::string& v, const location_type& l)
  {
    return symbol_type (token::DOTTED_IDENT, v, l);
  }

  Parser::symbol_type
  Parser::make_HOOK_IDENT (const std::string& v, const location_type& l)
  {
    return symbol_type (token::HOOK_IDENT, v, l);
  }

  Parser::symbol_type
  Parser::make_DOLLAR_IDENT (const std::string& v, const location_type& l)
  {
    return symbol_type (token::DOLLAR_IDENT, v, l);
  }

  Parser::symbol_type
  Parser::make_ATTRIBUTE (const std::string& v, const location_type& l)
  {
    return symbol_type (token::ATTRIBUTE, v, l);
  }

  Parser::symbol_type
  Parser::make_PROPERTY (const std::string& v, const location_type& l)
  {
    return symbol_type (token::PROPERTY, v, l);
  }

  Parser::symbol_type
  Parser::make_PREPROCESSOR (const std::string& v, const location_type& l)
  {
    return symbol_type (token::PREPROCESSOR, v, l);
  }

  Parser::symbol_type
  Parser::make_CSTRING (const std::string& v, const location_type& l)
  {
    return symbol_type (token::CSTRING, v, l);
  }

  Parser::symbol_type
  Parser::make_CBYTES (const std::string& v, const location_type& l)
  {
    return symbol_type (token::CBYTES, v, l);
  }

  Parser::symbol_type
  Parser::make_CREGEXP (const std::string& v, const location_type& l)
  {
    return symbol_type (token::CREGEXP, v, l);
  }

  Parser::symbol_type
  Parser::make_CADDRESS (const std::string& v, const location_type& l)
  {
    return symbol_type (token::CADDRESS, v, l);
  }

  Parser::symbol_type
  Parser::make_CPORT (const std::string& v, const location_type& l)
  {
    return symbol_type (token::CPORT, v, l);
  }

  Parser::symbol_type
  Parser::make_CUREAL (const double& v, const location_type& l)
  {
    return symbol_type (token::CUREAL, v, l);
  }

  Parser::symbol_type
  Parser::make_CUINTEGER (const uint64_t& v, const location_type& l)
  {
    return symbol_type (token::CUINTEGER, v, l);
  }

  Parser::symbol_type
  Parser::make_DOLLAR_NUMBER (const uint64_t& v, const location_type& l)
  {
    return symbol_type (token::DOLLAR_NUMBER, v, l);
  }

  Parser::symbol_type
  Parser::make_CBOOL (const bool& v, const location_type& l)
  {
    return symbol_type (token::CBOOL, v, l);
  }

  Parser::symbol_type
  Parser::make_CNULL (const location_type& l)
  {
    return symbol_type (token::CNULL, l);
  }

  Parser::symbol_type
  Parser::make_ASSERT (const location_type& l)
  {
    return symbol_type (token::ASSERT, l);
  }

  Parser::symbol_type
  Parser::make_ASSERT_EXCEPTION (const location_type& l)
  {
    return symbol_type (token::ASSERT_EXCEPTION, l);
  }

  Parser::symbol_type
  Parser::make_ADD (const location_type& l)
  {
    return symbol_type (token::ADD, l);
  }

  Parser::symbol_type
  Parser::make_ADDRESS (const location_type& l)
  {
    return symbol_type (token::ADDRESS, l);
  }

  Parser::symbol_type
  Parser::make_AND (const location_type& l)
  {
    return symbol_type (token::AND, l);
  }

  Parser::symbol_type
  Parser::make_ANY (const location_type& l)
  {
    return symbol_type (token::ANY, l);
  }

  Parser::symbol_type
  Parser::make_ARROW (const location_type& l)
  {
    return symbol_type (token::ARROW, l);
  }

  Parser::symbol_type
  Parser::make_AUTO (const location_type& l)
  {
    return symbol_type (token::AUTO, l);
  }

  Parser::symbol_type
  Parser::make_BITFIELD (const location_type& l)
  {
    return symbol_type (token::BITFIELD, l);
  }

  Parser::symbol_type
  Parser::make_BEGIN_ (const location_type& l)
  {
    return symbol_type (token::BEGIN_, l);
  }

  Parser::symbol_type
  Parser::make_BOOL (const location_type& l)
  {
    return symbol_type (token::BOOL, l);
  }

  Parser::symbol_type
  Parser::make_BREAK (const location_type& l)
  {
    return symbol_type (token::BREAK, l);
  }

  Parser::symbol_type
  Parser::make_BYTES (const location_type& l)
  {
    return symbol_type (token::BYTES, l);
  }

  Parser::symbol_type
  Parser::make_CADDR (const location_type& l)
  {
    return symbol_type (token::CADDR, l);
  }

  Parser::symbol_type
  Parser::make_CASE (const location_type& l)
  {
    return symbol_type (token::CASE, l);
  }

  Parser::symbol_type
  Parser::make_CAST (const location_type& l)
  {
    return symbol_type (token::CAST, l);
  }

  Parser::symbol_type
  Parser::make_CATCH (const location_type& l)
  {
    return symbol_type (token::CATCH, l);
  }

  Parser::symbol_type
  Parser::make_CONST (const location_type& l)
  {
    return symbol_type (token::CONST, l);
  }

  Parser::symbol_type
  Parser::make_CONSTANT (const location_type& l)
  {
    return symbol_type (token::CONSTANT, l);
  }

  Parser::symbol_type
  Parser::make_CONTINUE (const location_type& l)
  {
    return symbol_type (token::CONTINUE, l);
  }

  Parser::symbol_type
  Parser::make_DEBUG_ (const location_type& l)
  {
    return symbol_type (token::DEBUG_, l);
  }

  Parser::symbol_type
  Parser::make_DECLARE (const location_type& l)
  {
    return symbol_type (token::DECLARE, l);
  }

  Parser::symbol_type
  Parser::make_DEFAULT (const location_type& l)
  {
    return symbol_type (token::DEFAULT, l);
  }

  Parser::symbol_type
  Parser::make_DELETE (const location_type& l)
  {
    return symbol_type (token::DELETE, l);
  }

  Parser::symbol_type
  Parser::make_DIVIDEASSIGN (const location_type& l)
  {
    return symbol_type (token::DIVIDEASSIGN, l);
  }

  Parser::symbol_type
  Parser::make_DOLLARDOLLAR (const location_type& l)
  {
    return symbol_type (token::DOLLARDOLLAR, l);
  }

  Parser::symbol_type
  Parser::make_DOTDOT (const location_type& l)
  {
    return symbol_type (token::DOTDOT, l);
  }

  Parser::symbol_type
  Parser::make_REAL (const location_type& l)
  {
    return symbol_type (token::REAL, l);
  }

  Parser::symbol_type
  Parser::make_ELSE (const location_type& l)
  {
    return symbol_type (token::ELSE, l);
  }

  Parser::symbol_type
  Parser::make_END_ (const location_type& l)
  {
    return symbol_type (token::END_, l);
  }

  Parser::symbol_type
  Parser::make_ENUM (const location_type& l)
  {
    return symbol_type (token::ENUM, l);
  }

  Parser::symbol_type
  Parser::make_EQ (const location_type& l)
  {
    return symbol_type (token::EQ, l);
  }

  Parser::symbol_type
  Parser::make_EXCEPTION (const location_type& l)
  {
    return symbol_type (token::EXCEPTION, l);
  }

  Parser::symbol_type
  Parser::make_EXPORT (const location_type& l)
  {
    return symbol_type (token::EXPORT, l);
  }

  Parser::symbol_type
  Parser::make_FILE (const location_type& l)
  {
    return symbol_type (token::FILE, l);
  }

  Parser::symbol_type
  Parser::make_FOR (const location_type& l)
  {
    return symbol_type (token::FOR, l);
  }

  Parser::symbol_type
  Parser::make_FOREACH (const location_type& l)
  {
    return symbol_type (token::FOREACH, l);
  }

  Parser::symbol_type
  Parser::make_FROM (const location_type& l)
  {
    return symbol_type (token::FROM, l);
  }

  Parser::symbol_type
  Parser::make_FUNCTION (const location_type& l)
  {
    return symbol_type (token::FUNCTION, l);
  }

  Parser::symbol_type
  Parser::make_GEQ (const location_type& l)
  {
    return symbol_type (token::GEQ, l);
  }

  Parser::symbol_type
  Parser::make_GLOBAL (const location_type& l)
  {
    return symbol_type (token::GLOBAL, l);
  }

  Parser::symbol_type
  Parser::make_HASATTR (const location_type& l)
  {
    return symbol_type (token::HASATTR, l);
  }

  Parser::symbol_type
  Parser::make_HOOK_COMPOSE (const location_type& l)
  {
    return symbol_type (token::HOOK_COMPOSE, l);
  }

  Parser::symbol_type
  Parser::make_HOOK_PARSE (const location_type& l)
  {
    return symbol_type (token::HOOK_PARSE, l);
  }

  Parser::symbol_type
  Parser::make_IF (const location_type& l)
  {
    return symbol_type (token::IF, l);
  }

  Parser::symbol_type
  Parser::make_IMPORT (const location_type& l)
  {
    return symbol_type (token::IMPORT, l);
  }

  Parser::symbol_type
  Parser::make_IN (const location_type& l)
  {
    return symbol_type (token::IN, l);
  }

  Parser::symbol_type
  Parser::make_INOUT (const location_type& l)
  {
    return symbol_type (token::INOUT, l);
  }

  Parser::symbol_type
  Parser::make_INT (const location_type& l)
  {
    return symbol_type (token::INT, l);
  }

  Parser::symbol_type
  Parser::make_INT16 (const location_type& l)
  {
    return symbol_type (token::INT16, l);
  }

  Parser::symbol_type
  Parser::make_INT32 (const location_type& l)
  {
    return symbol_type (token::INT32, l);
  }

  Parser::symbol_type
  Parser::make_INT64 (const location_type& l)
  {
    return symbol_type (token::INT64, l);
  }

  Parser::symbol_type
  Parser::make_INT8 (const location_type& l)
  {
    return symbol_type (token::INT8, l);
  }

  Parser::symbol_type
  Parser::make_INTERVAL (const location_type& l)
  {
    return symbol_type (token::INTERVAL, l);
  }

  Parser::symbol_type
  Parser::make_INTERVAL_NS (const location_type& l)
  {
    return symbol_type (token::INTERVAL_NS, l);
  }

  Parser::symbol_type
  Parser::make_ITERATOR (const location_type& l)
  {
    return symbol_type (token::ITERATOR, l);
  }

  Parser::symbol_type
  Parser::make_CONST_ITERATOR (const location_type& l)
  {
    return symbol_type (token::CONST_ITERATOR, l);
  }

  Parser::symbol_type
  Parser::make_LEQ (const location_type& l)
  {
    return symbol_type (token::LEQ, l);
  }

  Parser::symbol_type
  Parser::make_LIBRARY_TYPE (const location_type& l)
  {
    return symbol_type (token::LIBRARY_TYPE, l);
  }

  Parser::symbol_type
  Parser::make_LIST (const location_type& l)
  {
    return symbol_type (token::LIST, l);
  }

  Parser::symbol_type
  Parser::make_LOCAL (const location_type& l)
  {
    return symbol_type (token::LOCAL, l);
  }

  Parser::symbol_type
  Parser::make_MAP (const location_type& l)
  {
    return symbol_type (token::MAP, l);
  }

  Parser::symbol_type
  Parser::make_MARK (const location_type& l)
  {
    return symbol_type (token::MARK, l);
  }

  Parser::symbol_type
  Parser::make_CAPTURES (const location_type& l)
  {
    return symbol_type (token::CAPTURES, l);
  }

  Parser::symbol_type
  Parser::make_MINUSASSIGN (const location_type& l)
  {
    return symbol_type (token::MINUSASSIGN, l);
  }

  Parser::symbol_type
  Parser::make_MINUSMINUS (const location_type& l)
  {
    return symbol_type (token::MINUSMINUS, l);
  }

  Parser::symbol_type
  Parser::make_MOD (const location_type& l)
  {
    return symbol_type (token::MOD, l);
  }

  Parser::symbol_type
  Parser::make_MODULE (const location_type& l)
  {
    return symbol_type (token::MODULE, l);
  }

  Parser::symbol_type
  Parser::make_NEQ (const location_type& l)
  {
    return symbol_type (token::NEQ, l);
  }

  Parser::symbol_type
  Parser::make_NET (const location_type& l)
  {
    return symbol_type (token::NET, l);
  }

  Parser::symbol_type
  Parser::make_NETWORK (const location_type& l)
  {
    return symbol_type (token::NETWORK, l);
  }

  Parser::symbol_type
  Parser::make_NEW (const location_type& l)
  {
    return symbol_type (token::NEW, l);
  }

  Parser::symbol_type
  Parser::make_NONE (const location_type& l)
  {
    return symbol_type (token::NONE, l);
  }

  Parser::symbol_type
  Parser::make_NOT_IN (const location_type& l)
  {
    return symbol_type (token::NOT_IN, l);
  }

  Parser::symbol_type
  Parser::make_OBJECT (const location_type& l)
  {
    return symbol_type (token::OBJECT, l);
  }

  Parser::symbol_type
  Parser::make_ON (const location_type& l)
  {
    return symbol_type (token::ON, l);
  }

  Parser::symbol_type
  Parser::make_OPTIONAL (const location_type& l)
  {
    return symbol_type (token::OPTIONAL, l);
  }

  Parser::symbol_type
  Parser::make_OR (const location_type& l)
  {
    return symbol_type (token::OR, l);
  }

  Parser::symbol_type
  Parser::make_PLUSASSIGN (const location_type& l)
  {
    return symbol_type (token::PLUSASSIGN, l);
  }

  Parser::symbol_type
  Parser::make_PLUSPLUS (const location_type& l)
  {
    return symbol_type (token::PLUSPLUS, l);
  }

  Parser::symbol_type
  Parser::make_PORT (const location_type& l)
  {
    return symbol_type (token::PORT, l);
  }

  Parser::symbol_type
  Parser::make_POW (const location_type& l)
  {
    return symbol_type (token::POW, l);
  }

  Parser::symbol_type
  Parser::make_PRINT (const location_type& l)
  {
    return symbol_type (token::PRINT, l);
  }

  Parser::symbol_type
  Parser::make_PRIORITY (const location_type& l)
  {
    return symbol_type (token::PRIORITY, l);
  }

  Parser::symbol_type
  Parser::make_PRIVATE (const location_type& l)
  {
    return symbol_type (token::PRIVATE, l);
  }

  Parser::symbol_type
  Parser::make_PUBLIC (const location_type& l)
  {
    return symbol_type (token::PUBLIC, l);
  }

  Parser::symbol_type
  Parser::make_REGEXP (const location_type& l)
  {
    return symbol_type (token::REGEXP, l);
  }

  Parser::symbol_type
  Parser::make_RETURN (const location_type& l)
  {
    return symbol_type (token::RETURN, l);
  }

  Parser::symbol_type
  Parser::make_SET (const location_type& l)
  {
    return symbol_type (token::SET, l);
  }

  Parser::symbol_type
  Parser::make_SHIFTLEFT (const location_type& l)
  {
    return symbol_type (token::SHIFTLEFT, l);
  }

  Parser::symbol_type
  Parser::make_SHIFTRIGHT (const location_type& l)
  {
    return symbol_type (token::SHIFTRIGHT, l);
  }

  Parser::symbol_type
  Parser::make_SINK (const location_type& l)
  {
    return symbol_type (token::SINK, l);
  }

  Parser::symbol_type
  Parser::make_STOP (const location_type& l)
  {
    return symbol_type (token::STOP, l);
  }

  Parser::symbol_type
  Parser::make_STREAM (const location_type& l)
  {
    return symbol_type (token::STREAM, l);
  }

  Parser::symbol_type
  Parser::make_STRING (const location_type& l)
  {
    return symbol_type (token::STRING, l);
  }

  Parser::symbol_type
  Parser::make_STRUCT (const location_type& l)
  {
    return symbol_type (token::STRUCT, l);
  }

  Parser::symbol_type
  Parser::make_SWITCH (const location_type& l)
  {
    return symbol_type (token::SWITCH, l);
  }

  Parser::symbol_type
  Parser::make_CONFIRM (const location_type& l)
  {
    return symbol_type (token::CONFIRM, l);
  }

  Parser::symbol_type
  Parser::make_REJECT_ (const location_type& l)
  {
    return symbol_type (token::REJECT_, l);
  }

  Parser::symbol_type
  Parser::make_THROW (const location_type& l)
  {
    return symbol_type (token::THROW, l);
  }

  Parser::symbol_type
  Parser::make_TIME (const location_type& l)
  {
    return symbol_type (token::TIME, l);
  }

  Parser::symbol_type
  Parser::make_TIME_NS (const location_type& l)
  {
    return symbol_type (token::TIME_NS, l);
  }

  Parser::symbol_type
  Parser::make_TIMER (const location_type& l)
  {
    return symbol_type (token::TIMER, l);
  }

  Parser::symbol_type
  Parser::make_TIMESASSIGN (const location_type& l)
  {
    return symbol_type (token::TIMESASSIGN, l);
  }

  Parser::symbol_type
  Parser::make_TRY (const location_type& l)
  {
    return symbol_type (token::TRY, l);
  }

  Parser::symbol_type
  Parser::make_TRYATTR (const location_type& l)
  {
    return symbol_type (token::TRYATTR, l);
  }

  Parser::symbol_type
  Parser::make_TUPLE (const location_type& l)
  {
    return symbol_type (token::TUPLE, l);
  }

  Parser::symbol_type
  Parser::make_TYPE (const location_type& l)
  {
    return symbol_type (token::TYPE, l);
  }

  Parser::symbol_type
  Parser::make_UINT (const location_type& l)
  {
    return symbol_type (token::UINT, l);
  }

  Parser::symbol_type
  Parser::make_UINT16 (const location_type& l)
  {
    return symbol_type (token::UINT16, l);
  }

  Parser::symbol_type
  Parser::make_UINT32 (const location_type& l)
  {
    return symbol_type (token::UINT32, l);
  }

  Parser::symbol_type
  Parser::make_UINT64 (const location_type& l)
  {
    return symbol_type (token::UINT64, l);
  }

  Parser::symbol_type
  Parser::make_UINT8 (const location_type& l)
  {
    return symbol_type (token::UINT8, l);
  }

  Parser::symbol_type
  Parser::make_UNIT (const location_type& l)
  {
    return symbol_type (token::UNIT, l);
  }

  Parser::symbol_type
  Parser::make_UNSET (const location_type& l)
  {
    return symbol_type (token::UNSET, l);
  }

  Parser::symbol_type
  Parser::make_VAR (const location_type& l)
  {
    return symbol_type (token::VAR, l);
  }

  Parser::symbol_type
  Parser::make_VECTOR (const location_type& l)
  {
    return symbol_type (token::VECTOR, l);
  }

  Parser::symbol_type
  Parser::make_VIEW (const location_type& l)
  {
    return symbol_type (token::VIEW, l);
  }

  Parser::symbol_type
  Parser::make_VOID (const location_type& l)
  {
    return symbol_type (token::VOID, l);
  }

  Parser::symbol_type
  Parser::make_WHILE (const location_type& l)
  {
    return symbol_type (token::WHILE, l);
  }

  Parser::symbol_type
  Parser::make_START_MODULE (const location_type& l)
  {
    return symbol_type (token::START_MODULE, l);
  }

  Parser::symbol_type
  Parser::make_START_EXPRESSION (const location_type& l)
  {
    return symbol_type (token::START_EXPRESSION, l);
  }



  // by_state.
  inline
  Parser::by_state::by_state ()
    : state (empty_state)
  {}

  inline
  Parser::by_state::by_state (const by_state& other)
    : state (other.state)
  {}

  inline
  void
  Parser::by_state::clear ()
  {
    state = empty_state;
  }

  inline
  void
  Parser::by_state::move (by_state& that)
  {
    state = that.state;
    that.clear ();
  }

  inline
  Parser::by_state::by_state (state_type s)
    : state (s)
  {}

  inline
  Parser::symbol_number_type
  Parser::by_state::type_get () const
  {
    if (state == empty_state)
      return empty_symbol;
    else
      return yystos_[state];
  }

  inline
  Parser::stack_symbol_type::stack_symbol_type ()
  {}


  inline
  Parser::stack_symbol_type::stack_symbol_type (state_type s, symbol_type& that)
    : super_type (s, that.location)
  {
      switch (that.type_get ())
    {
      case 19: // "bool value"
        value.move< bool > (that.value);
        break;

      case 16: // "real value"
      case 285: // const_real
        value.move< double > (that.value);
        break;

      case 255: // unit_hook_attribute
      case 307: // attribute
        value.move< hilti::Attribute > (that.value);
        break;

      case 284: // ctor
      case 288: // tuple
      case 292: // list
      case 293: // vector
      case 294: // set
      case 295: // map
      case 296: // struct_
      case 299: // regexp
        value.move< hilti::Ctor > (that.value);
        break;

      case 177: // global_scope_decl
      case 178: // type_decl
      case 179: // constant_decl
      case 180: // local_decl
      case 181: // local_init_decl
      case 182: // global_decl
      case 183: // function_decl
      case 184: // import_decl
      case 185: // property_decl
      case 186: // hook_decl
      case 220: // struct_field
        value.move< hilti::Declaration > (that.value);
        break;

      case 261: // expr
      case 266: // expr_0
      case 267: // expr_1
      case 268: // expr_2
      case 269: // expr_3
      case 270: // expr_4
      case 271: // expr_5
      case 272: // expr_6
      case 273: // expr_7
      case 274: // expr_8
      case 275: // expr_9
      case 276: // expr_a
      case 277: // expr_b
      case 278: // expr_c
      case 279: // expr_d
      case 280: // expr_e
      case 281: // expr_f
      case 282: // expr_g
      case 283: // member_expr
      case 291: // tuple_elem
        value.move< hilti::Expression > (that.value);
        break;

      case 188: // function_with_body
      case 189: // function_without_body
        value.move< hilti::Function > (that.value);
        break;

      case 171: // local_id
      case 172: // scoped_id
      case 173: // dotted_id
      case 252: // unit_hook_id
        value.move< hilti::ID > (that.value);
        break;

      case 199: // block
      case 200: // braced_block
      case 203: // stmt
      case 207: // stmt_decl
      case 208: // stmt_expr
        value.move< hilti::Statement > (that.value);
        break;

      case 209: // base_type_no_ref
      case 210: // reference_type
      case 211: // base_type
      case 212: // type
      case 215: // tuple_type
      case 218: // struct_type
      case 221: // enum_type
      case 224: // bitfield_type
      case 229: // unit_type
        value.move< hilti::Type > (that.value);
        break;

      case 306: // map_elem
        value.move< hilti::ctor::map::Element > (that.value);
        break;

      case 298: // struct_elem
        value.move< hilti::ctor::struct_::Field > (that.value);
        break;

      case 187: // opt_linkage
        value.move< hilti::declaration::Linkage > (that.value);
        break;

      case 197: // opt_func_param_kind
        value.move< hilti::declaration::parameter::Kind > (that.value);
        break;

      case 191: // opt_func_cc
        value.move< hilti::function::CallingConvention > (that.value);
        break;

      case 206: // switch_case
        value.move< hilti::statement::switch_::Case > (that.value);
        break;

      case 223: // enum_label
        value.move< hilti::type::enum_::Label > (that.value);
        break;

      case 190: // opt_func_flavor
        value.move< hilti::type::function::Flavor > (that.value);
        break;

      case 194: // func_param
        value.move< hilti::type::function::Parameter > (that.value);
        break;

      case 195: // func_result
      case 196: // opt_func_result
        value.move< hilti::type::function::Result > (that.value);
        break;

      case 217: // tuple_type_elem
        value.move< hilti::type::tuple::Element > (that.value);
        break;

      case 286: // const_sint
        value.move< int64_t > (that.value);
        break;

      case 241: // opt_unit_field_engine
      case 256: // opt_hook_engine
        value.move< spicy::Engine > (that.value);
        break;

      case 249: // unit_hook
        value.move< spicy::Hook > (that.value);
        break;

      case 228: // bitfield_bits_spec
        value.move< spicy::type::bitfield::Bits > (that.value);
        break;

      case 233: // unit_item
      case 234: // unit_variable
      case 235: // unit_sink
      case 236: // unit_property
      case 237: // unit_field
      case 238: // unit_field_in_container
      case 239: // unit_wide_hook
      case 257: // unit_switch
        value.move< spicy::type::unit::Item > (that.value);
        break;

      case 260: // unit_switch_case
        value.move< spicy::type::unit::item::switch_::Case > (that.value);
        break;

      case 251: // opt_unit_hook_attributes
      case 308: // opt_attributes
        value.move< std::optional<hilti::AttributeSet> > (that.value);
        break;

      case 198: // opt_init_expression
      case 243: // unit_field_repeat
      case 244: // opt_unit_field_repeat
      case 245: // opt_unit_field_condition
      case 258: // opt_unit_switch_expr
        value.move< std::optional<hilti::Expression> > (that.value);
        break;

      case 240: // opt_unit_field_id
        value.move< std::optional<hilti::ID> > (that.value);
        break;

      case 204: // opt_else_block
        value.move< std::optional<hilti::Statement> > (that.value);
        break;

      case 176: // global_scope_items
        value.move< std::pair<std::vector<hilti::Declaration>, std::vector<hilti::Statement>> > (that.value);
        break;

      case 3: // "identifier"
      case 4: // "scoped identifier"
      case 5: // "dotted identifier"
      case 6: // "hook identifier"
      case 7: // "$-identifier"
      case 8: // "attribute"
      case 9: // "property"
      case 10: // "preprocessor directive"
      case 11: // "string value"
      case 12: // "bytes value"
      case 13: // "regular expression value"
      case 14: // "address value"
      case 15: // "port value"
      case 301: // re_pattern_constant
        value.move< std::string > (that.value);
        break;

      case 219: // struct_fields
        value.move< std::vector<hilti::Declaration> > (that.value);
        break;

      case 242: // opt_unit_field_args
      case 246: // opt_unit_field_sinks
      case 264: // opt_exprs
      case 265: // exprs
      case 289: // opt_tuple_elems1
      case 290: // opt_tuple_elems2
        value.move< std::vector<hilti::Expression> > (that.value);
        break;

      case 201: // opt_stmts
      case 202: // stmts
        value.move< std::vector<hilti::Statement> > (that.value);
        break;

      case 304: // opt_map_elems
      case 305: // map_elems
        value.move< std::vector<hilti::ctor::map::Element> > (that.value);
        break;

      case 297: // struct_elems
        value.move< std::vector<hilti::ctor::struct_::Field> > (that.value);
        break;

      case 205: // switch_cases
        value.move< std::vector<hilti::statement::switch_::Case> > (that.value);
        break;

      case 222: // enum_labels
        value.move< std::vector<hilti::type::enum_::Label> > (that.value);
        break;

      case 192: // opt_func_params
      case 193: // func_params
      case 230: // opt_unit_params
      case 250: // opt_unit_hook_params
        value.move< std::vector<hilti::type::function::Parameter> > (that.value);
        break;

      case 216: // tuple_type_elems
        value.move< std::vector<hilti::type::tuple::Element> > (that.value);
        break;

      case 247: // opt_unit_item_hooks
      case 248: // unit_hooks
        value.move< std::vector<spicy::Hook> > (that.value);
        break;

      case 226: // opt_bitfield_bits
      case 227: // bitfield_bits
        value.move< std::vector<spicy::type::bitfield::Bits> > (that.value);
        break;

      case 231: // unit_items
      case 232: // opt_unit_items
        value.move< std::vector<spicy::type::unit::Item> > (that.value);
        break;

      case 259: // unit_switch_cases
        value.move< std::vector<spicy::type::unit::item::switch_::Case> > (that.value);
        break;

      case 300: // re_patterns
        value.move< std::vector<std::string> > (that.value);
        break;

      case 17: // "unsigned integer value"
      case 18: // "$<N>"
      case 287: // const_uint
        value.move< uint64_t > (that.value);
        break;

      default:
        break;
    }

    // that is emptied.
    that.type = empty_symbol;
  }

  inline
  Parser::stack_symbol_type&
  Parser::stack_symbol_type::operator= (const stack_symbol_type& that)
  {
    state = that.state;
      switch (that.type_get ())
    {
      case 19: // "bool value"
        value.copy< bool > (that.value);
        break;

      case 16: // "real value"
      case 285: // const_real
        value.copy< double > (that.value);
        break;

      case 255: // unit_hook_attribute
      case 307: // attribute
        value.copy< hilti::Attribute > (that.value);
        break;

      case 284: // ctor
      case 288: // tuple
      case 292: // list
      case 293: // vector
      case 294: // set
      case 295: // map
      case 296: // struct_
      case 299: // regexp
        value.copy< hilti::Ctor > (that.value);
        break;

      case 177: // global_scope_decl
      case 178: // type_decl
      case 179: // constant_decl
      case 180: // local_decl
      case 181: // local_init_decl
      case 182: // global_decl
      case 183: // function_decl
      case 184: // import_decl
      case 185: // property_decl
      case 186: // hook_decl
      case 220: // struct_field
        value.copy< hilti::Declaration > (that.value);
        break;

      case 261: // expr
      case 266: // expr_0
      case 267: // expr_1
      case 268: // expr_2
      case 269: // expr_3
      case 270: // expr_4
      case 271: // expr_5
      case 272: // expr_6
      case 273: // expr_7
      case 274: // expr_8
      case 275: // expr_9
      case 276: // expr_a
      case 277: // expr_b
      case 278: // expr_c
      case 279: // expr_d
      case 280: // expr_e
      case 281: // expr_f
      case 282: // expr_g
      case 283: // member_expr
      case 291: // tuple_elem
        value.copy< hilti::Expression > (that.value);
        break;

      case 188: // function_with_body
      case 189: // function_without_body
        value.copy< hilti::Function > (that.value);
        break;

      case 171: // local_id
      case 172: // scoped_id
      case 173: // dotted_id
      case 252: // unit_hook_id
        value.copy< hilti::ID > (that.value);
        break;

      case 199: // block
      case 200: // braced_block
      case 203: // stmt
      case 207: // stmt_decl
      case 208: // stmt_expr
        value.copy< hilti::Statement > (that.value);
        break;

      case 209: // base_type_no_ref
      case 210: // reference_type
      case 211: // base_type
      case 212: // type
      case 215: // tuple_type
      case 218: // struct_type
      case 221: // enum_type
      case 224: // bitfield_type
      case 229: // unit_type
        value.copy< hilti::Type > (that.value);
        break;

      case 306: // map_elem
        value.copy< hilti::ctor::map::Element > (that.value);
        break;

      case 298: // struct_elem
        value.copy< hilti::ctor::struct_::Field > (that.value);
        break;

      case 187: // opt_linkage
        value.copy< hilti::declaration::Linkage > (that.value);
        break;

      case 197: // opt_func_param_kind
        value.copy< hilti::declaration::parameter::Kind > (that.value);
        break;

      case 191: // opt_func_cc
        value.copy< hilti::function::CallingConvention > (that.value);
        break;

      case 206: // switch_case
        value.copy< hilti::statement::switch_::Case > (that.value);
        break;

      case 223: // enum_label
        value.copy< hilti::type::enum_::Label > (that.value);
        break;

      case 190: // opt_func_flavor
        value.copy< hilti::type::function::Flavor > (that.value);
        break;

      case 194: // func_param
        value.copy< hilti::type::function::Parameter > (that.value);
        break;

      case 195: // func_result
      case 196: // opt_func_result
        value.copy< hilti::type::function::Result > (that.value);
        break;

      case 217: // tuple_type_elem
        value.copy< hilti::type::tuple::Element > (that.value);
        break;

      case 286: // const_sint
        value.copy< int64_t > (that.value);
        break;

      case 241: // opt_unit_field_engine
      case 256: // opt_hook_engine
        value.copy< spicy::Engine > (that.value);
        break;

      case 249: // unit_hook
        value.copy< spicy::Hook > (that.value);
        break;

      case 228: // bitfield_bits_spec
        value.copy< spicy::type::bitfield::Bits > (that.value);
        break;

      case 233: // unit_item
      case 234: // unit_variable
      case 235: // unit_sink
      case 236: // unit_property
      case 237: // unit_field
      case 238: // unit_field_in_container
      case 239: // unit_wide_hook
      case 257: // unit_switch
        value.copy< spicy::type::unit::Item > (that.value);
        break;

      case 260: // unit_switch_case
        value.copy< spicy::type::unit::item::switch_::Case > (that.value);
        break;

      case 251: // opt_unit_hook_attributes
      case 308: // opt_attributes
        value.copy< std::optional<hilti::AttributeSet> > (that.value);
        break;

      case 198: // opt_init_expression
      case 243: // unit_field_repeat
      case 244: // opt_unit_field_repeat
      case 245: // opt_unit_field_condition
      case 258: // opt_unit_switch_expr
        value.copy< std::optional<hilti::Expression> > (that.value);
        break;

      case 240: // opt_unit_field_id
        value.copy< std::optional<hilti::ID> > (that.value);
        break;

      case 204: // opt_else_block
        value.copy< std::optional<hilti::Statement> > (that.value);
        break;

      case 176: // global_scope_items
        value.copy< std::pair<std::vector<hilti::Declaration>, std::vector<hilti::Statement>> > (that.value);
        break;

      case 3: // "identifier"
      case 4: // "scoped identifier"
      case 5: // "dotted identifier"
      case 6: // "hook identifier"
      case 7: // "$-identifier"
      case 8: // "attribute"
      case 9: // "property"
      case 10: // "preprocessor directive"
      case 11: // "string value"
      case 12: // "bytes value"
      case 13: // "regular expression value"
      case 14: // "address value"
      case 15: // "port value"
      case 301: // re_pattern_constant
        value.copy< std::string > (that.value);
        break;

      case 219: // struct_fields
        value.copy< std::vector<hilti::Declaration> > (that.value);
        break;

      case 242: // opt_unit_field_args
      case 246: // opt_unit_field_sinks
      case 264: // opt_exprs
      case 265: // exprs
      case 289: // opt_tuple_elems1
      case 290: // opt_tuple_elems2
        value.copy< std::vector<hilti::Expression> > (that.value);
        break;

      case 201: // opt_stmts
      case 202: // stmts
        value.copy< std::vector<hilti::Statement> > (that.value);
        break;

      case 304: // opt_map_elems
      case 305: // map_elems
        value.copy< std::vector<hilti::ctor::map::Element> > (that.value);
        break;

      case 297: // struct_elems
        value.copy< std::vector<hilti::ctor::struct_::Field> > (that.value);
        break;

      case 205: // switch_cases
        value.copy< std::vector<hilti::statement::switch_::Case> > (that.value);
        break;

      case 222: // enum_labels
        value.copy< std::vector<hilti::type::enum_::Label> > (that.value);
        break;

      case 192: // opt_func_params
      case 193: // func_params
      case 230: // opt_unit_params
      case 250: // opt_unit_hook_params
        value.copy< std::vector<hilti::type::function::Parameter> > (that.value);
        break;

      case 216: // tuple_type_elems
        value.copy< std::vector<hilti::type::tuple::Element> > (that.value);
        break;

      case 247: // opt_unit_item_hooks
      case 248: // unit_hooks
        value.copy< std::vector<spicy::Hook> > (that.value);
        break;

      case 226: // opt_bitfield_bits
      case 227: // bitfield_bits
        value.copy< std::vector<spicy::type::bitfield::Bits> > (that.value);
        break;

      case 231: // unit_items
      case 232: // opt_unit_items
        value.copy< std::vector<spicy::type::unit::Item> > (that.value);
        break;

      case 259: // unit_switch_cases
        value.copy< std::vector<spicy::type::unit::item::switch_::Case> > (that.value);
        break;

      case 300: // re_patterns
        value.copy< std::vector<std::string> > (that.value);
        break;

      case 17: // "unsigned integer value"
      case 18: // "$<N>"
      case 287: // const_uint
        value.copy< uint64_t > (that.value);
        break;

      default:
        break;
    }

    location = that.location;
    return *this;
  }


  template <typename Base>
  inline
  void
  Parser::yy_destroy_ (const char* yymsg, basic_symbol<Base>& yysym) const
  {
    if (yymsg)
      YY_SYMBOL_PRINT (yymsg, yysym);
  }

#if YYDEBUG
  template <typename Base>
  void
  Parser::yy_print_ (std::ostream& yyo,
                                     const basic_symbol<Base>& yysym) const
  {
    std::ostream& yyoutput = yyo;
    YYUSE (yyoutput);
    symbol_number_type yytype = yysym.type_get ();
    // Avoid a (spurious) G++ 4.8 warning about "array subscript is
    // below array bounds".
    if (yysym.empty ())
      std::abort ();
    yyo << (yytype < yyntokens_ ? "token" : "nterm")
        << ' ' << yytname_[yytype] << " ("
        << yysym.location << ": ";
    YYUSE (yytype);
    yyo << ')';
  }
#endif

  inline
  void
  Parser::yypush_ (const char* m, state_type s, symbol_type& sym)
  {
    stack_symbol_type t (s, sym);
    yypush_ (m, t);
  }

  inline
  void
  Parser::yypush_ (const char* m, stack_symbol_type& s)
  {
    if (m)
      YY_SYMBOL_PRINT (m, s);
    yystack_.push (s);
  }

  inline
  void
  Parser::yypop_ (unsigned int n)
  {
    yystack_.pop (n);
  }

#if YYDEBUG
  std::ostream&
  Parser::debug_stream () const
  {
    return *yycdebug_;
  }

  void
  Parser::set_debug_stream (std::ostream& o)
  {
    yycdebug_ = &o;
  }


  Parser::debug_level_type
  Parser::debug_level () const
  {
    return yydebug_;
  }

  void
  Parser::set_debug_level (debug_level_type l)
  {
    yydebug_ = l;
  }
#endif // YYDEBUG

  inline Parser::state_type
  Parser::yy_lr_goto_state_ (state_type yystate, int yysym)
  {
    int yyr = yypgoto_[yysym - yyntokens_] + yystate;
    if (0 <= yyr && yyr <= yylast_ && yycheck_[yyr] == yystate)
      return yytable_[yyr];
    else
      return yydefgoto_[yysym - yyntokens_];
  }

  inline bool
  Parser::yy_pact_value_is_default_ (int yyvalue)
  {
    return yyvalue == yypact_ninf_;
  }

  inline bool
  Parser::yy_table_value_is_error_ (int yyvalue)
  {
    return yyvalue == yytable_ninf_;
  }

  int
  Parser::parse ()
  {
    // State.
    int yyn;
    /// Length of the RHS of the rule being reduced.
    int yylen = 0;

    // Error handling.
    int yynerrs_ = 0;
    int yyerrstatus_ = 0;

    /// The lookahead symbol.
    symbol_type yyla;

    /// The locations where the error started and ended.
    stack_symbol_type yyerror_range[3];

    /// The return value of parse ().
    int yyresult;

    // FIXME: This shoud be completely indented.  It is not yet to
    // avoid gratuitous conflicts when merging into the master branch.
    try
      {
    YYCDEBUG << "Starting parse" << std::endl;


    // User initialization code.
    #line 20 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:741
{
    yyla.location.begin.filename = yyla.location.end.filename = driver->currentFile();
    yyla.location.begin.line = yyla.location.end.line = driver->currentLine();
}

#line 3528 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:741

    /* Initialize the stack.  The initial state will be set in
       yynewstate, since the latter expects the semantical and the
       location values to have been already stored, initialize these
       stacks with a primary value.  */
    yystack_.clear ();
    yypush_ (YY_NULLPTR, 0, yyla);

    // A new symbol was pushed on the stack.
  yynewstate:
    YYCDEBUG << "Entering state " << yystack_[0].state << std::endl;

    // Accept?
    if (yystack_[0].state == yyfinal_)
      goto yyacceptlab;

    goto yybackup;

    // Backup.
  yybackup:

    // Try to take a decision without lookahead.
    yyn = yypact_[yystack_[0].state];
    if (yy_pact_value_is_default_ (yyn))
      goto yydefault;

    // Read a lookahead token.
    if (yyla.empty ())
      {
        YYCDEBUG << "Reading a token: ";
        try
          {
            yyla.type = yytranslate_ (yylex (&yyla.value, &yyla.location, driver));
          }
        catch (const syntax_error& yyexc)
          {
            error (yyexc);
            goto yyerrlab1;
          }
      }
    YY_SYMBOL_PRINT ("Next token is", yyla);

    /* If the proper action on seeing token YYLA.TYPE is to reduce or
       to detect an error, take that action.  */
    yyn += yyla.type_get ();
    if (yyn < 0 || yylast_ < yyn || yycheck_[yyn] != yyla.type_get ())
      goto yydefault;

    // Reduce or error.
    yyn = yytable_[yyn];
    if (yyn <= 0)
      {
        if (yy_table_value_is_error_ (yyn))
          goto yyerrlab;
        yyn = -yyn;
        goto yyreduce;
      }

    // Count tokens shifted since error; after three, turn off error status.
    if (yyerrstatus_)
      --yyerrstatus_;

    // Shift the lookahead token.
    yypush_ ("Shifting", yyn, yyla);
    goto yynewstate;

  /*-----------------------------------------------------------.
  | yydefault -- do the default action for the current state.  |
  `-----------------------------------------------------------*/
  yydefault:
    yyn = yydefact_[yystack_[0].state];
    if (yyn == 0)
      goto yyerrlab;
    goto yyreduce;

  /*-----------------------------.
  | yyreduce -- Do a reduction.  |
  `-----------------------------*/
  yyreduce:
    yylen = yyr2_[yyn];
    {
      stack_symbol_type yylhs;
      yylhs.state = yy_lr_goto_state_(yystack_[yylen].state, yyr1_[yyn]);
      /* Variants are always initialized to an empty instance of the
         correct type. The default '$$ = $1' action is NOT applied
         when using variants.  */
        switch (yyr1_[yyn])
    {
      case 19: // "bool value"
        yylhs.value.build< bool > ();
        break;

      case 16: // "real value"
      case 285: // const_real
        yylhs.value.build< double > ();
        break;

      case 255: // unit_hook_attribute
      case 307: // attribute
        yylhs.value.build< hilti::Attribute > ();
        break;

      case 284: // ctor
      case 288: // tuple
      case 292: // list
      case 293: // vector
      case 294: // set
      case 295: // map
      case 296: // struct_
      case 299: // regexp
        yylhs.value.build< hilti::Ctor > ();
        break;

      case 177: // global_scope_decl
      case 178: // type_decl
      case 179: // constant_decl
      case 180: // local_decl
      case 181: // local_init_decl
      case 182: // global_decl
      case 183: // function_decl
      case 184: // import_decl
      case 185: // property_decl
      case 186: // hook_decl
      case 220: // struct_field
        yylhs.value.build< hilti::Declaration > ();
        break;

      case 261: // expr
      case 266: // expr_0
      case 267: // expr_1
      case 268: // expr_2
      case 269: // expr_3
      case 270: // expr_4
      case 271: // expr_5
      case 272: // expr_6
      case 273: // expr_7
      case 274: // expr_8
      case 275: // expr_9
      case 276: // expr_a
      case 277: // expr_b
      case 278: // expr_c
      case 279: // expr_d
      case 280: // expr_e
      case 281: // expr_f
      case 282: // expr_g
      case 283: // member_expr
      case 291: // tuple_elem
        yylhs.value.build< hilti::Expression > ();
        break;

      case 188: // function_with_body
      case 189: // function_without_body
        yylhs.value.build< hilti::Function > ();
        break;

      case 171: // local_id
      case 172: // scoped_id
      case 173: // dotted_id
      case 252: // unit_hook_id
        yylhs.value.build< hilti::ID > ();
        break;

      case 199: // block
      case 200: // braced_block
      case 203: // stmt
      case 207: // stmt_decl
      case 208: // stmt_expr
        yylhs.value.build< hilti::Statement > ();
        break;

      case 209: // base_type_no_ref
      case 210: // reference_type
      case 211: // base_type
      case 212: // type
      case 215: // tuple_type
      case 218: // struct_type
      case 221: // enum_type
      case 224: // bitfield_type
      case 229: // unit_type
        yylhs.value.build< hilti::Type > ();
        break;

      case 306: // map_elem
        yylhs.value.build< hilti::ctor::map::Element > ();
        break;

      case 298: // struct_elem
        yylhs.value.build< hilti::ctor::struct_::Field > ();
        break;

      case 187: // opt_linkage
        yylhs.value.build< hilti::declaration::Linkage > ();
        break;

      case 197: // opt_func_param_kind
        yylhs.value.build< hilti::declaration::parameter::Kind > ();
        break;

      case 191: // opt_func_cc
        yylhs.value.build< hilti::function::CallingConvention > ();
        break;

      case 206: // switch_case
        yylhs.value.build< hilti::statement::switch_::Case > ();
        break;

      case 223: // enum_label
        yylhs.value.build< hilti::type::enum_::Label > ();
        break;

      case 190: // opt_func_flavor
        yylhs.value.build< hilti::type::function::Flavor > ();
        break;

      case 194: // func_param
        yylhs.value.build< hilti::type::function::Parameter > ();
        break;

      case 195: // func_result
      case 196: // opt_func_result
        yylhs.value.build< hilti::type::function::Result > ();
        break;

      case 217: // tuple_type_elem
        yylhs.value.build< hilti::type::tuple::Element > ();
        break;

      case 286: // const_sint
        yylhs.value.build< int64_t > ();
        break;

      case 241: // opt_unit_field_engine
      case 256: // opt_hook_engine
        yylhs.value.build< spicy::Engine > ();
        break;

      case 249: // unit_hook
        yylhs.value.build< spicy::Hook > ();
        break;

      case 228: // bitfield_bits_spec
        yylhs.value.build< spicy::type::bitfield::Bits > ();
        break;

      case 233: // unit_item
      case 234: // unit_variable
      case 235: // unit_sink
      case 236: // unit_property
      case 237: // unit_field
      case 238: // unit_field_in_container
      case 239: // unit_wide_hook
      case 257: // unit_switch
        yylhs.value.build< spicy::type::unit::Item > ();
        break;

      case 260: // unit_switch_case
        yylhs.value.build< spicy::type::unit::item::switch_::Case > ();
        break;

      case 251: // opt_unit_hook_attributes
      case 308: // opt_attributes
        yylhs.value.build< std::optional<hilti::AttributeSet> > ();
        break;

      case 198: // opt_init_expression
      case 243: // unit_field_repeat
      case 244: // opt_unit_field_repeat
      case 245: // opt_unit_field_condition
      case 258: // opt_unit_switch_expr
        yylhs.value.build< std::optional<hilti::Expression> > ();
        break;

      case 240: // opt_unit_field_id
        yylhs.value.build< std::optional<hilti::ID> > ();
        break;

      case 204: // opt_else_block
        yylhs.value.build< std::optional<hilti::Statement> > ();
        break;

      case 176: // global_scope_items
        yylhs.value.build< std::pair<std::vector<hilti::Declaration>, std::vector<hilti::Statement>> > ();
        break;

      case 3: // "identifier"
      case 4: // "scoped identifier"
      case 5: // "dotted identifier"
      case 6: // "hook identifier"
      case 7: // "$-identifier"
      case 8: // "attribute"
      case 9: // "property"
      case 10: // "preprocessor directive"
      case 11: // "string value"
      case 12: // "bytes value"
      case 13: // "regular expression value"
      case 14: // "address value"
      case 15: // "port value"
      case 301: // re_pattern_constant
        yylhs.value.build< std::string > ();
        break;

      case 219: // struct_fields
        yylhs.value.build< std::vector<hilti::Declaration> > ();
        break;

      case 242: // opt_unit_field_args
      case 246: // opt_unit_field_sinks
      case 264: // opt_exprs
      case 265: // exprs
      case 289: // opt_tuple_elems1
      case 290: // opt_tuple_elems2
        yylhs.value.build< std::vector<hilti::Expression> > ();
        break;

      case 201: // opt_stmts
      case 202: // stmts
        yylhs.value.build< std::vector<hilti::Statement> > ();
        break;

      case 304: // opt_map_elems
      case 305: // map_elems
        yylhs.value.build< std::vector<hilti::ctor::map::Element> > ();
        break;

      case 297: // struct_elems
        yylhs.value.build< std::vector<hilti::ctor::struct_::Field> > ();
        break;

      case 205: // switch_cases
        yylhs.value.build< std::vector<hilti::statement::switch_::Case> > ();
        break;

      case 222: // enum_labels
        yylhs.value.build< std::vector<hilti::type::enum_::Label> > ();
        break;

      case 192: // opt_func_params
      case 193: // func_params
      case 230: // opt_unit_params
      case 250: // opt_unit_hook_params
        yylhs.value.build< std::vector<hilti::type::function::Parameter> > ();
        break;

      case 216: // tuple_type_elems
        yylhs.value.build< std::vector<hilti::type::tuple::Element> > ();
        break;

      case 247: // opt_unit_item_hooks
      case 248: // unit_hooks
        yylhs.value.build< std::vector<spicy::Hook> > ();
        break;

      case 226: // opt_bitfield_bits
      case 227: // bitfield_bits
        yylhs.value.build< std::vector<spicy::type::bitfield::Bits> > ();
        break;

      case 231: // unit_items
      case 232: // opt_unit_items
        yylhs.value.build< std::vector<spicy::type::unit::Item> > ();
        break;

      case 259: // unit_switch_cases
        yylhs.value.build< std::vector<spicy::type::unit::item::switch_::Case> > ();
        break;

      case 300: // re_patterns
        yylhs.value.build< std::vector<std::string> > ();
        break;

      case 17: // "unsigned integer value"
      case 18: // "$<N>"
      case 287: // const_uint
        yylhs.value.build< uint64_t > ();
        break;

      default:
        break;
    }


      // Compute the default @$.
      {
        slice<stack_symbol_type, stack_type> slice (yystack_, yylen);
        YYLLOC_DEFAULT (yylhs.location, slice, yylen);
      }

      // Perform the reduction.
      YY_REDUCE_PRINT (yyn);
      try
        {
          switch (yyn)
            {
  case 4:
#line 299 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { driver->setDestinationExpression(std::move(yystack_[0].value.as< hilti::Expression > ())); }
#line 3925 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 5:
#line 302 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { auto m = hilti::Module(yystack_[2].value.as< hilti::ID > (), std::move(yystack_[0].value.as< std::pair<std::vector<hilti::Declaration>, std::vector<hilti::Statement>> > ().first), std::move(yystack_[0].value.as< std::pair<std::vector<hilti::Declaration>, std::vector<hilti::Statement>> > ().second), __loc__);
                                                   driver->setDestinationModule(std::move(m));
                                                 }
#line 3933 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 6:
#line 309 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { std::string name(yystack_[0].value.as< std::string > ());

                                                   if ( name.find('-') != std::string::npos)
                                                       hilti::logger().error(hilti::util::fmt("Invalid ID '%s': cannot contain '-'", name), __loc__.location());
                                                   if ( name.substr(0, 2) == "__" )
                                                       hilti::logger().error(hilti::util::fmt("Invalid ID '%s': cannot start with '__'", name), __loc__.location());

                                                   yylhs.value.as< hilti::ID > () = hilti::ID(std::move(name), __loc__);
                                                 }
#line 3947 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 7:
#line 319 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::ID > () = std::move(yystack_[0].value.as< hilti::ID > ()); }
#line 3953 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 8:
#line 320 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::ID > () = hilti::ID(yystack_[0].value.as< std::string > (), __loc__); }
#line 3959 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 9:
#line 322 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { driver->enableDottedIDMode(); }
#line 3965 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 10:
#line 324 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { driver->disableDottedIDMode(); }
#line 3971 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 11:
#line 324 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::ID > () = hilti::ID(yystack_[1].value.as< std::string > (), __loc__); }
#line 3977 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 12:
#line 330 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::pair<std::vector<hilti::Declaration>, std::vector<hilti::Statement>> > () = std::move(yystack_[1].value.as< std::pair<std::vector<hilti::Declaration>, std::vector<hilti::Statement>> > ()); yylhs.value.as< std::pair<std::vector<hilti::Declaration>, std::vector<hilti::Statement>> > ().first.push_back(yystack_[0].value.as< hilti::Declaration > ()); }
#line 3983 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 13:
#line 332 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::pair<std::vector<hilti::Declaration>, std::vector<hilti::Statement>> > () = std::move(yystack_[1].value.as< std::pair<std::vector<hilti::Declaration>, std::vector<hilti::Statement>> > ()); yylhs.value.as< std::pair<std::vector<hilti::Declaration>, std::vector<hilti::Statement>> > ().second.push_back(yystack_[0].value.as< hilti::Statement > ()); }
#line 3989 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 14:
#line 333 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::pair<std::vector<hilti::Declaration>, std::vector<hilti::Statement>> > () = {}; }
#line 3995 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 15:
#line 337 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Declaration > () = std::move(yystack_[0].value.as< hilti::Declaration > ()); }
#line 4001 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 16:
#line 338 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Declaration > () = std::move(yystack_[0].value.as< hilti::Declaration > ()); }
#line 4007 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 17:
#line 339 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Declaration > () = std::move(yystack_[0].value.as< hilti::Declaration > ()); }
#line 4013 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 18:
#line 340 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Declaration > () = std::move(yystack_[0].value.as< hilti::Declaration > ()); }
#line 4019 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 19:
#line 341 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Declaration > () = std::move(yystack_[0].value.as< hilti::Declaration > ()); }
#line 4025 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 20:
#line 342 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Declaration > () = std::move(yystack_[0].value.as< hilti::Declaration > ()); }
#line 4031 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 21:
#line 343 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Declaration > () = std::move(yystack_[0].value.as< hilti::Declaration > ()); }
#line 4037 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 22:
#line 345 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    {
                                                   if ( auto x = yystack_[2].value.as< hilti::Type > ().isA<type::Unit>(); x && yystack_[1].value.as< std::optional<hilti::AttributeSet> > () && *yystack_[1].value.as< std::optional<hilti::AttributeSet> > () ) {
                                                       yystack_[2].value.as< hilti::Type > ().as<type::Unit>().setAttributes(*yystack_[1].value.as< std::optional<hilti::AttributeSet> > ());
                                                       yystack_[1].value.as< std::optional<hilti::AttributeSet> > () = {}; // don't associate with declaration
                                                       }

                                                   yylhs.value.as< hilti::Declaration > () = hilti::declaration::Type(std::move(yystack_[4].value.as< hilti::ID > ()), std::move(yystack_[2].value.as< hilti::Type > ()), std::move(yystack_[1].value.as< std::optional<hilti::AttributeSet> > ()), std::move(yystack_[6].value.as< hilti::declaration::Linkage > ()), __loc__);
                                                 }
#line 4050 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 23:
#line 355 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Declaration > () = hilti::declaration::Constant(yystack_[3].value.as< hilti::ID > (), yystack_[1].value.as< hilti::Expression > (), yystack_[5].value.as< hilti::declaration::Linkage > (), __loc__); }
#line 4056 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 24:
#line 357 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Declaration > () = hilti::declaration::Constant(yystack_[5].value.as< hilti::ID > (), yystack_[3].value.as< hilti::Type > (), yystack_[1].value.as< hilti::Expression > (), yystack_[7].value.as< hilti::declaration::Linkage > (), __loc__); }
#line 4062 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 25:
#line 360 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Declaration > () = hilti::declaration::LocalVariable(yystack_[3].value.as< hilti::ID > (), yystack_[1].value.as< hilti::Expression > (), false, __loc__); }
#line 4068 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 26:
#line 361 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Declaration > () = hilti::declaration::LocalVariable(yystack_[3].value.as< hilti::ID > (), yystack_[1].value.as< hilti::Type > (), {}, false, __loc__); }
#line 4074 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 27:
#line 363 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Declaration > () = hilti::declaration::LocalVariable(yystack_[5].value.as< hilti::ID > (), yystack_[3].value.as< hilti::Type > (), yystack_[1].value.as< hilti::Expression > (), false, __loc__); }
#line 4080 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 28:
#line 368 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Declaration > () = hilti::declaration::LocalVariable(yystack_[4].value.as< hilti::ID > (), yystack_[2].value.as< hilti::Type > (), yystack_[0].value.as< hilti::Expression > (), false, __loc__); }
#line 4086 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 29:
#line 370 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Declaration > () = hilti::declaration::LocalVariable(yystack_[2].value.as< hilti::ID > (), yystack_[0].value.as< hilti::Expression > (), false, __loc__); }
#line 4092 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 30:
#line 374 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Declaration > () = hilti::declaration::GlobalVariable(yystack_[3].value.as< hilti::ID > (), yystack_[1].value.as< hilti::Expression > (), yystack_[5].value.as< hilti::declaration::Linkage > (), __loc__); }
#line 4098 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 31:
#line 376 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Declaration > () = hilti::declaration::GlobalVariable(yystack_[3].value.as< hilti::ID > (), yystack_[1].value.as< hilti::Type > (), yystack_[5].value.as< hilti::declaration::Linkage > (), __loc__); }
#line 4104 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 32:
#line 378 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Declaration > () = hilti::declaration::GlobalVariable(yystack_[5].value.as< hilti::ID > (), yystack_[3].value.as< hilti::Type > (), yystack_[1].value.as< hilti::Expression > (), yystack_[7].value.as< hilti::declaration::Linkage > (), __loc__); }
#line 4110 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 33:
#line 382 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Declaration > () = hilti::declaration::Function(yystack_[0].value.as< hilti::Function > (), yystack_[1].value.as< hilti::declaration::Linkage > (), __loc__); }
#line 4116 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 34:
#line 384 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Declaration > () = hilti::declaration::Function(yystack_[1].value.as< hilti::Function > (), yystack_[2].value.as< hilti::declaration::Linkage > (), __loc__); }
#line 4122 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 35:
#line 387 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Declaration > () = hilti::declaration::ImportedModule(std::move(yystack_[1].value.as< hilti::ID > ()), std::string(".spicy"), __loc__); }
#line 4128 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 36:
#line 388 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Declaration > () = hilti::declaration::ImportedModule(std::move(yystack_[3].value.as< hilti::ID > ()), std::string(".spicy"), std::move(yystack_[1].value.as< hilti::ID > ()), __loc__); }
#line 4134 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 37:
#line 391 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Declaration > () = hilti::declaration::Property(ID(std::move(yystack_[1].value.as< std::string > ())), __loc__); }
#line 4140 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 38:
#line 392 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Declaration > () = hilti::declaration::Property(ID(std::move(yystack_[3].value.as< std::string > ())), std::move(yystack_[1].value.as< hilti::Expression > ()), __loc__); }
#line 4146 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 39:
#line 393 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Declaration > () = hilti::declaration::Property(ID(std::move(yystack_[3].value.as< std::string > ())), hilti::expression::Type_(std::move(yystack_[1].value.as< hilti::Type > ())), __loc__); }
#line 4152 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 40:
#line 396 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { ID unit = yystack_[1].value.as< hilti::ID > ().namespace_();
                                                   if ( unit.empty() )
                                                      error(yylhs.location, "hook requires unit namespace");

                                                   yylhs.value.as< hilti::Declaration > () = spicy::declaration::UnitHook(std::move(yystack_[1].value.as< hilti::ID > ()), std::move(yystack_[0].value.as< spicy::Hook > ()), __loc__);
                                                 }
#line 4163 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 41:
#line 404 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::declaration::Linkage > () = hilti::declaration::Linkage::Public; }
#line 4169 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 42:
#line 405 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::declaration::Linkage > () = hilti::declaration::Linkage::Private; }
#line 4175 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 43:
#line 406 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::declaration::Linkage > () = hilti::declaration::Linkage::Private; }
#line 4181 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 44:
#line 412 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    {
                                                    auto ftype = hilti::type::Function(yystack_[2].value.as< hilti::type::function::Result > (), yystack_[4].value.as< std::vector<hilti::type::function::Parameter> > (), yystack_[8].value.as< hilti::type::function::Flavor > (), __loc__);
                                                    yylhs.value.as< hilti::Function > () = hilti::Function(yystack_[6].value.as< hilti::ID > (), std::move(ftype), yystack_[0].value.as< hilti::Statement > (), yystack_[7].value.as< hilti::function::CallingConvention > (), yystack_[1].value.as< std::optional<hilti::AttributeSet> > (), __loc__);
                                                 }
#line 4190 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 45:
#line 419 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    {
                                                    auto ftype = hilti::type::Function(yystack_[1].value.as< hilti::type::function::Result > (), yystack_[3].value.as< std::vector<hilti::type::function::Parameter> > (), yystack_[7].value.as< hilti::type::function::Flavor > (), __loc__);
                                                    yylhs.value.as< hilti::Function > () = hilti::Function(yystack_[5].value.as< hilti::ID > (), std::move(ftype), {}, yystack_[6].value.as< hilti::function::CallingConvention > (), yystack_[0].value.as< std::optional<hilti::AttributeSet> > (), __loc__);
                                                 }
#line 4199 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 46:
#line 425 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::type::function::Flavor > () = hilti::type::function::Flavor::Standard; }
#line 4205 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 47:
#line 427 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { try {
                                                       yylhs.value.as< hilti::function::CallingConvention > () = hilti::function::calling_convention::from_string(yystack_[0].value.as< std::string > ());
                                                   } catch ( std::out_of_range& e ) {
                                                       error(yylhs.location, "unknown calling convention");
                                                   }
                                                 }
#line 4216 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 48:
#line 433 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::function::CallingConvention > () = hilti::function::CallingConvention::Standard; }
#line 4222 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 49:
#line 437 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<hilti::type::function::Parameter> > () = std::move(yystack_[0].value.as< std::vector<hilti::type::function::Parameter> > ()); }
#line 4228 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 50:
#line 438 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<hilti::type::function::Parameter> > () = std::vector<hilti::type::function::Parameter>{}; }
#line 4234 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 51:
#line 440 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<hilti::type::function::Parameter> > () = std::move(yystack_[2].value.as< std::vector<hilti::type::function::Parameter> > ()); yylhs.value.as< std::vector<hilti::type::function::Parameter> > ().push_back(yystack_[0].value.as< hilti::type::function::Parameter > ()); }
#line 4240 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 52:
#line 441 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<hilti::type::function::Parameter> > () = std::vector<hilti::type::function::Parameter>{yystack_[0].value.as< hilti::type::function::Parameter > ()}; }
#line 4246 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 53:
#line 444 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::type::function::Parameter > () = hilti::type::function::Parameter(yystack_[3].value.as< hilti::ID > (), yystack_[1].value.as< hilti::Type > (), yystack_[4].value.as< hilti::declaration::parameter::Kind > (), yystack_[0].value.as< std::optional<hilti::Expression> > (), __loc__); }
#line 4252 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 54:
#line 446 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::type::function::Result > () = hilti::type::function::Result(std::move(yystack_[0].value.as< hilti::Type > ()), __loc__); }
#line 4258 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 55:
#line 448 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::type::function::Result > () = std::move(yystack_[0].value.as< hilti::type::function::Result > ()); }
#line 4264 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 56:
#line 449 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::type::function::Result > () = hilti::type::function::Result(hilti::type::void_, __loc__); }
#line 4270 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 57:
#line 452 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::declaration::parameter::Kind > () = hilti::declaration::parameter::Kind::InOut; }
#line 4276 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 58:
#line 453 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::declaration::parameter::Kind > () = hilti::declaration::parameter::Kind::In; }
#line 4282 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 59:
#line 456 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::optional<hilti::Expression> > () = std::move(yystack_[0].value.as< hilti::Expression > ()); }
#line 4288 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 60:
#line 457 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::optional<hilti::Expression> > () = {}; }
#line 4294 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 61:
#line 462 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Statement > () = std::move(yystack_[0].value.as< hilti::Statement > ()); }
#line 4300 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 62:
#line 463 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Statement > () = hilti::statement::Block({yystack_[0].value.as< hilti::Statement > ()}, __loc__); }
#line 4306 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 63:
#line 466 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Statement > () = hilti::statement::Block(std::move(yystack_[1].value.as< std::vector<hilti::Statement> > ()), __loc__); }
#line 4312 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 64:
#line 468 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<hilti::Statement> > () = std::move(yystack_[0].value.as< std::vector<hilti::Statement> > ()); }
#line 4318 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 65:
#line 469 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<hilti::Statement> > () = std::vector<hilti::Statement>{}; }
#line 4324 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 66:
#line 471 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<hilti::Statement> > () = std::move(yystack_[1].value.as< std::vector<hilti::Statement> > ()); yylhs.value.as< std::vector<hilti::Statement> > ().push_back(yystack_[0].value.as< hilti::Statement > ()); }
#line 4330 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 67:
#line 472 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<hilti::Statement> > () = std::vector<hilti::Statement>{std::move(yystack_[0].value.as< hilti::Statement > ())}; }
#line 4336 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 68:
#line 474 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Statement > () = std::move(yystack_[1].value.as< hilti::Statement > ()); }
#line 4342 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 69:
#line 475 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Statement > () = std::move(yystack_[0].value.as< hilti::Statement > ()); }
#line 4348 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 70:
#line 476 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Statement > () = hilti::statement::Assert(std::move(yystack_[1].value.as< hilti::Expression > ()), {}, __loc__); }
#line 4354 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 71:
#line 477 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Statement > () = hilti::statement::Assert(std::move(yystack_[3].value.as< hilti::Expression > ()), std::move(yystack_[1].value.as< hilti::Expression > ()), __loc__); }
#line 4360 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 72:
#line 478 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Statement > () = hilti::statement::Assert(hilti::statement::assert::Exception(), std::move(yystack_[1].value.as< hilti::Expression > ()), {}, {}, __loc__); }
#line 4366 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 73:
#line 480 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Statement > () = hilti::statement::Assert(hilti::statement::assert::Exception(), std::move(yystack_[3].value.as< hilti::Expression > ()), {}, std::move(yystack_[1].value.as< hilti::Expression > ()), __loc__); }
#line 4372 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 74:
#line 481 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Statement > () = hilti::statement::Break(__loc__); }
#line 4378 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 75:
#line 482 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Statement > () = hilti::statement::Continue(__loc__); }
#line 4384 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 76:
#line 484 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Statement > () = hilti::statement::For(std::move(yystack_[4].value.as< hilti::ID > ()), std::move(yystack_[2].value.as< hilti::Expression > ()), std::move(yystack_[0].value.as< hilti::Statement > ()), __loc__); }
#line 4390 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 77:
#line 486 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Statement > () = hilti::statement::If(std::move(yystack_[3].value.as< hilti::Expression > ()), std::move(yystack_[1].value.as< hilti::Statement > ()), std::move(yystack_[0].value.as< std::optional<hilti::Statement> > ()), __loc__); }
#line 4396 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 78:
#line 488 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Statement > () = hilti::statement::If(std::move(yystack_[3].value.as< hilti::Declaration > ()), {}, std::move(yystack_[1].value.as< hilti::Statement > ()), std::move(yystack_[0].value.as< std::optional<hilti::Statement> > ()), __loc__); }
#line 4402 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 79:
#line 490 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Statement > () = hilti::statement::If(std::move(yystack_[5].value.as< hilti::Declaration > ()), std::move(yystack_[3].value.as< hilti::Expression > ()), std::move(yystack_[1].value.as< hilti::Statement > ()), std::move(yystack_[0].value.as< std::optional<hilti::Statement> > ()), __loc__); }
#line 4408 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 80:
#line 491 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Statement > () = spicy::statement::Print(std::move(yystack_[1].value.as< std::vector<hilti::Expression> > ()), __loc__); }
#line 4414 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 81:
#line 492 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Statement > () = hilti::statement::Return(__loc__); }
#line 4420 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 82:
#line 493 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Statement > () = hilti::statement::Return(std::move(yystack_[1].value.as< hilti::Expression > ()), __loc__); }
#line 4426 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 83:
#line 494 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Statement > () = spicy::statement::Stop(__loc__); }
#line 4432 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 84:
#line 495 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Statement > () = hilti::statement::Throw(hilti::builder::exception(hilti::builder::typeByID("spicy_rt::ParseError"), yystack_[1].value.as< hilti::Expression > (), __loc__), __loc__); }
#line 4438 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 85:
#line 497 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Statement > () = hilti::statement::Switch(std::move(yystack_[4].value.as< hilti::Expression > ()), std::move(yystack_[1].value.as< std::vector<hilti::statement::switch_::Case> > ()), __loc__); }
#line 4444 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 86:
#line 499 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Statement > () = hilti::statement::Switch(std::move(yystack_[4].value.as< hilti::Declaration > ()), std::move(yystack_[1].value.as< std::vector<hilti::statement::switch_::Case> > ()), __loc__); }
#line 4450 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 87:
#line 500 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Statement > () = spicy::statement::Confirm(__loc__); }
#line 4456 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 88:
#line 501 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Statement > () = spicy::statement::Reject(__loc__); }
#line 4462 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 89:
#line 503 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Statement > () = hilti::statement::While(std::move(yystack_[4].value.as< hilti::Declaration > ()), std::move(yystack_[2].value.as< hilti::Expression > ()), std::move(yystack_[0].value.as< hilti::Statement > ()), std::nullopt, __loc__); }
#line 4468 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 90:
#line 505 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Statement > () = hilti::statement::While(std::move(yystack_[2].value.as< hilti::Expression > ()), std::move(yystack_[0].value.as< hilti::Statement > ()), std::nullopt, __loc__); }
#line 4474 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 91:
#line 507 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Statement > () = hilti::statement::While(std::move(yystack_[2].value.as< hilti::Declaration > ()), {}, std::move(yystack_[0].value.as< hilti::Statement > ()), std::nullopt, __loc__); }
#line 4480 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 92:
#line 509 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { auto op = yystack_[1].value.as< hilti::Expression > ().tryAs<hilti::expression::UnresolvedOperator>();
                                                   if ( ! (op && op->kind() == hilti::operator_::Kind::Index) )
                                                        error(yylhs.location, "'add' must be used with index expression only");

                                                   auto expr = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::Add, op->operands(), __loc__);
                                                   yylhs.value.as< hilti::Statement > () = hilti::statement::Expression(std::move(expr), __loc__);
                                                 }
#line 4492 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 93:
#line 517 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { auto op = yystack_[1].value.as< hilti::Expression > ().tryAs<hilti::expression::UnresolvedOperator>();
                                                   if ( ! (op && op->kind() == hilti::operator_::Kind::Index) )
                                                        error(yylhs.location, "'delete' must be used with index expressions only");

                                                   auto expr = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::Delete, op->operands(), __loc__);
                                                   yylhs.value.as< hilti::Statement > () = hilti::statement::Expression(std::move(expr), __loc__);
                                                 }
#line 4504 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 94:
#line 525 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { auto op = yystack_[1].value.as< hilti::Expression > ().tryAs<hilti::expression::UnresolvedOperator>();
                                                   if ( ! (op && op->kind() == hilti::operator_::Kind::Member) )
                                                        error(yylhs.location, "'unset' must be used with member expressions only");

                                                   auto expr = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::Unset, op->operands(), __loc__);
                                                   yylhs.value.as< hilti::Statement > () = hilti::statement::Expression(std::move(expr), __loc__);
                                                 }
#line 4516 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 95:
#line 536 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::optional<hilti::Statement> > () = std::move(yystack_[0].value.as< hilti::Statement > ()); }
#line 4522 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 96:
#line 537 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::optional<hilti::Statement> > () = {}; }
#line 4528 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 97:
#line 539 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<hilti::statement::switch_::Case> > () = std::move(yystack_[1].value.as< std::vector<hilti::statement::switch_::Case> > ()); yylhs.value.as< std::vector<hilti::statement::switch_::Case> > ().push_back(std::move(yystack_[0].value.as< hilti::statement::switch_::Case > ())); }
#line 4534 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 98:
#line 540 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<hilti::statement::switch_::Case> > () = std::vector<hilti::statement::switch_::Case>({ std::move(yystack_[0].value.as< hilti::statement::switch_::Case > ()) }); }
#line 4540 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 99:
#line 542 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::statement::switch_::Case > () = hilti::statement::switch_::Case(std::move(yystack_[2].value.as< std::vector<hilti::Expression> > ()), std::move(yystack_[0].value.as< hilti::Statement > ()), __loc__); }
#line 4546 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 100:
#line 543 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::statement::switch_::Case > () = hilti::statement::switch_::Case(hilti::statement::switch_::Default(), std::move(yystack_[0].value.as< hilti::Statement > ()), __loc__); }
#line 4552 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 101:
#line 545 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Statement > () = hilti::statement::Declaration(yystack_[0].value.as< hilti::Declaration > (), __loc__); }
#line 4558 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 102:
#line 546 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Statement > () = hilti::statement::Declaration(yystack_[0].value.as< hilti::Declaration > (), __loc__); }
#line 4564 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 103:
#line 547 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Statement > () = hilti::statement::Declaration(yystack_[0].value.as< hilti::Declaration > (), __loc__); }
#line 4570 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 104:
#line 550 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Statement > () = hilti::statement::Expression(yystack_[0].value.as< hilti::Expression > (), __loc__); }
#line 4576 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 105:
#line 555 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = hilti::type::Any(__loc__); }
#line 4582 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 106:
#line 556 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = hilti::type::Address(__loc__); }
#line 4588 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 107:
#line 557 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = hilti::type::Bool(__loc__); }
#line 4594 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 108:
#line 558 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = hilti::type::Bytes(__loc__); }
#line 4600 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 109:
#line 559 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = hilti::type::Interval(__loc__); }
#line 4606 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 110:
#line 560 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = hilti::type::Network(__loc__); }
#line 4612 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 111:
#line 561 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = hilti::type::Port(__loc__); }
#line 4618 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 112:
#line 562 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = hilti::type::Real(__loc__); }
#line 4624 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 113:
#line 563 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = hilti::type::RegExp(__loc__); }
#line 4630 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 114:
#line 564 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = hilti::type::Stream(__loc__); }
#line 4636 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 115:
#line 565 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = hilti::type::String(__loc__); }
#line 4642 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 116:
#line 566 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = hilti::type::Time(__loc__); }
#line 4648 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 117:
#line 567 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = hilti::type::void_; }
#line 4654 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 118:
#line 569 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = hilti::type::SignedInteger(8, __loc__); }
#line 4660 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 119:
#line 570 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = hilti::type::SignedInteger(16, __loc__); }
#line 4666 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 120:
#line 571 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = hilti::type::SignedInteger(32, __loc__); }
#line 4672 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 121:
#line 572 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = hilti::type::SignedInteger(64, __loc__); }
#line 4678 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 122:
#line 573 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = hilti::type::UnsignedInteger(8, __loc__); }
#line 4684 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 123:
#line 574 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = hilti::type::UnsignedInteger(16, __loc__); }
#line 4690 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 124:
#line 575 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = hilti::type::UnsignedInteger(32, __loc__); }
#line 4696 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 125:
#line 576 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = hilti::type::UnsignedInteger(64, __loc__); }
#line 4702 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 126:
#line 578 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = iteratorForType(std::move(yystack_[1].value.as< hilti::Type > ()), true, __loc__); }
#line 4708 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 127:
#line 579 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = iteratorForType(std::move(yystack_[1].value.as< hilti::Type > ()), false, __loc__); }
#line 4714 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 128:
#line 580 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = hilti::type::Optional(yystack_[1].value.as< hilti::Type > (), __loc__); }
#line 4720 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 129:
#line 581 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = viewForType(std::move(yystack_[1].value.as< hilti::Type > ()), __loc__); }
#line 4726 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 130:
#line 583 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = hilti::type::Map(std::move(yystack_[3].value.as< hilti::Type > ()), std::move(yystack_[1].value.as< hilti::Type > ()), __loc__); }
#line 4732 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 131:
#line 584 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = hilti::type::Set(std::move(yystack_[1].value.as< hilti::Type > ()), __loc__); }
#line 4738 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 132:
#line 585 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = hilti::type::Vector(std::move(yystack_[1].value.as< hilti::Type > ()), __loc__); }
#line 4744 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 133:
#line 587 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = spicy::type::Sink(__loc__); }
#line 4750 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 134:
#line 589 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = hilti::type::Library(std::move(yystack_[1].value.as< std::string > ()), __loc__); }
#line 4756 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 135:
#line 591 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = std::move(yystack_[0].value.as< hilti::Type > ()); }
#line 4762 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 136:
#line 592 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = std::move(yystack_[0].value.as< hilti::Type > ()); }
#line 4768 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 137:
#line 593 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = std::move(yystack_[0].value.as< hilti::Type > ()); }
#line 4774 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 138:
#line 594 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = std::move(yystack_[0].value.as< hilti::Type > ()); }
#line 4780 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 139:
#line 595 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = std::move(yystack_[0].value.as< hilti::Type > ()); }
#line 4786 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 140:
#line 600 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = hilti::type::StrongReference(std::move(yystack_[1].value.as< hilti::Type > ()), __loc__); }
#line 4792 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 141:
#line 602 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = std::move(yystack_[0].value.as< hilti::Type > ()); }
#line 4798 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 142:
#line 603 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = hilti::type::StrongReference(std::move(yystack_[1].value.as< hilti::Type > ()), __loc__); }
#line 4804 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 143:
#line 606 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = std::move(yystack_[0].value.as< hilti::Type > ()); }
#line 4810 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 144:
#line 607 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = std::move(yystack_[0].value.as< hilti::Type > ()); }
#line 4816 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 145:
#line 608 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = hilti::type::UnresolvedID(std::move(yystack_[0].value.as< hilti::ID > ())); }
#line 4822 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 146:
#line 613 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { driver->disableExpressionMode(); }
#line 4828 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 147:
#line 617 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { driver->enableExpressionMode(); }
#line 4834 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 148:
#line 619 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = hilti::type::Tuple(hilti::type::Wildcard(), __loc__); }
#line 4840 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 149:
#line 620 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = hilti::type::Tuple(std::move(yystack_[1].value.as< std::vector<hilti::type::tuple::Element> > ()), __loc__); }
#line 4846 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 150:
#line 625 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<hilti::type::tuple::Element> > () = std::move(yystack_[2].value.as< std::vector<hilti::type::tuple::Element> > ()); yylhs.value.as< std::vector<hilti::type::tuple::Element> > ().push_back(std::move(yystack_[0].value.as< hilti::type::tuple::Element > ())); }
#line 4852 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 151:
#line 626 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<hilti::type::tuple::Element> > () = std::move(yystack_[1].value.as< std::vector<hilti::type::tuple::Element> > ()); }
#line 4858 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 152:
#line 627 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<hilti::type::tuple::Element> > () = std::vector<type::tuple::Element>{ std::move(yystack_[0].value.as< hilti::type::tuple::Element > ()) }; }
#line 4864 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 153:
#line 631 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::type::tuple::Element > () = type::tuple::Element(std::move(yystack_[0].value.as< hilti::Type > ())); }
#line 4870 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 154:
#line 632 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::type::tuple::Element > () = type::tuple::Element(std::move(yystack_[2].value.as< hilti::ID > ()), std::move(yystack_[0].value.as< hilti::Type > ())); }
#line 4876 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 155:
#line 635 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = hilti::type::Struct(std::move(yystack_[1].value.as< std::vector<hilti::Declaration> > ()), __loc__); }
#line 4882 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 156:
#line 637 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<hilti::Declaration> > () = std::move(yystack_[1].value.as< std::vector<hilti::Declaration> > ()); yylhs.value.as< std::vector<hilti::Declaration> > ().push_back(yystack_[0].value.as< hilti::Declaration > ()); }
#line 4888 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 157:
#line 638 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<hilti::Declaration> > () = std::vector<Declaration>{}; }
#line 4894 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 158:
#line 640 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Declaration > () = hilti::declaration::Field(std::move(yystack_[4].value.as< hilti::ID > ()), std::move(yystack_[2].value.as< hilti::Type > ()), std::move(yystack_[1].value.as< std::optional<hilti::AttributeSet> > ()), __loc__); }
#line 4900 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 159:
#line 642 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = hilti::type::Enum(std::move(yystack_[1].value.as< std::vector<hilti::type::enum_::Label> > ()), __loc__); }
#line 4906 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 160:
#line 644 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<hilti::type::enum_::Label> > () = std::move(yystack_[2].value.as< std::vector<hilti::type::enum_::Label> > ()); yylhs.value.as< std::vector<hilti::type::enum_::Label> > ().push_back(std::move(yystack_[0].value.as< hilti::type::enum_::Label > ())); }
#line 4912 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 161:
#line 645 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<hilti::type::enum_::Label> > () = std::move(yystack_[1].value.as< std::vector<hilti::type::enum_::Label> > ()); }
#line 4918 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 162:
#line 646 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<hilti::type::enum_::Label> > () = std::vector<hilti::type::enum_::Label>(); yylhs.value.as< std::vector<hilti::type::enum_::Label> > ().push_back(std::move(yystack_[0].value.as< hilti::type::enum_::Label > ())); }
#line 4924 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 163:
#line 649 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::type::enum_::Label > () = hilti::type::enum_::Label(std::move(yystack_[0].value.as< hilti::ID > ()), __loc__); }
#line 4930 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 164:
#line 650 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::type::enum_::Label > () = hilti::type::enum_::Label(std::move(yystack_[2].value.as< hilti::ID > ()), yystack_[0].value.as< uint64_t > (), __loc__); }
#line 4936 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 165:
#line 654 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { _field_width = yystack_[1].value.as< uint64_t > (); }
#line 4942 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 166:
#line 656 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = spicy::type::Bitfield(yystack_[5].value.as< uint64_t > (), yystack_[1].value.as< std::vector<spicy::type::bitfield::Bits> > (), __loc__); }
#line 4948 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 167:
#line 660 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<spicy::type::bitfield::Bits> > () = std::move(yystack_[0].value.as< std::vector<spicy::type::bitfield::Bits> > ()); }
#line 4954 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 168:
#line 661 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<spicy::type::bitfield::Bits> > () = std::vector<spicy::type::bitfield::Bits>(); }
#line 4960 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 169:
#line 665 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<spicy::type::bitfield::Bits> > () = std::move(yystack_[1].value.as< std::vector<spicy::type::bitfield::Bits> > ()); yylhs.value.as< std::vector<spicy::type::bitfield::Bits> > ().push_back(std::move(yystack_[0].value.as< spicy::type::bitfield::Bits > ()));  }
#line 4966 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 170:
#line 666 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<spicy::type::bitfield::Bits> > () = std::vector<spicy::type::bitfield::Bits>(); yylhs.value.as< std::vector<spicy::type::bitfield::Bits> > ().push_back(std::move(yystack_[0].value.as< spicy::type::bitfield::Bits > ())); }
#line 4972 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 171:
#line 670 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< spicy::type::bitfield::Bits > () = spicy::type::bitfield::Bits(std::move(yystack_[6].value.as< hilti::ID > ()), yystack_[4].value.as< uint64_t > (), yystack_[2].value.as< uint64_t > (), _field_width, std::move(yystack_[1].value.as< std::optional<hilti::AttributeSet> > ()), __loc__); }
#line 4978 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 172:
#line 672 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< spicy::type::bitfield::Bits > () = spicy::type::bitfield::Bits(std::move(yystack_[4].value.as< hilti::ID > ()), yystack_[2].value.as< uint64_t > (), yystack_[2].value.as< uint64_t > (), _field_width, std::move(yystack_[1].value.as< std::optional<hilti::AttributeSet> > ()), __loc__); }
#line 4984 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 173:
#line 677 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Type > () = spicy::type::Unit(std::move(yystack_[3].value.as< std::vector<hilti::type::function::Parameter> > ()), std::move(yystack_[1].value.as< std::vector<spicy::type::unit::Item> > ()), {}, __loc__); }
#line 4990 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 174:
#line 680 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<hilti::type::function::Parameter> > () = std::move(yystack_[1].value.as< std::vector<hilti::type::function::Parameter> > ()); }
#line 4996 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 175:
#line 681 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<hilti::type::function::Parameter> > () = std::vector<hilti::type::function::Parameter>{}; }
#line 5002 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 176:
#line 683 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<spicy::type::unit::Item> > () = std::move(yystack_[1].value.as< std::vector<spicy::type::unit::Item> > ()); yylhs.value.as< std::vector<spicy::type::unit::Item> > ().push_back(std::move(yystack_[0].value.as< spicy::type::unit::Item > ())); }
#line 5008 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 177:
#line 684 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<spicy::type::unit::Item> > () = std::vector<spicy::type::unit::Item>(); yylhs.value.as< std::vector<spicy::type::unit::Item> > ().push_back(yystack_[0].value.as< spicy::type::unit::Item > ()); }
#line 5014 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 178:
#line 686 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<spicy::type::unit::Item> > () = std::move(yystack_[0].value.as< std::vector<spicy::type::unit::Item> > ());}
#line 5020 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 179:
#line 687 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<spicy::type::unit::Item> > () = std::vector<spicy::type::unit::Item>{}; }
#line 5026 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 180:
#line 690 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< spicy::type::unit::Item > () = std::move(yystack_[0].value.as< spicy::type::unit::Item > ()); }
#line 5032 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 181:
#line 691 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< spicy::type::unit::Item > () = std::move(yystack_[0].value.as< spicy::type::unit::Item > ()); }
#line 5038 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 182:
#line 692 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< spicy::type::unit::Item > () = std::move(yystack_[0].value.as< spicy::type::unit::Item > ()); }
#line 5044 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 183:
#line 693 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< spicy::type::unit::Item > () = std::move(yystack_[0].value.as< spicy::type::unit::Item > ()); }
#line 5050 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 184:
#line 694 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< spicy::type::unit::Item > () = std::move(yystack_[0].value.as< spicy::type::unit::Item > ()); }
#line 5056 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 185:
#line 695 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< spicy::type::unit::Item > () = std::move(yystack_[0].value.as< spicy::type::unit::Item > ()); }
#line 5062 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 186:
#line 700 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< spicy::type::unit::Item > () = spicy::type::unit::item::Variable(std::move(yystack_[5].value.as< hilti::ID > ()), std::move(yystack_[3].value.as< hilti::Type > ()), std::move(yystack_[2].value.as< std::optional<hilti::Expression> > ()), std::move(yystack_[1].value.as< std::optional<hilti::AttributeSet> > ()), __loc__); }
#line 5068 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 187:
#line 702 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< spicy::type::unit::Item > () = spicy::type::unit::item::Sink(std::move(yystack_[2].value.as< hilti::ID > ()), std::move(yystack_[1].value.as< std::optional<hilti::AttributeSet> > ()), __loc__); }
#line 5074 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 188:
#line 704 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< spicy::type::unit::Item > () = type::unit::item::Property(ID(std::move(yystack_[2].value.as< std::string > ())), std::move(yystack_[1].value.as< std::optional<hilti::AttributeSet> > ()), false, __loc__); }
#line 5080 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 189:
#line 706 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< spicy::type::unit::Item > () = type::unit::item::Property(ID(std::move(yystack_[4].value.as< std::string > ())), std::move(yystack_[2].value.as< hilti::Expression > ()), std::move(yystack_[1].value.as< std::optional<hilti::AttributeSet> > ()), false, __loc__); }
#line 5086 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 190:
#line 707 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< spicy::type::unit::Item > () = type::unit::item::Property(ID(std::move(yystack_[3].value.as< std::string > ())), hilti::expression::Type_(std::move(yystack_[1].value.as< hilti::Type > ())), {}, false, __loc__); }
#line 5092 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 191:
#line 711 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    {   if ( yystack_[5].value.as< hilti::Type > ().isA<type::Vector>() )
                                                         error(yylhs.location, "vector<T> syntax is no longer supported for parsing sequences; use T[] instead.");
                                                     yylhs.value.as< spicy::type::unit::Item > () = spicy::type::unit::item::UnresolvedField(std::move(yystack_[7].value.as< std::optional<hilti::ID> > ()), std::move(yystack_[5].value.as< hilti::Type > ()), std::move(yystack_[6].value.as< spicy::Engine > ()), {}, std::move(yystack_[4].value.as< std::optional<hilti::Expression> > ()), std::move(yystack_[1].value.as< std::vector<hilti::Expression> > ()), std::move(yystack_[3].value.as< std::optional<hilti::AttributeSet> > ()), std::move(yystack_[2].value.as< std::optional<hilti::Expression> > ()), std::move(yystack_[0].value.as< std::vector<spicy::Hook> > ()), __loc__);
                                                 }
#line 5101 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 192:
#line 717 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< spicy::type::unit::Item > () = spicy::type::unit::item::UnresolvedField(std::move(yystack_[7].value.as< std::optional<hilti::ID> > ()), std::move(yystack_[5].value.as< hilti::Ctor > ()), std::move(yystack_[6].value.as< spicy::Engine > ()), {}, std::move(yystack_[4].value.as< std::optional<hilti::Expression> > ()), std::move(yystack_[1].value.as< std::vector<hilti::Expression> > ()), std::move(yystack_[3].value.as< std::optional<hilti::AttributeSet> > ()), std::move(yystack_[2].value.as< std::optional<hilti::Expression> > ()), std::move(yystack_[0].value.as< std::vector<spicy::Hook> > ()), __loc__); }
#line 5107 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 193:
#line 720 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< spicy::type::unit::Item > () = spicy::type::unit::item::UnresolvedField(std::move(yystack_[8].value.as< std::optional<hilti::ID> > ()), std::move(yystack_[6].value.as< hilti::ID > ()), std::move(yystack_[7].value.as< spicy::Engine > ()), std::move(yystack_[5].value.as< std::vector<hilti::Expression> > ()), std::move(yystack_[4].value.as< std::optional<hilti::Expression> > ()), std::move(yystack_[1].value.as< std::vector<hilti::Expression> > ()), std::move(yystack_[3].value.as< std::optional<hilti::AttributeSet> > ()), std::move(yystack_[2].value.as< std::optional<hilti::Expression> > ()), std::move(yystack_[0].value.as< std::vector<spicy::Hook> > ()), __loc__); }
#line 5113 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 194:
#line 723 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< spicy::type::unit::Item > () = spicy::type::unit::item::UnresolvedField(std::move(yystack_[9].value.as< std::optional<hilti::ID> > ()), std::move(yystack_[6].value.as< spicy::type::unit::Item > ()), std::move(yystack_[8].value.as< spicy::Engine > ()), {}, std::move(yystack_[4].value.as< std::optional<hilti::Expression> > ()), std::move(yystack_[1].value.as< std::vector<hilti::Expression> > ()), std::move(yystack_[3].value.as< std::optional<hilti::AttributeSet> > ()), std::move(yystack_[2].value.as< std::optional<hilti::Expression> > ()), std::move(yystack_[0].value.as< std::vector<spicy::Hook> > ()), __loc__); }
#line 5119 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 195:
#line 727 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< spicy::type::unit::Item > () = spicy::type::unit::item::UnresolvedField({}, std::move(yystack_[2].value.as< hilti::Ctor > ()), {}, std::move(yystack_[1].value.as< std::vector<hilti::Expression> > ()), {}, {}, std::move(yystack_[0].value.as< std::optional<hilti::AttributeSet> > ()), {}, {}, __loc__); }
#line 5125 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 196:
#line 729 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< spicy::type::unit::Item > () = spicy::type::unit::item::UnresolvedField({}, std::move(yystack_[3].value.as< hilti::ID > ()), {}, std::move(yystack_[2].value.as< std::vector<hilti::Expression> > ()), std::move(yystack_[1].value.as< std::optional<hilti::Expression> > ()), {}, std::move(yystack_[0].value.as< std::optional<hilti::AttributeSet> > ()), {}, {}, __loc__); }
#line 5131 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 197:
#line 731 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< spicy::type::unit::Item > () = spicy::type::unit::item::UnresolvedField({}, std::move(yystack_[3].value.as< hilti::Type > ()), {}, std::move(yystack_[1].value.as< std::vector<hilti::Expression> > ()), std::move(yystack_[2].value.as< std::optional<hilti::Expression> > ()), {}, std::move(yystack_[0].value.as< std::optional<hilti::AttributeSet> > ()), {}, {}, __loc__); }
#line 5137 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 198:
#line 733 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< spicy::type::unit::Item > () = spicy::type::unit::item::UnitHook(std::move(yystack_[1].value.as< hilti::ID > ()), std::move(yystack_[0].value.as< spicy::Hook > ()), __loc__); }
#line 5143 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 199:
#line 736 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::optional<hilti::ID> > () = std::move(yystack_[0].value.as< hilti::ID > ()); }
#line 5149 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 200:
#line 737 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::optional<hilti::ID> > () = std::nullopt; }
#line 5155 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 201:
#line 740 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< spicy::Engine > () = spicy::Engine::All; }
#line 5161 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 202:
#line 741 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< spicy::Engine > () = spicy::Engine::Parser; }
#line 5167 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 203:
#line 742 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< spicy::Engine > () = spicy::Engine::Composer; }
#line 5173 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 204:
#line 743 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< spicy::Engine > () = spicy::Engine::All; }
#line 5179 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 205:
#line 746 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<hilti::Expression> > () = std::move(yystack_[1].value.as< std::vector<hilti::Expression> > ()); }
#line 5185 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 206:
#line 747 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<hilti::Expression> > () = std::vector<hilti::Expression>(); }
#line 5191 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 207:
#line 750 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::optional<hilti::Expression> > () = std::move(yystack_[1].value.as< hilti::Expression > ()); }
#line 5197 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 208:
#line 751 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::optional<hilti::Expression> > () = hilti::builder::null(); }
#line 5203 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 209:
#line 754 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::optional<hilti::Expression> > () = std::move(yystack_[0].value.as< std::optional<hilti::Expression> > ()); }
#line 5209 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 210:
#line 755 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::optional<hilti::Expression> > () = {}; }
#line 5215 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 211:
#line 758 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::optional<hilti::Expression> > () = std::move(yystack_[1].value.as< hilti::Expression > ()); }
#line 5221 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 212:
#line 759 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::optional<hilti::Expression> > () = {}; }
#line 5227 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 213:
#line 762 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<hilti::Expression> > () = std::move(yystack_[0].value.as< std::vector<hilti::Expression> > ()); }
#line 5233 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 214:
#line 763 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<hilti::Expression> > () = std::vector<hilti::Expression>(); }
#line 5239 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 215:
#line 766 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<spicy::Hook> > () = std::move(yystack_[0].value.as< std::vector<spicy::Hook> > ()); }
#line 5245 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 216:
#line 767 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<spicy::Hook> > () = std::vector<spicy::Hook>(); }
#line 5251 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 217:
#line 769 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<spicy::Hook> > () = std::move(yystack_[1].value.as< std::vector<spicy::Hook> > ()); yylhs.value.as< std::vector<spicy::Hook> > ().push_back(std::move(yystack_[0].value.as< spicy::Hook > ())); }
#line 5257 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 218:
#line 770 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<spicy::Hook> > () = std::vector<spicy::Hook>{std::move(yystack_[0].value.as< spicy::Hook > ())}; }
#line 5263 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 219:
#line 773 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< spicy::Hook > () = spicy::Hook(std::move(yystack_[3].value.as< std::vector<hilti::type::function::Parameter> > ()), std::move(yystack_[0].value.as< hilti::Statement > ()), std::move(yystack_[1].value.as< spicy::Engine > ()), std::move(yystack_[2].value.as< std::optional<hilti::AttributeSet> > ()), __loc__); }
#line 5269 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 220:
#line 776 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<hilti::type::function::Parameter> > () = std::move(yystack_[1].value.as< std::vector<hilti::type::function::Parameter> > ()); }
#line 5275 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 221:
#line 777 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<hilti::type::function::Parameter> > () = std::vector<hilti::type::function::Parameter>{}; }
#line 5281 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 222:
#line 781 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::optional<hilti::AttributeSet> > () = hilti::AttributeSet::add(yystack_[1].value.as< std::optional<hilti::AttributeSet> > (), yystack_[0].value.as< hilti::Attribute > ()); }
#line 5287 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 223:
#line 782 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::optional<hilti::AttributeSet> > () = {}; }
#line 5293 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 224:
#line 784 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { driver->enableHookIDMode(); }
#line 5299 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 225:
#line 786 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { driver->disableHookIDMode(); }
#line 5305 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 226:
#line 786 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::ID > () = hilti::ID(hilti::util::replace(yystack_[1].value.as< std::string > (), "%", "0x25_"), __loc__); }
#line 5311 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 227:
#line 789 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Attribute > () = hilti::Attribute("foreach", __loc__); }
#line 5317 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 228:
#line 790 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Attribute > () = hilti::Attribute("priority", std::move(yystack_[0].value.as< hilti::Expression > ()), __loc__); }
#line 5323 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 229:
#line 791 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { if ( yystack_[0].value.as< std::string > () != "%debug" ) error(yylhs.location, "unexpected hook property, only %debug permitted");
                                                   yylhs.value.as< hilti::Attribute > () = hilti::Attribute("%debug", __loc__);
                                                 }
#line 5331 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 230:
#line 796 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< spicy::Engine > () = spicy::Engine::Composer; }
#line 5337 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 231:
#line 797 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< spicy::Engine > () = spicy::Engine::Parser; }
#line 5343 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 232:
#line 798 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< spicy::Engine > () = spicy::Engine::Parser; }
#line 5349 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 233:
#line 801 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< spicy::type::unit::Item > () = spicy::type::unit::item::Switch(std::move(yystack_[6].value.as< std::optional<hilti::Expression> > ()), std::move(yystack_[4].value.as< std::vector<spicy::type::unit::item::switch_::Case> > ()), spicy::Engine::All, std::move(yystack_[1].value.as< std::optional<hilti::Expression> > ()), {}, std::move(yystack_[2].value.as< std::optional<hilti::AttributeSet> > ()), __loc__); }
#line 5355 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 234:
#line 803 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::optional<hilti::Expression> > () = std::move(yystack_[1].value.as< hilti::Expression > ()); }
#line 5361 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 235:
#line 804 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::optional<hilti::Expression> > () = {}; }
#line 5367 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 236:
#line 808 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<spicy::type::unit::item::switch_::Case> > () = std::move(yystack_[1].value.as< std::vector<spicy::type::unit::item::switch_::Case> > ()); yylhs.value.as< std::vector<spicy::type::unit::item::switch_::Case> > ().push_back(std::move(yystack_[0].value.as< spicy::type::unit::item::switch_::Case > ())); }
#line 5373 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 237:
#line 809 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<spicy::type::unit::item::switch_::Case> > () = std::vector<spicy::type::unit::item::switch_::Case>(); yylhs.value.as< std::vector<spicy::type::unit::item::switch_::Case> > ().push_back(std::move(yystack_[0].value.as< spicy::type::unit::item::switch_::Case > ())); }
#line 5379 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 238:
#line 812 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< spicy::type::unit::item::switch_::Case > () = type::unit::item::switch_::Case(yystack_[4].value.as< std::vector<hilti::Expression> > (), yystack_[1].value.as< std::vector<spicy::type::unit::Item> > (), __loc__); }
#line 5385 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 239:
#line 813 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< spicy::type::unit::item::switch_::Case > () = type::unit::item::switch_::Case(yystack_[1].value.as< std::vector<spicy::type::unit::Item> > (), __loc__); }
#line 5391 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 240:
#line 814 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< spicy::type::unit::item::switch_::Case > () = type::unit::item::switch_::Case(yystack_[2].value.as< std::vector<hilti::Expression> > (), {yystack_[0].value.as< spicy::type::unit::Item > ()}, __loc__); }
#line 5397 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 241:
#line 815 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< spicy::type::unit::item::switch_::Case > () = type::unit::item::switch_::Case(std::vector<type::unit::Item>{yystack_[0].value.as< spicy::type::unit::Item > ()}, __loc__); }
#line 5403 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 242:
#line 816 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< spicy::type::unit::item::switch_::Case > () = type::unit::item::switch_::Case(yystack_[0].value.as< spicy::type::unit::Item > (), __loc__); }
#line 5409 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 243:
#line 823 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { driver->enableExpressionMode(); }
#line 5415 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 244:
#line 825 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { driver->disableExpressionMode(); }
#line 5421 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 245:
#line 826 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = std::move(yystack_[1].value.as< hilti::Expression > ()); }
#line 5427 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 246:
#line 829 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<hilti::Expression> > () = std::move(yystack_[0].value.as< std::vector<hilti::Expression> > ()); }
#line 5433 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 247:
#line 830 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<hilti::Expression> > () = std::vector<Expression>(); }
#line 5439 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 248:
#line 832 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<hilti::Expression> > () = std::move(yystack_[2].value.as< std::vector<hilti::Expression> > ()); yylhs.value.as< std::vector<hilti::Expression> > ().push_back(std::move(yystack_[0].value.as< hilti::Expression > ())); }
#line 5445 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 249:
#line 833 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<hilti::Expression> > () = std::vector<Expression>{std::move(yystack_[0].value.as< hilti::Expression > ())}; }
#line 5451 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 250:
#line 835 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = std::move(yystack_[0].value.as< hilti::Expression > ()); }
#line 5457 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 251:
#line 838 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::Assign(std::move(yystack_[2].value.as< hilti::Expression > ()), std::move(yystack_[0].value.as< hilti::Expression > ()), __loc__); }
#line 5463 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 252:
#line 839 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::DifferenceAssign, {std::move(yystack_[2].value.as< hilti::Expression > ()), std::move(yystack_[0].value.as< hilti::Expression > ())}, __loc__); }
#line 5469 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 253:
#line 840 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::SumAssign, {std::move(yystack_[2].value.as< hilti::Expression > ()), std::move(yystack_[0].value.as< hilti::Expression > ())}, __loc__); }
#line 5475 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 254:
#line 841 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::MultipleAssign, {std::move(yystack_[2].value.as< hilti::Expression > ()), std::move(yystack_[0].value.as< hilti::Expression > ())}, __loc__); }
#line 5481 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 255:
#line 842 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::DivisionAssign, {std::move(yystack_[2].value.as< hilti::Expression > ()), std::move(yystack_[0].value.as< hilti::Expression > ())}, __loc__); }
#line 5487 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 256:
#line 843 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::Ternary(std::move(yystack_[4].value.as< hilti::Expression > ()), std::move(yystack_[2].value.as< hilti::Expression > ()), std::move(yystack_[0].value.as< hilti::Expression > ()), __loc__); }
#line 5493 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 257:
#line 844 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = std::move(yystack_[0].value.as< hilti::Expression > ()); }
#line 5499 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 258:
#line 846 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::LogicalOr(std::move(yystack_[2].value.as< hilti::Expression > ()), std::move(yystack_[0].value.as< hilti::Expression > ()), __loc__); }
#line 5505 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 259:
#line 847 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = std::move(yystack_[0].value.as< hilti::Expression > ()); }
#line 5511 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 260:
#line 849 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::LogicalAnd(std::move(yystack_[2].value.as< hilti::Expression > ()), std::move(yystack_[0].value.as< hilti::Expression > ()), __loc__); }
#line 5517 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 261:
#line 850 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = std::move(yystack_[0].value.as< hilti::Expression > ()); }
#line 5523 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 262:
#line 852 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::Equal, {std::move(yystack_[2].value.as< hilti::Expression > ()), std::move(yystack_[0].value.as< hilti::Expression > ())}, __loc__); }
#line 5529 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 263:
#line 853 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::Unequal, {std::move(yystack_[2].value.as< hilti::Expression > ()), std::move(yystack_[0].value.as< hilti::Expression > ())}, __loc__); }
#line 5535 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 264:
#line 854 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = std::move(yystack_[0].value.as< hilti::Expression > ()); }
#line 5541 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 265:
#line 856 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::Lower, {std::move(yystack_[2].value.as< hilti::Expression > ()), std::move(yystack_[0].value.as< hilti::Expression > ())}, __loc__); }
#line 5547 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 266:
#line 857 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::Greater, {std::move(yystack_[2].value.as< hilti::Expression > ()), std::move(yystack_[0].value.as< hilti::Expression > ())}, __loc__); }
#line 5553 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 267:
#line 858 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::GreaterEqual, {std::move(yystack_[2].value.as< hilti::Expression > ()), std::move(yystack_[0].value.as< hilti::Expression > ())}, __loc__); }
#line 5559 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 268:
#line 859 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::LowerEqual, {std::move(yystack_[2].value.as< hilti::Expression > ()), std::move(yystack_[0].value.as< hilti::Expression > ())}, __loc__); }
#line 5565 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 269:
#line 860 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = std::move(yystack_[0].value.as< hilti::Expression > ()); }
#line 5571 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 270:
#line 862 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::BitOr, {std::move(yystack_[2].value.as< hilti::Expression > ()), std::move(yystack_[0].value.as< hilti::Expression > ())}, __loc__); }
#line 5577 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 271:
#line 863 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = std::move(yystack_[0].value.as< hilti::Expression > ()); }
#line 5583 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 272:
#line 865 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::BitXor, {std::move(yystack_[2].value.as< hilti::Expression > ()), std::move(yystack_[0].value.as< hilti::Expression > ())}, __loc__); }
#line 5589 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 273:
#line 866 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = std::move(yystack_[0].value.as< hilti::Expression > ()); }
#line 5595 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 274:
#line 868 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::BitAnd, {std::move(yystack_[2].value.as< hilti::Expression > ()), std::move(yystack_[0].value.as< hilti::Expression > ())}, __loc__); }
#line 5601 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 275:
#line 869 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = std::move(yystack_[0].value.as< hilti::Expression > ()); }
#line 5607 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 276:
#line 871 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::ShiftLeft, {std::move(yystack_[2].value.as< hilti::Expression > ()), std::move(yystack_[0].value.as< hilti::Expression > ())}, __loc__); }
#line 5613 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 277:
#line 872 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::ShiftRight, {std::move(yystack_[2].value.as< hilti::Expression > ()), std::move(yystack_[0].value.as< hilti::Expression > ())}, __loc__); }
#line 5619 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 278:
#line 873 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = std::move(yystack_[0].value.as< hilti::Expression > ()); }
#line 5625 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 279:
#line 875 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::Sum, {std::move(yystack_[2].value.as< hilti::Expression > ()), std::move(yystack_[0].value.as< hilti::Expression > ())}, __loc__); }
#line 5631 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 280:
#line 876 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::Difference, {std::move(yystack_[2].value.as< hilti::Expression > ()), std::move(yystack_[0].value.as< hilti::Expression > ())}, __loc__); }
#line 5637 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 281:
#line 877 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = std::move(yystack_[0].value.as< hilti::Expression > ()); }
#line 5643 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 282:
#line 879 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::Modulo, {std::move(yystack_[2].value.as< hilti::Expression > ()), std::move(yystack_[0].value.as< hilti::Expression > ())}, __loc__); }
#line 5649 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 283:
#line 880 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::Multiple, {std::move(yystack_[2].value.as< hilti::Expression > ()), std::move(yystack_[0].value.as< hilti::Expression > ())}, __loc__); }
#line 5655 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 284:
#line 881 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::Division, {std::move(yystack_[2].value.as< hilti::Expression > ()), std::move(yystack_[0].value.as< hilti::Expression > ())}, __loc__); }
#line 5661 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 285:
#line 882 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::Power, {std::move(yystack_[2].value.as< hilti::Expression > ()), std::move(yystack_[0].value.as< hilti::Expression > ())}, __loc__); }
#line 5667 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 286:
#line 883 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = std::move(yystack_[0].value.as< hilti::Expression > ()); }
#line 5673 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 287:
#line 885 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::LogicalNot(std::move(yystack_[0].value.as< hilti::Expression > ()), __loc__); }
#line 5679 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 288:
#line 886 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::Deref, {std::move(yystack_[0].value.as< hilti::Expression > ())}, __loc__); }
#line 5685 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 289:
#line 887 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::Negate, {std::move(yystack_[0].value.as< hilti::Expression > ())}, __loc__); }
#line 5691 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 290:
#line 888 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::Size, {std::move(yystack_[1].value.as< hilti::Expression > ())}, __loc__); }
#line 5697 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 291:
#line 889 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::DecrPrefix, {std::move(yystack_[0].value.as< hilti::Expression > ())}, __loc__); }
#line 5703 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 292:
#line 890 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::IncrPrefix, {std::move(yystack_[0].value.as< hilti::Expression > ())}, __loc__); }
#line 5709 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 293:
#line 891 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = std::move(yystack_[0].value.as< hilti::Expression > ()); }
#line 5715 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 294:
#line 893 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::Call, {std::move(yystack_[3].value.as< hilti::Expression > ()), hilti::expression::Ctor(hilti::ctor::Tuple(std::move(yystack_[1].value.as< std::vector<hilti::Expression> > ()), __loc__))}, __loc__); }
#line 5721 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 295:
#line 894 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::Member, {std::move(yystack_[2].value.as< hilti::Expression > ()), std::move(yystack_[0].value.as< hilti::Expression > ())}, __loc__); }
#line 5727 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 296:
#line 895 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::MemberCall, {std::move(yystack_[5].value.as< hilti::Expression > ()), std::move(yystack_[3].value.as< hilti::Expression > ()), hilti::expression::Ctor(hilti::ctor::Tuple(std::move(yystack_[1].value.as< std::vector<hilti::Expression> > ()), __loc__))}, __loc__); }
#line 5733 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 297:
#line 896 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::Index, {std::move(yystack_[3].value.as< hilti::Expression > ()), std::move(yystack_[1].value.as< hilti::Expression > ())}, __loc__); }
#line 5739 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 298:
#line 897 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::HasMember, {std::move(yystack_[2].value.as< hilti::Expression > ()), std::move(yystack_[0].value.as< hilti::Expression > ())}, __loc__); }
#line 5745 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 299:
#line 898 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::In, {std::move(yystack_[2].value.as< hilti::Expression > ()), std::move(yystack_[0].value.as< hilti::Expression > ())}, __loc__); }
#line 5751 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 300:
#line 899 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::LogicalNot(hilti::expression::UnresolvedOperator(hilti::operator_::Kind::In, {std::move(yystack_[2].value.as< hilti::Expression > ()), std::move(yystack_[0].value.as< hilti::Expression > ())}, __loc__)); }
#line 5757 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 301:
#line 900 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::DecrPostfix, {std::move(yystack_[1].value.as< hilti::Expression > ())}, __loc__); }
#line 5763 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 302:
#line 901 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::IncrPostfix, {std::move(yystack_[1].value.as< hilti::Expression > ())}, __loc__); }
#line 5769 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 303:
#line 902 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::TryMember, {std::move(yystack_[2].value.as< hilti::Expression > ()), std::move(yystack_[0].value.as< hilti::Expression > ())}, __loc__); }
#line 5775 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 304:
#line 903 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = std::move(yystack_[0].value.as< hilti::Expression > ()); }
#line 5781 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 305:
#line 905 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::Cast, {std::move(yystack_[1].value.as< hilti::Expression > ()), hilti::expression::Type_(std::move(yystack_[4].value.as< hilti::Type > ()))}, __loc__); }
#line 5787 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 306:
#line 906 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::Begin, {std::move(yystack_[1].value.as< hilti::Expression > ())}, __loc__); }
#line 5793 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 307:
#line 907 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::End, {std::move(yystack_[1].value.as< hilti::Expression > ())}, __loc__); }
#line 5799 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 308:
#line 908 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::New, {hilti::expression::Ctor(std::move(yystack_[0].value.as< hilti::Ctor > ()), __loc__), hilti::expression::Ctor(hilti::ctor::Tuple({}, __loc__))}, __loc__); }
#line 5805 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 309:
#line 909 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::New, {hilti::expression::UnresolvedID(std::move(yystack_[0].value.as< hilti::ID > ()), __loc__), hilti::expression::Ctor(hilti::ctor::Tuple({}, __loc__))}, __loc__); }
#line 5811 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 310:
#line 910 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::New, {hilti::expression::UnresolvedID(std::move(yystack_[3].value.as< hilti::ID > ()), __loc__), hilti::expression::Ctor(hilti::ctor::Tuple(std::move(yystack_[1].value.as< std::vector<hilti::Expression> > ()), __loc__))}, __loc__); }
#line 5817 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 311:
#line 911 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = std::move(yystack_[0].value.as< hilti::Expression > ()); }
#line 5823 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 312:
#line 913 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::Ctor(std::move(yystack_[0].value.as< hilti::Ctor > ()), __loc__); }
#line 5829 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 313:
#line 914 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::builder::port(std::move(yystack_[3].value.as< hilti::Expression > ()), std::move(yystack_[1].value.as< hilti::Expression > ()), __loc__); }
#line 5835 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 314:
#line 915 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::SignNeg, {std::move(yystack_[0].value.as< hilti::Expression > ())}, __loc__); }
#line 5841 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 315:
#line 917 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::ListComprehension(std::move(yystack_[1].value.as< hilti::Expression > ()), std::move(yystack_[5].value.as< hilti::Expression > ()), std::move(yystack_[3].value.as< hilti::ID > ()), {},  __loc__); }
#line 5847 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 316:
#line 919 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::ListComprehension(std::move(yystack_[3].value.as< hilti::Expression > ()), std::move(yystack_[7].value.as< hilti::Expression > ()), std::move(yystack_[5].value.as< hilti::ID > ()), std::move(yystack_[1].value.as< hilti::Expression > ()),  __loc__); }
#line 5853 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 317:
#line 920 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = std::move(yystack_[0].value.as< hilti::Expression > ()); }
#line 5859 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 318:
#line 922 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::Grouping(std::move(yystack_[1].value.as< hilti::Expression > ())); }
#line 5865 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 319:
#line 923 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::UnresolvedID(std::move(yystack_[0].value.as< hilti::ID > ()), __loc__); }
#line 5871 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 320:
#line 924 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::UnresolvedID(std::move("__dd"), __loc__);}
#line 5877 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 321:
#line 925 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { // $N -> $@[N] (with $@ being available internally only, not exposed to users)
                                                   auto captures = hilti::expression::Keyword(hilti::expression::keyword::Kind::Captures, hilti::builder::typeByID("hilti::Captures"), __loc__);
                                                   auto index = hilti::expression::Ctor(hilti::ctor::UnsignedInteger(yystack_[0].value.as< uint64_t > (), 64, __loc__), __loc__);
                                                   yylhs.value.as< hilti::Expression > () = hilti::expression::UnresolvedOperator(hilti::operator_::Kind::Index, {std::move(captures), std::move(index)}, __loc__);
                                                 }
#line 5887 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 322:
#line 931 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::Member(std::move(yystack_[0].value.as< hilti::ID > ()), __loc__); }
#line 5893 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 323:
#line 935 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Ctor > () = hilti::ctor::Address(hilti::ctor::Address::Value(yystack_[0].value.as< std::string > ()), __loc__); }
#line 5899 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 324:
#line 936 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Ctor > () = hilti::ctor::Network(hilti::ctor::Network::Value(yystack_[2].value.as< std::string > (), yystack_[0].value.as< uint64_t > ()), __loc__); }
#line 5905 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 325:
#line 937 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Ctor > () = hilti::ctor::Bool(yystack_[0].value.as< bool > (), __loc__); }
#line 5911 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 326:
#line 938 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Ctor > () = hilti::ctor::Bytes(std::move(yystack_[0].value.as< std::string > ()), __loc__); }
#line 5917 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 327:
#line 939 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Ctor > () = hilti::ctor::Port(hilti::ctor::Port::Value(yystack_[0].value.as< std::string > ()), __loc__); }
#line 5923 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 328:
#line 940 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Ctor > () = hilti::ctor::Null(__loc__); }
#line 5929 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 329:
#line 941 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Ctor > () = hilti::ctor::String(yystack_[0].value.as< std::string > (), __loc__); }
#line 5935 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 330:
#line 943 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Ctor > () = hilti::ctor::Real(yystack_[0].value.as< double > (), __loc__); }
#line 5941 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 331:
#line 944 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Ctor > () = hilti::ctor::UnsignedInteger(yystack_[0].value.as< uint64_t > (), 64, __loc__); }
#line 5947 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 332:
#line 945 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Ctor > () = hilti::ctor::SignedInteger(check_int64_range(yystack_[0].value.as< uint64_t > (), true, __loc__), 64, __loc__); }
#line 5953 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 333:
#line 946 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Ctor > () = hilti::ctor::SignedInteger(-check_int64_range(yystack_[0].value.as< uint64_t > (), false, __loc__), 64, __loc__); }
#line 5959 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 334:
#line 947 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Ctor > () = hilti::ctor::Optional(std::move(yystack_[1].value.as< hilti::Expression > ()), __loc__); }
#line 5965 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 335:
#line 948 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { try { yylhs.value.as< hilti::Ctor > () = hilti::ctor::Interval(hilti::ctor::Interval::Value(yystack_[1].value.as< double > (), hilti::rt::Interval::SecondTag()), __loc__); }
                                                   catch ( hilti::rt::OutOfRange& e ) { yylhs.value.as< hilti::Ctor > () = hilti::ctor::Interval(hilti::ctor::Interval::Value()); error(yylhs.location, e.what()); }
                                                 }
#line 5973 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 336:
#line 951 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { try { yylhs.value.as< hilti::Ctor > () = hilti::ctor::Interval(hilti::ctor::Interval::Value(yystack_[1].value.as< int64_t > (), hilti::rt::Interval::SecondTag()), __loc__); }
                                                   catch ( hilti::rt::OutOfRange& e ) { yylhs.value.as< hilti::Ctor > () = hilti::ctor::Interval(hilti::ctor::Interval::Value()); error(yylhs.location, e.what()); }
                                                 }
#line 5981 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 337:
#line 954 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Ctor > () = hilti::ctor::Interval(hilti::ctor::Interval::Value(yystack_[1].value.as< int64_t > (), hilti::rt::Interval::NanosecondTag()), __loc__); }
#line 5987 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 338:
#line 955 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { try { yylhs.value.as< hilti::Ctor > () = hilti::ctor::Time(hilti::ctor::Time::Value(yystack_[1].value.as< double > (), hilti::rt::Time::SecondTag()), __loc__); }
                                                   catch ( hilti::rt::OutOfRange& e ) { yylhs.value.as< hilti::Ctor > () = hilti::ctor::Time(hilti::ctor::Time::Value()); error(yylhs.location, e.what()); }
                                                 }
#line 5995 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 339:
#line 958 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { try { yylhs.value.as< hilti::Ctor > () = hilti::ctor::Time(hilti::ctor::Time::Value(yystack_[1].value.as< uint64_t > (), hilti::rt::Time::SecondTag()), __loc__); }
                                                   catch ( hilti::rt::OutOfRange& e ) { yylhs.value.as< hilti::Ctor > () = hilti::ctor::Time(hilti::ctor::Time::Value()); error(yylhs.location, e.what()); }
                                                 }
#line 6003 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 340:
#line 961 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Ctor > () = hilti::ctor::Time(hilti::ctor::Time::Value(yystack_[1].value.as< uint64_t > (), hilti::rt::Time::NanosecondTag()), __loc__); }
#line 6009 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 341:
#line 962 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Ctor > () = hilti::ctor::Stream(std::move(yystack_[1].value.as< std::string > ()), __loc__); }
#line 6015 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 342:
#line 964 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Ctor > () = hilti::ctor::UnsignedInteger(yystack_[1].value.as< uint64_t > (), 8, __loc__); }
#line 6021 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 343:
#line 965 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Ctor > () = hilti::ctor::UnsignedInteger(yystack_[1].value.as< uint64_t > (), 16, __loc__); }
#line 6027 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 344:
#line 966 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Ctor > () = hilti::ctor::UnsignedInteger(yystack_[1].value.as< uint64_t > (), 32, __loc__); }
#line 6033 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 345:
#line 967 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Ctor > () = hilti::ctor::UnsignedInteger(yystack_[1].value.as< uint64_t > (), 64, __loc__); }
#line 6039 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 346:
#line 968 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Ctor > () = hilti::ctor::SignedInteger(yystack_[1].value.as< int64_t > (), 8, __loc__); }
#line 6045 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 347:
#line 969 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Ctor > () = hilti::ctor::SignedInteger(yystack_[1].value.as< int64_t > (), 16, __loc__); }
#line 6051 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 348:
#line 970 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Ctor > () = hilti::ctor::SignedInteger(yystack_[1].value.as< int64_t > (), 32, __loc__); }
#line 6057 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 349:
#line 971 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Ctor > () = hilti::ctor::SignedInteger(yystack_[1].value.as< int64_t > (), 64, __loc__); }
#line 6063 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 350:
#line 973 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Ctor > () = std::move(yystack_[0].value.as< hilti::Ctor > ()); }
#line 6069 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 351:
#line 974 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Ctor > () = std::move(yystack_[0].value.as< hilti::Ctor > ()); }
#line 6075 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 352:
#line 975 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Ctor > () = std::move(yystack_[0].value.as< hilti::Ctor > ()); }
#line 6081 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 353:
#line 976 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Ctor > () = std::move(yystack_[0].value.as< hilti::Ctor > ()); }
#line 6087 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 354:
#line 977 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Ctor > () = std::move(yystack_[0].value.as< hilti::Ctor > ()); }
#line 6093 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 355:
#line 978 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Ctor > () = std::move(yystack_[0].value.as< hilti::Ctor > ()); }
#line 6099 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 356:
#line 979 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Ctor > () = std::move(yystack_[0].value.as< hilti::Ctor > ()); }
#line 6105 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 357:
#line 982 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< double > () = yystack_[0].value.as< double > (); }
#line 6111 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 358:
#line 983 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< double > () = yystack_[0].value.as< double > (); }
#line 6117 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 359:
#line 984 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< double > () = -yystack_[0].value.as< double > (); }
#line 6123 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 360:
#line 986 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< int64_t > () = check_int64_range(yystack_[0].value.as< uint64_t > (), true, __loc__); }
#line 6129 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 361:
#line 987 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< int64_t > () = check_int64_range(yystack_[0].value.as< uint64_t > (), true, __loc__); }
#line 6135 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 362:
#line 988 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< int64_t > () = -check_int64_range(yystack_[0].value.as< uint64_t > (), false, __loc__); }
#line 6141 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 363:
#line 990 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< uint64_t > () = yystack_[0].value.as< uint64_t > (); }
#line 6147 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 364:
#line 991 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< uint64_t > () = yystack_[0].value.as< uint64_t > (); }
#line 6153 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 365:
#line 993 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Ctor > () = hilti::ctor::Tuple(std::move(yystack_[1].value.as< std::vector<hilti::Expression> > ()), __loc__); }
#line 6159 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 366:
#line 994 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Ctor > () = hilti::ctor::Tuple(std::move(yystack_[1].value.as< std::vector<hilti::Expression> > ()), __loc__); }
#line 6165 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 367:
#line 997 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<hilti::Expression> > () = std::vector<hilti::Expression>{std::move(yystack_[0].value.as< hilti::Expression > ())}; }
#line 6171 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 368:
#line 998 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<hilti::Expression> > () = std::vector<hilti::Expression>{std::move(yystack_[2].value.as< hilti::Expression > ())}; yylhs.value.as< std::vector<hilti::Expression> > ().insert(yylhs.value.as< std::vector<hilti::Expression> > ().end(), yystack_[0].value.as< std::vector<hilti::Expression> > ().begin(), yystack_[0].value.as< std::vector<hilti::Expression> > ().end()); }
#line 6177 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 369:
#line 999 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<hilti::Expression> > () = std::vector<hilti::Expression>(); }
#line 6183 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 370:
#line 1002 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<hilti::Expression> > () = std::vector<hilti::Expression>{ std::move(yystack_[0].value.as< hilti::Expression > ())}; }
#line 6189 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 371:
#line 1003 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<hilti::Expression> > () = std::vector<hilti::Expression>{std::move(yystack_[2].value.as< hilti::Expression > ())}; yylhs.value.as< std::vector<hilti::Expression> > ().insert(yylhs.value.as< std::vector<hilti::Expression> > ().end(), yystack_[0].value.as< std::vector<hilti::Expression> > ().begin(), yystack_[0].value.as< std::vector<hilti::Expression> > ().end()); }
#line 6195 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 372:
#line 1004 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<hilti::Expression> > () = std::vector<hilti::Expression>{ std::move(yystack_[0].value.as< hilti::Expression > ())}; }
#line 6201 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 373:
#line 1005 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<hilti::Expression> > () = std::vector<hilti::Expression>(); }
#line 6207 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 374:
#line 1008 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = std::move(yystack_[0].value.as< hilti::Expression > ()); }
#line 6213 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 375:
#line 1009 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Expression > () = hilti::expression::Ctor(hilti::ctor::Null(__loc__), __loc__); }
#line 6219 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 376:
#line 1011 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Ctor > () = hilti::ctor::List(std::move(yystack_[1].value.as< std::vector<hilti::Expression> > ()), __loc__); }
#line 6225 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 377:
#line 1012 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Ctor > () = hilti::ctor::List(std::move(yystack_[1].value.as< std::vector<hilti::Expression> > ()), __loc__); }
#line 6231 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 378:
#line 1014 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Ctor > () = hilti::ctor::List(std::move(yystack_[4].value.as< hilti::Type > ()), std::move(yystack_[1].value.as< std::vector<hilti::Expression> > ()), __loc__); }
#line 6237 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 379:
#line 1016 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Ctor > () = hilti::ctor::Vector(std::move(yystack_[1].value.as< std::vector<hilti::Expression> > ()), __loc__); }
#line 6243 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 380:
#line 1018 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Ctor > () = hilti::ctor::Vector(std::move(yystack_[4].value.as< hilti::Type > ()), std::move(yystack_[1].value.as< std::vector<hilti::Expression> > ()), __loc__); }
#line 6249 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 381:
#line 1020 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Ctor > () = hilti::ctor::Set(std::move(yystack_[1].value.as< std::vector<hilti::Expression> > ()), __loc__); }
#line 6255 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 382:
#line 1022 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Ctor > () = hilti::ctor::Set(std::move(yystack_[4].value.as< hilti::Type > ()), std::move(yystack_[1].value.as< std::vector<hilti::Expression> > ()), __loc__); }
#line 6261 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 383:
#line 1024 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Ctor > () = hilti::ctor::Map(std::move(yystack_[1].value.as< std::vector<hilti::ctor::map::Element> > ()), __loc__); }
#line 6267 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 384:
#line 1026 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Ctor > () = hilti::ctor::Map(std::move(yystack_[6].value.as< hilti::Type > ()), std::move(yystack_[4].value.as< hilti::Type > ()), std::move(yystack_[1].value.as< std::vector<hilti::ctor::map::Element> > ()), __loc__); }
#line 6273 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 385:
#line 1028 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Ctor > () = hilti::ctor::Struct(std::move(yystack_[1].value.as< std::vector<hilti::ctor::struct_::Field> > ()), __loc__); }
#line 6279 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 386:
#line 1031 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<hilti::ctor::struct_::Field> > () = std::move(yystack_[2].value.as< std::vector<hilti::ctor::struct_::Field> > ()); yylhs.value.as< std::vector<hilti::ctor::struct_::Field> > ().push_back(yystack_[0].value.as< hilti::ctor::struct_::Field > ()); }
#line 6285 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 387:
#line 1032 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<hilti::ctor::struct_::Field> > () = std::vector<hilti::ctor::struct_::Field>{ std::move(yystack_[0].value.as< hilti::ctor::struct_::Field > ()) }; }
#line 6291 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 388:
#line 1034 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::ctor::struct_::Field > () = hilti::ctor::struct_::Field(hilti::ID(std::move(yystack_[2].value.as< std::string > ())), std::move(yystack_[0].value.as< hilti::Expression > ())); }
#line 6297 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 389:
#line 1036 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Ctor > () = hilti::ctor::RegExp(std::move(yystack_[0].value.as< std::vector<std::string> > ()), {}, __loc__); }
#line 6303 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 390:
#line 1039 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<std::string> > () = yystack_[2].value.as< std::vector<std::string> > (); yylhs.value.as< std::vector<std::string> > ().push_back(std::move(yystack_[0].value.as< std::string > ())); }
#line 6309 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 391:
#line 1040 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<std::string> > () = std::vector<std::string>{std::move(yystack_[0].value.as< std::string > ())}; }
#line 6315 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 392:
#line 1043 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { driver->enablePatternMode(); }
#line 6321 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 393:
#line 1043 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { driver->disablePatternMode(); }
#line 6327 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 394:
#line 1044 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::string > () = std::move(yystack_[2].value.as< std::string > ()); }
#line 6333 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 395:
#line 1046 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<hilti::ctor::map::Element> > () = std::move(yystack_[0].value.as< std::vector<hilti::ctor::map::Element> > ()); }
#line 6339 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 396:
#line 1047 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<hilti::ctor::map::Element> > () = std::vector<hilti::ctor::map::Element>(); }
#line 6345 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 397:
#line 1049 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<hilti::ctor::map::Element> > () = std::move(yystack_[2].value.as< std::vector<hilti::ctor::map::Element> > ()); yylhs.value.as< std::vector<hilti::ctor::map::Element> > ().push_back(std::move(yystack_[0].value.as< hilti::ctor::map::Element > ())); }
#line 6351 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 398:
#line 1050 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::vector<hilti::ctor::map::Element> > () = std::vector<hilti::ctor::map::Element>(); yylhs.value.as< std::vector<hilti::ctor::map::Element> > ().push_back(std::move(yystack_[0].value.as< hilti::ctor::map::Element > ())); }
#line 6357 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 399:
#line 1052 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::ctor::map::Element > () = hilti::ctor::map::Element(yystack_[2].value.as< hilti::Expression > (), yystack_[0].value.as< hilti::Expression > ()); }
#line 6363 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 400:
#line 1056 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Attribute > () = hilti::Attribute(std::move(yystack_[0].value.as< std::string > ()), __loc__); }
#line 6369 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 401:
#line 1057 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< hilti::Attribute > () = hilti::Attribute(std::move(yystack_[2].value.as< std::string > ()), std::move(yystack_[0].value.as< hilti::Expression > ()), __loc__); }
#line 6375 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 402:
#line 1060 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::optional<hilti::AttributeSet> > () = hilti::AttributeSet::add(yystack_[1].value.as< std::optional<hilti::AttributeSet> > (), yystack_[0].value.as< hilti::Attribute > ()); }
#line 6381 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;

  case 403:
#line 1061 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:859
    { yylhs.value.as< std::optional<hilti::AttributeSet> > () = {}; }
#line 6387 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
    break;


#line 6391 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:859
            default:
              break;
            }
        }
      catch (const syntax_error& yyexc)
        {
          error (yyexc);
          YYERROR;
        }
      YY_SYMBOL_PRINT ("-> $$ =", yylhs);
      yypop_ (yylen);
      yylen = 0;
      YY_STACK_PRINT ();

      // Shift the result of the reduction.
      yypush_ (YY_NULLPTR, yylhs);
    }
    goto yynewstate;

  /*--------------------------------------.
  | yyerrlab -- here on detecting error.  |
  `--------------------------------------*/
  yyerrlab:
    // If not already recovering from an error, report this error.
    if (!yyerrstatus_)
      {
        ++yynerrs_;
        error (yyla.location, yysyntax_error_ (yystack_[0].state, yyla));
      }


    yyerror_range[1].location = yyla.location;
    if (yyerrstatus_ == 3)
      {
        /* If just tried and failed to reuse lookahead token after an
           error, discard it.  */

        // Return failure if at end of input.
        if (yyla.type_get () == yyeof_)
          YYABORT;
        else if (!yyla.empty ())
          {
            yy_destroy_ ("Error: discarding", yyla);
            yyla.clear ();
          }
      }

    // Else will try to reuse lookahead token after shifting the error token.
    goto yyerrlab1;


  /*---------------------------------------------------.
  | yyerrorlab -- error raised explicitly by YYERROR.  |
  `---------------------------------------------------*/
  yyerrorlab:

    /* Pacify compilers like GCC when the user code never invokes
       YYERROR and the label yyerrorlab therefore never appears in user
       code.  */
    if (false)
      goto yyerrorlab;
    yyerror_range[1].location = yystack_[yylen - 1].location;
    /* Do not reclaim the symbols of the rule whose action triggered
       this YYERROR.  */
    yypop_ (yylen);
    yylen = 0;
    goto yyerrlab1;

  /*-------------------------------------------------------------.
  | yyerrlab1 -- common code for both syntax error and YYERROR.  |
  `-------------------------------------------------------------*/
  yyerrlab1:
    yyerrstatus_ = 3;   // Each real token shifted decrements this.
    {
      stack_symbol_type error_token;
      for (;;)
        {
          yyn = yypact_[yystack_[0].state];
          if (!yy_pact_value_is_default_ (yyn))
            {
              yyn += yyterror_;
              if (0 <= yyn && yyn <= yylast_ && yycheck_[yyn] == yyterror_)
                {
                  yyn = yytable_[yyn];
                  if (0 < yyn)
                    break;
                }
            }

          // Pop the current state because it cannot handle the error token.
          if (yystack_.size () == 1)
            YYABORT;

          yyerror_range[1].location = yystack_[0].location;
          yy_destroy_ ("Error: popping", yystack_[0]);
          yypop_ ();
          YY_STACK_PRINT ();
        }

      yyerror_range[2].location = yyla.location;
      YYLLOC_DEFAULT (error_token.location, yyerror_range, 2);

      // Shift the error token.
      error_token.state = yyn;
      yypush_ ("Shifting", error_token);
    }
    goto yynewstate;

    // Accept.
  yyacceptlab:
    yyresult = 0;
    goto yyreturn;

    // Abort.
  yyabortlab:
    yyresult = 1;
    goto yyreturn;

  yyreturn:
    if (!yyla.empty ())
      yy_destroy_ ("Cleanup: discarding lookahead", yyla);

    /* Do not reclaim the symbols of the rule whose action triggered
       this YYABORT or YYACCEPT.  */
    yypop_ (yylen);
    while (1 < yystack_.size ())
      {
        yy_destroy_ ("Cleanup: popping", yystack_[0]);
        yypop_ ();
      }

    return yyresult;
  }
    catch (...)
      {
        YYCDEBUG << "Exception caught: cleaning lookahead and stack"
                 << std::endl;
        // Do not try to display the values of the reclaimed symbols,
        // as their printer might throw an exception.
        if (!yyla.empty ())
          yy_destroy_ (YY_NULLPTR, yyla);

        while (1 < yystack_.size ())
          {
            yy_destroy_ (YY_NULLPTR, yystack_[0]);
            yypop_ ();
          }
        throw;
      }
  }

  void
  Parser::error (const syntax_error& yyexc)
  {
    error (yyexc.location, yyexc.what());
  }

  // Generate an error message.
  std::string
  Parser::yysyntax_error_ (state_type yystate, const symbol_type& yyla) const
  {
    // Number of reported tokens (one for the "unexpected", one per
    // "expected").
    size_t yycount = 0;
    // Its maximum.
    enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
    // Arguments of yyformat.
    char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];

    /* There are many possibilities here to consider:
       - If this state is a consistent state with a default action, then
         the only way this function was invoked is if the default action
         is an error action.  In that case, don't check for expected
         tokens because there are none.
       - The only way there can be no lookahead present (in yyla) is
         if this state is a consistent state with a default action.
         Thus, detecting the absence of a lookahead is sufficient to
         determine that there is no unexpected or expected token to
         report.  In that case, just report a simple "syntax error".
       - Don't assume there isn't a lookahead just because this state is
         a consistent state with a default action.  There might have
         been a previous inconsistent state, consistent state with a
         non-default action, or user semantic action that manipulated
         yyla.  (However, yyla is currently not documented for users.)
       - Of course, the expected token list depends on states to have
         correct lookahead information, and it depends on the parser not
         to perform extra reductions after fetching a lookahead from the
         scanner and before detecting a syntax error.  Thus, state
         merging (from LALR or IELR) and default reductions corrupt the
         expected token list.  However, the list is correct for
         canonical LR with one exception: it will still contain any
         token that will not be accepted due to an error action in a
         later state.
    */
    if (!yyla.empty ())
      {
        int yytoken = yyla.type_get ();
        yyarg[yycount++] = yytname_[yytoken];
        int yyn = yypact_[yystate];
        if (!yy_pact_value_is_default_ (yyn))
          {
            /* Start YYX at -YYN if negative to avoid negative indexes in
               YYCHECK.  In other words, skip the first -YYN actions for
               this state because they are default actions.  */
            int yyxbegin = yyn < 0 ? -yyn : 0;
            // Stay within bounds of both yycheck and yytname.
            int yychecklim = yylast_ - yyn + 1;
            int yyxend = yychecklim < yyntokens_ ? yychecklim : yyntokens_;
            for (int yyx = yyxbegin; yyx < yyxend; ++yyx)
              if (yycheck_[yyx + yyn] == yyx && yyx != yyterror_
                  && !yy_table_value_is_error_ (yytable_[yyx + yyn]))
                {
                  if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                    {
                      yycount = 1;
                      break;
                    }
                  else
                    yyarg[yycount++] = yytname_[yyx];
                }
          }
      }

    char const* yyformat = YY_NULLPTR;
    switch (yycount)
      {
#define YYCASE_(N, S)                         \
        case N:                               \
          yyformat = S;                       \
        break
        YYCASE_(0, YY_("syntax error"));
        YYCASE_(1, YY_("syntax error, unexpected %s"));
        YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
        YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
        YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
        YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
#undef YYCASE_
      }

    std::string yyres;
    // Argument number.
    size_t yyi = 0;
    for (char const* yyp = yyformat; *yyp; ++yyp)
      if (yyp[0] == '%' && yyp[1] == 's' && yyi < yycount)
        {
          yyres += yytnamerr_ (yyarg[yyi++]);
          ++yyp;
        }
      else
        yyres += *yyp;
    return yyres;
  }


  const short int Parser::yypact_ninf_ = -790;

  const short int Parser::yytable_ninf_ = -397;

  const short int
  Parser::yypact_[] =
  {
     154,   -38,  -790,    71,   131,  -790,  -790,  -790,  1175,  -790,
    -790,   -57,  -790,  -790,  -790,   -17,  -790,  -790,  -790,  -790,
    -790,  -790,    13,    91,  -790,   121,   129,   157,   168,   204,
     215,   228,    27,   140,  1175,  1740,   267,  1175,   303,   141,
     305,   315,   323,   337,   354,   363,   370,   373,   180,   -49,
    1175,     9,  1175,   409,    58,  -790,  1175,  1175,  -790,  -790,
    -790,  -790,   360,   321,    -4,   188,   198,   237,   253,   336,
     293,   -47,  -790,   432,  -790,  -790,  -790,  -790,  -790,  -790,
    -790,  -790,  -790,  -790,  -790,  -790,   330,  -790,  -790,   391,
    -790,  -790,  2056,  -790,    56,    56,    56,    56,    36,    56,
     273,  2056,   377,  2056,  -790,   -49,     9,   439,   379,  -790,
    -790,  -790,  -790,   273,  2056,   485,    42,     0,   273,     0,
       0,     0,     0,   273,  2056,  -790,   381,   382,   383,  -790,
     386,   477,   378,   387,   -64,  -790,   380,  -790,  -790,  -790,
    -790,  -790,  -790,   523,  -790,  -790,  -790,  1175,  1175,  1175,
    1175,  1175,  1175,  -790,  1175,  1175,  1175,  1175,  1175,  1175,
    1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,
    1175,  1175,   131,  1644,  -790,  1644,  -790,   131,   273,  -790,
     131,   374,  1973,  -790,   392,  -790,  -790,   395,  -790,  -790,
    -790,   393,  -790,  -790,  -790,  -790,  -790,    91,    91,   397,
      91,  -790,    91,  -790,  -790,    91,  -790,  -790,  -790,   399,
    -790,    91,  -790,  -790,  -790,  -790,   398,    91,    91,  -790,
    -790,  -790,  -790,  -790,   -81,  -790,  -790,  -790,  -790,  -790,
     403,  -790,   529,   537,   408,   410,   412,   413,   449,   451,
     415,   416,   419,  -790,   420,   -81,   411,   422,   425,  -790,
     165,  -790,   273,   427,   428,   430,   -81,   433,  -790,   456,
     559,   441,   444,   562,   445,   447,   450,   452,   453,   455,
     457,   -81,  -790,  -790,   -29,  -790,   131,  -790,  -790,   589,
    -790,  -790,   459,  -790,  -790,  -790,   321,  -790,  -790,  -790,
     458,    -4,   188,   188,   198,   198,   198,   198,   237,   253,
     336,   293,   293,   -47,   -47,  -790,  -790,  -790,  -790,  -790,
    -790,   528,   582,  -790,   461,   454,   469,  -790,   338,  -790,
    -790,  -790,   475,   480,  -790,   474,   479,   131,   482,  -790,
     483,  -790,  -790,   486,   487,   489,   488,   490,  -790,  -790,
     491,  -790,   846,  1012,  -790,  -790,  -790,  -790,  -790,  -790,
      83,  -790,  -790,   493,  -790,  -790,     0,   131,  2056,  2056,
     621,  2056,  2056,  2056,  -790,  1854,    33,   492,  2056,  2056,
     211,  -790,   494,  -790,  -790,  -790,  -790,  -790,  -790,  -790,
    -790,  -790,  -790,  -790,   496,  -790,  -790,  -790,  2056,   498,
    -790,  -790,  -790,   497,  -790,  -790,  -790,  -790,  -790,  -790,
    -790,  -790,  -790,  -790,  -790,   501,  -790,   343,  -790,   571,
    -790,  -790,   500,  -790,  -790,  -790,   273,  -790,  2271,   182,
     230,   507,  -790,  -790,   508,   131,   574,   -18,   348,   510,
     653,   521,  -790,   522,  -790,   574,  -790,  -790,   526,   530,
     574,   482,  -790,   482,   482,  -790,   534,  -790,   519,   527,
     247,  -790,   -81,   -81,   531,   200,   -81,   -81,    21,   532,
     536,   533,   126,  -790,  -790,   539,   540,  -790,   131,    18,
     -81,   -81,  -790,   -49,  -790,  -790,   -81,  -790,   543,   -49,
     -49,   -29,  -790,  -790,  -790,   544,   549,   553,  -790,  -790,
    -790,  -790,  -790,  -790,   612,   131,   187,   550,  -790,  -790,
    -790,  2056,    33,  -790,  -790,  -790,  -790,  -790,   552,   554,
    -790,  -790,   210,   556,   351,   693,   358,   561,  -790,  -790,
     689,   131,  -790,  -790,  -790,  -790,  2056,  -790,  -790,  -790,
     564,  -790,  -790,  2056,  2056,  -790,  -790,   643,   567,   569,
    -790,   131,   572,   131,  -790,   103,   565,  -790,  -790,  -790,
    -790,  -790,  -790,   -26,  -790,  -790,  -790,   575,   576,   573,
    -790,   583,   586,  -790,   -32,  -790,  -790,  -790,   578,   593,
    -790,   361,  -790,  2188,  2188,   595,   724,   596,   -15,   597,
     241,  -790,   591,   601,  -790,  2188,  2188,  -790,  2056,  -790,
     482,  -790,  2056,  2056,   602,  -790,  -790,   -81,  2056,   533,
    -790,  -790,  2056,  2364,    24,   510,  -790,  -790,   603,   600,
    -790,  -790,  -790,  -790,  -790,  1491,  -790,  -790,   377,  -790,
    -790,  -790,  -790,  -790,  -790,   599,  -790,  2056,   606,   703,
    -790,  -790,     4,   705,  -790,  -790,   706,  -790,  -790,  -790,
    -790,  -790,  -790,  -790,  -790,  -790,  -790,   613,  -790,   609,
     102,   102,   618,  -790,  -790,   617,   -55,   620,   624,   111,
     533,   131,  -790,   533,    -3,   626,  -790,   627,  -790,  -790,
    -790,    29,   623,    55,  2056,   628,   629,   630,   631,   632,
     140,   183,   141,   633,   634,   192,   635,   636,   637,   639,
     180,  1338,   640,   638,   638,   625,   641,  2188,  -790,   120,
    2188,   644,  2099,  -790,  2188,  -790,  -790,  -790,   645,  -790,
    -790,  -790,   642,     8,  -790,    88,  2188,  -790,  -790,    33,
    -790,  -790,  -790,    57,   646,   648,   131,  -790,    70,  -790,
    -790,  -790,    79,  -790,  -790,  -790,   770,   763,    12,  -790,
       7,    -3,  2056,  2056,  2056,   649,   638,   652,   649,   273,
     638,   651,  -790,  -790,  -790,  -790,  -790,  -790,  -790,   747,
    -790,  -790,  -790,  -790,  -790,   245,  2188,  -790,  -790,  -790,
    -790,   657,   658,   667,  -790,     0,  -790,  -790,  -790,  -790,
    -790,  -790,  -790,   172,  -790,  -790,   203,  -790,   258,   -81,
     -81,   638,   649,   638,  -790,   665,  -790,  -790,   661,    52,
      52,  -790,  -790,  2188,  -790,  -790,   668,  -790,   767,   274,
    -790,    52,   340,  -790,    86,  2056,   673,   678,  -790,  -790,
    -790,   817,  -790,    52,  -790,   680,   800,   800,  -790,  2056,
    -790,  -790,     0,    87,   144,   685,   173,  -790,   -81,   817,
     817,    52,   800,  -790,  -790,   269,   269,   533,    20,  -790,
    -790,  -790,  -790,  -790,   683,   800,   269,   686,   387,  -790,
    -790,   161,  -790,  -790,  -790,   101,   269,  -790,  -790,  -790,
    -790,  -790
  };

  const unsigned short int
  Parser::yydefact_[] =
  {
       0,     0,   243,     0,     0,     2,     3,     4,     0,     1,
       6,     0,     8,   329,   326,   323,   327,   357,   331,   321,
     325,   328,     0,     0,   320,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   243,
       0,   243,     0,     0,     0,   392,     0,     0,     7,   319,
     244,   250,   257,   259,   261,   264,   269,   271,   273,   275,
     278,   281,   286,   293,   304,   311,   317,   312,   330,   355,
     350,   356,   353,   351,   354,   352,   389,   391,    14,     0,
     243,   146,     0,   243,     0,     0,     0,     0,     0,     0,
     243,     0,   243,     0,   291,   243,   243,     0,   309,   308,
     243,   292,   243,   243,     0,     0,     0,     0,   243,     0,
       0,     0,     0,   243,     0,   375,   374,     0,   367,   288,
       0,   249,     0,   246,     0,   387,     0,   358,   332,   359,
     333,   243,   314,     0,   287,   289,   245,     0,     0,     0,
       0,     0,     0,   243,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   301,     0,   302,     0,   243,   243,
       0,     0,   243,   324,     0,   106,   105,     0,   107,   108,
     112,     0,   119,   120,   121,   118,   109,     0,     0,     0,
       0,   110,     0,   111,   113,     0,   133,   114,   115,     0,
     116,     0,   123,   124,   125,   122,   175,     0,     0,   117,
     145,   141,   144,   143,     0,   135,   136,   137,   138,   139,
       0,   360,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   249,     0,     0,     0,     0,   395,   398,
       0,   374,   243,     0,     0,     0,     0,     0,   363,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   318,   365,   243,   243,     0,   376,   243,     0,
     385,   290,     0,   393,   255,   252,   258,   253,   254,   251,
       0,   260,   262,   263,   267,   268,   265,   266,   270,   272,
     274,   276,   277,   279,   280,   285,   283,   282,   284,   322,
     298,   299,   300,   303,     0,     0,   295,   390,     0,   243,
     243,   243,     0,     0,   243,     0,     0,     0,     0,   224,
     243,    42,    41,   243,     0,     0,     0,     0,   243,   243,
       0,    12,    15,    16,   101,    17,    18,    19,    20,    21,
       0,    13,    69,     0,   104,   306,     0,     0,     0,     0,
       0,     0,     0,     0,   157,     0,    50,     0,     0,     0,
     140,   147,     0,   307,   361,   362,   347,   348,   349,   346,
     335,   336,   337,   377,     0,   243,   383,   243,     0,     0,
     334,   243,   381,     0,   341,   364,   338,   339,   340,   366,
     343,   344,   345,   342,   379,     0,   368,   370,   388,     0,
     248,   386,     0,   243,   294,   297,   243,    37,   243,     0,
       0,     0,    74,    75,     0,     0,   243,     0,     0,   221,
       0,     0,    81,     0,    83,   243,    87,    88,     0,     0,
     243,     0,    46,     0,     0,    33,     0,    68,     0,   163,
       0,   162,     0,     0,     0,     0,     0,     0,     0,     0,
       7,   153,     0,   152,    57,     0,    49,    52,     0,   200,
       0,     0,   243,   243,   399,   397,     0,   310,     0,   243,
     243,   243,   243,   394,   256,     0,     0,     0,    70,   243,
      72,   243,    92,    93,     0,     0,     0,     0,     9,    35,
     243,     0,    50,    40,   223,   225,    80,    82,     0,     0,
      84,    94,     0,     0,     0,    48,     0,     0,    34,   165,
       0,   161,   159,   127,   126,   134,     0,   128,   131,   155,
       0,   156,   148,     0,   151,   149,   174,    58,     0,   403,
     224,     0,   235,     0,   199,   200,     0,   177,   181,   184,
     183,   180,   182,   204,   185,   132,   129,     0,     0,     0,
     313,     0,     0,   371,     0,   296,    39,    38,     0,     0,
     243,     0,   243,   243,   243,     0,     0,     0,     0,     0,
     232,   226,     0,     0,   243,   243,   243,   243,     0,    47,
       0,   243,     0,     0,     0,   164,   160,     0,     0,   154,
     150,    51,     0,   243,     0,   221,   403,   243,     0,     0,
     176,   173,   201,   202,   203,     0,   305,   378,   243,   382,
     380,   243,   315,    71,    73,     0,   243,     0,     0,   243,
     102,   103,     0,    96,    61,    62,    96,    36,    10,    25,
      26,   243,   220,   229,   227,   230,   231,     0,   222,     0,
       0,     0,     0,    91,    90,     0,     0,     0,     0,     0,
     403,   168,   130,   403,    60,     0,   403,   400,   188,   402,
     198,     0,     0,   243,     0,   119,   120,   121,   118,   109,
       0,     0,     0,   114,   116,     0,   123,   124,   125,   122,
       0,   243,   206,   210,   210,     0,     0,   243,    29,     0,
     243,     0,   243,    67,   243,    78,    77,    11,     0,   243,
     219,   243,     0,     0,    98,     0,   243,    23,   243,    50,
      30,    31,   243,     0,     0,     0,   167,   170,     0,   243,
      53,   190,     0,   243,   187,   234,   200,     0,   243,   237,
       0,    60,     0,     0,     0,   206,   210,     0,   206,   243,
     210,   243,   209,   403,   403,   384,   316,    76,   243,    96,
      63,    66,    95,    27,   228,     0,   243,    86,    97,    85,
      89,     0,     0,     0,    22,     0,   166,   169,   158,    59,
     189,   401,   242,   200,   403,   236,   200,   403,     0,     0,
       0,   210,   206,   210,   403,     0,   403,   208,     0,   212,
     212,    28,    79,   243,   100,    24,    56,    32,   403,   200,
     241,   212,   200,   240,     0,     0,   131,   132,   403,   403,
     403,   195,   205,   212,   207,     0,   214,   214,    99,     0,
      55,   403,     0,     0,   200,     0,   200,   186,     0,   196,
     197,   212,   214,   243,   243,   221,   221,    54,    45,   403,
     172,   239,   233,   238,   130,   214,   221,     0,   213,   216,
     191,   215,   218,   192,    44,     0,   221,   193,   211,   217,
     171,   194
  };

  const short int
  Parser::yypgoto_[] =
  {
    -790,  -790,  -790,  -790,     6,    19,  -790,  -790,  -790,  -790,
    -790,   650,   654,  -790,  -129,  -790,  -790,  -790,  -790,  -790,
     655,  -790,  -790,  -790,  -790,  -483,  -790,   298,  -790,  -790,
    -790,    89,  -506,  -634,  -790,  -790,  -179,  -610,   193,  -281,
    -790,  -790,   236,  -790,  -410,    60,   -10,  -225,  -790,  -790,
     311,  -790,  -790,  -790,  -790,  -790,   326,  -790,  -790,  -790,
    -790,   125,  -790,  -790,  -395,  -790,  -534,  -790,  -790,  -790,
     116,  -790,  -790,  -790,  -790,  -679,  -790,  -653,  -499,  -564,
    -789,  -790,  -420,  -790,  -790,   314,  -790,  -790,  -790,  -790,
    -790,  -790,  -790,   118,    -2,  -790,  -790,   -88,  -655,  -790,
     292,  -790,   710,   716,   352,   243,   711,   709,   714,   350,
     355,   342,   262,  -790,  -790,   819,   250,   -34,   -35,   270,
    -115,  -790,  -323,   400,  -260,  -790,  -790,  -790,  -790,  -790,
    -790,   604,  -790,  -790,   698,  -790,  -790,   256,  -790,   504,
    -790,  -561
  };

  const short int
  Parser::yydefgoto_[] =
  {
      -1,     3,     6,     5,    58,    59,   575,   576,   707,   182,
     341,   630,   631,   344,   496,   345,   346,   347,   348,   349,
     632,   445,   446,   515,   590,   465,   466,   467,   830,   831,
     468,   730,   633,   634,   701,   702,   635,   705,   713,   714,
     352,   353,   221,   222,   223,   461,   362,   372,   225,   462,
     463,   226,   458,   531,   227,   450,   451,   228,   594,   725,
     726,   727,   229,   367,   545,   546,   547,   548,   549,   550,
     551,   747,   552,   553,   615,   750,   752,   753,   826,   845,
     860,   861,   862,   504,   580,   429,   430,   581,   648,   649,
     554,   608,   738,   739,   243,     8,   146,   132,   133,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,   310,    77,    78,   234,
     262,    79,   127,   406,   128,    80,    81,    82,    83,    84,
     134,   135,    85,    86,    87,   143,   412,   247,   248,   249,
     669,   604
  };

  const short int
  Parser::yytable_[] =
  {
       7,   109,   264,   351,   266,   267,   268,   269,   486,   503,
      11,   610,   244,    92,   407,   710,   130,   258,   740,   579,
     384,    10,   101,   103,    10,   255,   706,   539,   667,   114,
     265,   393,   667,   621,   786,   270,   -58,   667,   124,   736,
     498,   754,   441,   711,   125,   671,   405,   126,   155,   131,
       4,   712,    17,   231,   108,   168,   765,   863,    17,   258,
     667,    10,    12,   240,   125,   667,   791,   867,   636,   794,
     370,     9,   371,   231,   139,   140,    19,   871,   667,   653,
     654,   261,   736,   740,   279,   156,    88,   667,   184,   718,
     314,   230,   280,   792,   667,   667,   370,   796,  -369,   723,
     246,   464,   728,   251,    24,   732,    10,   169,   253,   667,
     254,   220,   539,   819,   540,   170,   171,   825,  -373,   612,
     220,   441,   220,   711,   622,   499,   613,   614,   640,   641,
     541,   712,   444,   220,    10,   542,   370,   711,   818,   282,
     820,   729,   442,   220,   443,   712,    89,    10,   370,   802,
     558,   290,   224,   539,   543,   278,   561,   562,   767,    90,
     263,   245,   784,   250,   389,  -247,   737,   668,  -179,   629,
    -215,   529,   734,   100,   256,    10,    10,   315,   309,    91,
     354,   539,   539,   309,   271,   670,   309,   358,   359,   858,
     361,   757,   799,   800,   759,   363,   238,   239,   762,   540,
     774,   365,   259,   260,   141,   693,    10,   368,   369,   737,
     770,   444,   539,   778,   864,   541,   232,   233,  -221,  -140,
     542,   407,   780,   811,  -221,  -221,   814,   523,   524,   837,
     850,   527,   528,   821,   532,   823,   772,   535,   769,   543,
     540,   448,   431,    91,   870,   555,   556,   833,   157,   810,
     643,   559,   813,  -178,   721,   722,   541,   839,   840,   841,
     804,   542,   370,   846,   758,  -221,   158,    93,   540,   540,
     848,   370,   251,   408,   534,    94,   410,    10,   856,   371,
     543,   746,   409,   539,   541,   541,   102,   113,   865,   542,
     542,   866,    91,    91,   851,     1,     2,   828,   644,   540,
     610,   827,   610,    95,   645,   646,   508,   502,   543,   543,
    -221,   512,   835,   388,    96,   541,   370,   419,   420,   421,
     542,   809,   424,   853,   842,   488,   123,   489,   485,   110,
     572,   433,    91,   427,   573,    91,   438,   439,   118,   543,
     159,   160,   855,    10,    91,   647,   154,   428,   526,   539,
      97,   370,   812,   584,  -140,  -140,   161,   585,  -140,  -140,
    -140,    98,  -140,   449,  -140,   235,   236,   237,   241,   242,
     540,   460,   662,   490,    99,   491,   104,   220,   220,   111,
     220,   220,   220,   474,   220,   246,   541,   220,   220,   478,
     803,   542,   129,   278,   136,   521,   162,   522,   144,   145,
     294,   295,   296,   297,   163,   147,   815,   220,   183,   370,
     543,   484,   859,   110,   834,   502,   487,   836,   452,   453,
    -247,   455,   456,   457,   497,   137,   138,   313,   470,   471,
     316,   494,   768,   509,   768,   311,   540,   312,   513,   284,
     285,   869,   287,   288,   289,   148,   164,   165,   476,   112,
     703,   115,   541,   166,   167,   139,   140,   542,   149,   150,
     514,   116,   516,   517,   530,   137,   374,   139,   375,   117,
     557,   251,   137,   395,   538,   544,   543,   251,   251,   251,
     564,   417,   418,   118,   151,    10,    12,   568,   181,   569,
    -370,   481,   500,   501,   172,   587,   588,   257,   577,   173,
     119,   571,   591,   592,   152,   626,   627,   292,   293,   120,
     305,   306,   307,   308,   301,   302,   121,   153,   174,   122,
     220,   303,   304,   761,  -396,   252,   175,   449,   272,   273,
     275,   274,   176,   276,   277,   278,   283,    55,   281,   355,
     460,   356,   357,   360,   366,   220,   374,   606,   364,   609,
     373,   544,   220,   220,   375,   376,   385,   377,   177,   378,
     379,   578,   380,   381,   816,   817,   382,   383,   625,   386,
     628,   354,   354,   387,   390,   139,   391,   392,   178,   395,
     394,   694,   652,   354,   354,   655,   597,   179,   396,   658,
     172,   397,   398,   599,   399,   173,   130,   400,   180,   401,
     402,   666,   403,   413,   404,   672,   272,   220,   414,   657,
     415,   220,   220,   854,   174,   416,   246,   220,   422,   696,
     425,   220,   175,   423,   698,   426,  -247,   354,   176,   432,
     434,   436,   454,   437,   692,   435,   447,   440,   482,   708,
     472,   469,   473,   479,   172,   477,   220,   480,   656,   173,
     492,   493,   659,   660,   177,   495,   502,   748,   663,   505,
     808,   795,   664,   483,   506,   507,   519,   724,   174,   510,
     742,   520,   743,   511,   178,   365,   175,   518,   525,   570,
     744,   533,   176,   179,   370,   371,   536,   699,   537,   251,
     560,   565,   566,   220,   180,   354,   567,   574,   354,   582,
     354,   583,   354,   586,   589,   593,   595,   764,   177,   598,
     745,   464,   602,   603,   354,   611,   771,   849,   607,   618,
     773,   623,   616,   617,   319,   320,   321,   779,   178,   638,
     619,   781,   724,   620,   741,   322,   624,   179,   637,   639,
     650,   -43,   544,   323,   642,   674,   697,   324,   180,   798,
     651,   661,   673,   700,   704,   704,   801,   709,   629,   325,
     717,   220,   220,   220,   354,   716,   719,   720,   326,   731,
     735,   733,   755,    10,    94,    95,    96,    97,    98,   115,
     116,   119,   120,   121,   328,   122,   749,   766,   763,   544,
     783,   775,   544,   751,   760,   749,   704,   756,   776,   793,
     805,   354,   788,   789,   790,   806,   330,   797,   331,   332,
     807,   333,   822,   829,   832,   544,   334,   824,   544,   479,
     335,   336,   337,   338,   480,   667,   843,   844,   852,   618,
     787,   -43,   342,   868,   220,   601,   343,   350,   339,   665,
     544,   857,   544,   340,   715,   600,   -15,   596,   220,   -15,
     -15,   777,   782,   -65,   605,   -15,   785,   -15,   -15,   286,
     -15,   -15,   -15,   -15,   -15,   -15,   -15,   -15,   -15,   -15,
     291,   299,   298,   142,   695,   838,   -15,   300,   -15,   317,
       0,   563,   -15,   411,   -15,     0,   -15,     0,     0,   847,
     -15,   475,   -15,     0,     0,     0,   -15,     0,     0,     0,
       0,     0,   -15,     0,     0,   -15,     0,   -15,     0,     0,
       0,   -15,   -15,     0,     0,     0,   -15,   -15,   -15,   -15,
     -15,   -15,     0,     0,     0,     0,   -15,   -15,   -15,     0,
       0,     0,   -15,     0,     0,     0,     0,     0,   -15,     0,
       0,     0,   -15,   -15,     0,     0,   -15,   -15,     0,   -15,
       0,   -15,   -15,     0,   -15,   -15,     0,     0,     0,   -15,
     -15,     0,     0,   -15,   -15,   -15,   -15,   -15,   -15,     0,
       0,     0,     0,   -15,   -15,     0,   -15,   -15,   -15,   -15,
       0,   -15,     0,   -15,     0,     0,   -15,     0,     0,     0,
       0,     0,   -15,     0,     0,     0,     0,     0,     0,     0,
     -15,   -15,     0,     0,   -15,     0,   -15,   -15,     0,   -15,
     -15,   -15,   -16,     0,     0,   -16,   -16,     0,     0,     0,
       0,   -16,     0,   -16,   -16,     0,   -16,   -16,   -16,   -16,
     -16,   -16,   -16,   -16,   -16,   -16,     0,     0,     0,     0,
       0,     0,   -16,     0,   -16,     0,     0,     0,   -16,     0,
     -16,     0,   -16,     0,     0,     0,   -16,     0,   -16,     0,
       0,     0,   -16,     0,     0,     0,     0,     0,   -16,     0,
       0,   -16,     0,   -16,     0,     0,     0,   -16,   -16,     0,
       0,     0,   -16,   -16,   -16,   -16,   -16,   -16,     0,     0,
       0,     0,   -16,   -16,   -16,     0,     0,     0,   -16,     0,
       0,     0,     0,     0,   -16,     0,     0,     0,   -16,   -16,
       0,     0,   -16,   -16,     0,   -16,     0,   -16,   -16,     0,
     -16,   -16,     0,     0,     0,   -16,   -16,     0,     0,   -16,
     -16,   -16,   -16,   -16,   -16,     0,     0,     0,     0,   -16,
     -16,     0,   -16,   -16,   -16,   -16,     0,   -16,     0,   -16,
       0,     0,   -16,     0,     0,     0,     0,     0,   -16,     0,
       0,     0,     0,     0,     0,     0,   -16,   -16,     0,     0,
     -16,     0,   -16,   -16,     0,   -16,   -16,   -16,    10,    12,
       0,     0,     0,     0,     0,     0,    13,    14,     0,    15,
      16,    17,    18,    19,    20,    21,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    22,     0,     0,     0,     0,
       0,    23,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    24,     0,     0,     0,    25,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    26,    27,    28,    29,    30,
      31,     0,     0,     0,     0,    32,     0,    33,     0,     0,
       0,    34,     0,     0,     0,     0,     0,    35,     0,     0,
       0,     0,    36,     0,     0,    37,    38,     0,     0,     0,
       0,     0,     0,     0,    39,     0,     0,     0,     0,    40,
       0,     0,     0,     0,     0,     0,    41,    42,     0,     0,
       0,     0,    43,     0,     0,    44,    45,    46,    47,     0,
       0,     0,    48,     0,     0,     0,     0,     0,     0,     0,
       0,    49,     0,     0,     0,     0,     0,     0,     0,    50,
      51,     0,     0,    52,     0,    53,    54,     0,    55,    56,
      57,    10,    12,     0,     0,     0,     0,     0,     0,    13,
      14,     0,    15,    16,    17,    18,     0,    20,    21,     0,
       0,     0,   185,     0,   186,     0,     0,   187,     0,   188,
       0,   189,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   190,     0,     0,   191,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   675,   676,
     677,   678,   679,    31,   197,   198,     0,   199,    32,     0,
     680,     0,     0,     0,     0,     0,     0,     0,     0,   201,
       0,   125,     0,     0,     0,   681,     0,     0,     0,   203,
       0,     0,     0,     0,     0,   204,     0,   682,     0,     0,
     206,     0,   683,   208,   209,     0,     0,     0,     0,   684,
      42,     0,     0,     0,     0,   685,     0,     0,   686,   687,
     688,   689,   216,     0,     0,   690,   218,   219,     0,     0,
       0,     0,     0,     0,   105,  -369,     0,     0,     0,     0,
       0,     0,     0,   106,    10,    12,     0,     0,    53,   107,
       0,    55,    13,    14,     0,    15,    16,    17,    18,     0,
      20,    21,     0,     0,     0,   185,     0,   186,     0,     0,
     187,     0,   188,     0,   189,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   190,
       0,     0,   191,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   675,   676,   677,   678,   679,    31,   197,   198,     0,
     199,    32,     0,   680,     0,     0,     0,     0,     0,     0,
       0,     0,   201,     0,     0,     0,     0,     0,   681,     0,
       0,     0,   203,     0,     0,     0,     0,     0,   204,     0,
     682,     0,     0,   206,     0,   683,   208,   209,     0,     0,
       0,     0,   684,    42,     0,     0,     0,     0,   685,     0,
       0,   686,   687,   688,   689,   216,     0,     0,   690,   218,
     219,     0,     0,     0,     0,     0,     0,   691,     0,     0,
       0,     0,     0,     0,     0,     0,   106,    10,    12,     0,
       0,    53,   107,     0,    55,    13,    14,     0,    15,    16,
      17,    18,    19,    20,    21,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    22,     0,     0,     0,     0,     0,
      23,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      24,     0,     0,     0,    25,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    26,    27,    28,    29,    30,    31,
       0,     0,     0,     0,    32,     0,    33,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    35,     0,     0,     0,
       0,    36,     0,    10,    12,    38,     0,     0,     0,     0,
       0,    13,    14,    39,    15,    16,    17,    18,    40,    20,
      21,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,    43,     0,     0,    44,    45,    46,    47,     0,     0,
       0,    48,     0,     0,     0,     0,     0,     0,     0,     0,
      49,     0,     0,     0,     0,     0,     0,     0,     0,    51,
       0,     0,     0,     0,    53,    54,     0,    55,     0,     0,
      26,    27,    28,    29,    30,    31,     0,     0,     0,     0,
      32,     0,    33,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    36,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    39,
       0,     0,     0,     0,    40,     0,     0,    10,    12,     0,
       0,    41,    42,     0,     0,     0,     0,    43,     0,     0,
      44,    45,    46,    47,     0,     0,     0,    48,   185,     0,
     186,     0,     0,   187,     0,   188,   105,   189,     0,     0,
       0,     0,     0,     0,     0,   106,     0,     0,     0,     0,
      53,   107,   190,    55,     0,   191,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   192,   193,   194,   195,   196,     0,
     197,   198,     0,   199,     0,     0,   200,     0,     0,     0,
       0,     0,     0,     0,     0,   201,     0,     0,     0,     0,
       0,   202,     0,     0,     0,   203,     0,     0,     0,     0,
       0,   204,     0,   205,     0,     0,   206,     0,   207,   208,
     209,     0,     0,    -5,     0,   210,     0,     0,     0,     0,
       0,   211,   318,     0,   212,   213,   214,   215,   216,     0,
       0,   217,   218,   219,   319,   320,   321,     0,     0,     0,
       0,     0,     0,     0,     0,   322,     0,     0,   459,     0,
       0,   -43,     0,   323,     0,     0,     0,   324,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   325,
       0,     0,   -43,     0,   -43,     0,     0,     0,   326,   327,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   328,     0,     0,     0,     0,    10,
      12,     0,     0,     0,     0,     0,     0,     0,     0,   329,
       0,     0,     0,     0,     0,     0,   330,     0,   331,   332,
     185,   333,   186,     0,     0,   187,   334,   188,     0,   189,
     335,   336,   337,   338,     0,     0,     0,     0,     0,     0,
       0,   -43,     0,     0,   190,     0,     0,   191,   339,     0,
       0,     0,     0,   340,     0,     0,     0,     0,     0,     0,
     319,   320,   321,     0,     0,     0,   192,   193,   194,   195,
     196,   322,   197,   198,     0,   199,     0,   -43,   200,   323,
       0,     0,     0,   324,     0,     0,     0,   201,     0,     0,
       0,     0,     0,   202,     0,   325,     0,   203,     0,     0,
       0,     0,     0,   204,   326,   205,     0,     0,   206,     0,
     207,   208,   209,     0,     0,     0,     0,   210,     0,     0,
     328,     0,     0,   211,     0,     0,   212,   213,   214,   215,
     216,     0,     0,   217,   218,   219,     0,     0,     0,     0,
       0,     0,   330,     0,   331,   332,     0,   333,     0,   319,
     320,   321,   334,     0,     0,     0,   335,   336,   337,   338,
     322,     0,     0,     0,     0,     0,   -43,   -43,   323,     0,
       0,     0,   324,     0,   339,     0,     0,     0,     0,   340,
       0,     0,     0,     0,   325,     0,     0,     0,     0,   -64,
       0,     0,     0,   326,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   328,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   330,     0,   331,   332,   185,   333,   186,     0,     0,
     187,   334,   188,     0,   189,   335,   336,   337,   338,     0,
       0,     0,     0,     0,     0,     0,   -43,     0,     0,   190,
       0,     0,   191,   339,     0,     0,     0,     0,   340,     0,
       0,     0,     0,     0,     0,     0,     0,   629,     0,     0,
       0,   192,   193,   194,   195,   196,     0,   197,   198,     0,
     199,     0,     0,   200,     0,     0,     0,     0,     0,     0,
       0,     0,   201,     0,     0,     0,     0,     0,   202,     0,
       0,     0,   203,     0,     0,     0,     0,     0,   204,     0,
     205,     0,     0,   206,     0,   207,   208,   209,   185,     0,
     186,     0,   210,   187,     0,   188,     0,   189,   211,     0,
       0,   212,   213,   214,   215,   216,     0,     0,   217,   218,
     219,     0,   190,     0,     0,   191,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   192,   193,   194,   195,   196,     0,
     197,   198,     0,   199,     0,     0,   200,     0,     0,     0,
       0,     0,     0,     0,     0,   201,     0,     0,     0,     0,
       0,   202,     0,     0,     0,   203,     0,     0,     0,     0,
       0,   204,     0,   205,     0,     0,   206,     0,   207,   208,
     209,     0,     0,     0,     0,   210,     0,     0,     0,     0,
       0,   211,     0,     0,   212,   213,   214,   215,   216,     0,
       0,   217,   218,   219
  };

  const short int
  Parser::yycheck_[] =
  {
       2,    35,   117,   182,   119,   120,   121,   122,   418,   429,
       4,   545,   100,    23,   274,   649,     7,    17,   673,   502,
     245,     3,    32,    33,     3,   113,   636,     9,     8,    39,
     118,   256,     8,    65,    27,   123,     3,     8,    48,    27,
      58,   694,    38,    35,    93,   606,   271,    49,    52,    51,
      88,    43,    16,    17,    35,   102,   711,   846,    16,    17,
       8,     3,     4,    98,    93,     8,   745,   856,   574,   748,
     151,     0,   153,    17,    16,    17,    18,   866,     8,   585,
     586,   116,    27,   738,   148,    89,   143,     8,    90,   144,
     178,    93,   156,   746,     8,     8,   151,   750,   147,   660,
     102,    68,   663,   105,    46,   666,     3,   154,   110,     8,
     112,    92,     9,   792,    96,   162,   163,    65,   147,   145,
     101,    38,   103,    35,   156,   143,   152,   153,   143,   144,
     112,    43,   128,   114,     3,   117,   151,    35,   791,   141,
     793,   144,    59,   124,    61,    43,   163,     3,   151,   759,
     473,   153,    92,     9,   136,   148,   479,   480,   150,   146,
     160,   101,   150,   103,   252,   156,   154,   143,   150,   149,
       9,   150,   143,   146,   114,     3,     3,   179,   172,   152,
     182,     9,     9,   177,   124,   605,   180,   197,   198,   844,
     200,   697,   753,   754,   700,   205,   160,   161,   704,    96,
     143,   211,   160,   161,   146,   615,     3,   217,   218,   154,
     716,   128,     9,   143,   848,   112,   160,   161,    57,     8,
     117,   481,   143,   784,    63,    64,   787,   452,   453,   143,
     143,   456,   457,   794,   459,   796,   719,   462,   150,   136,
      96,   356,   330,   152,   143,   470,   471,   808,    60,   783,
       9,   476,   786,   150,   143,   144,   112,   818,   819,   820,
     766,   117,   151,   827,   144,   104,    78,   146,    96,    96,
     831,   151,   274,   275,   148,   146,   278,     3,   842,   153,
     136,   691,   276,     9,   112,   112,   146,   146,   849,   117,
     117,   855,   152,   152,   150,   141,   142,   803,    57,    96,
     834,   800,   836,   146,    63,    64,   435,   146,   136,   136,
     149,   440,   811,   148,   146,   112,   151,   319,   320,   321,
     117,   149,   324,   150,   823,   143,   146,   145,   416,   146,
     143,   333,   152,   327,   147,   152,   338,   339,   146,   136,
     152,   153,   841,     3,   152,   104,    25,   328,   148,     9,
     146,   151,   149,   143,   143,   144,   158,   147,   147,   148,
     149,   146,   151,   357,   153,    95,    96,    97,    98,    99,
      96,   365,   597,   143,   146,   145,    34,   358,   359,    37,
     361,   362,   363,   385,   365,   387,   112,   368,   369,   391,
     145,   117,    50,   148,    52,   148,   159,   150,    56,    57,
     157,   158,   159,   160,   151,    45,   148,   388,    17,   151,
     136,   413,   143,   146,   809,   146,   418,   812,   358,   359,
     147,   361,   362,   363,   426,    16,    17,   177,   368,   369,
     180,   425,   713,   435,   715,   173,    96,   175,   440,   147,
     148,   861,   150,   151,   152,    85,   110,   111,   388,   146,
     629,   146,   112,   160,   161,    16,    17,   117,    98,    99,
     441,   146,   443,   444,   458,    16,    17,    16,    17,   146,
     472,   473,    16,    17,   468,   469,   136,   479,   480,   481,
     482,   143,   144,   146,   124,     3,     4,   489,   158,   491,
     147,   148,   144,   145,    62,   144,   145,    12,   500,    67,
     146,   495,   144,   145,   144,   144,   145,   155,   156,   146,
     168,   169,   170,   171,   164,   165,   146,   157,    86,   146,
     501,   166,   167,   702,   147,   146,    94,   521,   147,   147,
     144,   148,   100,    56,   156,   148,    13,   163,   158,   147,
     534,   146,   149,   146,   146,   526,    17,   541,   149,   543,
     147,   545,   533,   534,    17,   147,   145,   147,   126,   147,
     147,   501,   147,   147,   789,   790,   147,   147,   570,   147,
     572,   573,   574,   148,   147,    16,   148,   147,   146,    17,
     147,   615,   584,   585,   586,   587,   526,   155,   147,   591,
      62,   147,   147,   533,   147,    67,     7,   147,   166,   147,
     147,   603,   147,   145,   147,   607,   147,   588,   147,   590,
     156,   592,   593,   838,    86,   146,   618,   598,   143,   621,
     146,   602,    94,   143,   626,   146,   143,   629,   100,   143,
     143,   143,    11,   143,   615,   146,   143,   146,    67,   641,
     146,   149,   146,   146,    62,   147,   627,   146,   588,    67,
     143,   143,   592,   593,   126,    81,   146,   691,   598,     6,
     775,   749,   602,   163,   143,   143,   147,   661,    86,   143,
     680,   144,   682,   143,   146,   685,    94,   143,   147,    67,
     690,   145,   100,   155,   151,   153,   147,   627,   148,   691,
     147,   147,   143,   674,   166,   697,   143,   147,   700,   147,
     702,   147,   704,   147,    11,   144,    17,   709,   126,   145,
     691,    68,   145,   144,   716,   150,   718,   832,   146,   146,
     722,   143,   147,   147,    21,    22,    23,   729,   146,     5,
     147,   733,   726,   147,   674,    32,   143,   155,   143,   143,
     149,    38,   736,    40,   147,   145,   147,    44,   166,   751,
     149,   149,   149,   147,    49,    49,   758,   144,   149,    56,
     143,   742,   743,   744,   766,   147,   146,   143,    65,   143,
     147,   144,   147,     3,   146,   146,   146,   146,   146,   146,
     146,   146,   146,   146,    81,   146,   146,   145,   143,   783,
      27,   145,   786,   155,   150,   146,    49,   156,   150,   147,
     143,   803,   742,   743,   744,   147,   103,   156,   105,   106,
     143,   108,   147,   145,    47,   809,   113,   156,   812,   146,
     117,   118,   119,   120,   146,     8,   146,    27,   143,   146,
     741,   128,   182,   147,   815,   537,   182,   182,   135,   603,
     834,   843,   836,   140,   651,   534,     0,   521,   829,     3,
       4,   726,   736,   150,   540,     9,   738,    11,    12,   149,
      14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
     154,   162,   161,    54,   618,   815,    30,   163,    32,   181,
      -1,   481,    36,   279,    38,    -1,    40,    -1,    -1,   829,
      44,   387,    46,    -1,    -1,    -1,    50,    -1,    -1,    -1,
      -1,    -1,    56,    -1,    -1,    59,    -1,    61,    -1,    -1,
      -1,    65,    66,    -1,    -1,    -1,    70,    71,    72,    73,
      74,    75,    -1,    -1,    -1,    -1,    80,    81,    82,    -1,
      -1,    -1,    86,    -1,    -1,    -1,    -1,    -1,    92,    -1,
      -1,    -1,    96,    97,    -1,    -1,   100,   101,    -1,   103,
      -1,   105,   106,    -1,   108,   109,    -1,    -1,    -1,   113,
     114,    -1,    -1,   117,   118,   119,   120,   121,   122,    -1,
      -1,    -1,    -1,   127,   128,    -1,   130,   131,   132,   133,
      -1,   135,    -1,   137,    -1,    -1,   140,    -1,    -1,    -1,
      -1,    -1,   146,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     154,   155,    -1,    -1,   158,    -1,   160,   161,    -1,   163,
     164,   165,     0,    -1,    -1,     3,     4,    -1,    -1,    -1,
      -1,     9,    -1,    11,    12,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    22,    23,    -1,    -1,    -1,    -1,
      -1,    -1,    30,    -1,    32,    -1,    -1,    -1,    36,    -1,
      38,    -1,    40,    -1,    -1,    -1,    44,    -1,    46,    -1,
      -1,    -1,    50,    -1,    -1,    -1,    -1,    -1,    56,    -1,
      -1,    59,    -1,    61,    -1,    -1,    -1,    65,    66,    -1,
      -1,    -1,    70,    71,    72,    73,    74,    75,    -1,    -1,
      -1,    -1,    80,    81,    82,    -1,    -1,    -1,    86,    -1,
      -1,    -1,    -1,    -1,    92,    -1,    -1,    -1,    96,    97,
      -1,    -1,   100,   101,    -1,   103,    -1,   105,   106,    -1,
     108,   109,    -1,    -1,    -1,   113,   114,    -1,    -1,   117,
     118,   119,   120,   121,   122,    -1,    -1,    -1,    -1,   127,
     128,    -1,   130,   131,   132,   133,    -1,   135,    -1,   137,
      -1,    -1,   140,    -1,    -1,    -1,    -1,    -1,   146,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   154,   155,    -1,    -1,
     158,    -1,   160,   161,    -1,   163,   164,   165,     3,     4,
      -1,    -1,    -1,    -1,    -1,    -1,    11,    12,    -1,    14,
      15,    16,    17,    18,    19,    20,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    30,    -1,    -1,    -1,    -1,
      -1,    36,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    46,    -1,    -1,    -1,    50,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    70,    71,    72,    73,    74,
      75,    -1,    -1,    -1,    -1,    80,    -1,    82,    -1,    -1,
      -1,    86,    -1,    -1,    -1,    -1,    -1,    92,    -1,    -1,
      -1,    -1,    97,    -1,    -1,   100,   101,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   109,    -1,    -1,    -1,    -1,   114,
      -1,    -1,    -1,    -1,    -1,    -1,   121,   122,    -1,    -1,
      -1,    -1,   127,    -1,    -1,   130,   131,   132,   133,    -1,
      -1,    -1,   137,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   146,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   154,
     155,    -1,    -1,   158,    -1,   160,   161,    -1,   163,   164,
     165,     3,     4,    -1,    -1,    -1,    -1,    -1,    -1,    11,
      12,    -1,    14,    15,    16,    17,    -1,    19,    20,    -1,
      -1,    -1,    24,    -1,    26,    -1,    -1,    29,    -1,    31,
      -1,    33,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    48,    -1,    -1,    51,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    70,    71,
      72,    73,    74,    75,    76,    77,    -1,    79,    80,    -1,
      82,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,
      -1,    93,    -1,    -1,    -1,    97,    -1,    -1,    -1,   101,
      -1,    -1,    -1,    -1,    -1,   107,    -1,   109,    -1,    -1,
     112,    -1,   114,   115,   116,    -1,    -1,    -1,    -1,   121,
     122,    -1,    -1,    -1,    -1,   127,    -1,    -1,   130,   131,
     132,   133,   134,    -1,    -1,   137,   138,   139,    -1,    -1,
      -1,    -1,    -1,    -1,   146,   147,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   155,     3,     4,    -1,    -1,   160,   161,
      -1,   163,    11,    12,    -1,    14,    15,    16,    17,    -1,
      19,    20,    -1,    -1,    -1,    24,    -1,    26,    -1,    -1,
      29,    -1,    31,    -1,    33,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    48,
      -1,    -1,    51,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    70,    71,    72,    73,    74,    75,    76,    77,    -1,
      79,    80,    -1,    82,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    91,    -1,    -1,    -1,    -1,    -1,    97,    -1,
      -1,    -1,   101,    -1,    -1,    -1,    -1,    -1,   107,    -1,
     109,    -1,    -1,   112,    -1,   114,   115,   116,    -1,    -1,
      -1,    -1,   121,   122,    -1,    -1,    -1,    -1,   127,    -1,
      -1,   130,   131,   132,   133,   134,    -1,    -1,   137,   138,
     139,    -1,    -1,    -1,    -1,    -1,    -1,   146,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   155,     3,     4,    -1,
      -1,   160,   161,    -1,   163,    11,    12,    -1,    14,    15,
      16,    17,    18,    19,    20,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    30,    -1,    -1,    -1,    -1,    -1,
      36,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      46,    -1,    -1,    -1,    50,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    70,    71,    72,    73,    74,    75,
      -1,    -1,    -1,    -1,    80,    -1,    82,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    92,    -1,    -1,    -1,
      -1,    97,    -1,     3,     4,   101,    -1,    -1,    -1,    -1,
      -1,    11,    12,   109,    14,    15,    16,    17,   114,    19,
      20,    -1,    -1,    -1,    -1,   121,   122,    -1,    -1,    -1,
      -1,   127,    -1,    -1,   130,   131,   132,   133,    -1,    -1,
      -1,   137,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     146,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   155,
      -1,    -1,    -1,    -1,   160,   161,    -1,   163,    -1,    -1,
      70,    71,    72,    73,    74,    75,    -1,    -1,    -1,    -1,
      80,    -1,    82,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    97,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,
      -1,    -1,    -1,    -1,   114,    -1,    -1,     3,     4,    -1,
      -1,   121,   122,    -1,    -1,    -1,    -1,   127,    -1,    -1,
     130,   131,   132,   133,    -1,    -1,    -1,   137,    24,    -1,
      26,    -1,    -1,    29,    -1,    31,   146,    33,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   155,    -1,    -1,    -1,    -1,
     160,   161,    48,   163,    -1,    51,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    70,    71,    72,    73,    74,    -1,
      76,    77,    -1,    79,    -1,    -1,    82,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    91,    -1,    -1,    -1,    -1,
      -1,    97,    -1,    -1,    -1,   101,    -1,    -1,    -1,    -1,
      -1,   107,    -1,   109,    -1,    -1,   112,    -1,   114,   115,
     116,    -1,    -1,     0,    -1,   121,    -1,    -1,    -1,    -1,
      -1,   127,     9,    -1,   130,   131,   132,   133,   134,    -1,
      -1,   137,   138,   139,    21,    22,    23,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    32,    -1,    -1,   154,    -1,
      -1,    38,    -1,    40,    -1,    -1,    -1,    44,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    56,
      -1,    -1,    59,    -1,    61,    -1,    -1,    -1,    65,    66,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    81,    -1,    -1,    -1,    -1,     3,
       4,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    96,
      -1,    -1,    -1,    -1,    -1,    -1,   103,    -1,   105,   106,
      24,   108,    26,    -1,    -1,    29,   113,    31,    -1,    33,
     117,   118,   119,   120,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   128,    -1,    -1,    48,    -1,    -1,    51,   135,    -1,
      -1,    -1,    -1,   140,    -1,    -1,    -1,    -1,    -1,    -1,
      21,    22,    23,    -1,    -1,    -1,    70,    71,    72,    73,
      74,    32,    76,    77,    -1,    79,    -1,    38,    82,    40,
      -1,    -1,    -1,    44,    -1,    -1,    -1,    91,    -1,    -1,
      -1,    -1,    -1,    97,    -1,    56,    -1,   101,    -1,    -1,
      -1,    -1,    -1,   107,    65,   109,    -1,    -1,   112,    -1,
     114,   115,   116,    -1,    -1,    -1,    -1,   121,    -1,    -1,
      81,    -1,    -1,   127,    -1,    -1,   130,   131,   132,   133,
     134,    -1,    -1,   137,   138,   139,    -1,    -1,    -1,    -1,
      -1,    -1,   103,    -1,   105,   106,    -1,   108,    -1,    21,
      22,    23,   113,    -1,    -1,    -1,   117,   118,   119,   120,
      32,    -1,    -1,    -1,    -1,    -1,    38,   128,    40,    -1,
      -1,    -1,    44,    -1,   135,    -1,    -1,    -1,    -1,   140,
      -1,    -1,    -1,    -1,    56,    -1,    -1,    -1,    -1,   150,
      -1,    -1,    -1,    65,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    81,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   103,    -1,   105,   106,    24,   108,    26,    -1,    -1,
      29,   113,    31,    -1,    33,   117,   118,   119,   120,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   128,    -1,    -1,    48,
      -1,    -1,    51,   135,    -1,    -1,    -1,    -1,   140,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   149,    -1,    -1,
      -1,    70,    71,    72,    73,    74,    -1,    76,    77,    -1,
      79,    -1,    -1,    82,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    91,    -1,    -1,    -1,    -1,    -1,    97,    -1,
      -1,    -1,   101,    -1,    -1,    -1,    -1,    -1,   107,    -1,
     109,    -1,    -1,   112,    -1,   114,   115,   116,    24,    -1,
      26,    -1,   121,    29,    -1,    31,    -1,    33,   127,    -1,
      -1,   130,   131,   132,   133,   134,    -1,    -1,   137,   138,
     139,    -1,    48,    -1,    -1,    51,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    70,    71,    72,    73,    74,    -1,
      76,    77,    -1,    79,    -1,    -1,    82,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    91,    -1,    -1,    -1,    -1,
      -1,    97,    -1,    -1,    -1,   101,    -1,    -1,    -1,    -1,
      -1,   107,    -1,   109,    -1,    -1,   112,    -1,   114,   115,
     116,    -1,    -1,    -1,    -1,   121,    -1,    -1,    -1,    -1,
      -1,   127,    -1,    -1,   130,   131,   132,   133,   134,    -1,
      -1,   137,   138,   139
  };

  const unsigned short int
  Parser::yystos_[] =
  {
       0,   141,   142,   168,    88,   170,   169,   261,   262,     0,
       3,   171,     4,    11,    12,    14,    15,    16,    17,    18,
      19,    20,    30,    36,    46,    50,    70,    71,    72,    73,
      74,    75,    80,    82,    86,    92,    97,   100,   101,   109,
     114,   121,   122,   127,   130,   131,   132,   133,   137,   146,
     154,   155,   158,   160,   161,   163,   164,   165,   171,   172,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   284,   285,   288,
     292,   293,   294,   295,   296,   299,   300,   301,   143,   163,
     146,   152,   213,   146,   146,   146,   146,   146,   146,   146,
     146,   213,   146,   213,   278,   146,   155,   161,   172,   284,
     146,   278,   146,   146,   213,   146,   146,   146,   146,   146,
     146,   146,   146,   146,   213,    93,   261,   289,   291,   278,
       7,   261,   264,   265,   297,   298,   278,    16,    17,    16,
      17,   146,   282,   302,   278,   278,   263,    45,    85,    98,
      99,   124,   144,   157,    25,    52,    89,    60,    78,   152,
     153,   158,   159,   151,   110,   111,   160,   161,   102,   154,
     162,   163,    62,    67,    86,    94,   100,   126,   146,   155,
     166,   158,   176,    17,   261,    24,    26,    29,    31,    33,
      48,    51,    70,    71,    72,    73,    74,    76,    77,    79,
      82,    91,    97,   101,   107,   109,   112,   114,   115,   116,
     121,   127,   130,   131,   132,   133,   134,   137,   138,   139,
     172,   209,   210,   211,   212,   215,   218,   221,   224,   229,
     261,    17,   160,   161,   286,   286,   286,   286,   160,   161,
     285,   286,   286,   261,   264,   212,   261,   304,   305,   306,
     212,   261,   146,   261,   261,   264,   212,    12,    17,   160,
     161,   285,   287,   160,   287,   264,   287,   287,   287,   287,
     264,   212,   147,   147,   148,   144,    56,   156,   148,   148,
     156,   158,   261,    13,   267,   267,   269,   267,   267,   267,
     261,   270,   271,   271,   272,   272,   272,   272,   273,   274,
     275,   276,   276,   277,   277,   278,   278,   278,   278,   171,
     283,   279,   279,   283,   264,   261,   283,   301,     9,    21,
      22,    23,    32,    40,    44,    56,    65,    66,    81,    96,
     103,   105,   106,   108,   113,   117,   118,   119,   120,   135,
     140,   177,   178,   179,   180,   182,   183,   184,   185,   186,
     187,   203,   207,   208,   261,   147,   146,   149,   213,   213,
     146,   213,   213,   213,   149,   213,   146,   230,   213,   213,
     151,   153,   214,   147,    17,    17,   147,   147,   147,   147,
     147,   147,   147,   147,   214,   145,   147,   148,   148,   264,
     147,   148,   147,   214,   147,    17,   147,   147,   147,   147,
     147,   147,   147,   147,   147,   214,   290,   291,   261,   171,
     261,   298,   303,   145,   147,   156,   146,   143,   144,   261,
     261,   261,   143,   143,   261,   146,   146,   171,   172,   252,
     253,   264,   143,   261,   143,   146,   143,   143,   261,   261,
     146,    38,    59,    61,   128,   188,   189,   143,   287,   171,
     222,   223,   212,   212,    11,   212,   212,   212,   219,   154,
     171,   212,   216,   217,    68,   192,   193,   194,   197,   149,
     212,   212,   146,   146,   261,   306,   212,   147,   261,   146,
     146,   148,    67,   163,   261,   264,   211,   261,   143,   145,
     143,   145,   143,   143,   171,    81,   181,   261,    58,   143,
     144,   145,   146,   249,   250,     6,   143,   143,   181,   261,
     143,   143,   181,   261,   172,   190,   172,   172,   143,   147,
     144,   148,   150,   214,   214,   147,   148,   214,   214,   150,
     171,   220,   214,   145,   148,   214,   147,   148,   171,     9,
      96,   112,   117,   136,   171,   231,   232,   233,   234,   235,
     236,   237,   239,   240,   257,   214,   214,   261,   289,   214,
     147,   289,   289,   290,   261,   147,   143,   143,   261,   261,
      67,   171,   143,   147,   147,   173,   174,   261,   212,   192,
     251,   254,   147,   147,   143,   147,   147,   144,   145,    11,
     191,   144,   145,   144,   225,    17,   223,   212,   145,   212,
     217,   194,   145,   144,   308,   252,   171,   146,   258,   171,
     233,   150,   145,   152,   153,   241,   147,   147,   146,   147,
     147,    65,   156,   143,   143,   261,   144,   145,   261,   149,
     178,   179,   187,   199,   200,   203,   199,   143,     5,   143,
     143,   144,   147,     9,    57,    63,    64,   104,   255,   256,
     149,   149,   261,   199,   199,   261,   212,   172,   261,   212,
     212,   149,   214,   212,   212,   209,   261,     8,   143,   307,
     249,   308,   261,   149,   145,    70,    71,    72,    73,    74,
      82,    97,   109,   114,   121,   127,   130,   131,   132,   133,
     137,   146,   172,   211,   284,   304,   261,   147,   261,   212,
     147,   201,   202,   203,    49,   204,   204,   175,   261,   144,
     200,    35,    43,   205,   206,   205,   147,   143,   144,   146,
     143,   143,   144,   308,   171,   226,   227,   228,   308,   144,
     198,   143,   308,   144,   143,   147,    27,   154,   259,   260,
     265,   212,   213,   213,   213,   172,   211,   238,   284,   146,
     242,   155,   243,   244,   244,   147,   156,   199,   144,   199,
     150,   203,   199,   143,   261,   265,   145,   150,   206,   150,
     199,   261,   192,   261,   143,   145,   150,   228,   143,   261,
     143,   261,   237,    27,   150,   260,    27,   198,   212,   212,
     212,   242,   244,   147,   242,   264,   244,   156,   261,   308,
     308,   261,   204,   145,   199,   143,   147,   143,   287,   149,
     233,   308,   149,   233,   308,   148,   214,   214,   244,   242,
     244,   308,   147,   308,   156,    65,   245,   245,   199,   145,
     195,   196,    47,   308,   231,   245,   231,   143,   212,   308,
     308,   308,   245,   146,    27,   246,   246,   212,   308,   287,
     143,   150,   143,   150,   214,   245,   246,   261,   265,   143,
     247,   248,   249,   247,   200,   308,   246,   247,   147,   249,
     143,   247
  };

  const unsigned short int
  Parser::yyr1_[] =
  {
       0,   167,   168,   168,   169,   170,   171,   172,   172,   174,
     175,   173,   176,   176,   176,   177,   177,   177,   177,   177,
     177,   177,   178,   179,   179,   180,   180,   180,   181,   181,
     182,   182,   182,   183,   183,   184,   184,   185,   185,   185,
     186,   187,   187,   187,   188,   189,   190,   191,   191,   192,
     192,   193,   193,   194,   195,   196,   196,   197,   197,   198,
     198,   199,   199,   200,   201,   201,   202,   202,   203,   203,
     203,   203,   203,   203,   203,   203,   203,   203,   203,   203,
     203,   203,   203,   203,   203,   203,   203,   203,   203,   203,
     203,   203,   203,   203,   203,   204,   204,   205,   205,   206,
     206,   207,   207,   207,   208,   209,   209,   209,   209,   209,
     209,   209,   209,   209,   209,   209,   209,   209,   209,   209,
     209,   209,   209,   209,   209,   209,   209,   209,   209,   209,
     209,   209,   209,   209,   209,   209,   209,   209,   209,   209,
     210,   211,   210,   212,   212,   212,   213,   214,   215,   215,
     216,   216,   216,   217,   217,   218,   219,   219,   220,   221,
     222,   222,   222,   223,   223,   225,   224,   226,   226,   227,
     227,   228,   228,   229,   230,   230,   231,   231,   232,   232,
     233,   233,   233,   233,   233,   233,   234,   235,   236,   236,
     236,   237,   237,   237,   237,   238,   238,   238,   239,   240,
     240,   241,   241,   241,   241,   242,   242,   243,   243,   244,
     244,   245,   245,   246,   246,   247,   247,   248,   248,   249,
     250,   250,   251,   251,   253,   254,   252,   255,   255,   255,
     256,   256,   256,   257,   258,   258,   259,   259,   260,   260,
     260,   260,   260,   262,   263,   261,   264,   264,   265,   265,
     266,   267,   267,   267,   267,   267,   267,   267,   268,   268,
     269,   269,   270,   270,   270,   271,   271,   271,   271,   271,
     272,   272,   273,   273,   274,   274,   275,   275,   275,   276,
     276,   276,   277,   277,   277,   277,   277,   278,   278,   278,
     278,   278,   278,   278,   279,   279,   279,   279,   279,   279,
     279,   279,   279,   279,   279,   280,   280,   280,   280,   280,
     280,   280,   281,   281,   281,   281,   281,   281,   282,   282,
     282,   282,   283,   284,   284,   284,   284,   284,   284,   284,
     284,   284,   284,   284,   284,   284,   284,   284,   284,   284,
     284,   284,   284,   284,   284,   284,   284,   284,   284,   284,
     284,   284,   284,   284,   284,   284,   284,   285,   285,   285,
     286,   286,   286,   287,   287,   288,   288,   289,   289,   289,
     290,   290,   290,   290,   291,   291,   292,   292,   292,   293,
     293,   294,   294,   295,   295,   296,   297,   297,   298,   299,
     300,   300,   302,   303,   301,   304,   304,   305,   305,   306,
     307,   307,   308,   308
  };

  const unsigned char
  Parser::yyr2_[] =
  {
       0,     2,     2,     2,     1,     4,     1,     1,     1,     0,
       0,     3,     2,     2,     0,     1,     1,     1,     1,     1,
       1,     1,     7,     6,     8,     5,     5,     7,     6,     4,
       6,     6,     8,     2,     3,     3,     5,     2,     4,     4,
       3,     1,     1,     0,    10,     9,     0,     1,     0,     1,
       0,     3,     1,     5,     2,     1,     0,     1,     0,     2,
       0,     1,     1,     3,     1,     0,     2,     1,     2,     1,
       3,     5,     3,     5,     2,     2,     7,     6,     6,     8,
       3,     2,     3,     2,     3,     7,     7,     2,     2,     7,
       5,     5,     3,     3,     3,     2,     0,     2,     1,     4,
       3,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     4,     4,     4,     4,
       6,     4,     4,     1,     4,     1,     1,     1,     1,     1,
       2,     1,     2,     1,     1,     1,     1,     1,     4,     4,
       3,     2,     1,     1,     3,     4,     2,     0,     5,     4,
       3,     2,     1,     1,     3,     0,     8,     1,     0,     2,
       1,     7,     5,     5,     3,     0,     2,     1,     1,     0,
       1,     1,     1,     1,     1,     1,     7,     4,     3,     5,
       4,     8,     8,     9,    10,     3,     4,     4,     3,     1,
       0,     1,     1,     1,     0,     3,     0,     3,     2,     1,
       0,     4,     0,     2,     0,     1,     1,     2,     1,     4,
       3,     0,     2,     0,     0,     0,     3,     1,     3,     1,
       1,     1,     0,     8,     3,     0,     2,     1,     5,     5,
       3,     3,     2,     0,     0,     3,     1,     0,     3,     1,
       1,     3,     3,     3,     3,     3,     5,     1,     3,     1,
       3,     1,     3,     3,     1,     3,     3,     3,     3,     1,
       3,     1,     3,     1,     3,     1,     3,     3,     1,     3,
       3,     1,     3,     3,     3,     3,     1,     2,     2,     2,
       3,     2,     2,     1,     4,     3,     6,     4,     3,     3,
       3,     2,     2,     3,     1,     7,     4,     4,     2,     2,
       5,     1,     1,     6,     2,     7,     9,     1,     3,     1,
       1,     1,     1,     1,     3,     1,     1,     1,     1,     1,
       1,     1,     2,     2,     4,     4,     4,     4,     4,     4,
       4,     4,     4,     4,     4,     4,     4,     4,     4,     4,
       1,     1,     1,     1,     1,     1,     1,     1,     2,     2,
       1,     2,     2,     1,     2,     3,     4,     1,     3,     0,
       1,     3,     1,     0,     1,     1,     3,     4,     7,     4,
       7,     4,     7,     4,     9,     3,     3,     1,     3,     1,
       3,     1,     0,     0,     5,     1,     0,     3,     1,     3,
       1,     3,     2,     0
  };



  // YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
  // First, the terminals, then, starting at \a yyntokens_, nonterminals.
  const char*
  const Parser::yytname_[] =
  {
  "\"<end of input>\"", "error", "$undefined", "\"identifier\"",
  "\"scoped identifier\"", "\"dotted identifier\"", "\"hook identifier\"",
  "\"$-identifier\"", "\"attribute\"", "\"property\"",
  "\"preprocessor directive\"", "\"string value\"", "\"bytes value\"",
  "\"regular expression value\"", "\"address value\"", "\"port value\"",
  "\"real value\"", "\"unsigned integer value\"", "\"$<N>\"",
  "\"bool value\"", "\"null value\"", "\"assert\"", "\"assert-exception\"",
  "ADD", "ADDRESS", "AND", "ANY", "ARROW", "AUTO", "BITFIELD", "BEGIN_",
  "BOOL", "BREAK", "BYTES", "CADDR", "CASE", "CAST", "CATCH", "CONST",
  "CONSTANT", "CONTINUE", "DEBUG_", "DECLARE", "DEFAULT", "DELETE",
  "DIVIDEASSIGN", "DOLLARDOLLAR", "DOTDOT", "REAL", "ELSE", "END_", "ENUM",
  "EQ", "EXCEPTION", "EXPORT", "FILE", "FOR", "FOREACH", "FROM",
  "FUNCTION", "GEQ", "GLOBAL", "HASATTR", "HOOK_COMPOSE", "HOOK_PARSE",
  "IF", "IMPORT", "IN", "INOUT", "INT", "INT16", "INT32", "INT64", "INT8",
  "INTERVAL", "INTERVAL_NS", "ITERATOR", "CONST_ITERATOR", "LEQ",
  "\"library type\"", "LIST", "LOCAL", "MAP", "MARK", "CAPTURES",
  "MINUSASSIGN", "MINUSMINUS", "MOD", "MODULE", "NEQ", "NET", "NETWORK",
  "NEW", "NONE", "NOT_IN", "OBJECT", "ON", "OPTIONAL", "OR", "PLUSASSIGN",
  "PLUSPLUS", "PORT", "POW", "PRINT", "PRIORITY", "PRIVATE", "PUBLIC",
  "REGEXP", "RETURN", "SET", "SHIFTLEFT", "SHIFTRIGHT", "SINK", "STOP",
  "\"stream\"", "STRING", "STRUCT", "SWITCH", "\"confirm\"", "\"reject\"",
  "THROW", "TIME", "TIME_NS", "TIMER", "TIMESASSIGN", "TRY", "TRYATTR",
  "TUPLE", "TYPE", "UINT", "UINT16", "UINT32", "UINT64", "UINT8", "UNIT",
  "UNSET", "VAR", "VECTOR", "VIEW", "VOID", "WHILE", "START_MODULE",
  "START_EXPRESSION", "';'", "'='", "':'", "'('", "')'", "','", "'{'",
  "'}'", "'&'", "'<'", "'>'", "'*'", "'['", "']'", "'?'", "'|'", "'^'",
  "'+'", "'-'", "'%'", "'/'", "'!'", "'~'", "'.'", "$accept", "start",
  "start_expr", "module", "local_id", "scoped_id", "dotted_id", "$@1",
  "$@2", "global_scope_items", "global_scope_decl", "type_decl",
  "constant_decl", "local_decl", "local_init_decl", "global_decl",
  "function_decl", "import_decl", "property_decl", "hook_decl",
  "opt_linkage", "function_with_body", "function_without_body",
  "opt_func_flavor", "opt_func_cc", "opt_func_params", "func_params",
  "func_param", "func_result", "opt_func_result", "opt_func_param_kind",
  "opt_init_expression", "block", "braced_block", "opt_stmts", "stmts",
  "stmt", "opt_else_block", "switch_cases", "switch_case", "stmt_decl",
  "stmt_expr", "base_type_no_ref", "reference_type", "base_type", "type",
  "type_param_begin", "type_param_end", "tuple_type", "tuple_type_elems",
  "tuple_type_elem", "struct_type", "struct_fields", "struct_field",
  "enum_type", "enum_labels", "enum_label", "bitfield_type", "$@3",
  "opt_bitfield_bits", "bitfield_bits", "bitfield_bits_spec", "unit_type",
  "opt_unit_params", "unit_items", "opt_unit_items", "unit_item",
  "unit_variable", "unit_sink", "unit_property", "unit_field",
  "unit_field_in_container", "unit_wide_hook", "opt_unit_field_id",
  "opt_unit_field_engine", "opt_unit_field_args", "unit_field_repeat",
  "opt_unit_field_repeat", "opt_unit_field_condition",
  "opt_unit_field_sinks", "opt_unit_item_hooks", "unit_hooks", "unit_hook",
  "opt_unit_hook_params", "opt_unit_hook_attributes", "unit_hook_id",
  "$@4", "$@5", "unit_hook_attribute", "opt_hook_engine", "unit_switch",
  "opt_unit_switch_expr", "unit_switch_cases", "unit_switch_case", "expr",
  "$@6", "$@7", "opt_exprs", "exprs", "expr_0", "expr_1", "expr_2",
  "expr_3", "expr_4", "expr_5", "expr_6", "expr_7", "expr_8", "expr_9",
  "expr_a", "expr_b", "expr_c", "expr_d", "expr_e", "expr_f", "expr_g",
  "member_expr", "ctor", "const_real", "const_sint", "const_uint", "tuple",
  "opt_tuple_elems1", "opt_tuple_elems2", "tuple_elem", "list", "vector",
  "set", "map", "struct_", "struct_elems", "struct_elem", "regexp",
  "re_patterns", "re_pattern_constant", "$@8", "$@9", "opt_map_elems",
  "map_elems", "map_elem", "attribute", "opt_attributes", YY_NULLPTR
  };

#if YYDEBUG
  const unsigned short int
  Parser::yyrline_[] =
  {
       0,   295,   295,   296,   299,   301,   309,   319,   320,   322,
     324,   322,   329,   331,   333,   337,   338,   339,   340,   341,
     342,   343,   345,   354,   356,   360,   361,   362,   367,   369,
     373,   375,   377,   381,   383,   387,   388,   391,   392,   393,
     396,   404,   405,   406,   411,   418,   425,   427,   433,   437,
     438,   440,   441,   443,   446,   448,   449,   452,   453,   456,
     457,   462,   463,   466,   468,   469,   471,   472,   474,   475,
     476,   477,   478,   479,   481,   482,   483,   485,   487,   489,
     491,   492,   493,   494,   495,   496,   498,   500,   501,   502,
     504,   506,   509,   517,   525,   536,   537,   539,   540,   542,
     543,   545,   546,   547,   550,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   569,   570,
     571,   572,   573,   574,   575,   576,   578,   579,   580,   581,
     583,   584,   585,   587,   589,   591,   592,   593,   594,   595,
     600,   602,   603,   606,   607,   608,   612,   616,   619,   620,
     624,   626,   627,   631,   632,   635,   637,   638,   640,   642,
     644,   645,   646,   649,   650,   654,   653,   659,   661,   664,
     666,   669,   671,   676,   680,   681,   683,   684,   686,   687,
     690,   691,   692,   693,   694,   695,   699,   702,   704,   705,
     707,   710,   716,   719,   722,   726,   728,   730,   733,   736,
     737,   740,   741,   742,   743,   746,   747,   750,   751,   754,
     755,   758,   759,   762,   763,   766,   767,   769,   770,   772,
     776,   777,   780,   782,   784,   786,   784,   789,   790,   791,
     796,   797,   798,   800,   803,   804,   807,   809,   812,   813,
     814,   815,   816,   823,   825,   823,   829,   830,   832,   833,
     835,   838,   839,   840,   841,   842,   843,   844,   846,   847,
     849,   850,   852,   853,   854,   856,   857,   858,   859,   860,
     862,   863,   865,   866,   868,   869,   871,   872,   873,   875,
     876,   877,   879,   880,   881,   882,   883,   885,   886,   887,
     888,   889,   890,   891,   893,   894,   895,   896,   897,   898,
     899,   900,   901,   902,   903,   905,   906,   907,   908,   909,
     910,   911,   913,   914,   915,   916,   918,   920,   922,   923,
     924,   925,   931,   935,   936,   937,   938,   939,   940,   941,
     943,   944,   945,   946,   947,   948,   951,   954,   955,   958,
     961,   962,   964,   965,   966,   967,   968,   969,   970,   971,
     973,   974,   975,   976,   977,   978,   979,   982,   983,   984,
     986,   987,   988,   990,   991,   993,   994,   997,   998,   999,
    1002,  1003,  1004,  1005,  1008,  1009,  1011,  1012,  1013,  1016,
    1017,  1020,  1021,  1024,  1025,  1028,  1031,  1032,  1034,  1036,
    1038,  1040,  1043,  1043,  1043,  1046,  1047,  1049,  1050,  1052,
    1056,  1057,  1060,  1061
  };

  // Print the state stack on the debug stream.
  void
  Parser::yystack_print_ ()
  {
    *yycdebug_ << "Stack now";
    for (stack_type::const_iterator
           i = yystack_.begin (),
           i_end = yystack_.end ();
         i != i_end; ++i)
      *yycdebug_ << ' ' << i->state;
    *yycdebug_ << std::endl;
  }

  // Report on the debug stream that the rule \a yyrule is going to be reduced.
  void
  Parser::yy_reduce_print_ (int yyrule)
  {
    unsigned int yylno = yyrline_[yyrule];
    int yynrhs = yyr2_[yyrule];
    // Print the symbols being reduced, and their result.
    *yycdebug_ << "Reducing stack by rule " << yyrule - 1
               << " (line " << yylno << "):" << std::endl;
    // The symbols being reduced.
    for (int yyi = 0; yyi < yynrhs; yyi++)
      YY_SYMBOL_PRINT ("   $" << yyi + 1 << " =",
                       yystack_[(yynrhs) - (yyi + 1)]);
  }
#endif // YYDEBUG

  // Symbol number corresponding to token number t.
  inline
  Parser::token_number_type
  Parser::yytranslate_ (int t)
  {
    static
    const token_number_type
    translate_table[] =
    {
     0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   164,     2,     2,     2,   162,   151,     2,
     146,   147,   154,   160,   148,   161,   166,   163,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   145,   143,
     152,   144,   153,   157,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   155,     2,   156,   159,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   149,   158,   150,   165,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142
    };
    const unsigned int user_token_number_max_ = 397;
    const token_number_type undef_token_ = 2;

    if (static_cast<int>(t) <= yyeof_)
      return yyeof_;
    else if (static_cast<unsigned int> (t) <= user_token_number_max_)
      return translate_table[t];
    else
      return undef_token_;
  }

#line 28 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:1167
} } } // spicy::detail::parser
#line 7779 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc" // lalr1.cc:1167
#line 1063 "/builddir/build/BUILD/zeek-5.0.9/build/auxil/spicy/spicy/spicy/src/autogen/__parser.cc.pp" // lalr1.cc:1168


void spicy::detail::parser::Parser::error(const Parser::location_type& l, const std::string& m) {
    driver->error(m, toMeta(l));
}
