/* A Bison parser, made by GNU Bison 3.0.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* Copy the first part of user declarations.  */
#line 1 "parse.y" /* yacc.c:339  */

// See the file "COPYING" in the main distribution directory for copyright.
#line 80 "parse.y" /* yacc.c:339  */

#include <stdlib.h>
#include <string.h>
#include <assert.h>

#include <set>
#include <string>

#include "zeek/input.h"
#include "zeek/ZeekList.h"
#include "zeek/Desc.h"
#include "zeek/Expr.h"
#include "zeek/Func.h"
#include "zeek/Stmt.h"
#include "zeek/Val.h"
#include "zeek/Var.h"
#include "zeek/RE.h"
#include "zeek/Scope.h"
#include "zeek/Reporter.h"
#include "zeek/ScriptCoverageManager.h"
#include "zeek/zeekygen/Manager.h"
#include "zeek/module_util.h"
#include "zeek/IntrusivePtr.h"
#include "zeek/script_opt/IDOptInfo.h"

extern const char* filename;  // Absolute path of file currently being parsed.
extern const char* last_filename; // Absolute path of last file parsed.
extern const char* last_tok_filename;
extern const char* last_last_tok_filename;

extern int conditional_epoch; // let's us track embedded conditionals

// Whether the file we're currently parsing includes @if conditionals.
extern bool current_file_has_conditionals;

extern YYLTYPE GetCurrentLocation();
extern int yyerror(const char[]);
extern int brolex();

#define YYLLOC_DEFAULT(Current, Rhs, N) \
	(Current) = (Rhs)[(N)];

using namespace zeek;
using namespace zeek::detail;

// Part of the module facility: while parsing, keep track of which
// module to put things in.
std::string zeek::detail::current_module = GLOBAL_MODULE_NAME;

bool is_export = false; // true if in an export {} block

// When parsing an expression for the debugger, where to put the result
// (obviously not reentrant).
extern Expr* g_curr_debug_expr;
extern bool in_debug;
extern const char* g_curr_debug_error;

extern int in_when_cond;

static int in_hook = 0;
int in_init = 0;
int in_record = 0;
static int in_record_redef = 0;
static int in_enum_redef = 0;
bool resolving_global_ID = false;
bool defining_global_ID = false;
std::vector<int> saved_in_init;

std::vector<std::set<const ID*>> locals_at_this_scope;
static std::unordered_set<const ID*> out_of_scope_locals;
static std::unordered_set<const ID*> warned_about_locals;

static Location func_hdr_location;
static int func_hdr_cond_epoch = 0;
EnumType* cur_enum_type = nullptr;
static ID* cur_decl_type_id = nullptr;

static void parse_new_enum(void)
	{
	// Starting a new enum definition.
	assert(cur_enum_type == nullptr);

	if ( cur_decl_type_id )
		{
		auto name = make_full_var_name(current_module.c_str(), cur_decl_type_id->Name());
		cur_enum_type = new EnumType(name);
		}
	else
		reporter->FatalError("incorrect syntax for enum type declaration");
	}

static void parse_redef_enum(ID* id)
	{
	// Redef an enum. id points to the enum to be redefined.
	// Let cur_enum_type point to it.
	assert(cur_enum_type == nullptr);

	// abort on errors; enums need to be accessible to continue parsing
	if ( ! id->GetType() )
		reporter->FatalError("unknown enum identifier \"%s\"", id->Name());
	else
		{
		if ( ! id->GetType() || id->GetType()->Tag() != TYPE_ENUM )
			reporter->FatalError("identifier \"%s\" is not an enum", id->Name());
		cur_enum_type = id->GetType()->AsEnumType();
		}
	}

static void extend_record(ID* id, std::unique_ptr<type_decl_list> fields,
                          std::unique_ptr<std::vector<AttrPtr>> attrs)
	{
	const auto& types = Type::Aliases(id->Name());

	if ( types.empty() )
		{
		id->Error("failed to redef record: no types found in alias map");
		return;
		}

	bool add_log_attr = false;

	if ( attrs )
		for ( const auto& at : *attrs )
			if ( at->Tag() == ATTR_LOG )
				{
				add_log_attr = true;
				break;
				}

	for ( const auto& t : types )
		{
		auto error = t->AsRecordType()->AddFields(*fields, add_log_attr);

		if ( error )
			{
			id->Error(error);
			break;
			}
		}
	}

static AttributesPtr
make_attributes(std::vector<AttrPtr>* attrs,
                TypePtr t, bool in_record, bool is_global)
	{
	if ( ! attrs )
		return nullptr;

	auto rval = make_intrusive<Attributes>(std::move(*attrs), std::move(t),
	                                       in_record, is_global);
	delete attrs;
	return rval;
	}

static bool expr_is_table_type_name(const Expr* expr)
	{
	if ( expr->Tag() != EXPR_NAME )
		return false;

	const auto& type = expr->GetType();

	if ( type->IsTable() )
		return true;

	if ( type->Tag() == TYPE_TYPE )
		return type->AsTypeType()->GetType()->IsTable();

	return false;
	}

static void build_global(ID* id, Type* t, InitClass ic, Expr* e,
                         std::vector<AttrPtr>* attrs, DeclType dt)
	{
	IDPtr id_ptr{AdoptRef{}, id};
	TypePtr t_ptr{AdoptRef{}, t};
	ExprPtr e_ptr{AdoptRef{}, e};

	auto attrs_ptr = attrs ? std::make_unique<std::vector<AttrPtr>>(*attrs) : nullptr;

	add_global(id_ptr, std::move(t_ptr), ic, e_ptr, std::move(attrs_ptr), dt);

	id->GetOptInfo()->AddInitExpr(e_ptr);

	if ( dt == VAR_REDEF )
		zeekygen_mgr->Redef(id, ::filename, ic, std::move(e_ptr));
	else
		zeekygen_mgr->Identifier(std::move(id_ptr));
	}

static StmtPtr build_local(ID* id, Type* t, InitClass ic, Expr* e,
                           std::vector<AttrPtr>* attrs, DeclType dt,
                           bool do_coverage)
	{
	IDPtr id_ptr{AdoptRef{}, id};
	TypePtr t_ptr{AdoptRef{}, t};
	ExprPtr e_ptr{AdoptRef{}, e};

	auto attrs_ptr = attrs ? std::make_unique<std::vector<AttrPtr>>(*attrs) : nullptr;

	auto init = add_local(std::move(id_ptr), std::move(t_ptr), ic,
	                      e_ptr, std::move(attrs_ptr), dt);

	id->GetOptInfo()->AddInitExpr(std::move(e_ptr));

	if ( do_coverage )
		script_coverage_mgr.AddStmt(init.get());

	return init;
	}

#line 280 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "broparse.h".  */
#ifndef YY_YY_BUILDDIR_BUILD_BUILD_ZEEK_5_0_9_BUILD_SRC_BROPARSE_H_INCLUDED
# define YY_YY_BUILDDIR_BUILD_BUILD_ZEEK_5_0_9_BUILD_SRC_BROPARSE_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 1
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    TOK_ADD = 258,
    TOK_ADD_TO = 259,
    TOK_ADDR = 260,
    TOK_ANY = 261,
    TOK_ATENDIF = 262,
    TOK_ATELSE = 263,
    TOK_ATIF = 264,
    TOK_ATIFDEF = 265,
    TOK_ATIFNDEF = 266,
    TOK_BOOL = 267,
    TOK_BREAK = 268,
    TOK_CASE = 269,
    TOK_OPTION = 270,
    TOK_CONST = 271,
    TOK_CONSTANT = 272,
    TOK_COPY = 273,
    TOK_COUNT = 274,
    TOK_DEFAULT = 275,
    TOK_DELETE = 276,
    TOK_DOUBLE = 277,
    TOK_ELSE = 278,
    TOK_ENUM = 279,
    TOK_EVENT = 280,
    TOK_EXPORT = 281,
    TOK_FALLTHROUGH = 282,
    TOK_FILE = 283,
    TOK_FOR = 284,
    TOK_FUNCTION = 285,
    TOK_GLOBAL = 286,
    TOK_HOOK = 287,
    TOK_ID = 288,
    TOK_IF = 289,
    TOK_INT = 290,
    TOK_INTERVAL = 291,
    TOK_LIST = 292,
    TOK_MODULE = 293,
    TOK_LOCAL = 294,
    TOK_WHEN_LOCAL = 295,
    TOK_NEXT = 296,
    TOK_OF = 297,
    TOK_OPAQUE = 298,
    TOK_PATTERN = 299,
    TOK_PATTERN_END = 300,
    TOK_PATTERN_TEXT = 301,
    TOK_PORT = 302,
    TOK_PRINT = 303,
    TOK_RECORD = 304,
    TOK_REDEF = 305,
    TOK_REMOVE_FROM = 306,
    TOK_RETURN = 307,
    TOK_SCHEDULE = 308,
    TOK_SET = 309,
    TOK_STRING = 310,
    TOK_SUBNET = 311,
    TOK_SWITCH = 312,
    TOK_TABLE = 313,
    TOK_TIME = 314,
    TOK_TIMEOUT = 315,
    TOK_TYPE = 316,
    TOK_VECTOR = 317,
    TOK_WHEN = 318,
    TOK_WHILE = 319,
    TOK_AS = 320,
    TOK_IS = 321,
    TOK_ATTR_ADD_FUNC = 322,
    TOK_ATTR_DEFAULT = 323,
    TOK_ATTR_OPTIONAL = 324,
    TOK_ATTR_REDEF = 325,
    TOK_ATTR_DEL_FUNC = 326,
    TOK_ATTR_EXPIRE_FUNC = 327,
    TOK_ATTR_EXPIRE_CREATE = 328,
    TOK_ATTR_EXPIRE_READ = 329,
    TOK_ATTR_EXPIRE_WRITE = 330,
    TOK_ATTR_RAW_OUTPUT = 331,
    TOK_ATTR_ON_CHANGE = 332,
    TOK_ATTR_BROKER_STORE = 333,
    TOK_ATTR_BROKER_STORE_ALLOW_COMPLEX = 334,
    TOK_ATTR_BACKEND = 335,
    TOK_ATTR_PRIORITY = 336,
    TOK_ATTR_LOG = 337,
    TOK_ATTR_ERROR_HANDLER = 338,
    TOK_ATTR_TYPE_COLUMN = 339,
    TOK_ATTR_DEPRECATED = 340,
    TOK_ATTR_IS_ASSIGNED = 341,
    TOK_ATTR_IS_USED = 342,
    TOK_DEBUG = 343,
    TOK_NO_TEST = 344,
    TOK_OR_OR = 345,
    TOK_AND_AND = 346,
    TOK_LE = 347,
    TOK_GE = 348,
    TOK_EQ = 349,
    TOK_NE = 350,
    TOK_IN = 351,
    TOK_NOT_IN = 352,
    TOK_INCR = 353,
    TOK_DECR = 354,
    TOK_HAS_FIELD = 355,
    TOK_HAS_ATTR = 356
  };
#endif

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED

union YYSTYPE
{
#line 291 "parse.y" /* yacc.c:355  */

	bool b;
	char* str;
	zeek::detail::ID* id;
	zeek::IDPList* id_l;
	zeek::detail::InitClass ic;
	zeek::Val* val;
	zeek::RE_Matcher* re;
	zeek::detail::Expr* expr;
	zeek::detail::EventExpr* event_expr;
	zeek::detail::Stmt* stmt;
	zeek::detail::ListExpr* list;
	zeek::Type* type;
	zeek::RecordType* record;
	zeek::FuncType* func_type;
	zeek::TypeList* type_l;
	zeek::TypeDecl* type_decl;
	zeek::type_decl_list* type_decl_l;
	zeek::detail::Case* c_case;
	zeek::detail::case_list* case_l;
	zeek::detail::Attr* attr;
	std::vector<zeek::detail::AttrPtr>* attr_l;
	zeek::detail::AttrTag attrtag;
	zeek::FuncType::Capture* capture;
	zeek::FuncType::CaptureList* captures;
	zeek::detail::WhenInfo* when_clause;

#line 450 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:355  */
};

typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif

/* Location type.  */
#if ! defined YYLTYPE && ! defined YYLTYPE_IS_DECLARED
typedef struct YYLTYPE YYLTYPE;
struct YYLTYPE
{
  int first_line;
  int first_column;
  int last_line;
  int last_column;
};
# define YYLTYPE_IS_DECLARED 1
# define YYLTYPE_IS_TRIVIAL 1
#endif


extern YYSTYPE yylval;
extern YYLTYPE yylloc;
int yyparse (void);

#endif /* !YY_YY_BUILDDIR_BUILD_BUILD_ZEEK_5_0_9_BUILD_SRC_BROPARSE_H_INCLUDED  */

/* Copy the second part of user declarations.  */

#line 481 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL \
             && defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
  YYLTYPE yyls_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE) + sizeof (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  5
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   3125

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  126
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  97
/* YYNRULES -- Number of rules.  */
#define YYNRULES  281
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  738

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   356

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   114,     2,     2,   116,   111,   106,     2,
     119,   120,   109,   107,    90,   108,     2,   110,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    93,   125,
      96,    91,    97,    92,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   117,     2,   118,   105,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   123,   104,   124,   115,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    94,    95,    98,    99,   100,
     101,   102,   103,   112,   113,   121,   122
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   323,   323,   322,   347,   347,   354,   355,   359,   362,
     366,   374,   378,   386,   392,   400,   403,   408,   410,   414,
     414,   414,   419,   425,   431,   437,   443,   449,   455,   491,
     497,   503,   509,   515,   521,   527,   533,   539,   545,   551,
     557,   563,   569,   575,   581,   587,   593,   599,   605,   611,
     623,   632,   641,   643,   649,   656,   655,   665,   671,   679,
     704,   711,   717,   717,   717,   725,   732,   739,   745,   738,
     788,   788,   801,   807,   809,   815,   880,   886,   886,   900,
     907,   913,   920,   920,   925,   928,   930,   934,   940,   948,
     950,   954,   960,   968,   970,   979,   992,  1000,  1010,  1015,
    1020,  1025,  1030,  1035,  1040,  1045,  1050,  1055,  1060,  1065,
    1070,  1076,  1083,  1085,  1082,  1092,  1092,  1099,  1107,  1115,
    1121,  1127,  1133,  1139,  1145,  1151,  1157,  1177,  1179,  1187,
    1192,  1198,  1211,  1213,  1216,  1220,  1222,  1224,  1229,  1238,
    1244,  1244,  1247,  1252,  1257,  1262,  1268,  1267,  1276,  1278,
    1280,  1275,  1293,  1292,  1304,  1303,  1310,  1313,  1314,  1318,
    1320,  1322,  1324,  1326,  1331,  1340,  1354,  1363,  1374,  1384,
    1373,  1404,  1410,  1403,  1436,  1441,  1460,  1463,  1467,  1472,
    1481,  1507,  1510,  1514,  1516,  1521,  1524,  1528,  1529,  1530,
    1531,  1535,  1535,  1535,  1538,  1542,  1566,  1568,  1572,  1574,
    1582,  1584,  1586,  1588,  1590,  1592,  1594,  1596,  1598,  1600,
    1602,  1604,  1606,  1608,  1610,  1612,  1614,  1616,  1618,  1620,
    1622,  1624,  1644,  1643,  1660,  1668,  1676,  1683,  1690,  1697,
    1703,  1709,  1717,  1725,  1733,  1741,  1749,  1757,  1765,  1773,
    1779,  1785,  1795,  1803,  1810,  1815,  1822,  1826,  1848,  1851,
    1855,  1858,  1861,  1866,  1869,  1877,  1883,  1900,  1928,  1933,
    1966,  1987,  1989,  1997,  2019,  2019,  2024,  2024,  2024,  2029,
    2029,  2034,  2072,  2086,  2089,  2093,  2096,  2100,  2103,  2117,
    2120,  2121
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "TOK_ADD", "TOK_ADD_TO", "TOK_ADDR",
  "TOK_ANY", "TOK_ATENDIF", "TOK_ATELSE", "TOK_ATIF", "TOK_ATIFDEF",
  "TOK_ATIFNDEF", "TOK_BOOL", "TOK_BREAK", "TOK_CASE", "TOK_OPTION",
  "TOK_CONST", "TOK_CONSTANT", "TOK_COPY", "TOK_COUNT", "TOK_DEFAULT",
  "TOK_DELETE", "TOK_DOUBLE", "TOK_ELSE", "TOK_ENUM", "TOK_EVENT",
  "TOK_EXPORT", "TOK_FALLTHROUGH", "TOK_FILE", "TOK_FOR", "TOK_FUNCTION",
  "TOK_GLOBAL", "TOK_HOOK", "TOK_ID", "TOK_IF", "TOK_INT", "TOK_INTERVAL",
  "TOK_LIST", "TOK_MODULE", "TOK_LOCAL", "TOK_WHEN_LOCAL", "TOK_NEXT",
  "TOK_OF", "TOK_OPAQUE", "TOK_PATTERN", "TOK_PATTERN_END",
  "TOK_PATTERN_TEXT", "TOK_PORT", "TOK_PRINT", "TOK_RECORD", "TOK_REDEF",
  "TOK_REMOVE_FROM", "TOK_RETURN", "TOK_SCHEDULE", "TOK_SET", "TOK_STRING",
  "TOK_SUBNET", "TOK_SWITCH", "TOK_TABLE", "TOK_TIME", "TOK_TIMEOUT",
  "TOK_TYPE", "TOK_VECTOR", "TOK_WHEN", "TOK_WHILE", "TOK_AS", "TOK_IS",
  "TOK_ATTR_ADD_FUNC", "TOK_ATTR_DEFAULT", "TOK_ATTR_OPTIONAL",
  "TOK_ATTR_REDEF", "TOK_ATTR_DEL_FUNC", "TOK_ATTR_EXPIRE_FUNC",
  "TOK_ATTR_EXPIRE_CREATE", "TOK_ATTR_EXPIRE_READ",
  "TOK_ATTR_EXPIRE_WRITE", "TOK_ATTR_RAW_OUTPUT", "TOK_ATTR_ON_CHANGE",
  "TOK_ATTR_BROKER_STORE", "TOK_ATTR_BROKER_STORE_ALLOW_COMPLEX",
  "TOK_ATTR_BACKEND", "TOK_ATTR_PRIORITY", "TOK_ATTR_LOG",
  "TOK_ATTR_ERROR_HANDLER", "TOK_ATTR_TYPE_COLUMN", "TOK_ATTR_DEPRECATED",
  "TOK_ATTR_IS_ASSIGNED", "TOK_ATTR_IS_USED", "TOK_DEBUG", "TOK_NO_TEST",
  "','", "'='", "'?'", "':'", "TOK_OR_OR", "TOK_AND_AND", "'<'", "'>'",
  "TOK_LE", "TOK_GE", "TOK_EQ", "TOK_NE", "TOK_IN", "TOK_NOT_IN", "'|'",
  "'^'", "'&'", "'+'", "'-'", "'*'", "'/'", "'%'", "TOK_INCR", "TOK_DECR",
  "'!'", "'~'", "'$'", "'['", "']'", "'('", "')'", "TOK_HAS_FIELD",
  "TOK_HAS_ATTR", "'{'", "'}'", "';'", "$accept", "zeek", "$@1", "$@2",
  "decl_list", "opt_expr", "when_clause", "when_head", "when_start",
  "when_flavor", "when_captures", "when_condition", "$@3", "$@4", "expr",
  "$@5", "$@6", "$@7", "$@8", "$@9", "$@10", "$@11", "rhs", "$@12",
  "rhs_expr_list", "expr_list", "opt_expr_list", "enum_body",
  "enum_body_list", "enum_body_elem", "type", "$@13", "$@14", "$@15",
  "type_list", "type_decl_list", "type_decl", "formal_args",
  "formal_args_decl_list", "formal_args_decl", "decl", "$@16", "$@17",
  "$@18", "$@19", "$@20", "$@21", "$@22", "conditional_list",
  "conditional", "func_hdr", "func_body", "$@23", "$@24", "lambda_body",
  "$@25", "$@26", "anonymous_function", "begin_lambda", "opt_captures",
  "capture_list", "capture", "opt_deep", "func_params", "opt_type",
  "init_class", "opt_init", "$@27", "$@28", "index_slice", "opt_attr",
  "attr_list", "attr", "stmt", "$@29", "stmt_list", "event", "case_list",
  "case", "case_type_list", "case_type", "for_head", "local_id_list",
  "local_id", "global_id", "$@30", "def_global_id", "$@31", "$@32",
  "event_id", "$@33", "global_or_event_id", "resolve_id", "opt_no_test",
  "opt_no_test_block", "opt_deprecated", "opt_comma", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
      44,    61,    63,    58,   345,   346,    60,    62,   347,   348,
     349,   350,   351,   352,   124,    94,    38,    43,    45,    42,
      47,    37,   353,   354,    33,   126,    36,    91,    93,    40,
      41,   355,   356,   123,   125,    59
};
# endif

#define YYPACT_NINF -631

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-631)))

#define YYTABLE_NINF -195

#define yytable_value_is_error(Yytable_value) \
  (!!((Yytable_value) == (-195)))

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
     -64,  -631,    68,  3064,  2522,  -631,  -631,  -631,   -47,   -42,
      13,  -631,  -631,  -631,   -44,  -631,  -631,  -631,   113,   119,
    -631,  -631,  -631,  -631,  -631,  -631,    29,    38,  -631,  -631,
     130,    58,  2522,    60,    63,    79,  2522,  2522,  2522,  -631,
    2522,  2522,  2522,  2522,   151,  2407,  2522,  2071,  -631,  -631,
    2522,   166,   168,   120,  -631,   120,    93,   181,  -631,    93,
     120,    93,    97,  -631,  -631,  -631,   120,   181,   125,   956,
    -631,  2522,   205,   101,    93,  2522,  -631,   134,  2522,  1126,
    2522,  -631,  2522,  2134,   179,   179,   182,   179,   179,   179,
     179,    50,  -631,  2071,   -27,  1315,  2292,  2292,  2664,  2664,
    2292,  2549,  2522,  2522,  2522,  2522,  2522,  2522,  2522,  2522,
    2522,  2522,  2522,  2522,  2522,  2522,  2522,  2522,  2522,  2522,
     198,  2549,  -631,   199,  1378,   121,   122,  2664,    65,  -631,
      65,   207,  1253,  -631,  -631,  -631,  1253,    65,  1253,  -631,
     239,    93,  -631,    65,  -631,  -631,  2522,   126,   130,  2522,
     213,   128,   131,   135,   130,   133,  2522,   446,  2522,  -631,
     142,  -631,  -631,  -631,   202,   956,   -29,   695,  -631,   172,
    -631,   956,    11,  1441,  -631,   -24,  -631,   231,  -631,  -631,
    -631,  2850,  2292,   -38,   213,   176,   158,  2522,   162,  2445,
     241,  2522,   193,  2522,  -631,  -631,  -631,  2071,  -631,  -631,
    -631,  -631,  -631,  -631,  -631,   167,   169,   249,    93,   178,
    -631,  -631,  -631,   260,   261,  -631,  -631,   183,   190,  -631,
    -631,   194,  -631,   268,  -631,  -631,  -631,  -631,  1504,  2776,
    2850,  2876,  2876,  2876,  2876,  2876,  2876,   100,   100,   309,
    1331,   227,  1085,  1085,   179,   179,   179,  -631,   225,  1567,
      31,  2522,  -631,  -631,  -631,  -631,  -631,  -631,  -631,  -631,
     579,  -631,   579,   229,   200,   -41,  -631,   232,   233,  -631,
    -631,   235,   238,   240,   251,   258,  -631,   259,   262,  -631,
     263,   264,  -631,  -631,   266,   267,  -631,  -631,  -631,  1253,
    -631,   165,  -631,   579,  -631,   217,  1253,   355,   579,  2664,
     814,   272,   120,   933,   265,   253,   272,     2,  2522,   120,
     272,    -5,  -631,   272,   996,  1189,  2522,   290,  2522,  -631,
      47,  -631,   272,  2522,  -631,  -631,  -631,  -631,  -631,   205,
    -631,  -631,  -631,  -631,  -631,   256,  1253,   269,  -631,  -631,
    2071,  -631,  2071,  2522,  -631,   207,  2664,  -631,   207,  2664,
     348,  -631,  2664,  2664,  2664,  2522,  2522,  -631,  -631,  1253,
    2292,  1253,  2664,   289,   207,   207,  2522,  2522,  2522,  2522,
    2522,  2522,  2522,  2522,  2522,  2522,  2522,  2522,   366,  -631,
    -631,  1253,  -631,  -631,   270,  1253,  1253,   272,  -631,  -631,
      65,   272,  2522,   272,  -631,    48,   130,  1630,    65,  -631,
     272,  -631,   272,  -631,  1693,  -631,  -631,  1252,   273,   295,
     275,  2522,  -631,  1063,  -631,  -631,   956,  -631,  -631,  -631,
     101,   276,   296,   357,   279,  -631,   282,  -631,  -631,  -631,
    -631,    33,    39,  -631,  2682,   274,  2071,   283,   280,  -631,
     281,  1253,  2664,  -631,  -631,  2071,  2071,  2071,  2071,  2071,
    2071,  2071,  2071,  2071,  2071,  2071,  2071,  -631,   284,   357,
    -631,   285,   286,  -631,   579,  -631,   288,  -631,   371,  2522,
      43,  -631,   956,   579,  -631,  -631,    34,   956,   718,   290,
     293,  -631,  2071,   272,   956,   297,  1253,  -631,  -631,  2522,
    -631,   -10,   298,   323,  -631,  -631,  -631,   390,  2664,  -631,
     385,  -631,  -631,  -631,  -631,  -631,  -631,  -631,  -631,   305,
    -631,  -631,  -631,  1253,  -631,   329,  1756,   130,    57,   410,
    1253,  2434,   341,  -631,  -631,  -631,  -631,  -631,  -631,  -631,
    -631,   311,  -631,  -631,   345,    10,  -631,  -631,   357,   352,
     326,  -631,  -631,  2664,   322,   390,   327,  2522,  -631,  -631,
     421,  2522,   956,   330,  2709,   -67,    -7,  -631,  -631,   837,
     336,  -631,   441,   374,   443,  -631,  2664,  -631,  -631,  -631,
     343,   272,  1819,   368,  1882,  -631,   272,   403,  -631,   411,
    -631,   956,  -631,  -631,  -631,  -631,  -631,  1253,  1253,  -631,
    -631,  2522,  -631,  -631,   438,   956,  -631,   956,   349,   350,
    1945,  -631,  -631,  -631,  -631,  -631,   130,   354,   358,  2549,
    2549,  2549,  2549,  2549,  2549,   447,  2319,  2319,  2709,  2709,
    2319,  2549,  2549,  2549,  2549,  2549,  2549,  2549,  2549,  2549,
    2549,  2549,  2549,  2549,  2549,  2549,  2549,  2549,  2549,  2549,
    2197,   439,   363,   442,   373,   449,  2549,  2549,   392,  2522,
    -631,   211,   211,   211,   211,   211,   211,    71,  2197,  2008,
    2803,  2923,  2949,  2949,  2949,  2949,  2949,  2949,   164,   164,
     423,  1394,   332,  1142,  1142,   211,   211,   211,  2709,   207,
    2709,  2664,  2709,  2197,  2923,  2319,   372,  2522,  2549,  2549,
     376,    74,  1505,   377,  2197,  2729,  -631,   451,   407,   412,
     414,   415,   416,   419,   420,   422,   424,   425,   427,   429,
    1505,  -631,  2709,  2549,  2549,  2549,  2549,  2549,  2549,  2549,
    2549,  2549,  2549,  2549,  2549,  1505,  2197,  2197,  2197,  2197,
    2197,  2197,  2197,  2197,  2197,  2197,  2197,  2197
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
       7,     4,     0,     2,     0,     1,   162,   163,     0,     0,
       0,   266,   266,   269,     0,   266,   266,   266,     0,   264,
     264,   246,     6,   156,   154,    76,     0,   177,    70,    75,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    77,
       0,     0,     0,     0,     0,     0,     0,     5,    73,    52,
       0,     0,     0,   186,   264,   186,     0,     0,   140,     0,
     186,     0,     0,   264,   269,   264,   186,     0,     0,     3,
     157,     0,   182,     0,     0,     0,   263,     0,     0,     0,
      90,    62,    90,     0,    29,    28,     0,    24,    25,    26,
      27,   177,    60,    88,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     9,    67,     0,     0,     0,     0,     0,   187,   267,
     187,   134,   197,   271,   270,     7,   197,   187,   197,   139,
       0,     0,   148,   187,   265,   152,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    16,
       0,   222,   243,   240,    11,     0,     0,     0,   244,    52,
     245,     0,     0,     0,   181,     0,   179,     0,   171,   174,
     175,    71,     0,     0,     0,    89,     0,    90,     0,    79,
       0,     0,     0,     0,    59,    22,    82,    84,    31,    33,
     107,   109,    98,   100,   101,     0,     0,   124,     0,     0,
     272,    99,   103,   117,     0,   105,   106,     0,     0,   104,
     108,     0,   102,     0,    80,   126,    81,    49,     0,    41,
      40,    44,    46,    45,    47,    42,    43,    57,    58,    38,
      39,    37,    30,    32,    34,    35,    36,    53,     0,    88,
       0,    90,    72,   159,   160,   161,   185,   189,   190,   188,
     191,   268,   191,     0,     0,   132,   137,     0,     0,   201,
     202,     0,     0,     0,     0,     0,   215,     0,     0,   209,
       0,     0,   218,   219,     0,   220,   203,   204,   165,   196,
     199,     0,   164,   191,   166,     0,   197,     0,   191,     0,
       0,   274,   186,     0,     0,     0,   274,     0,     0,   186,
     274,     0,    15,   274,     0,     0,     0,   276,     0,    12,
      18,    19,   274,     0,   229,   168,   158,   155,    23,   182,
     176,   180,   246,    50,    61,     0,   197,     0,    66,    78,
      54,    55,    87,    86,   115,   134,     0,   120,   134,     0,
       0,   112,     0,     0,     0,     0,     9,    51,    68,   197,
       0,   197,     0,   184,     0,   133,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   198,
     141,   197,   146,   167,     0,   197,   197,   274,   273,   232,
     187,   274,    90,   274,   233,     0,     0,     0,   187,   231,
     274,   234,   274,   249,     0,   275,   246,     0,     0,    17,
       0,     0,   242,     0,   246,   178,   172,    74,    65,    63,
       0,     0,   281,     0,     0,   123,     0,   118,   125,   130,
     128,     0,     0,   119,    48,     0,     8,     0,     0,   192,
       0,   197,     0,   136,   135,   205,   200,   206,   211,   212,
     213,   214,   207,   208,   210,   216,   217,   221,     0,     0,
     149,     0,     0,   236,   191,   237,     0,   225,     0,     0,
       0,   262,     0,   191,   224,   235,     0,     0,     0,   276,
       0,    14,    20,   274,   169,     0,   197,    56,    83,   280,
      85,   279,     0,    91,    93,   121,   122,   113,     0,   111,
       0,   195,    69,   143,   193,   144,   138,   183,   142,     0,
     130,   145,   153,   197,   247,     0,     0,     0,     0,   226,
     197,     0,     0,   228,   248,   230,   223,   246,    19,    21,
     241,     0,   173,    64,   277,     0,    97,   116,    92,     0,
       0,   129,   127,     0,     0,   150,     0,     0,   257,   261,
       0,     0,     0,     0,     0,     0,     0,   254,   246,     0,
       0,   170,     0,   279,     0,    94,     0,   114,   110,   147,
       0,   274,     0,     0,     0,   227,   274,   255,   246,     0,
     246,   252,    10,    13,   278,    95,    96,   197,   197,   239,
     259,     0,   258,   238,     0,   250,   253,   251,     0,     0,
       0,   256,   131,   151,   260,    70,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      88,   124,     0,   117,     0,     0,     0,     0,     0,    90,
      62,    29,    28,    24,    25,    26,    27,   177,    84,     0,
      41,    40,    44,    46,    45,    47,    42,    43,    57,    58,
      38,    39,    37,    30,    32,    34,    35,    36,     0,   134,
       0,     0,     0,    87,    71,     0,     0,    90,     0,     0,
       0,     0,   197,     0,    54,    48,   184,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     196,    63,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   197,   205,   200,   206,   211,
     212,   213,   214,   207,   208,   210,   216,   217
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -631,  -631,  -631,  -631,   359,   145,  -631,  -631,  -631,  -631,
    -631,   -26,  -631,  -631,    -4,  -631,  -136,  -188,  -631,  -631,
     -80,  -631,   -93,  -631,  -631,   -34,   -51,    67,  -631,    -3,
     -97,  -631,  -631,  -631,  -348,    26,  -631,  -332,  -631,  -171,
    -631,  -631,  -631,  -631,  -631,  -631,  -631,  -631,  -631,    14,
    -631,  -631,  -631,  -631,   117,  -631,  -631,  -631,   511,  -631,
     226,   216,  -631,    -1,   -15,   -73,  -237,  -631,  -631,   -40,
    -126,  -630,  -286,  -156,  -631,  -279,   364,  -631,  -631,  -631,
     -30,  -631,  -631,  -140,   106,  -631,   222,  -631,  -631,   487,
    -631,   485,  -631,  -263,    85,     3,  -631
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     2,    21,     4,     3,   248,   163,   164,   165,   166,
     408,   410,   411,   529,   167,   420,   187,   486,   251,   437,
      75,    86,   198,   343,   421,   185,   186,   492,   493,   494,
     430,   429,   540,   423,   431,   497,   541,   264,   265,   266,
      22,   135,   459,   297,   510,   570,   299,    70,   172,   168,
      24,   327,   414,   531,   179,   332,   485,    48,   192,    74,
     175,   176,   177,   347,   128,   260,   359,   360,   504,    49,
     418,   289,   290,   170,   317,    69,   305,   476,   524,   556,
     557,   171,   470,    77,    66,    67,    53,    54,   261,    56,
      57,   134,   225,   389,   406,   536,   490
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
      47,   224,   226,   379,   199,   432,   288,   227,   302,   319,
     292,    94,   294,   424,   309,   324,   426,    23,     6,     7,
       8,     9,    10,   646,     1,   361,   578,   563,    79,   169,
     256,   188,    83,    84,    85,   395,    87,    88,    89,    90,
     130,    93,    95,   394,   183,   137,   124,   399,   521,   364,
     401,   143,   193,   416,   522,   132,   381,   262,   136,   412,
     138,   385,   710,   193,   293,   174,   329,   173,     5,   257,
     298,   181,    50,   180,    93,   534,    93,    51,    93,    58,
    -182,   535,   334,   579,   365,   193,   580,   250,   320,   333,
     321,   194,   197,   197,   330,   710,   197,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   258,   249,   564,   396,
     400,   193,   311,   498,   463,   169,    68,   478,   465,   498,
     467,   169,    52,   517,   325,   484,   337,   474,   468,   475,
     296,   191,   300,    63,    64,   303,    62,   550,    71,   357,
     469,   499,    93,   314,   315,    72,   259,   500,   523,   551,
     129,   518,   688,    76,   498,    98,    99,    72,    65,   140,
     383,   142,     6,     7,     8,     9,    10,    78,   197,    80,
      11,    12,    81,    93,    91,   239,   326,   340,    72,   342,
      13,    14,   697,   443,   444,    15,    16,    17,    82,   125,
     358,   126,   386,    18,   112,   113,   114,   115,   116,   117,
     118,   119,   131,   127,   133,    19,   120,   121,   145,   122,
     530,   123,   139,   174,   178,   182,    20,   513,   190,   618,
     619,   247,   252,   438,    55,   440,   520,    59,    60,    61,
     263,   254,   255,   295,    98,    99,   304,    93,   559,   425,
     307,   301,   427,   306,   308,   458,   471,   433,   310,   461,
     462,   316,   318,   323,   331,   441,   193,   439,   632,   633,
     634,   635,   636,   637,   638,   639,   618,   619,   336,   581,
     120,   121,   338,   122,   341,   123,   339,   390,   345,   380,
     344,   346,    98,    99,   398,   120,   121,   348,   122,   595,
     123,   597,   349,   350,   397,    23,   351,   352,   589,   422,
     354,   353,   404,   593,   407,   506,   519,   464,   356,   413,
     363,   525,   362,   366,   367,   473,   368,   120,   121,   369,
     122,   370,   123,   691,   115,   116,   117,   118,   119,    93,
     382,   466,   371,   120,   121,   507,   122,   690,   123,   372,
     373,   434,   436,   374,   375,   376,   197,   377,   378,   384,
     533,   388,   445,   446,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,    98,    99,   169,   549,   393,   405,
     417,   428,   442,   457,   392,   329,   489,   546,    93,   419,
     491,   480,   501,   460,   553,   481,   575,   618,   619,   495,
     488,   542,   496,   502,   515,   503,   505,   482,   514,   508,
     511,   512,   528,   538,   113,   114,   115,   116,   117,   118,
     119,   532,   537,   539,   379,   120,   121,   543,   122,   544,
     123,   547,   169,   552,   558,   561,   562,   169,   169,   635,
     636,   637,   638,   639,   169,   566,   568,   569,   120,   121,
     567,   122,   571,   123,   573,   576,   583,   577,   584,   534,
     586,   598,   599,    25,    26,   516,   648,   588,   594,   587,
     591,   601,   554,   649,   602,   603,    27,   650,    28,    29,
     657,   678,   679,   685,   680,   342,    30,   555,   618,   619,
     681,   682,   692,   712,   291,    31,   696,   711,   713,    32,
      33,   435,   560,   714,    34,   715,   716,   717,    35,   312,
     718,   719,   169,   720,   687,   721,   722,   640,   723,   169,
     724,   224,   226,   725,   199,   647,   509,   227,   633,   634,
     635,   636,   637,   638,   639,   565,   545,   487,    73,   120,
     121,   169,   122,   572,   123,   415,   409,   574,   335,   596,
      36,   141,   144,    37,    38,   169,    39,   169,    40,    41,
      42,    43,    44,    45,   527,    46,   585,     0,     0,     0,
       0,   313,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   425,     0,   427,     0,   433,     0,   600,     0,     0,
       0,     0,   333,     0,     0,     0,     0,     0,   686,   533,
       0,     0,     0,     0,     0,   651,   652,   653,   654,   655,
     656,     0,   658,   658,     0,   568,   658,   659,   660,   661,
     662,   663,   664,   665,   666,   667,   668,   669,   670,   671,
     672,   673,   674,   675,   676,   677,   693,     0,     0,     0,
       0,     0,   683,   684,     0,    93,  -194,  -194,  -194,  -194,
    -194,  -194,  -194,  -194,  -194,  -194,  -194,  -194,  -194,  -194,
    -194,  -194,  -194,  -194,  -194,  -194,  -194,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   658,     0,    93,   694,   695,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    96,
       0,     0,     0,     0,  -194,     0,     0,     0,     0,   726,
     727,   728,   729,   730,   731,   732,   733,   734,   735,   736,
     737,   146,     0,     0,     0,     6,     7,     8,     9,    10,
       0,   147,     0,     0,   148,    25,    26,     0,     0,   149,
       0,     0,     0,   150,     0,   151,    97,   152,    27,     0,
      28,    29,   153,     0,     0,     0,     0,   154,    30,   155,
      98,    99,     0,     0,     0,     0,   156,    31,     0,     0,
     157,    32,    33,     0,     0,   158,    34,     0,     0,     0,
      35,   159,   160,     0,     0,     0,   100,   101,     0,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,     0,     0,     0,
       0,   120,   121,     0,   122,     0,   123,     0,    96,     0,
     322,     0,    36,     0,     0,    37,    38,     0,    39,     0,
      40,    41,    42,    43,    44,    45,     0,    46,     0,     0,
     146,   161,   526,   162,     6,     7,     8,     9,    10,     0,
     147,     0,     0,   148,    25,    26,     0,     0,   149,     0,
       0,     0,   150,     0,   151,    97,   152,    27,     0,    28,
      29,   153,     0,     0,     0,     0,   154,    30,   155,    98,
      99,     0,     0,     0,     0,   156,    31,     0,     0,   157,
      32,    33,     0,     0,   158,    34,     0,     0,     0,    35,
     159,   160,     0,     0,     0,   100,   101,     0,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,     0,     0,     0,     0,
     120,   121,     0,   122,     0,   123,     0,    96,     0,   387,
       0,    36,     0,     0,    37,    38,     0,    39,     0,    40,
      41,    42,    43,    44,    45,     0,    46,     0,     0,   146,
     161,   582,   162,     6,     7,     8,     9,    10,     0,   147,
       0,     0,   148,    25,    26,     0,     0,   149,     0,     0,
       0,   150,     0,   151,    97,   152,    27,     0,    28,    29,
     153,     0,     0,     0,     0,   154,    30,   155,    98,    99,
      96,     0,     0,     0,   156,    31,     0,     0,   157,    32,
      33,     0,     0,   158,    34,     0,     0,     0,    35,   159,
     160,     0,     0,     0,   100,   101,     0,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,     0,     0,    97,     0,   120,
     121,     0,   122,     0,   123,     0,     0,     0,   391,     0,
      36,    98,    99,    37,    38,     0,    39,    96,    40,    41,
      42,    43,    44,    45,     0,    46,     0,     0,     0,   161,
       0,   162,     0,     0,     0,     0,     0,   100,   101,     0,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,     0,     0,
       0,     0,   120,   121,    97,   122,     0,   123,     0,     0,
       0,   402,     0,     0,     0,     0,     0,     0,    98,    99,
      96,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      98,    99,     0,     0,   100,   101,     0,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,     0,     0,    97,     0,   120,
     121,     0,   122,     0,   123,     0,     0,     0,   483,     0,
       0,    98,    99,    96,   117,   118,   119,     0,     0,     0,
       0,   120,   121,     0,   122,     0,   123,   618,   619,     0,
       0,     0,     0,     0,     0,     0,     0,   100,   101,     0,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,     0,     0,
      97,     0,   120,   121,     0,   122,     0,   123,     0,   184,
       0,   637,   638,   639,    98,    99,    96,     0,   120,   121,
       0,   122,     0,   123,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     100,   101,     0,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,     0,     0,    97,     0,   120,   121,     0,   122,     0,
     123,     0,   403,     0,     0,     0,     0,    98,    99,    96,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,     0,     0,   100,   101,     0,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,     0,     0,    97,     0,   120,   121,
       0,   122,     0,   123,     0,   479,     0,     0,     0,     0,
      98,    99,    96,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    98,    99,     0,     0,
       0,     0,     0,     0,     0,     0,   100,   101,     0,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,     0,     0,    97,
       0,   120,   121,     0,   122,   195,   123,   114,   115,   116,
     117,   118,   119,    98,    99,    96,     0,   120,   121,     0,
     122,     0,   123,     0,     0,     0,     0,     0,     0,   618,
     619,     0,     0,     0,     0,     0,     0,     0,     0,   100,
     101,     0,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
       0,     0,    97,     0,   120,   121,     0,   122,   253,   123,
     634,   635,   636,   637,   638,   639,    98,    99,   616,     0,
     120,   121,     0,   122,     0,   123,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   100,   101,     0,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,     0,     0,   617,     0,   120,   121,     0,
     122,   328,   123,     0,     0,     0,     0,     0,     0,   618,
     619,   616,   698,   699,   269,   270,   700,   701,   702,   703,
     704,   276,   705,   706,   279,   707,   708,   282,   283,   709,
     285,   286,   287,     0,     0,   620,   621,   355,   622,   623,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,   635,   636,   637,   638,   639,     0,     0,   617,     0,
     120,   121,     0,   122,     0,   123,     0,     0,     0,     0,
       0,     0,   618,   619,    96,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   620,   621,
      -8,   622,   623,   624,   625,   626,   627,   628,   629,   630,
     631,   632,   633,   634,   635,   636,   637,   638,   639,     0,
       0,    97,     0,   120,   121,     0,   122,     0,   123,     0,
       0,     0,     0,     0,     0,    98,    99,    96,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   100,   101,     0,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,     0,     0,    97,     0,   120,   121,     0,   122,
     472,   123,     0,     0,     0,     0,     0,     0,    98,    99,
      96,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   100,   101,     0,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,     0,     0,    97,     0,   120,
     121,     0,   122,   477,   123,     0,     0,     0,     0,     0,
       0,    98,    99,    96,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   100,   101,     0,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,     0,     0,
      97,     0,   120,   121,     0,   122,   548,   123,     0,     0,
       0,     0,     0,     0,    98,    99,    96,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     100,   101,     0,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,     0,     0,    97,     0,   120,   121,     0,   122,   590,
     123,     0,     0,     0,     0,     0,     0,    98,    99,    96,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   100,   101,     0,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,     0,     0,    97,     0,   120,   121,
       0,   122,   592,   123,     0,     0,     0,     0,     0,     0,
      98,    99,   616,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   100,   101,     0,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,     0,     0,   617,
       0,   120,   121,     0,   122,   604,   123,     0,     0,     0,
       0,     0,     0,   618,   619,    96,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   620,
     621,   689,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
       0,     0,    97,     0,   120,   121,     0,   122,     0,   123,
       0,     0,     0,     0,     0,     0,    98,    99,    96,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   100,   101,     0,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,     0,     0,    97,     0,   120,   121,     0,
     122,     0,   123,     0,     0,     0,     0,     0,     0,    98,
      99,   616,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   100,   101,     0,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   189,   113,
     114,   115,   116,   117,   118,   119,     0,     0,   617,     0,
     120,   121,     0,   122,     0,   123,     0,     0,     0,     0,
       0,     0,   618,   619,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   620,   621,
       0,   622,   623,   624,   625,   626,   627,   628,   629,   630,
     631,   632,   633,   634,   635,   636,   637,   638,   639,    25,
      26,     0,     0,   120,   121,     0,   122,     0,   123,     0,
       0,     0,    27,     0,    28,    29,     0,     0,     0,     0,
       0,     0,    30,     0,     0,     0,    25,    26,     0,     0,
       0,    31,     0,     0,     0,    32,    33,     0,     0,    27,
      34,   605,    29,     0,    35,     0,     0,     0,     0,   606,
       0,     0,     0,     0,     0,     0,     0,     0,    31,     0,
       0,     0,    32,   607,     0,     0,     0,   608,     0,     0,
       0,    35,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    36,     0,     0,    37,
      38,     0,    39,     0,    40,    41,    42,    43,    44,    45,
       0,    46,     0,     0,     0,   196,     0,     0,     0,     0,
       0,     0,     0,    36,    25,    26,   609,   610,     0,    39,
       0,   611,   612,   613,   614,   615,    45,    27,    46,    28,
      29,     0,   196,     0,     0,     0,     0,    30,     0,     0,
       0,    25,    26,     0,     0,     0,    31,     0,     0,     0,
      32,    33,    25,    26,    27,    34,   605,    29,     0,    35,
       0,     0,     0,     0,   606,    27,     0,    28,    29,     0,
       0,     0,     0,    31,     0,    30,     0,    32,   607,     0,
       0,     0,   608,     0,    31,   554,    35,     0,    32,    33,
       0,     0,     0,    34,     0,     0,     0,    35,     0,     0,
       0,    36,     0,     0,    37,    38,     0,    39,     0,    40,
      41,    42,    43,    44,    45,    92,    46,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    36,    25,
      26,   609,   610,     0,    39,     0,   611,   612,   613,   614,
     615,    45,    27,    46,    28,    29,     0,    40,    41,    42,
      43,     0,    30,     0,     0,     0,    25,    26,     0,     0,
       0,    31,     0,     0,     0,    32,    33,     0,     0,    27,
      34,   605,    29,     0,    35,     0,     0,     0,     0,   606,
       0,     0,     0,     0,     0,     0,     0,     0,    31,     0,
       0,     0,    32,   607,     0,     0,     0,   608,     0,     0,
       0,    35,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    36,     0,     0,    37,
      38,     0,    39,     0,    40,    41,    42,    43,    44,    45,
       0,    46,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    36,     0,     0,   609,   610,     0,    39,
       0,   611,   612,   613,   614,   615,    45,     0,    46,   200,
     201,     0,     0,     0,     0,     0,   202,     0,     0,     0,
       0,     0,     0,   203,     0,     0,   204,     0,   205,   206,
       0,     0,   207,     0,   208,     0,   209,   210,     0,   211,
     212,   213,     0,     0,     0,     0,     0,   214,   215,     0,
       0,   216,     0,   217,   200,   201,     0,     0,   218,   219,
     220,   202,   221,   222,     0,     0,   223,     0,   203,     0,
       0,   204,     0,   205,   206,     0,     0,   641,     0,   642,
       0,   209,   210,     0,   211,   212,   643,    98,    99,     0,
       0,     0,   214,   215,     0,     0,   216,     0,   217,     0,
       0,     0,     0,   218,   219,   220,     0,   644,   222,     0,
       0,   645,     0,     0,   101,     0,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   618,   619,     0,     0,   120,   121,
       0,   122,     0,   123,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   621,     0,   622,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,    98,    99,     0,     0,   120,   121,     0,   122,     0,
     123,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   618,   619,
       0,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,     0,     0,
       0,     0,   120,   121,     0,   122,     0,   123,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,    98,    99,     0,     0,   120,
     121,     0,   122,     0,   123,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    98,    99,     0,     0,     0,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,     0,     0,     0,     0,   120,   121,     0,   122,
       0,   123,  -195,  -195,  -195,  -195,  -195,  -195,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   618,   619,
       0,     0,   120,   121,     0,   122,     0,   123,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   618,   619,     0,     0,     0,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,     0,     0,     0,     0,   120,
     121,     0,   122,     0,   123,  -195,  -195,  -195,  -195,  -195,
    -195,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,     0,     0,     0,     0,   120,   121,     0,   122,     0,
     123,     6,     7,     8,     9,    10,     0,     0,     0,    11,
      12,     0,     0,     0,     0,     0,     0,     0,     0,    13,
      14,     0,     0,     0,    15,    16,    17,     0,     0,     0,
       0,     0,    18,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    19,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    20
};

static const yytype_int16 yycheck[] =
{
       4,    98,    99,   289,    97,   353,   132,   100,   148,   165,
     136,    45,   138,   345,   154,   171,   348,     3,     7,     8,
       9,    10,    11,    90,    88,   262,    93,    17,    32,    69,
     127,    82,    36,    37,    38,    33,    40,    41,    42,    43,
      55,    45,    46,   306,    78,    60,    50,   310,    14,    90,
     313,    66,    90,   332,    20,    56,   293,   130,    59,   322,
      61,   298,   692,    90,   137,    18,    90,    71,     0,     4,
     143,    75,   119,    74,    78,    85,    80,   119,    82,   123,
      33,    91,   120,    90,   125,    90,    93,   121,   117,   182,
     119,   118,    96,    97,   118,   725,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,    51,   121,   108,   117,
     125,    90,   156,    90,   387,   165,    20,   406,   391,    90,
     393,   171,   119,    90,   123,   414,   187,   400,    90,   402,
     141,    91,   146,    24,    25,   149,    33,    90,   119,   118,
     102,   118,   156,   157,   158,   117,    91,   118,   124,   102,
      54,   118,    91,    33,    90,    65,    66,   117,    49,    63,
     296,    65,     7,     8,     9,    10,    11,   119,   182,   119,
      15,    16,   119,   187,    33,   189,   172,   191,   117,   193,
      25,    26,   118,   364,   365,    30,    31,    32,   119,    33,
     251,    33,   299,    38,   104,   105,   106,   107,   108,   109,
     110,   111,   119,    93,    33,    50,   116,   117,    93,   119,
     483,   121,   125,    18,   123,    91,    61,   464,    46,    65,
      66,    33,    33,   359,    12,   361,   473,    15,    16,    17,
      33,   120,   120,     4,    65,    66,    33,   251,   527,   346,
     119,   125,   349,   125,   119,   381,   396,   354,   125,   385,
     386,   119,    60,    91,    33,   362,    90,   360,   104,   105,
     106,   107,   108,   109,   110,   111,    65,    66,   120,   558,
     116,   117,   120,   119,    91,   121,    45,   302,   119,   124,
     123,    42,    65,    66,   309,   116,   117,   119,   119,   578,
     121,   580,    42,    42,   308,   291,   123,   117,   571,   343,
      42,   117,   316,   576,   318,   441,   472,   390,    93,   323,
     120,   477,    93,    91,    91,   398,    91,   116,   117,    91,
     119,    91,   121,   681,   107,   108,   109,   110,   111,   343,
     123,   392,    91,   116,   117,   442,   119,   679,   121,    91,
      91,   355,   356,    91,    91,    91,   360,    91,    91,     4,
     486,    89,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,    65,    66,   416,   517,   125,    89,
     124,    33,    93,    17,   119,    90,    90,   513,   392,   120,
      33,   118,   118,   123,   520,   120,   552,    65,    66,   120,
     124,   498,   120,   120,    33,   125,   125,   411,   120,   125,
     125,   125,   119,    90,   105,   106,   107,   108,   109,   110,
     111,   124,   124,    33,   710,   116,   117,    42,   119,   124,
     121,   102,   472,    23,    93,   124,    91,   477,   478,   107,
     108,   109,   110,   111,   484,    93,   543,   125,   116,   117,
     124,   119,   125,   121,    33,   125,   120,   554,    17,    85,
      17,   587,   588,    17,    18,   469,   606,   124,    65,   566,
     102,    33,    61,   119,   125,   125,    30,   119,    32,    33,
      33,    42,   119,    91,    42,   489,    40,   521,    65,    66,
     117,    42,   120,    42,   135,    49,   120,   120,    91,    53,
      54,   356,   528,    91,    58,    91,    91,    91,    62,    63,
      91,    91,   552,    91,   650,    91,    91,   521,    91,   559,
      91,   618,   619,   711,   617,   605,   459,   620,   105,   106,
     107,   108,   109,   110,   111,   538,   510,   420,    27,   116,
     117,   581,   119,   547,   121,   329,   320,   551,   184,   579,
     104,    64,    67,   107,   108,   595,   110,   597,   112,   113,
     114,   115,   116,   117,   479,   119,   563,    -1,    -1,    -1,
      -1,   125,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   678,    -1,   680,    -1,   682,    -1,   591,    -1,    -1,
      -1,    -1,   685,    -1,    -1,    -1,    -1,    -1,   649,   725,
      -1,    -1,    -1,    -1,    -1,   609,   610,   611,   612,   613,
     614,    -1,   616,   617,    -1,   712,   620,   621,   622,   623,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   687,    -1,    -1,    -1,
      -1,    -1,   646,   647,    -1,   649,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   685,    -1,   687,   688,   689,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     4,
      -1,    -1,    -1,    -1,   125,    -1,    -1,    -1,    -1,   713,
     714,   715,   716,   717,   718,   719,   720,   721,   722,   723,
     724,     3,    -1,    -1,    -1,     7,     8,     9,    10,    11,
      -1,    13,    -1,    -1,    16,    17,    18,    -1,    -1,    21,
      -1,    -1,    -1,    25,    -1,    27,    51,    29,    30,    -1,
      32,    33,    34,    -1,    -1,    -1,    -1,    39,    40,    41,
      65,    66,    -1,    -1,    -1,    -1,    48,    49,    -1,    -1,
      52,    53,    54,    -1,    -1,    57,    58,    -1,    -1,    -1,
      62,    63,    64,    -1,    -1,    -1,    91,    92,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,    -1,    -1,    -1,
      -1,   116,   117,    -1,   119,    -1,   121,    -1,     4,    -1,
     125,    -1,   104,    -1,    -1,   107,   108,    -1,   110,    -1,
     112,   113,   114,   115,   116,   117,    -1,   119,    -1,    -1,
       3,   123,   124,   125,     7,     8,     9,    10,    11,    -1,
      13,    -1,    -1,    16,    17,    18,    -1,    -1,    21,    -1,
      -1,    -1,    25,    -1,    27,    51,    29,    30,    -1,    32,
      33,    34,    -1,    -1,    -1,    -1,    39,    40,    41,    65,
      66,    -1,    -1,    -1,    -1,    48,    49,    -1,    -1,    52,
      53,    54,    -1,    -1,    57,    58,    -1,    -1,    -1,    62,
      63,    64,    -1,    -1,    -1,    91,    92,    -1,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,    -1,    -1,    -1,    -1,
     116,   117,    -1,   119,    -1,   121,    -1,     4,    -1,   125,
      -1,   104,    -1,    -1,   107,   108,    -1,   110,    -1,   112,
     113,   114,   115,   116,   117,    -1,   119,    -1,    -1,     3,
     123,   124,   125,     7,     8,     9,    10,    11,    -1,    13,
      -1,    -1,    16,    17,    18,    -1,    -1,    21,    -1,    -1,
      -1,    25,    -1,    27,    51,    29,    30,    -1,    32,    33,
      34,    -1,    -1,    -1,    -1,    39,    40,    41,    65,    66,
       4,    -1,    -1,    -1,    48,    49,    -1,    -1,    52,    53,
      54,    -1,    -1,    57,    58,    -1,    -1,    -1,    62,    63,
      64,    -1,    -1,    -1,    91,    92,    -1,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,    -1,    -1,    51,    -1,   116,
     117,    -1,   119,    -1,   121,    -1,    -1,    -1,   125,    -1,
     104,    65,    66,   107,   108,    -1,   110,     4,   112,   113,
     114,   115,   116,   117,    -1,   119,    -1,    -1,    -1,   123,
      -1,   125,    -1,    -1,    -1,    -1,    -1,    91,    92,    -1,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,    -1,    -1,
      -1,    -1,   116,   117,    51,   119,    -1,   121,    -1,    -1,
      -1,   125,    -1,    -1,    -1,    -1,    -1,    -1,    65,    66,
       4,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      65,    66,    -1,    -1,    91,    92,    -1,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,    -1,    -1,    51,    -1,   116,
     117,    -1,   119,    -1,   121,    -1,    -1,    -1,   125,    -1,
      -1,    65,    66,     4,   109,   110,   111,    -1,    -1,    -1,
      -1,   116,   117,    -1,   119,    -1,   121,    65,    66,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,    92,    -1,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,    -1,    -1,
      51,    -1,   116,   117,    -1,   119,    -1,   121,    -1,   123,
      -1,   109,   110,   111,    65,    66,     4,    -1,   116,   117,
      -1,   119,    -1,   121,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      91,    92,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,    -1,    -1,    51,    -1,   116,   117,    -1,   119,    -1,
     121,    -1,   123,    -1,    -1,    -1,    -1,    65,    66,     4,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
      87,    -1,    -1,    91,    92,    -1,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,    -1,    -1,    51,    -1,   116,   117,
      -1,   119,    -1,   121,    -1,   123,    -1,    -1,    -1,    -1,
      65,    66,     4,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    65,    66,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    91,    92,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,    -1,    -1,    51,
      -1,   116,   117,    -1,   119,   120,   121,   106,   107,   108,
     109,   110,   111,    65,    66,     4,    -1,   116,   117,    -1,
     119,    -1,   121,    -1,    -1,    -1,    -1,    -1,    -1,    65,
      66,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,
      92,    -1,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
      -1,    -1,    51,    -1,   116,   117,    -1,   119,   120,   121,
     106,   107,   108,   109,   110,   111,    65,    66,     4,    -1,
     116,   117,    -1,   119,    -1,   121,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    91,    92,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,    -1,    -1,    51,    -1,   116,   117,    -1,
     119,   120,   121,    -1,    -1,    -1,    -1,    -1,    -1,    65,
      66,     4,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    -1,    -1,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,    -1,    -1,    51,    -1,
     116,   117,    -1,   119,    -1,   121,    -1,    -1,    -1,    -1,
      -1,    -1,    65,    66,     4,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,    -1,
      -1,    51,    -1,   116,   117,    -1,   119,    -1,   121,    -1,
      -1,    -1,    -1,    -1,    -1,    65,    66,     4,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    91,    92,    -1,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,    -1,    -1,    51,    -1,   116,   117,    -1,   119,
     120,   121,    -1,    -1,    -1,    -1,    -1,    -1,    65,    66,
       4,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    91,    92,    -1,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,    -1,    -1,    51,    -1,   116,
     117,    -1,   119,   120,   121,    -1,    -1,    -1,    -1,    -1,
      -1,    65,    66,     4,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,    92,    -1,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,    -1,    -1,
      51,    -1,   116,   117,    -1,   119,   120,   121,    -1,    -1,
      -1,    -1,    -1,    -1,    65,    66,     4,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      91,    92,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,    -1,    -1,    51,    -1,   116,   117,    -1,   119,   120,
     121,    -1,    -1,    -1,    -1,    -1,    -1,    65,    66,     4,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    91,    92,    -1,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,    -1,    -1,    51,    -1,   116,   117,
      -1,   119,   120,   121,    -1,    -1,    -1,    -1,    -1,    -1,
      65,    66,     4,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    91,    92,    -1,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,    -1,    -1,    51,
      -1,   116,   117,    -1,   119,   120,   121,    -1,    -1,    -1,
      -1,    -1,    -1,    65,    66,     4,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
      -1,    -1,    51,    -1,   116,   117,    -1,   119,    -1,   121,
      -1,    -1,    -1,    -1,    -1,    -1,    65,    66,     4,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    91,    92,    -1,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,    -1,    -1,    51,    -1,   116,   117,    -1,
     119,    -1,   121,    -1,    -1,    -1,    -1,    -1,    -1,    65,
      66,     4,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    91,    92,    -1,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,    -1,    -1,    51,    -1,
     116,   117,    -1,   119,    -1,   121,    -1,    -1,    -1,    -1,
      -1,    -1,    65,    66,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,    92,
      -1,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,    17,
      18,    -1,    -1,   116,   117,    -1,   119,    -1,   121,    -1,
      -1,    -1,    30,    -1,    32,    33,    -1,    -1,    -1,    -1,
      -1,    -1,    40,    -1,    -1,    -1,    17,    18,    -1,    -1,
      -1,    49,    -1,    -1,    -1,    53,    54,    -1,    -1,    30,
      58,    32,    33,    -1,    62,    -1,    -1,    -1,    -1,    40,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    49,    -1,
      -1,    -1,    53,    54,    -1,    -1,    -1,    58,    -1,    -1,
      -1,    62,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   104,    -1,    -1,   107,
     108,    -1,   110,    -1,   112,   113,   114,   115,   116,   117,
      -1,   119,    -1,    -1,    -1,   123,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   104,    17,    18,   107,   108,    -1,   110,
      -1,   112,   113,   114,   115,   116,   117,    30,   119,    32,
      33,    -1,   123,    -1,    -1,    -1,    -1,    40,    -1,    -1,
      -1,    17,    18,    -1,    -1,    -1,    49,    -1,    -1,    -1,
      53,    54,    17,    18,    30,    58,    32,    33,    -1,    62,
      -1,    -1,    -1,    -1,    40,    30,    -1,    32,    33,    -1,
      -1,    -1,    -1,    49,    -1,    40,    -1,    53,    54,    -1,
      -1,    -1,    58,    -1,    49,    61,    62,    -1,    53,    54,
      -1,    -1,    -1,    58,    -1,    -1,    -1,    62,    -1,    -1,
      -1,   104,    -1,    -1,   107,   108,    -1,   110,    -1,   112,
     113,   114,   115,   116,   117,   118,   119,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   104,    17,
      18,   107,   108,    -1,   110,    -1,   112,   113,   114,   115,
     116,   117,    30,   119,    32,    33,    -1,   112,   113,   114,
     115,    -1,    40,    -1,    -1,    -1,    17,    18,    -1,    -1,
      -1,    49,    -1,    -1,    -1,    53,    54,    -1,    -1,    30,
      58,    32,    33,    -1,    62,    -1,    -1,    -1,    -1,    40,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    49,    -1,
      -1,    -1,    53,    54,    -1,    -1,    -1,    58,    -1,    -1,
      -1,    62,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   104,    -1,    -1,   107,
     108,    -1,   110,    -1,   112,   113,   114,   115,   116,   117,
      -1,   119,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   104,    -1,    -1,   107,   108,    -1,   110,
      -1,   112,   113,   114,   115,   116,   117,    -1,   119,     5,
       6,    -1,    -1,    -1,    -1,    -1,    12,    -1,    -1,    -1,
      -1,    -1,    -1,    19,    -1,    -1,    22,    -1,    24,    25,
      -1,    -1,    28,    -1,    30,    -1,    32,    33,    -1,    35,
      36,    37,    -1,    -1,    -1,    -1,    -1,    43,    44,    -1,
      -1,    47,    -1,    49,     5,     6,    -1,    -1,    54,    55,
      56,    12,    58,    59,    -1,    -1,    62,    -1,    19,    -1,
      -1,    22,    -1,    24,    25,    -1,    -1,    28,    -1,    30,
      -1,    32,    33,    -1,    35,    36,    37,    65,    66,    -1,
      -1,    -1,    43,    44,    -1,    -1,    47,    -1,    49,    -1,
      -1,    -1,    -1,    54,    55,    56,    -1,    58,    59,    -1,
      -1,    62,    -1,    -1,    92,    -1,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,    65,    66,    -1,    -1,   116,   117,
      -1,   119,    -1,   121,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    92,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,    65,    66,    -1,    -1,   116,   117,    -1,   119,    -1,
     121,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    66,
      -1,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,    -1,    -1,
      -1,    -1,   116,   117,    -1,   119,    -1,   121,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,    65,    66,    -1,    -1,   116,
     117,    -1,   119,    -1,   121,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    65,    66,    -1,    -1,    -1,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,    -1,    -1,    -1,    -1,   116,   117,    -1,   119,
      -1,   121,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,    65,    66,
      -1,    -1,   116,   117,    -1,   119,    -1,   121,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    65,    66,    -1,    -1,    -1,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,    -1,    -1,    -1,    -1,   116,
     117,    -1,   119,    -1,   121,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,    -1,    -1,    -1,    -1,   116,   117,    -1,   119,    -1,
     121,     7,     8,     9,    10,    11,    -1,    -1,    -1,    15,
      16,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    25,
      26,    -1,    -1,    -1,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,    38,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    50,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    61
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,    88,   127,   130,   129,     0,     7,     8,     9,    10,
      11,    15,    16,    25,    26,    30,    31,    32,    38,    50,
      61,   128,   166,   175,   176,    17,    18,    30,    32,    33,
      40,    49,    53,    54,    58,    62,   104,   107,   108,   110,
     112,   113,   114,   115,   116,   117,   119,   140,   183,   195,
     119,   119,   119,   212,   213,   212,   215,   216,   123,   212,
     212,   212,    33,    24,    25,    49,   210,   211,   210,   201,
     173,   119,   117,   184,   185,   146,    33,   209,   119,   140,
     119,   119,   119,   140,   140,   140,   147,   140,   140,   140,
     140,    33,   118,   140,   151,   140,     4,    51,    65,    66,
      91,    92,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     116,   117,   119,   121,   140,    33,    33,    93,   190,   210,
     190,   119,   189,    33,   217,   167,   189,   190,   189,   125,
     210,   215,   210,   190,   217,    93,     3,    13,    16,    21,
      25,    27,    29,    34,    39,    41,    48,    52,    57,    63,
      64,   123,   125,   132,   133,   134,   135,   140,   175,   195,
     199,   207,   174,   140,    18,   186,   187,   188,   123,   180,
     189,   140,    91,   151,   123,   151,   152,   142,   152,   104,
      46,    91,   184,    90,   118,   120,   123,   140,   148,   148,
       5,     6,    12,    19,    22,    24,    25,    28,    30,    32,
      33,    35,    36,    37,    43,    44,    47,    49,    54,    55,
      56,    58,    59,    62,   156,   218,   156,   148,   140,   140,
     140,   140,   140,   140,   140,   140,   140,   140,   140,   140,
     140,   140,   140,   140,   140,   140,   140,    33,   131,   140,
     151,   144,    33,   120,   120,   120,   156,     4,    51,    91,
     191,   214,   191,    33,   163,   164,   165,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,   196,   197,
     198,   130,   196,   191,   196,     4,   189,   169,   191,   172,
     140,   125,   209,   140,    33,   202,   125,   119,   119,   209,
     125,   151,    63,   125,   140,   140,   119,   200,    60,   199,
     117,   119,   125,    91,   199,   123,   175,   177,   120,    90,
     118,    33,   181,   148,   120,   202,   120,   152,   120,    45,
     140,    91,   140,   149,   123,   119,    42,   189,   119,    42,
      42,   123,   117,   117,    42,    93,    93,   118,   152,   192,
     193,   192,    93,   120,    90,   125,    91,    91,    91,    91,
      91,    91,    91,    91,    91,    91,    91,    91,    91,   198,
     124,   192,   123,   196,     4,   192,   156,   125,    89,   219,
     190,   125,   119,   125,   219,    33,   117,   140,   190,   219,
     125,   219,   125,   123,   140,    89,   220,   140,   136,   186,
     137,   138,   219,   140,   178,   187,   201,   124,   196,   120,
     141,   150,   151,   159,   163,   156,   163,   156,    33,   157,
     156,   160,   160,   156,   140,   131,   140,   145,   196,   148,
     196,   156,    93,   165,   165,   140,   140,   140,   140,   140,
     140,   140,   140,   140,   140,   140,   140,    17,   196,   168,
     123,   196,   196,   219,   191,   219,   152,   219,    90,   102,
     208,   209,   120,   191,   219,   219,   203,   120,   201,   123,
     118,   120,   140,   125,   201,   182,   143,   180,   124,    90,
     222,    33,   153,   154,   155,   120,   120,   161,    90,   118,
     118,   118,   120,   125,   194,   125,   196,   156,   125,   153,
     170,   125,   125,   192,   120,    33,   140,    90,   118,   199,
     192,    14,    20,   124,   204,   199,   124,   220,   119,   139,
     219,   179,   124,   196,    85,    91,   221,   124,    90,    33,
     158,   162,   156,    42,   124,   161,   196,   102,   120,   209,
      90,   102,    23,   196,    61,   151,   205,   206,    93,   201,
     137,   124,    91,    17,   108,   155,    93,   124,   156,   125,
     171,   125,   140,    33,   140,   199,   125,   156,    93,    90,
      93,   201,   124,   120,    17,   221,    17,   156,   124,   219,
     120,   102,   120,   219,    65,   201,   206,   201,   196,   196,
     140,    33,   125,   125,   120,    32,    40,    54,    58,   107,
     108,   112,   113,   114,   115,   116,     4,    51,    65,    66,
      91,    92,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     140,    28,    30,    37,    58,    62,    90,   146,   209,   119,
     119,   140,   140,   140,   140,   140,   140,    33,   140,   140,
     140,   140,   140,   140,   140,   140,   140,   140,   140,   140,
     140,   140,   140,   140,   140,   140,   140,   140,    42,   119,
      42,   117,    42,   140,   140,    91,   152,   142,    91,    93,
     163,   160,   120,   152,   140,   140,   120,   118,    67,    68,
      71,    72,    73,    74,    75,    77,    78,    80,    81,    84,
     197,   120,    42,    91,    91,    91,    91,    91,    91,    91,
      91,    91,    91,    91,    91,   143,   140,   140,   140,   140,
     140,   140,   140,   140,   140,   140,   140,   140
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,   126,   128,   127,   129,   127,   130,   130,   131,   131,
     132,   132,   133,   134,   134,   135,   135,   136,   136,   138,
     139,   137,   140,   140,   140,   140,   140,   140,   140,   140,
     140,   140,   140,   140,   140,   140,   140,   140,   140,   140,
     140,   140,   140,   140,   140,   140,   140,   140,   140,   140,
     140,   140,   140,   140,   140,   141,   140,   140,   140,   140,
     140,   140,   142,   143,   140,   140,   140,   144,   145,   140,
     146,   140,   140,   140,   140,   140,   140,   147,   140,   140,
     140,   140,   149,   148,   148,   150,   150,   151,   151,   152,
     152,   153,   153,   154,   154,   155,   155,   155,   156,   156,
     156,   156,   156,   156,   156,   156,   156,   156,   156,   156,
     156,   156,   157,   158,   156,   159,   156,   156,   156,   156,
     156,   156,   156,   156,   156,   156,   156,   160,   160,   161,
     161,   162,   163,   163,   163,   164,   164,   164,   165,   166,
     167,   166,   166,   166,   166,   166,   168,   166,   169,   170,
     171,   166,   172,   166,   173,   166,   166,   174,   174,   175,
     175,   175,   175,   175,   176,   176,   176,   176,   178,   179,
     177,   181,   182,   180,   183,   184,   185,   185,   186,   186,
     187,   188,   188,   189,   189,   190,   190,   191,   191,   191,
     191,   193,   194,   192,   192,   195,   196,   196,   197,   197,
     198,   198,   198,   198,   198,   198,   198,   198,   198,   198,
     198,   198,   198,   198,   198,   198,   198,   198,   198,   198,
     198,   198,   200,   199,   199,   199,   199,   199,   199,   199,
     199,   199,   199,   199,   199,   199,   199,   199,   199,   199,
     199,   199,   199,   199,   199,   201,   201,   202,   203,   203,
     204,   204,   204,   205,   205,   206,   206,   207,   207,   207,
     207,   208,   208,   209,   211,   210,   213,   214,   212,   216,
     215,   217,   218,   219,   219,   220,   220,   221,   221,   221,
     222,   222
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     0,     3,     0,     3,     2,     0,     1,     0,
       7,     1,     2,     7,     4,     2,     1,     1,     0,     0,
       0,     3,     3,     4,     2,     2,     2,     2,     2,     2,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     5,     3,
       4,     4,     1,     3,     4,     0,     6,     3,     3,     3,
       2,     4,     0,     0,     7,     5,     4,     0,     0,     6,
       0,     3,     3,     1,     5,     1,     1,     0,     4,     3,
       3,     3,     0,     4,     1,     2,     0,     3,     1,     1,
       0,     1,     2,     1,     3,     4,     4,     2,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       6,     4,     0,     0,     6,     0,     5,     1,     3,     3,
       2,     4,     4,     3,     1,     3,     1,     3,     1,     2,
       0,     5,     1,     2,     0,     3,     3,     1,     4,     3,
       0,     5,     7,     7,     7,     7,     0,     9,     0,     0,
       0,    12,     0,     7,     0,     4,     1,     0,     2,     4,
       4,     4,     1,     1,     4,     4,     4,     5,     0,     0,
       5,     0,     0,     5,     3,     2,     3,     0,     3,     1,
       2,     1,     0,     5,     3,     2,     0,     0,     1,     1,
       1,     0,     0,     3,     0,     6,     1,     0,     2,     1,
       3,     1,     1,     1,     1,     3,     3,     3,     3,     1,
       3,     3,     3,     3,     3,     1,     3,     3,     1,     1,
       1,     3,     0,     5,     4,     4,     5,     7,     5,     2,
       5,     3,     3,     3,     3,     4,     4,     4,     8,     8,
       1,     5,     3,     1,     1,     2,     0,     4,     2,     0,
       4,     4,     3,     3,     1,     2,     4,     6,     8,     8,
      10,     3,     1,     1,     0,     2,     0,     0,     3,     0,
       2,     1,     1,     1,     0,     1,     0,     1,     3,     0,
       1,     0
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)                                \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;        \
          (Current).first_column = YYRHSLOC (Rhs, 1).first_column;      \
          (Current).last_line    = YYRHSLOC (Rhs, N).last_line;         \
          (Current).last_column  = YYRHSLOC (Rhs, N).last_column;       \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).first_line   = (Current).last_line   =              \
            YYRHSLOC (Rhs, 0).last_line;                                \
          (Current).first_column = (Current).last_column =              \
            YYRHSLOC (Rhs, 0).last_column;                              \
        }                                                               \
    while (0)
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K])


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL

/* Print *YYLOCP on YYO.  Private, do not rely on its existence. */

YY_ATTRIBUTE_UNUSED
static unsigned
yy_location_print_ (FILE *yyo, YYLTYPE const * const yylocp)
{
  unsigned res = 0;
  int end_col = 0 != yylocp->last_column ? yylocp->last_column - 1 : 0;
  if (0 <= yylocp->first_line)
    {
      res += YYFPRINTF (yyo, "%d", yylocp->first_line);
      if (0 <= yylocp->first_column)
        res += YYFPRINTF (yyo, ".%d", yylocp->first_column);
    }
  if (0 <= yylocp->last_line)
    {
      if (yylocp->first_line < yylocp->last_line)
        {
          res += YYFPRINTF (yyo, "-%d", yylocp->last_line);
          if (0 <= end_col)
            res += YYFPRINTF (yyo, ".%d", end_col);
        }
      else if (0 <= end_col && yylocp->first_column < end_col)
        res += YYFPRINTF (yyo, "-%d", end_col);
    }
  return res;
 }

#  define YY_LOCATION_PRINT(File, Loc)          \
  yy_location_print_ (File, &(Loc))

# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value, Location); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  YYUSE (yylocationp);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  YY_LOCATION_PRINT (yyoutput, *yylocationp);
  YYFPRINTF (yyoutput, ": ");
  yy_symbol_value_print (yyoutput, yytype, yyvaluep, yylocationp);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, YYLTYPE *yylsp, int yyrule)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                       , &(yylsp[(yyi + 1) - (yynrhs)])                       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, yylsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep, YYLTYPE *yylocationp)
{
  YYUSE (yyvaluep);
  YYUSE (yylocationp);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Location data for the lookahead symbol.  */
YYLTYPE yylloc
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
  = { 1, 1, 1, 1 }
# endif
;
/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.
       'yyls': related to locations.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    /* The location stack.  */
    YYLTYPE yylsa[YYINITDEPTH];
    YYLTYPE *yyls;
    YYLTYPE *yylsp;

    /* The locations where the error started and ended.  */
    YYLTYPE yyerror_range[3];

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yylsp = yyls = yylsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  yylsp[0] = yylloc;
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;
        YYLTYPE *yyls1 = yyls;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yyls1, yysize * sizeof (*yylsp),
                    &yystacksize);

        yyls = yyls1;
        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
        YYSTACK_RELOCATE (yyls_alloc, yyls);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END
  *++yylsp = yylloc;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location.  */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 323 "parse.y" /* yacc.c:1646  */
    {
			// Without the following, in some scenarios the
			// location associated with global statements gets
			// associated with the last @load'd file rather than
			// the script that includes the global statements.
			auto loc = zeek::detail::GetCurrentLocation();
			if ( loc.filename )
				set_location(loc);
			}
#line 2657 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 3:
#line 333 "parse.y" /* yacc.c:1646  */
    {
			if ( stmts )
				stmts->AsStmtList()->Stmts().push_back((yyvsp[0].stmt));
			else
				stmts = (yyvsp[0].stmt);

			// Any objects creates from here on out should not
			// have file positions associated with them.
			set_location(no_location);
			}
#line 2672 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 4:
#line 347 "parse.y" /* yacc.c:1646  */
    { in_debug = true; }
#line 2678 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 5:
#line 348 "parse.y" /* yacc.c:1646  */
    {
			g_curr_debug_expr = (yyvsp[0].expr);
			}
#line 2686 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 8:
#line 360 "parse.y" /* yacc.c:1646  */
    { (yyval.expr) = (yyvsp[0].expr); }
#line 2692 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 9:
#line 362 "parse.y" /* yacc.c:1646  */
    { (yyval.expr) = 0; }
#line 2698 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 10:
#line 367 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-6]), (yylsp[0]));
			(yyvsp[-6].when_clause)->AddTimeout({AdoptRef{}, (yyvsp[-4].expr)}, {AdoptRef{}, (yyvsp[-1].stmt)});
			if ( (yyvsp[-2].b) )
			    script_coverage_mgr.DecIgnoreDepth();
			}
#line 2709 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 12:
#line 379 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-1]), (yylsp[0]));
			(yyvsp[-1].when_clause)->AddBody({AdoptRef{}, (yyvsp[0].stmt)});
			}
#line 2718 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 13:
#line 387 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-6]), (yylsp[0]));
			(yyval.when_clause) = new WhenInfo({AdoptRef{}, (yyvsp[-1].expr)}, (yyvsp[-4].captures), (yyvsp[-6].b));
			}
#line 2727 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 14:
#line 393 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-3]), (yylsp[0]));
			(yyval.when_clause) = new WhenInfo({AdoptRef{}, (yyvsp[-1].expr)}, nullptr, (yyvsp[-3].b));
			}
#line 2736 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 15:
#line 401 "parse.y" /* yacc.c:1646  */
    { (yyval.b) = true; }
#line 2742 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 16:
#line 404 "parse.y" /* yacc.c:1646  */
    { (yyval.b) = false; }
#line 2748 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 18:
#line 410 "parse.y" /* yacc.c:1646  */
    { (yyval.captures) = new zeek::FuncType::CaptureList; }
#line 2754 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 19:
#line 414 "parse.y" /* yacc.c:1646  */
    { ++in_when_cond; }
#line 2760 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 20:
#line 414 "parse.y" /* yacc.c:1646  */
    { --in_when_cond; }
#line 2766 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 21:
#line 415 "parse.y" /* yacc.c:1646  */
    { (yyval.expr) = (yyvsp[-1].expr); }
#line 2772 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 22:
#line 420 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = (yyvsp[-1].expr); (yyval.expr)->MarkParen();
			}
#line 2781 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 23:
#line 426 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-3]), (yylsp[0]));
			(yyval.expr) = new CloneExpr({AdoptRef{}, (yyvsp[-1].expr)});
			}
#line 2790 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 24:
#line 432 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-1]), (yylsp[0]));
			(yyval.expr) = new IncrExpr(EXPR_INCR, {AdoptRef{}, (yyvsp[0].expr)});
			}
#line 2799 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 25:
#line 438 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-1]), (yylsp[0]));
			(yyval.expr) = new IncrExpr(EXPR_DECR, {AdoptRef{}, (yyvsp[0].expr)});
			}
#line 2808 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 26:
#line 444 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-1]), (yylsp[0]));
			(yyval.expr) = new NotExpr({AdoptRef{}, (yyvsp[0].expr)});
			}
#line 2817 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 27:
#line 450 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-1]), (yylsp[0]));
			(yyval.expr) = new ComplementExpr({AdoptRef{}, (yyvsp[0].expr)});
			}
#line 2826 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 28:
#line 456 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-1]), (yylsp[0]));
			(yyval.expr) = new NegExpr({AdoptRef{}, (yyvsp[0].expr)});

			if ( ! (yyval.expr)->IsError() && (yyvsp[0].expr)->IsConst() )
				{
				auto v = (yyvsp[0].expr)->ExprVal();
				auto tag = v->GetType()->Tag();

				if ( tag == TYPE_COUNT )
					{
					auto c = v->AsCount();
					uint64_t int_max = static_cast<uint64_t>(INT64_MAX) + 1;

					if ( c <= int_max )
						{
						auto ce = new ConstExpr(val_mgr->Int(-c));
						Unref((yyval.expr));
						(yyval.expr) = ce;
						}
					else
						{
						(yyval.expr)->Error("literal is outside range of 'int' values");
						(yyval.expr)->SetError();
						}
					}
				else
					{
					auto ce = new ConstExpr((yyval.expr)->Eval(nullptr));
					Unref((yyval.expr));
					(yyval.expr) = ce;
					}
				}
			}
#line 2865 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 29:
#line 492 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-1]), (yylsp[0]));
			(yyval.expr) = new PosExpr({AdoptRef{}, (yyvsp[0].expr)});
			}
#line 2874 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 30:
#line 498 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new AddExpr({AdoptRef{}, (yyvsp[-2].expr)}, {AdoptRef{}, (yyvsp[0].expr)});
			}
#line 2883 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 31:
#line 504 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new AddToExpr({AdoptRef{}, (yyvsp[-2].expr)}, {AdoptRef{}, (yyvsp[0].expr)});
			}
#line 2892 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 32:
#line 510 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new SubExpr({AdoptRef{}, (yyvsp[-2].expr)}, {AdoptRef{}, (yyvsp[0].expr)});
			}
#line 2901 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 33:
#line 516 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new RemoveFromExpr({AdoptRef{}, (yyvsp[-2].expr)}, {AdoptRef{}, (yyvsp[0].expr)});
			}
#line 2910 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 34:
#line 522 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new TimesExpr({AdoptRef{}, (yyvsp[-2].expr)}, {AdoptRef{}, (yyvsp[0].expr)});
			}
#line 2919 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 35:
#line 528 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new DivideExpr({AdoptRef{}, (yyvsp[-2].expr)}, {AdoptRef{}, (yyvsp[0].expr)});
			}
#line 2928 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 36:
#line 534 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new ModExpr({AdoptRef{}, (yyvsp[-2].expr)}, {AdoptRef{}, (yyvsp[0].expr)});
			}
#line 2937 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 37:
#line 540 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new BitExpr(EXPR_AND, {AdoptRef{}, (yyvsp[-2].expr)}, {AdoptRef{}, (yyvsp[0].expr)});
			}
#line 2946 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 38:
#line 546 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new BitExpr(EXPR_OR, {AdoptRef{}, (yyvsp[-2].expr)}, {AdoptRef{}, (yyvsp[0].expr)});
			}
#line 2955 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 39:
#line 552 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new BitExpr(EXPR_XOR, {AdoptRef{}, (yyvsp[-2].expr)}, {AdoptRef{}, (yyvsp[0].expr)});
			}
#line 2964 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 40:
#line 558 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new BoolExpr(EXPR_AND_AND, {AdoptRef{}, (yyvsp[-2].expr)}, {AdoptRef{}, (yyvsp[0].expr)});
			}
#line 2973 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 41:
#line 564 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new BoolExpr(EXPR_OR_OR, {AdoptRef{}, (yyvsp[-2].expr)}, {AdoptRef{}, (yyvsp[0].expr)});
			}
#line 2982 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 42:
#line 570 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new EqExpr(EXPR_EQ, {AdoptRef{}, (yyvsp[-2].expr)}, {AdoptRef{}, (yyvsp[0].expr)});
			}
#line 2991 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 43:
#line 576 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new EqExpr(EXPR_NE, {AdoptRef{}, (yyvsp[-2].expr)}, {AdoptRef{}, (yyvsp[0].expr)});
			}
#line 3000 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 44:
#line 582 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new RelExpr(EXPR_LT, {AdoptRef{}, (yyvsp[-2].expr)}, {AdoptRef{}, (yyvsp[0].expr)});
			}
#line 3009 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 45:
#line 588 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new RelExpr(EXPR_LE, {AdoptRef{}, (yyvsp[-2].expr)}, {AdoptRef{}, (yyvsp[0].expr)});
			}
#line 3018 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 46:
#line 594 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new RelExpr(EXPR_GT, {AdoptRef{}, (yyvsp[-2].expr)}, {AdoptRef{}, (yyvsp[0].expr)});
			}
#line 3027 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 47:
#line 600 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new RelExpr(EXPR_GE, {AdoptRef{}, (yyvsp[-2].expr)}, {AdoptRef{}, (yyvsp[0].expr)});
			}
#line 3036 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 48:
#line 606 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-4]), (yylsp[0]));
			(yyval.expr) = new CondExpr({AdoptRef{}, (yyvsp[-4].expr)}, {AdoptRef{}, (yyvsp[-2].expr)}, {AdoptRef{}, (yyvsp[0].expr)});
			}
#line 3045 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 49:
#line 612 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[0]));

			if ( (yyvsp[-2].expr)->Tag() == EXPR_INDEX && (yyvsp[-2].expr)->AsIndexExpr()->IsSlice() )
				reporter->Error("index slice assignment may not be used"
				                      " in arbitrary expression contexts, only"
				                      " as a statement");

			(yyval.expr) = get_assign_expr({AdoptRef{}, (yyvsp[-2].expr)}, {AdoptRef{}, (yyvsp[0].expr)}, in_init).release();
			}
#line 3060 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 50:
#line 624 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			if ( ! locals_at_this_scope.empty() )
			       locals_at_this_scope.back().insert((yyvsp[-2].id));
			(yyval.expr) = add_and_assign_local({AdoptRef{}, (yyvsp[-2].id)}, {AdoptRef{}, (yyvsp[0].expr)},
			                                        val_mgr->True()).release();
			}
#line 3072 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 51:
#line 633 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-3]), (yylsp[0]));
			if ( in_when_cond > 0 )
				(yyval.expr) = new IndexExprWhen({AdoptRef{}, (yyvsp[-3].expr)}, {AdoptRef{}, (yyvsp[-1].list)});
			else
				(yyval.expr) = new IndexExpr({AdoptRef{}, (yyvsp[-3].expr)}, {AdoptRef{}, (yyvsp[-1].list)});
			}
#line 3084 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 53:
#line 644 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new FieldExpr({AdoptRef{}, (yyvsp[-2].expr)}, (yyvsp[0].str));
			}
#line 3093 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 54:
#line 650 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-3]), (yylsp[0]));
			(yyval.expr) = new FieldAssignExpr((yyvsp[-2].str), {AdoptRef{}, (yyvsp[0].expr)});
			}
#line 3102 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 55:
#line 656 "parse.y" /* yacc.c:1646  */
    {
			func_hdr_location = (yylsp[-3]);
			(yyvsp[-1].id)->SetInferReturnType(true);
			}
#line 3111 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 56:
#line 661 "parse.y" /* yacc.c:1646  */
    {
			(yyval.expr) = new FieldAssignExpr((yyvsp[-4].str), IntrusivePtr{AdoptRef{}, (yyvsp[0].expr)});
			}
#line 3119 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 57:
#line 666 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new InExpr({AdoptRef{}, (yyvsp[-2].expr)}, {AdoptRef{}, (yyvsp[0].expr)});
			}
#line 3128 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 58:
#line 672 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new NotExpr(make_intrusive<InExpr>(
			        ExprPtr{AdoptRef{}, (yyvsp[-2].expr)},
			        ExprPtr{AdoptRef{}, (yyvsp[0].expr)}));
			}
#line 3139 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 59:
#line 680 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[0]));

			bool is_record_ctor = true;

			// If every expression in the list is a field assignment,
			// then treat it as a record constructor, else as a list
			// used for an initializer.

			for ( int i = 0; i < (yyvsp[-1].list)->Exprs().length(); ++i )
				{
				if ( (yyvsp[-1].list)->Exprs()[i]->Tag() != EXPR_FIELD_ASSIGN )
					{
					is_record_ctor = false;
					break;
					}
				}

			if ( is_record_ctor )
				(yyval.expr) = new RecordConstructorExpr({AdoptRef{}, (yyvsp[-1].list)});
			else
				(yyval.expr) = (yyvsp[-1].list);
			}
#line 3167 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 60:
#line 705 "parse.y" /* yacc.c:1646  */
    {
			// We interpret this as an empty record constructor.
			(yyval.expr) = new RecordConstructorExpr(make_intrusive<ListExpr>());
			}
#line 3176 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 61:
#line 712 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-3]), (yylsp[0]));
			(yyval.expr) = new RecordConstructorExpr({AdoptRef{}, (yyvsp[-1].list)});
			}
#line 3185 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 62:
#line 717 "parse.y" /* yacc.c:1646  */
    { ++in_init; }
#line 3191 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 63:
#line 717 "parse.y" /* yacc.c:1646  */
    { --in_init; }
#line 3197 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 64:
#line 719 "parse.y" /* yacc.c:1646  */
    { // the ++in_init fixes up the parsing of "[x] = y"
			set_location((yylsp[-6]), (yylsp[-2]));
			std::unique_ptr<std::vector<AttrPtr>> attrs{(yyvsp[0].attr_l)};
			(yyval.expr) = new TableConstructorExpr({AdoptRef{}, (yyvsp[-3].list)}, std::move(attrs));
			}
#line 3207 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 65:
#line 726 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-4]), (yylsp[-1]));
			std::unique_ptr<std::vector<AttrPtr>> attrs{(yyvsp[0].attr_l)};
			(yyval.expr) = new SetConstructorExpr({AdoptRef{}, (yyvsp[-2].list)}, std::move(attrs));
			}
#line 3217 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 66:
#line 733 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-3]), (yylsp[0]));
			(yyval.expr) = new VectorConstructorExpr({AdoptRef{}, (yyvsp[-1].list)});
			}
#line 3226 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 67:
#line 739 "parse.y" /* yacc.c:1646  */
    {
			if ( expr_is_table_type_name((yyvsp[-1].expr)) )
				++in_init;
			}
#line 3235 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 68:
#line 745 "parse.y" /* yacc.c:1646  */
    {
			if ( expr_is_table_type_name((yyvsp[-3].expr)) )
				--in_init;
			}
#line 3244 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 69:
#line 751 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-5]), (yylsp[0]));

			if ( (yyvsp[-5].expr)->Tag() == EXPR_NAME && (yyvsp[-5].expr)->AsNameExpr()->Id()->IsType() )
				{
				const auto& ctor_type = (yyvsp[-5].expr)->AsNameExpr()->Id()->GetType();

				switch ( ctor_type->Tag() ) {
				case TYPE_RECORD:
					{
					auto rt = cast_intrusive<RecordType>(ctor_type);
					(yyval.expr) = new RecordConstructorExpr(rt, ListExprPtr{AdoptRef{}, (yyvsp[-2].list)});
					}
					break;

				case TYPE_TABLE:
					if ( ctor_type->IsTable() )
						(yyval.expr) = new TableConstructorExpr({AdoptRef{}, (yyvsp[-2].list)}, 0, ctor_type);
					else
						(yyval.expr) = new SetConstructorExpr({AdoptRef{}, (yyvsp[-2].list)}, 0, ctor_type);

					break;

				case TYPE_VECTOR:
					(yyval.expr) = new VectorConstructorExpr({AdoptRef{}, (yyvsp[-2].list)}, ctor_type);
					break;

				default:
					(yyvsp[-5].expr)->Error("constructor type not implemented");
					YYERROR;
				}
				}

			else
				(yyval.expr) = new CallExpr({AdoptRef{}, (yyvsp[-5].expr)}, {AdoptRef{}, (yyvsp[-2].list)}, in_hook > 0, in_when_cond);
			}
#line 3285 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 70:
#line 788 "parse.y" /* yacc.c:1646  */
    { ++in_hook; }
#line 3291 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 71:
#line 789 "parse.y" /* yacc.c:1646  */
    {
			--in_hook;
			set_location((yylsp[-2]), (yylsp[0]));

			if ( (yyvsp[0].expr)->Tag() != EXPR_CALL )
				(yyvsp[0].expr)->Error("not a valid hook call expression");
			else if ( (yyvsp[0].expr)->AsCallExpr()->Func()->GetType()->AsFuncType()->Flavor() != FUNC_FLAVOR_HOOK )
				(yyvsp[0].expr)->Error("hook keyword should only be used to call hooks");

			(yyval.expr) = (yyvsp[0].expr);
			}
#line 3307 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 72:
#line 802 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new HasFieldExpr({AdoptRef{}, (yyvsp[-2].expr)}, (yyvsp[0].str));
			}
#line 3316 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 74:
#line 810 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-4]), (yylsp[0]));
			(yyval.expr) = new ScheduleExpr({AdoptRef{}, (yyvsp[-3].expr)}, {AdoptRef{}, (yyvsp[-1].event_expr)});
			}
#line 3325 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 75:
#line 816 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[0]));
			auto id = lookup_ID((yyvsp[0].str), current_module.c_str());

			if ( ! id )
				{
				if ( ! in_debug )
					{
/*	// CHECK THAT THIS IS NOT GLOBAL.
					id = install_ID($1, current_module.c_str(),
							        false, is_export);
*/

					yyerror(util::fmt("unknown identifier %s", (yyvsp[0].str)));
					YYERROR;
					}
				else
					{
					yyerror(util::fmt("unknown identifier %s", (yyvsp[0].str)));
					YYERROR;
					}
				}
			else
				{
				if ( id->IsDeprecated() )
					reporter->Warning("%s", id->GetDeprecationWarning().c_str());

				if ( ! id->GetType() )
					{
					id->Error("undeclared variable");
					id->SetType(error_type());
					(yyval.expr) = new NameExpr(std::move(id));
					}

				else if ( id->IsEnumConst() )
					{
					if ( IsErrorType(id->GetType()->Tag()) )
						{
						// The most-relevant error message should already be reported, so
						// just bail out.
						YYERROR;
						}

					EnumType* t = id->GetType()->AsEnumType();
					auto intval = t->Lookup(id->ModuleName(), id->Name());
					if ( intval < 0 )
						reporter->InternalError("enum value not found for %s", id->Name());
					(yyval.expr) = new ConstExpr(t->GetEnumVal(intval));
					}
				else
					{
					if ( out_of_scope_locals.count(id.get()) > 0 &&
					     warned_about_locals.count(id.get()) == 0 )
						{
						// Remove in v5.1
						reporter->Warning("use of out-of-scope local %s deprecated; move declaration to outer scope", id->Name());
						warned_about_locals.insert(id.get());
						}

					(yyval.expr) = new NameExpr(std::move(id));
					}
				}
			}
#line 3393 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 76:
#line 881 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[0]));
			(yyval.expr) = new ConstExpr({AdoptRef{}, (yyvsp[0].val)});
			}
#line 3402 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 77:
#line 886 "parse.y" /* yacc.c:1646  */
    { begin_RE(); }
#line 3408 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 78:
#line 887 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-1]));

			auto* re = new RE_Matcher((yyvsp[-1].str));
			delete [] (yyvsp[-1].str);

			if ( (yyvsp[0].b) )
				re->MakeCaseInsensitive();

			re->Compile();
			(yyval.expr) = new ConstExpr(make_intrusive<PatternVal>(re));
			}
#line 3425 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 79:
#line 901 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			ExprPtr e{AdoptRef{}, (yyvsp[-1].expr)};
			(yyval.expr) = new SizeExpr(std::move(e));
			}
#line 3435 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 80:
#line 908 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new CastExpr({AdoptRef{}, (yyvsp[-2].expr)}, {AdoptRef{}, (yyvsp[0].type)});
			}
#line 3444 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 81:
#line 914 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new IsExpr({AdoptRef{}, (yyvsp[-2].expr)}, {AdoptRef{}, (yyvsp[0].type)});
			}
#line 3453 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 82:
#line 920 "parse.y" /* yacc.c:1646  */
    { ++in_init; }
#line 3459 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 83:
#line 921 "parse.y" /* yacc.c:1646  */
    {
			--in_init;
			(yyval.expr) = (yyvsp[-1].list);
			}
#line 3468 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 86:
#line 930 "parse.y" /* yacc.c:1646  */
    { (yyval.list) = new ListExpr(); }
#line 3474 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 87:
#line 935 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyvsp[-2].list)->Append({AdoptRef{}, (yyvsp[0].expr)});
			}
#line 3483 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 88:
#line 941 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[0]));
			(yyval.list) = new ListExpr({AdoptRef{}, (yyvsp[0].expr)});
			}
#line 3492 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 90:
#line 950 "parse.y" /* yacc.c:1646  */
    { (yyval.list) = new ListExpr(); }
#line 3498 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 91:
#line 955 "parse.y" /* yacc.c:1646  */
    {
			(yyval.type) = cur_enum_type;
			cur_enum_type = nullptr;
			}
#line 3507 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 92:
#line 961 "parse.y" /* yacc.c:1646  */
    {
			(yyval.type) = cur_enum_type;
			cur_enum_type = nullptr;
			}
#line 3516 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 95:
#line 980 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-3]), (yylsp[-1]));
			assert(cur_enum_type);

			if ( (yyvsp[-1].val)->GetType()->Tag() != TYPE_COUNT )
				reporter->Error("enumerator is not a count constant");
			else
				cur_enum_type->AddName(current_module, (yyvsp[-3].str),
				                       (yyvsp[-1].val)->InternalUnsigned(), is_export, (yyvsp[0].expr),
				                       in_enum_redef != 0);
			}
#line 3532 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 96:
#line 993 "parse.y" /* yacc.c:1646  */
    {
			// We only accept counts as enumerator, but we want to return a nice
			// error message if users triy to use a negative integer (will also
			// catch other cases, but that's fine.)
			reporter->Error("enumerator is not a count constant");
			}
#line 3543 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 97:
#line 1001 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-1]));
			assert(cur_enum_type);
			cur_enum_type->AddName(current_module, (yyvsp[-1].str), is_export, (yyvsp[0].expr),
			                       in_enum_redef != 0);
			}
#line 3554 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 98:
#line 1010 "parse.y" /* yacc.c:1646  */
    {
				set_location((yylsp[0]));
				(yyval.type) = base_type(TYPE_BOOL)->Ref();
				}
#line 3563 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 99:
#line 1015 "parse.y" /* yacc.c:1646  */
    {
				set_location((yylsp[0]));
				(yyval.type) = base_type(TYPE_INT)->Ref();
				}
#line 3572 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 100:
#line 1020 "parse.y" /* yacc.c:1646  */
    {
				set_location((yylsp[0]));
				(yyval.type) = base_type(TYPE_COUNT)->Ref();
				}
#line 3581 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 101:
#line 1025 "parse.y" /* yacc.c:1646  */
    {
				set_location((yylsp[0]));
				(yyval.type) = base_type(TYPE_DOUBLE)->Ref();
				}
#line 3590 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 102:
#line 1030 "parse.y" /* yacc.c:1646  */
    {
				set_location((yylsp[0]));
				(yyval.type) = base_type(TYPE_TIME)->Ref();
				}
#line 3599 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 103:
#line 1035 "parse.y" /* yacc.c:1646  */
    {
				set_location((yylsp[0]));
				(yyval.type) = base_type(TYPE_INTERVAL)->Ref();
				}
#line 3608 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 104:
#line 1040 "parse.y" /* yacc.c:1646  */
    {
				set_location((yylsp[0]));
				(yyval.type) = base_type(TYPE_STRING)->Ref();
				}
#line 3617 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 105:
#line 1045 "parse.y" /* yacc.c:1646  */
    {
				set_location((yylsp[0]));
				(yyval.type) = base_type(TYPE_PATTERN)->Ref();
				}
#line 3626 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 106:
#line 1050 "parse.y" /* yacc.c:1646  */
    {
				set_location((yylsp[0]));
				(yyval.type) = base_type(TYPE_PORT)->Ref();
				}
#line 3635 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 107:
#line 1055 "parse.y" /* yacc.c:1646  */
    {
				set_location((yylsp[0]));
				(yyval.type) = base_type(TYPE_ADDR)->Ref();
				}
#line 3644 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 108:
#line 1060 "parse.y" /* yacc.c:1646  */
    {
				set_location((yylsp[0]));
				(yyval.type) = base_type(TYPE_SUBNET)->Ref();
				}
#line 3653 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 109:
#line 1065 "parse.y" /* yacc.c:1646  */
    {
				set_location((yylsp[0]));
				(yyval.type) = base_type(TYPE_ANY)->Ref();
				}
#line 3662 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 110:
#line 1071 "parse.y" /* yacc.c:1646  */
    {
				set_location((yylsp[-5]), (yylsp[0]));
				(yyval.type) = new TableType({AdoptRef{}, (yyvsp[-3].type_l)}, {AdoptRef{}, (yyvsp[0].type)});
				}
#line 3671 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 111:
#line 1077 "parse.y" /* yacc.c:1646  */
    {
				set_location((yylsp[-3]), (yylsp[0]));
				(yyval.type) = new SetType({AdoptRef{}, (yyvsp[-1].type_l)}, nullptr);
				}
#line 3680 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 112:
#line 1083 "parse.y" /* yacc.c:1646  */
    { ++in_record; }
#line 3686 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 113:
#line 1085 "parse.y" /* yacc.c:1646  */
    { --in_record; }
#line 3692 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 114:
#line 1087 "parse.y" /* yacc.c:1646  */
    {
				set_location((yylsp[-5]), (yylsp[-1]));
				(yyval.type) = new RecordType((yyvsp[-2].type_decl_l));
				}
#line 3701 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 115:
#line 1092 "parse.y" /* yacc.c:1646  */
    { set_location((yylsp[-1])); parse_new_enum(); }
#line 3707 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 116:
#line 1093 "parse.y" /* yacc.c:1646  */
    {
				set_location((yylsp[-4]), (yylsp[0]));
				(yyvsp[-1].type)->UpdateLocationEndInfo((yylsp[0]));
				(yyval.type) = (yyvsp[-1].type);
				}
#line 3717 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 117:
#line 1100 "parse.y" /* yacc.c:1646  */
    {
				set_location((yylsp[0]));
				// $$ = new TypeList();
				reporter->Error("list type not implemented");
				(yyval.type) = 0;
				}
#line 3728 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 118:
#line 1108 "parse.y" /* yacc.c:1646  */
    {
				set_location((yylsp[-2]));
				// $$ = new TypeList($3);
				reporter->Error("list type not implemented");
				(yyval.type) = 0;
				}
#line 3739 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 119:
#line 1116 "parse.y" /* yacc.c:1646  */
    {
				set_location((yylsp[-2]), (yylsp[0]));
				(yyval.type) = new VectorType({AdoptRef{}, (yyvsp[0].type)});
				}
#line 3748 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 120:
#line 1122 "parse.y" /* yacc.c:1646  */
    {
				set_location((yylsp[-1]), (yylsp[0]));
				(yyval.type) = (yyvsp[0].func_type);
				}
#line 3757 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 121:
#line 1128 "parse.y" /* yacc.c:1646  */
    {
				set_location((yylsp[-3]), (yylsp[-1]));
				(yyval.type) = new FuncType({AdoptRef{}, (yyvsp[-1].record)}, nullptr, FUNC_FLAVOR_EVENT);
				}
#line 3766 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 122:
#line 1134 "parse.y" /* yacc.c:1646  */
    {
				set_location((yylsp[-3]), (yylsp[-1]));
				(yyval.type) = new FuncType({AdoptRef{}, (yyvsp[-1].record)}, base_type(TYPE_BOOL), FUNC_FLAVOR_HOOK);
				}
#line 3775 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 123:
#line 1140 "parse.y" /* yacc.c:1646  */
    {
				set_location((yylsp[-2]), (yylsp[0]));
				(yyval.type) = new FileType({AdoptRef{}, (yyvsp[0].type)});
				}
#line 3784 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 124:
#line 1146 "parse.y" /* yacc.c:1646  */
    {
				set_location((yylsp[0]));
				(yyval.type) = new FileType(base_type(TYPE_STRING));
				}
#line 3793 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 125:
#line 1152 "parse.y" /* yacc.c:1646  */
    {
				set_location((yylsp[-2]), (yylsp[0]));
				(yyval.type) = new OpaqueType((yyvsp[0].str));
				}
#line 3802 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 126:
#line 1158 "parse.y" /* yacc.c:1646  */
    {
			if ( ! (yyvsp[0].id) || ! ((yyval.type) = (yyvsp[0].id)->IsType() ? (yyvsp[0].id)->GetType().get() : nullptr) )
				{
				NullStmt here;
				if ( (yyvsp[0].id) )
					(yyvsp[0].id)->Error("not a Zeek type", &here);
				(yyval.type) = error_type()->Ref();
				}
			else
				{
				Ref((yyval.type));

				if ( (yyvsp[0].id)->IsDeprecated() )
					reporter->Warning("%s", (yyvsp[0].id)->GetDeprecationWarning().c_str());
				}
			}
#line 3823 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 127:
#line 1178 "parse.y" /* yacc.c:1646  */
    { (yyvsp[-2].type_l)->AppendEvenIfNotPure({AdoptRef{}, (yyvsp[0].type)}); }
#line 3829 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 128:
#line 1180 "parse.y" /* yacc.c:1646  */
    {
			(yyval.type_l) = new TypeList({NewRef{}, (yyvsp[0].type)});
			(yyval.type_l)->Append({AdoptRef{}, (yyvsp[0].type)});
			}
#line 3838 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 129:
#line 1188 "parse.y" /* yacc.c:1646  */
    {
			(yyvsp[-1].type_decl_l)->push_back((yyvsp[0].type_decl));
			}
#line 3846 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 130:
#line 1192 "parse.y" /* yacc.c:1646  */
    {
			(yyval.type_decl_l) = new type_decl_list();
			}
#line 3854 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 131:
#line 1199 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-4]), (yylsp[-1]));
			auto attrs = make_attributes((yyvsp[-1].attr_l), {NewRef{}, (yyvsp[-2].type)}, in_record > 0, false);
			(yyval.type_decl) = new TypeDecl((yyvsp[-4].str), {AdoptRef{}, (yyvsp[-2].type)}, std::move(attrs));

			if ( in_record > 0 && cur_decl_type_id )
				zeekygen_mgr->RecordField(cur_decl_type_id, (yyval.type_decl), ::filename,
				                                        in_record_redef != 0);
			}
#line 3868 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 132:
#line 1212 "parse.y" /* yacc.c:1646  */
    { (yyval.record) = new RecordType((yyvsp[0].type_decl_l)); }
#line 3874 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 133:
#line 1214 "parse.y" /* yacc.c:1646  */
    { (yyval.record) = new RecordType((yyvsp[-1].type_decl_l)); }
#line 3880 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 134:
#line 1216 "parse.y" /* yacc.c:1646  */
    { (yyval.record) = new RecordType(new type_decl_list()); }
#line 3886 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 135:
#line 1221 "parse.y" /* yacc.c:1646  */
    { (yyvsp[-2].type_decl_l)->push_back((yyvsp[0].type_decl)); }
#line 3892 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 136:
#line 1223 "parse.y" /* yacc.c:1646  */
    { (yyvsp[-2].type_decl_l)->push_back((yyvsp[0].type_decl)); }
#line 3898 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 137:
#line 1225 "parse.y" /* yacc.c:1646  */
    { (yyval.type_decl_l) = new type_decl_list(); (yyval.type_decl_l)->push_back((yyvsp[0].type_decl)); }
#line 3904 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 138:
#line 1230 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-3]), (yylsp[0]));
			auto attrs = make_attributes((yyvsp[0].attr_l), {NewRef{}, (yyvsp[-1].type)}, true, false);
			(yyval.type_decl) = new TypeDecl((yyvsp[-3].str), {AdoptRef{}, (yyvsp[-1].type)}, std::move(attrs));
			}
#line 3914 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 139:
#line 1239 "parse.y" /* yacc.c:1646  */
    {
			current_module = (yyvsp[-1].str);
			zeekygen_mgr->ModuleUsage(::filename, current_module);
			}
#line 3923 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 140:
#line 1244 "parse.y" /* yacc.c:1646  */
    { is_export = true; }
#line 3929 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 141:
#line 1245 "parse.y" /* yacc.c:1646  */
    { is_export = false; }
#line 3935 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 142:
#line 1248 "parse.y" /* yacc.c:1646  */
    {
			build_global((yyvsp[-5].id), (yyvsp[-4].type), (yyvsp[-3].ic), (yyvsp[-2].expr), (yyvsp[-1].attr_l), VAR_REGULAR);
			}
#line 3943 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 143:
#line 1253 "parse.y" /* yacc.c:1646  */
    {
			build_global((yyvsp[-5].id), (yyvsp[-4].type), (yyvsp[-3].ic), (yyvsp[-2].expr), (yyvsp[-1].attr_l), VAR_OPTION);
			}
#line 3951 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 144:
#line 1258 "parse.y" /* yacc.c:1646  */
    {
			build_global((yyvsp[-5].id), (yyvsp[-4].type), (yyvsp[-3].ic), (yyvsp[-2].expr), (yyvsp[-1].attr_l), VAR_CONST);
			}
#line 3959 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 145:
#line 1263 "parse.y" /* yacc.c:1646  */
    {
			build_global((yyvsp[-5].id), (yyvsp[-4].type), (yyvsp[-3].ic), (yyvsp[-2].expr), (yyvsp[-1].attr_l), VAR_REDEF);
			}
#line 3967 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 146:
#line 1268 "parse.y" /* yacc.c:1646  */
    { ++in_enum_redef; parse_redef_enum((yyvsp[-2].id)); zeekygen_mgr->Redef((yyvsp[-2].id), ::filename); }
#line 3973 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 147:
#line 1270 "parse.y" /* yacc.c:1646  */
    {
			--in_enum_redef;
			// Zeekygen already grabbed new enum IDs as the type created them.
			}
#line 3982 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 148:
#line 1276 "parse.y" /* yacc.c:1646  */
    { cur_decl_type_id = (yyvsp[0].id); zeekygen_mgr->Redef((yyvsp[0].id), ::filename); }
#line 3988 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 149:
#line 1278 "parse.y" /* yacc.c:1646  */
    { ++in_record; ++in_record_redef; }
#line 3994 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 150:
#line 1280 "parse.y" /* yacc.c:1646  */
    { --in_record; --in_record_redef; }
#line 4000 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 151:
#line 1282 "parse.y" /* yacc.c:1646  */
    {
			cur_decl_type_id = 0;

			if ( ! (yyvsp[-9].id)->GetType() )
				(yyvsp[-9].id)->Error("unknown identifier");
			else
				extend_record((yyvsp[-9].id), std::unique_ptr<type_decl_list>((yyvsp[-4].type_decl_l)),
				              std::unique_ptr<std::vector<AttrPtr>>((yyvsp[-1].attr_l)));
			}
#line 4014 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 152:
#line 1293 "parse.y" /* yacc.c:1646  */
    { cur_decl_type_id = (yyvsp[-1].id); zeekygen_mgr->StartType({NewRef{}, (yyvsp[-1].id)});  }
#line 4020 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 153:
#line 1295 "parse.y" /* yacc.c:1646  */
    {
			cur_decl_type_id = 0;
			IntrusivePtr id{AdoptRef{}, (yyvsp[-5].id)};
			add_type(id.get(), {AdoptRef{}, (yyvsp[-2].type)},
			                       std::unique_ptr<std::vector<AttrPtr>>{(yyvsp[-1].attr_l)});
			zeekygen_mgr->Identifier(std::move(id));
			}
#line 4032 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 154:
#line 1304 "parse.y" /* yacc.c:1646  */
    {
			func_hdr_location = (yylsp[0]);
			func_hdr_cond_epoch = conditional_epoch;
			}
#line 4041 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 159:
#line 1319 "parse.y" /* yacc.c:1646  */
    { do_atif((yyvsp[-1].expr)); }
#line 4047 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 160:
#line 1321 "parse.y" /* yacc.c:1646  */
    { do_atifdef((yyvsp[-1].str)); }
#line 4053 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 161:
#line 1323 "parse.y" /* yacc.c:1646  */
    { do_atifndef((yyvsp[-1].str)); }
#line 4059 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 162:
#line 1325 "parse.y" /* yacc.c:1646  */
    { do_atendif(); }
#line 4065 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 163:
#line 1327 "parse.y" /* yacc.c:1646  */
    { do_atelse(); }
#line 4071 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 164:
#line 1332 "parse.y" /* yacc.c:1646  */
    {
			IntrusivePtr id{AdoptRef{}, (yyvsp[-2].id)};
			begin_func(id, current_module.c_str(),
				                     FUNC_FLAVOR_FUNCTION, false, {NewRef{}, (yyvsp[-1].func_type)},
			                         std::unique_ptr<std::vector<AttrPtr>>{(yyvsp[0].attr_l)});
			(yyval.func_type) = (yyvsp[-1].func_type);
			zeekygen_mgr->Identifier(std::move(id));
			}
#line 4084 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 165:
#line 1341 "parse.y" /* yacc.c:1646  */
    {
			const char* name = (yyvsp[-2].id)->Name();
			if ( util::streq("bro_init", name) || util::streq("bro_done", name) || util::streq("bro_script_loaded", name) )
				{
				auto base = std::string(name).substr(4);
				reporter->Error("event %s() is no longer available, use zeek_%s() instead", name, base.c_str());
				}

			begin_func({NewRef{}, (yyvsp[-2].id)}, current_module.c_str(),
				                     FUNC_FLAVOR_EVENT, false, {NewRef{}, (yyvsp[-1].func_type)},
			                         std::unique_ptr<std::vector<AttrPtr>>{(yyvsp[0].attr_l)});
			(yyval.func_type) = (yyvsp[-1].func_type);
			}
#line 4102 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 166:
#line 1355 "parse.y" /* yacc.c:1646  */
    {
			(yyvsp[-1].func_type)->ClearYieldType(FUNC_FLAVOR_HOOK);
			(yyvsp[-1].func_type)->SetYieldType(base_type(TYPE_BOOL));
			begin_func({NewRef{}, (yyvsp[-2].id)}, current_module.c_str(),
				                     FUNC_FLAVOR_HOOK, false, {NewRef{}, (yyvsp[-1].func_type)},
			                         std::unique_ptr<std::vector<AttrPtr>>{(yyvsp[0].attr_l)});
			(yyval.func_type) = (yyvsp[-1].func_type);
			}
#line 4115 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 167:
#line 1364 "parse.y" /* yacc.c:1646  */
    {
			begin_func({NewRef{}, (yyvsp[-2].id)}, current_module.c_str(),
				                     FUNC_FLAVOR_EVENT, true, {NewRef{}, (yyvsp[-1].func_type)},
			                         std::unique_ptr<std::vector<AttrPtr>>{(yyvsp[0].attr_l)});
			(yyval.func_type) = (yyvsp[-1].func_type);
			}
#line 4126 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 168:
#line 1374 "parse.y" /* yacc.c:1646  */
    {
			saved_in_init.push_back(in_init);
			in_init = 0;

			locals_at_this_scope.clear();
			out_of_scope_locals.clear();
			warned_about_locals.clear();
			}
#line 4139 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 169:
#line 1384 "parse.y" /* yacc.c:1646  */
    {
			in_init = saved_in_init.back();
			saved_in_init.pop_back();
			}
#line 4148 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 170:
#line 1390 "parse.y" /* yacc.c:1646  */
    {
			set_location(func_hdr_location, (yylsp[0]));

			bool free_of_conditionals = true;
			if ( current_file_has_conditionals ||
			     conditional_epoch > func_hdr_cond_epoch )
				free_of_conditionals = false;

			end_func({AdoptRef{}, (yyvsp[-2].stmt)}, free_of_conditionals);
			}
#line 4163 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 171:
#line 1404 "parse.y" /* yacc.c:1646  */
    {
			saved_in_init.push_back(in_init);
			in_init = 0;
			}
#line 4172 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 172:
#line 1410 "parse.y" /* yacc.c:1646  */
    {
			in_init = saved_in_init.back();
			saved_in_init.pop_back();
			}
#line 4181 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 173:
#line 1416 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-4]), (yylsp[0]));

			// Code duplication here is sad but needed.
			// end_func actually instantiates the function
			// and associates it with an ID. We perform that
			// association later and need to return a lambda
			// expression.

			// Gather the ingredients for a Func from the
			// current scope.
			auto ingredients = std::make_unique<function_ingredients>(
				current_scope(), IntrusivePtr{AdoptRef{}, (yyvsp[-2].stmt)});
			auto outer_ids = gather_outer_ids(pop_scope(), ingredients->body);

			(yyval.expr) = new LambdaExpr(std::move(ingredients), std::move(outer_ids));
			}
#line 4203 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 174:
#line 1437 "parse.y" /* yacc.c:1646  */
    { (yyval.expr) = (yyvsp[0].expr); }
#line 4209 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 175:
#line 1442 "parse.y" /* yacc.c:1646  */
    {
			auto id = current_scope()->GenerateTemporary("anonymous-function");
			begin_func(id, current_module.c_str(), FUNC_FLAVOR_FUNCTION, false, {AdoptRef{}, (yyvsp[0].func_type)});

			std::optional<FuncType::CaptureList> captures;

			if ( (yyvsp[-1].captures) )
				{
				captures = *(yyvsp[-1].captures);
				delete (yyvsp[-1].captures);
				}

			(yyvsp[0].func_type)->SetCaptures(std::move(captures));
			(yyval.id) = id.release();
			}
#line 4229 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 176:
#line 1461 "parse.y" /* yacc.c:1646  */
    { (yyval.captures) = (yyvsp[-1].captures); }
#line 4235 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 177:
#line 1463 "parse.y" /* yacc.c:1646  */
    { (yyval.captures) = nullptr; }
#line 4241 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 178:
#line 1468 "parse.y" /* yacc.c:1646  */
    {
			(yyvsp[-2].captures)->push_back(*(yyvsp[0].capture));
			delete (yyvsp[0].capture);
			}
#line 4250 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 179:
#line 1473 "parse.y" /* yacc.c:1646  */
    {
			(yyval.captures) = new zeek::FuncType::CaptureList;
			(yyval.captures)->push_back(*(yyvsp[0].capture));
			delete (yyvsp[0].capture);
			}
#line 4260 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 180:
#line 1482 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[0]));
			auto id = lookup_ID((yyvsp[0].str), current_module.c_str());

			if ( ! id )
				reporter->Error("no such local identifier: %s", (yyvsp[0].str));
			else if ( id->IsType() )
				{
				reporter->Error("cannot specify type in capture: %s", (yyvsp[0].str));
				id = nullptr;
				}
			else if ( id->IsGlobal() )
				{
				reporter->Error("cannot specify global in capture: %s", (yyvsp[0].str));
				id = nullptr;
				}

			delete [] (yyvsp[0].str);

			(yyval.capture) = new FuncType::Capture;
			(yyval.capture)->id = id;
			(yyval.capture)->deep_copy = (yyvsp[-1].b);
			}
#line 4288 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 181:
#line 1508 "parse.y" /* yacc.c:1646  */
    { (yyval.b) = true; }
#line 4294 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 182:
#line 1510 "parse.y" /* yacc.c:1646  */
    { (yyval.b) = false; }
#line 4300 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 183:
#line 1515 "parse.y" /* yacc.c:1646  */
    { (yyval.func_type) = new FuncType({AdoptRef{}, (yyvsp[-3].record)}, {AdoptRef{}, (yyvsp[0].type)}, FUNC_FLAVOR_FUNCTION); }
#line 4306 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 184:
#line 1517 "parse.y" /* yacc.c:1646  */
    { (yyval.func_type) = new FuncType({AdoptRef{}, (yyvsp[-1].record)}, base_type(TYPE_VOID), FUNC_FLAVOR_FUNCTION); }
#line 4312 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 185:
#line 1522 "parse.y" /* yacc.c:1646  */
    { (yyval.type) = (yyvsp[0].type); }
#line 4318 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 186:
#line 1524 "parse.y" /* yacc.c:1646  */
    { (yyval.type) = 0; }
#line 4324 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 187:
#line 1528 "parse.y" /* yacc.c:1646  */
    { (yyval.ic) = INIT_NONE; }
#line 4330 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 188:
#line 1529 "parse.y" /* yacc.c:1646  */
    { (yyval.ic) = INIT_FULL; }
#line 4336 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 189:
#line 1530 "parse.y" /* yacc.c:1646  */
    { (yyval.ic) = INIT_EXTRA; }
#line 4342 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 190:
#line 1531 "parse.y" /* yacc.c:1646  */
    { (yyval.ic) = INIT_REMOVE; }
#line 4348 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 191:
#line 1535 "parse.y" /* yacc.c:1646  */
    { ++in_init; }
#line 4354 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 192:
#line 1535 "parse.y" /* yacc.c:1646  */
    { --in_init; }
#line 4360 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 193:
#line 1536 "parse.y" /* yacc.c:1646  */
    { (yyval.expr) = (yyvsp[-1].expr); }
#line 4366 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 194:
#line 1538 "parse.y" /* yacc.c:1646  */
    { (yyval.expr) = 0; }
#line 4372 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 195:
#line 1543 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-5]), (yylsp[0]));

			auto low = (yyvsp[-3].expr) ? ExprPtr{AdoptRef{}, (yyvsp[-3].expr)} :
			                make_intrusive<ConstExpr>(val_mgr->Count(0));

			auto high = (yyvsp[-1].expr) ? ExprPtr{AdoptRef{}, (yyvsp[-1].expr)} :
			                 make_intrusive<SizeExpr>(
			                     ExprPtr{NewRef{}, (yyvsp[-5].expr)});

			if ( ! IsIntegral(low->GetType()->Tag()) || ! IsIntegral(high->GetType()->Tag()) )
				reporter->Error("slice notation must have integral values as indexes");

			auto le = make_intrusive<ListExpr>(std::move(low));
			le->Append(std::move(high));

			if ( in_when_cond > 0  )
				(yyval.expr) = new IndexExprWhen({AdoptRef{}, (yyvsp[-5].expr)}, std::move(le), true);
			else
				(yyval.expr) = new IndexExpr({AdoptRef{}, (yyvsp[-5].expr)}, std::move(le), true);
			}
#line 4398 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 197:
#line 1568 "parse.y" /* yacc.c:1646  */
    { (yyval.attr_l) = nullptr; }
#line 4404 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 198:
#line 1573 "parse.y" /* yacc.c:1646  */
    { (yyvsp[-1].attr_l)->emplace_back(AdoptRef{}, (yyvsp[0].attr)); }
#line 4410 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 199:
#line 1575 "parse.y" /* yacc.c:1646  */
    {
			(yyval.attr_l) = new std::vector<AttrPtr>;
			(yyval.attr_l)->emplace_back(AdoptRef{}, (yyvsp[0].attr));
			}
#line 4419 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 200:
#line 1583 "parse.y" /* yacc.c:1646  */
    { (yyval.attr) = new Attr(ATTR_DEFAULT, {AdoptRef{}, (yyvsp[0].expr)}); }
#line 4425 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 201:
#line 1585 "parse.y" /* yacc.c:1646  */
    { (yyval.attr) = new Attr(ATTR_OPTIONAL); }
#line 4431 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 202:
#line 1587 "parse.y" /* yacc.c:1646  */
    { (yyval.attr) = new Attr(ATTR_REDEF); }
#line 4437 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 203:
#line 1589 "parse.y" /* yacc.c:1646  */
    { (yyval.attr) = new Attr(ATTR_IS_ASSIGNED); }
#line 4443 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 204:
#line 1591 "parse.y" /* yacc.c:1646  */
    { (yyval.attr) = new Attr(ATTR_IS_USED); }
#line 4449 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 205:
#line 1593 "parse.y" /* yacc.c:1646  */
    { (yyval.attr) = new Attr(ATTR_ADD_FUNC, {AdoptRef{}, (yyvsp[0].expr)}); }
#line 4455 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 206:
#line 1595 "parse.y" /* yacc.c:1646  */
    { (yyval.attr) = new Attr(ATTR_DEL_FUNC, {AdoptRef{}, (yyvsp[0].expr)}); }
#line 4461 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 207:
#line 1597 "parse.y" /* yacc.c:1646  */
    { (yyval.attr) = new Attr(ATTR_ON_CHANGE, {AdoptRef{}, (yyvsp[0].expr)}); }
#line 4467 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 208:
#line 1599 "parse.y" /* yacc.c:1646  */
    { (yyval.attr) = new Attr(ATTR_BROKER_STORE, {AdoptRef{}, (yyvsp[0].expr)}); }
#line 4473 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 209:
#line 1601 "parse.y" /* yacc.c:1646  */
    { (yyval.attr) = new Attr(ATTR_BROKER_STORE_ALLOW_COMPLEX); }
#line 4479 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 210:
#line 1603 "parse.y" /* yacc.c:1646  */
    { (yyval.attr) = new Attr(ATTR_BACKEND, {AdoptRef{}, (yyvsp[0].expr)}); }
#line 4485 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 211:
#line 1605 "parse.y" /* yacc.c:1646  */
    { (yyval.attr) = new Attr(ATTR_EXPIRE_FUNC, {AdoptRef{}, (yyvsp[0].expr)}); }
#line 4491 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 212:
#line 1607 "parse.y" /* yacc.c:1646  */
    { (yyval.attr) = new Attr(ATTR_EXPIRE_CREATE, {AdoptRef{}, (yyvsp[0].expr)}); }
#line 4497 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 213:
#line 1609 "parse.y" /* yacc.c:1646  */
    { (yyval.attr) = new Attr(ATTR_EXPIRE_READ, {AdoptRef{}, (yyvsp[0].expr)}); }
#line 4503 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 214:
#line 1611 "parse.y" /* yacc.c:1646  */
    { (yyval.attr) = new Attr(ATTR_EXPIRE_WRITE, {AdoptRef{}, (yyvsp[0].expr)}); }
#line 4509 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 215:
#line 1613 "parse.y" /* yacc.c:1646  */
    { (yyval.attr) = new Attr(ATTR_RAW_OUTPUT); }
#line 4515 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 216:
#line 1615 "parse.y" /* yacc.c:1646  */
    { (yyval.attr) = new Attr(ATTR_PRIORITY, {AdoptRef{}, (yyvsp[0].expr)}); }
#line 4521 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 217:
#line 1617 "parse.y" /* yacc.c:1646  */
    { (yyval.attr) = new Attr(ATTR_TYPE_COLUMN, {AdoptRef{}, (yyvsp[0].expr)}); }
#line 4527 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 218:
#line 1619 "parse.y" /* yacc.c:1646  */
    { (yyval.attr) = new Attr(ATTR_LOG); }
#line 4533 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 219:
#line 1621 "parse.y" /* yacc.c:1646  */
    { (yyval.attr) = new Attr(ATTR_ERROR_HANDLER); }
#line 4539 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 220:
#line 1623 "parse.y" /* yacc.c:1646  */
    { (yyval.attr) = new Attr(ATTR_DEPRECATED); }
#line 4545 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 221:
#line 1625 "parse.y" /* yacc.c:1646  */
    {
			if ( IsString((yyvsp[0].val)->GetType()->Tag()) )
				(yyval.attr) = new Attr(
					ATTR_DEPRECATED,
					make_intrusive<ConstExpr>(IntrusivePtr{AdoptRef{}, (yyvsp[0].val)}));
			else
				{
				ODesc d;
				(yyvsp[0].val)->Describe(&d);
				Unref((yyvsp[0].val));
				reporter->Error("'&deprecated=%s' must use a string literal",
				                      d.Description());
				(yyval.attr) = new Attr(ATTR_DEPRECATED);
				}
			}
#line 4565 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 222:
#line 1644 "parse.y" /* yacc.c:1646  */
    {
			std::set<const ID*> id_set;
			locals_at_this_scope.emplace_back(id_set);
			}
#line 4574 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 223:
#line 1649 "parse.y" /* yacc.c:1646  */
    {
			auto& scope_locals = locals_at_this_scope.back();
			out_of_scope_locals.insert(scope_locals.begin(), scope_locals.end());
			locals_at_this_scope.pop_back();

			set_location((yylsp[-4]), (yylsp[0]));
			(yyval.stmt) = (yyvsp[-1].stmt);
			if ( (yyvsp[-2].b) )
			    script_coverage_mgr.DecIgnoreDepth();
			}
#line 4589 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 224:
#line 1661 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-3]), (yylsp[-1]));
			(yyval.stmt) = new PrintStmt(IntrusivePtr{AdoptRef{}, (yyvsp[-2].list)});
			if ( ! (yyvsp[0].b) )
			    script_coverage_mgr.AddStmt((yyval.stmt));
			}
#line 4600 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 225:
#line 1669 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-3]), (yylsp[-1]));
			(yyval.stmt) = new EventStmt({AdoptRef{}, (yyvsp[-2].event_expr)});
			if ( ! (yyvsp[0].b) )
			    script_coverage_mgr.AddStmt((yyval.stmt));
			}
#line 4611 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 226:
#line 1677 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-4]), (yylsp[-1]));
			(yyval.stmt) = new IfStmt({AdoptRef{}, (yyvsp[-2].expr)}, {AdoptRef{}, (yyvsp[0].stmt)}, make_intrusive<NullStmt>());
			script_coverage_mgr.AddStmt((yyval.stmt));
			}
#line 4621 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 227:
#line 1684 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-6]), (yylsp[-3]));
			(yyval.stmt) = new IfStmt({AdoptRef{}, (yyvsp[-4].expr)}, {AdoptRef{}, (yyvsp[-2].stmt)}, {AdoptRef{}, (yyvsp[0].stmt)});
			script_coverage_mgr.AddStmt((yyval.stmt));
			}
#line 4631 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 228:
#line 1691 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-4]), (yylsp[-3]));
			(yyval.stmt) = new SwitchStmt({AdoptRef{}, (yyvsp[-3].expr)}, (yyvsp[-1].case_l));
			script_coverage_mgr.AddStmt((yyval.stmt));
			}
#line 4641 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 229:
#line 1698 "parse.y" /* yacc.c:1646  */
    {
			(yyvsp[-1].stmt)->AsForStmt()->AddBody({AdoptRef{}, (yyvsp[0].stmt)});
			script_coverage_mgr.AddStmt((yyvsp[-1].stmt));
			}
#line 4650 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 230:
#line 1704 "parse.y" /* yacc.c:1646  */
    {
			(yyval.stmt) = new WhileStmt({AdoptRef{}, (yyvsp[-2].expr)}, {AdoptRef{}, (yyvsp[0].stmt)});
			script_coverage_mgr.AddStmt((yyval.stmt));
			}
#line 4659 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 231:
#line 1710 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[-1]));
			(yyval.stmt) = new NextStmt;
			if ( ! (yyvsp[0].b) )
			    script_coverage_mgr.AddStmt((yyval.stmt));
			}
#line 4670 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 232:
#line 1718 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[-1]));
			(yyval.stmt) = new BreakStmt;
			if ( ! (yyvsp[0].b) )
			    script_coverage_mgr.AddStmt((yyval.stmt));
			}
#line 4681 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 233:
#line 1726 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[-1]));
			(yyval.stmt) = new FallthroughStmt;
			if ( ! (yyvsp[0].b) )
				script_coverage_mgr.AddStmt((yyval.stmt));
			}
#line 4692 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 234:
#line 1734 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[-1]));
			(yyval.stmt) = new ReturnStmt(0);
			if ( ! (yyvsp[0].b) )
			    script_coverage_mgr.AddStmt((yyval.stmt));
			}
#line 4703 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 235:
#line 1742 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-3]), (yylsp[-2]));
			(yyval.stmt) = new ReturnStmt({AdoptRef{}, (yyvsp[-2].expr)});
			if ( ! (yyvsp[0].b) )
			    script_coverage_mgr.AddStmt((yyval.stmt));
			}
#line 4714 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 236:
#line 1750 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-3]), (yylsp[-1]));
			(yyval.stmt) = new AddStmt({AdoptRef{}, (yyvsp[-2].expr)});
			if ( ! (yyvsp[0].b) )
			    script_coverage_mgr.AddStmt((yyval.stmt));
			}
#line 4725 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 237:
#line 1758 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-3]), (yylsp[-1]));
			(yyval.stmt) = new DelStmt({AdoptRef{}, (yyvsp[-2].expr)});
			if ( ! (yyvsp[0].b) )
			    script_coverage_mgr.AddStmt((yyval.stmt));
			}
#line 4736 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 238:
#line 1766 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-7]), (yylsp[-1]));
			if ( ! locals_at_this_scope.empty() )
			       locals_at_this_scope.back().insert((yyvsp[-6].id));
			(yyval.stmt) = build_local((yyvsp[-6].id), (yyvsp[-5].type), (yyvsp[-4].ic), (yyvsp[-3].expr), (yyvsp[-2].attr_l), VAR_REGULAR, ! (yyvsp[0].b)).release();
			}
#line 4747 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 239:
#line 1774 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-7]), (yylsp[-2]));
			(yyval.stmt) = build_local((yyvsp[-6].id), (yyvsp[-5].type), (yyvsp[-4].ic), (yyvsp[-3].expr), (yyvsp[-2].attr_l), VAR_CONST, ! (yyvsp[0].b)).release();
			}
#line 4756 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 240:
#line 1780 "parse.y" /* yacc.c:1646  */
    {
			(yyval.stmt) = new WhenStmt((yyvsp[0].when_clause));
			script_coverage_mgr.AddStmt((yyval.stmt));
			}
#line 4765 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 241:
#line 1786 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-4]), (yylsp[-1]));
			(yyval.stmt) = new ExprStmt(get_assign_expr({AdoptRef{}, (yyvsp[-4].expr)},
			                                  {AdoptRef{}, (yyvsp[-2].expr)}, in_init));

			if ( ! (yyvsp[0].b) )
				script_coverage_mgr.AddStmt((yyval.stmt));
			}
#line 4778 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 242:
#line 1796 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[-1]));
			(yyval.stmt) = new ExprStmt({AdoptRef{}, (yyvsp[-2].expr)});
			if ( ! (yyvsp[0].b) )
			    script_coverage_mgr.AddStmt((yyval.stmt));
			}
#line 4789 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 243:
#line 1804 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[0]), (yylsp[0]));
			(yyval.stmt) = new NullStmt;
			script_coverage_mgr.AddStmt((yyval.stmt));
			}
#line 4799 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 244:
#line 1811 "parse.y" /* yacc.c:1646  */
    { (yyval.stmt) = new NullStmt; }
#line 4805 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 245:
#line 1816 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-1]), (yylsp[0]));
			(yyvsp[-1].stmt)->AsStmtList()->Stmts().push_back((yyvsp[0].stmt));
			(yyvsp[-1].stmt)->UpdateLocationEndInfo((yylsp[0]));
			}
#line 4815 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 246:
#line 1822 "parse.y" /* yacc.c:1646  */
    { (yyval.stmt) = new StmtList(); }
#line 4821 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 247:
#line 1827 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-3]), (yylsp[0]));
			const auto& id = lookup_ID((yyvsp[-3].str), current_module.c_str());

			if ( id )
				{
				if ( ! id->IsGlobal() )
					{
					yyerror(util::fmt("local identifier \"%s\" cannot be used to reference an event", (yyvsp[-3].str)));
					YYERROR;
					}

				if ( id->IsDeprecated() )
					reporter->Warning("%s", id->GetDeprecationWarning().c_str());
				}

			(yyval.event_expr) = new EventExpr((yyvsp[-3].str), {AdoptRef{}, (yyvsp[-1].list)});
			}
#line 4844 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 248:
#line 1849 "parse.y" /* yacc.c:1646  */
    { (yyvsp[-1].case_l)->push_back((yyvsp[0].c_case)); }
#line 4850 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 249:
#line 1851 "parse.y" /* yacc.c:1646  */
    { (yyval.case_l) = new case_list; }
#line 4856 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 250:
#line 1856 "parse.y" /* yacc.c:1646  */
    { (yyval.c_case) = new Case({AdoptRef{}, (yyvsp[-2].list)}, nullptr, {AdoptRef{}, (yyvsp[0].stmt)}); }
#line 4862 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 251:
#line 1859 "parse.y" /* yacc.c:1646  */
    { (yyval.c_case) = new Case(nullptr, (yyvsp[-2].id_l), {AdoptRef{}, (yyvsp[0].stmt)}); }
#line 4868 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 252:
#line 1862 "parse.y" /* yacc.c:1646  */
    { (yyval.c_case) = new Case(nullptr, nullptr, {AdoptRef{}, (yyvsp[0].stmt)}); }
#line 4874 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 253:
#line 1867 "parse.y" /* yacc.c:1646  */
    { (yyvsp[-2].id_l)->push_back((yyvsp[0].id)); }
#line 4880 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 254:
#line 1870 "parse.y" /* yacc.c:1646  */
    {
			(yyval.id_l) = new IDPList;
			(yyval.id_l)->push_back((yyvsp[0].id));
			}
#line 4889 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 255:
#line 1878 "parse.y" /* yacc.c:1646  */
    {
			(yyval.id) = new ID(0, SCOPE_FUNCTION, 0);
			(yyval.id)->SetType({AdoptRef{}, (yyvsp[0].type)});
			}
#line 4898 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 256:
#line 1884 "parse.y" /* yacc.c:1646  */
    {
			const char* name = (yyvsp[0].str);
			TypePtr type{AdoptRef{}, (yyvsp[-2].type)};
			auto case_var = lookup_ID(name, current_module.c_str());

			if ( case_var && case_var->IsGlobal() )
				case_var->Error("already a global identifier");
			else
				case_var = install_ID(name, current_module.c_str(), false, false);

			add_local(case_var, std::move(type), INIT_NONE, nullptr, nullptr,
			                        VAR_REGULAR);
			(yyval.id) = case_var.release();
			}
#line 4917 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 257:
#line 1901 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-5]), (yylsp[0]));

			// This rule needs to be separate from the loop
			// body so that we execute these actions - defining
			// the local variable - prior to parsing the body,
			// which might refer to the variable.
			auto loop_var = lookup_ID((yyvsp[-3].str), current_module.c_str());

			if ( loop_var )
				{
				if ( loop_var->IsGlobal() )
					loop_var->Error("global variable used in for loop");
				}

			else
				{
				loop_var = install_ID((yyvsp[-3].str), current_module.c_str(),
				                                    false, false);
				}

			auto* loop_vars = new IDPList;
			loop_vars->push_back(loop_var.release());

			(yyval.stmt) = new ForStmt(loop_vars, {AdoptRef{}, (yyvsp[-1].expr)});
			}
#line 4948 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 258:
#line 1929 "parse.y" /* yacc.c:1646  */
    {
			(yyval.stmt) = new ForStmt((yyvsp[-4].id_l), {AdoptRef{}, (yyvsp[-1].expr)});
			}
#line 4956 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 259:
#line 1934 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-7]), (yylsp[0]));
			const char* module = current_module.c_str();

			// Check for previous definitions of key and
			// value variables.
			auto key_var = lookup_ID((yyvsp[-5].str), module);
			auto val_var = lookup_ID((yyvsp[-3].str), module);

			// Validate previous definitions as needed.
			if ( key_var )
				{
				if ( key_var->IsGlobal() )
					key_var->Error("global variable used in for loop");
				}
			else
				key_var = install_ID((yyvsp[-5].str), module, false, false);

			if ( val_var )
				{
				if ( val_var->IsGlobal() )
					val_var->Error("global variable used in for loop");
				}
			else
				val_var = install_ID((yyvsp[-3].str), module, false, false);

			auto* loop_vars = new IDPList;
			loop_vars->push_back(key_var.release());

			(yyval.stmt) = new ForStmt(loop_vars, {AdoptRef{}, (yyvsp[-1].expr)}, std::move(val_var));
			}
#line 4992 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 260:
#line 1967 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-9]), (yylsp[0]));
			const char* module = current_module.c_str();

			// Validate value variable
			auto val_var = lookup_ID((yyvsp[-3].str), module);

			if ( val_var )
				{
				if ( val_var->IsGlobal() )
					val_var->Error("global variable used in for loop");
				}
			else
				val_var = install_ID((yyvsp[-3].str), module, false, false);

			(yyval.stmt) = new ForStmt((yyvsp[-6].id_l), {AdoptRef{}, (yyvsp[-1].expr)}, std::move(val_var));
			}
#line 5014 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 261:
#line 1988 "parse.y" /* yacc.c:1646  */
    { (yyvsp[-2].id_l)->push_back((yyvsp[0].id)); }
#line 5020 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 262:
#line 1990 "parse.y" /* yacc.c:1646  */
    {
			(yyval.id_l) = new IDPList;
			(yyval.id_l)->push_back((yyvsp[0].id));
			}
#line 5029 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 263:
#line 1998 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[0]));
			auto id = lookup_ID((yyvsp[0].str), current_module.c_str());
			(yyval.id) = id.release();

			if ( (yyval.id) )
				{
				if ( (yyval.id)->IsGlobal() )
					(yyval.id)->Error("already a global identifier");
				delete [] (yyvsp[0].str);
				}

			else
				{
				(yyval.id) = install_ID((yyvsp[0].str), current_module.c_str(),
				                              false, is_export).release();
				}
			}
#line 5052 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 264:
#line 2019 "parse.y" /* yacc.c:1646  */
    { resolving_global_ID = 1; }
#line 5058 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 265:
#line 2020 "parse.y" /* yacc.c:1646  */
    { (yyval.id) = (yyvsp[0].id); }
#line 5064 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 266:
#line 2024 "parse.y" /* yacc.c:1646  */
    { defining_global_ID = 1; }
#line 5070 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 267:
#line 2024 "parse.y" /* yacc.c:1646  */
    { defining_global_ID = 0; }
#line 5076 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 268:
#line 2025 "parse.y" /* yacc.c:1646  */
    { (yyval.id) = (yyvsp[-1].id); }
#line 5082 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 269:
#line 2029 "parse.y" /* yacc.c:1646  */
    { resolving_global_ID = 0; }
#line 5088 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 270:
#line 2030 "parse.y" /* yacc.c:1646  */
    { (yyval.id) = (yyvsp[0].id); }
#line 5094 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 271:
#line 2035 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[0]));
			auto id = lookup_ID((yyvsp[0].str), current_module.c_str(), false,
			                    defining_global_ID);
			(yyval.id) = id.release();

			if ( (yyval.id) )
				{
				if ( ! (yyval.id)->IsGlobal() )
					(yyval.id)->Error("already a local identifier");

				if ( (yyval.id)->IsDeprecated() )
					{
					const auto& t = (yyval.id)->GetType();

					if ( t->Tag() != TYPE_FUNC ||
					     t->AsFuncType()->Flavor() != FUNC_FLAVOR_FUNCTION )
						reporter->Warning("%s", (yyval.id)->GetDeprecationWarning().c_str());
					}

				delete [] (yyvsp[0].str);
				}

			else
				{
				const char* module_name =
					resolving_global_ID ?
						current_module.c_str() : 0;

				(yyval.id) = install_ID((yyvsp[0].str), module_name,
				                              true, is_export).release();
				}
			}
#line 5132 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 272:
#line 2073 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[0]));
			auto id = lookup_ID((yyvsp[0].str), current_module.c_str());
			(yyval.id) = id.release();

			if ( ! (yyval.id) )
				reporter->Error("identifier not defined: %s", (yyvsp[0].str));

			delete [] (yyvsp[0].str);
			}
#line 5147 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 273:
#line 2087 "parse.y" /* yacc.c:1646  */
    { (yyval.b) = true; }
#line 5153 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 274:
#line 2089 "parse.y" /* yacc.c:1646  */
    { (yyval.b) = false; }
#line 5159 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 275:
#line 2094 "parse.y" /* yacc.c:1646  */
    { (yyval.b) = true; script_coverage_mgr.IncIgnoreDepth(); }
#line 5165 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 276:
#line 2096 "parse.y" /* yacc.c:1646  */
    { (yyval.b) = false; }
#line 5171 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 277:
#line 2101 "parse.y" /* yacc.c:1646  */
    { (yyval.expr) = new ConstExpr(make_intrusive<StringVal>("")); }
#line 5177 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 278:
#line 2104 "parse.y" /* yacc.c:1646  */
    {
			if ( IsString((yyvsp[0].val)->GetType()->Tag()) )
				(yyval.expr) = new ConstExpr({AdoptRef{}, (yyvsp[0].val)});
			else
				{
				ODesc d;
				(yyvsp[0].val)->Describe(&d);
				reporter->Error("'&deprecated=%s' must use a string literal",
				                      d.Description());
				(yyval.expr) = new ConstExpr(make_intrusive<StringVal>(""));
				}
			}
#line 5194 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 279:
#line 2117 "parse.y" /* yacc.c:1646  */
    { (yyval.expr) = nullptr; }
#line 5200 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
    break;


#line 5204 "/builddir/build/BUILD/zeek-5.0.9/build/src/p.cc" /* yacc.c:1646  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }

  yyerror_range[1] = yylloc;

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, &yylloc);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  yyerror_range[1] = yylsp[1-yylen];
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;

      yyerror_range[1] = *yylsp;
      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp, yylsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  yyerror_range[2] = yylloc;
  /* Using YYLLOC is tempting, but would change the location of
     the lookahead.  YYLOC is available though.  */
  YYLLOC_DEFAULT (yyloc, yyerror_range, 2);
  *++yylsp = yyloc;

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, &yylloc);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp, yylsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 2124 "parse.y" /* yacc.c:1906  */


int yyerror(const char msg[])
	{
	if ( in_debug )
		g_curr_debug_error = util::copy_string(msg);

	if ( last_tok[0] == '\n' )
		reporter->Error("%s, on previous line", msg);
	else if ( last_tok[0] == '\0' )
		{
		if ( last_filename )
			reporter->Error("%s, at end of file %s", msg, last_filename);
		else
			reporter->Error("%s, at end of file", msg);
		}
	else
		{
		if ( last_last_tok_filename && last_tok_filename &&
		     ! util::streq(last_last_tok_filename, last_tok_filename) )
			reporter->Error("%s, at or near \"%s\" or end of file %s",
			                      msg, last_tok, last_last_tok_filename);
		else
			reporter->Error("%s, at or near \"%s\"", msg, last_tok);
		}

	return 0;
	}
